#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>

#define J  10     //pocet skrytych neuronov
#define PocTrenParov    25
#define PocetVektorov   25
#define I  6 			//Velkost Vstupneho vektora
#define K  6  		//Velkost Vystupneho vektora


double x[PocetVektorov][I]=
					{
					 {0,0,1,0,0,1},{0,0,1,0,1,0},{0,0,1,0,1,1},{0,0,1,1,0,0},{0,0,1,1,0,1},
					 {0,1,0,0,0,1},{0,1,0,0,1,0},{0,1,0,0,1,1},{0,1,0,1,0,0},{0,1,0,1,0,1},
					 {0,1,1,0,0,1},{0,1,1,0,1,0},{0,1,1,0,1,1},{0,1,1,1,0,0},{0,1,1,1,0,1},
					 {1,0,0,0,0,1},{1,0,0,0,1,0},{1,0,0,0,1,1},{1,0,0,1,0,0},{1,0,0,1,0,1},
					 {1,0,1,0,0,1},{1,0,1,0,1,0},{1,0,1,0,1,1},{1,0,1,1,0,0},{1,0,1,1,0,1}
					};      //Vstupne vektory
double d[PocetVektorov][K]=
					{
					 {0,0,0,0,0,1},{0,0,0,0,1,0},{0,0,0,0,1,1},{0,0,0,1,0,0},{0,0,0,1,0,1},
					 {0,0,0,0,1,0},{0,0,0,1,0,0},{0,0,0,1,1,0},{0,0,1,0,0,0},{0,0,1,0,1,0},
					 {0,0,0,0,1,1},{0,0,0,1,1,0},{0,0,1,0,0,1},{0,0,1,1,0,0},{0,0,1,1,1,1},
					 {0,0,0,1,0,0},{0,0,1,0,0,0},{0,0,1,1,0,0},{0,1,0,0,0,0},{0,1,0,1,0,0},
					 {0,0,0,1,0,1},{0,0,1,0,1,0},{0,0,1,1,1,1},{0,1,0,1,0,0},{0,1,1,0,0,1}
					};      //Vystupne vektory

FILE *vystup,*vahy,*VysVahy;
double v[J][I],w[K][J];
double o[PocetVektorov][K];  //Skutocny vystup


void main(void)
{
	double AktFcia(double *,double *,int);
	int Koniec(void);
	int i,j,k,p,Cislo;
	int Krok1=-1;
	double Krok=-1;
	double Suma,E,S,Eta=0.67;    //Eta urcuje rychlost ucenia
	double y[PocetVektorov][J];	//Vystup Y zo skrytej vrstvy
	double Delta_o[K];          //Pomocne premene na vypocet nasledujucej
	double Delta_y[J];					//hodnoty Skutocneho vystupu
	char Subor;

	if((vystup = fopen("b1320_x.txt","w")) == NULL)
	{
		printf("\nNemozem otvorit subor \"backprop.txt\" !");
		exit(1);
	}

	clrscr();
	randomize();
	printf("1.Nacitat vahy zo suboru\n2.Vygenerovat vahy\n");

	do{
		Subor=getch();
	}while(Subor<'1' || Subor>'2');

	if(Subor=='1')
	{
		if((vahy = fopen("vahy.txt","r")) == NULL)
		{
			printf("\nNemozem otvorit subor \"vahy.txt\" !");
			fclose(vystup);
			exit(1);
		}

		for(i=0;i<I;i++)  //K=I => mozeme pouzit ten isty cyklus na inic. vah
			for(j=0;j<J;j++)
				fscanf(vahy,"%lf %lf",&v[j][i],&w[i][j]);
	}
	else
		for(i=0;i<I;i++)  //K=I => mozeme pouzit ten isty cyklus na inic. vah
			for(j=0;j<J;j++)
			{
				v[j][i]=(rand()%20-10)/10.0;
				w[i][j]=(rand()%20-10)/10.0;
			}

	printf("Rychlost ucenia je %4.2f",Eta);
	fprintf(vystup,"Rychlost ucenia je %4.2f",Eta);

	do{

		S=0;

		for(p=0;p<PocTrenParov;p++)
		{
			for(j=0;j<J;j++)
				y[p][j]=AktFcia(v[j],x[p],I);

			for(k=0;k<K;k++)
				o[p][k]=AktFcia(w[k],y[p],J);

			for(k=0;k<K;k++)
				Delta_o[k]=(d[p][k]-o[p][k])*o[p][k]*(1-o[p][k]);

			for(j=0;j<J;j++)
			{
				Suma=0;

				for(k=0;k<K;k++)
					Suma+=Delta_o[k]*w[k][j];

				Delta_y[j]=Suma*y[p][j]*(1-y[p][j]);
			}

			for(j=0;j<J;j++)
			{
				for(k=0;k<K;k++)
					w[k][j]+=Eta*Delta_o[k]*y[p][j];

				for(i=0;i<I;i++)
					v[j][i]+=Eta*Delta_y[j]*x[p][i];
			}

			for(k=0;k<K;k++)
				S+=(d[p][k]-o[p][k])*(d[p][k]-o[p][k]);
		}

		E=0.5*S;
		Krok++;
		Krok1++;


		if(!(Krok1%100))
		{
			Krok1=0;

			printf("\nCyklus %.0f Chyba:%13.10f\n",Krok,E);
			fprintf(vystup,"\n\nCyklus %.0f Chyba:%13.10f",Krok,E);

			for(p=0;p<PocetVektorov;p++)
			{

				for(j=0;j<J;j++)
					y[p][j]=AktFcia(v[j],x[p],I);

				for(k=0;k<K;k++)
					o[p][k]=AktFcia(w[k],y[p],J);

				if(!(p%5))
				{
					printf("\r");
					fprintf(vystup,"\n");
				}

				if(!(p%PocTrenParov)&&p!=0)
				{
					printf("----------------------------------------------------------------------------\n");
					fprintf(vystup,"----------------------------------------------------------------------------\n");
				}

				Cislo=0;

				for(j=0;j<I/2;j++)
					Cislo=(Cislo*2)+(int)x[p][j];

				printf("%dx",Cislo);
				fprintf(vystup,"%dx",Cislo);
				Cislo=0;

				for(j=i/2;j<I;j++)
					Cislo=(Cislo*2)+(int)x[p][j];

				printf("%d=",Cislo);
				fprintf(vystup,"%d=",Cislo);
				Cislo=0;

				for(j=0;j<I;j++)
					if(o[p][j]>0.9)
						Cislo=(Cislo*2)+1;
					else
						Cislo*=2;

				printf("%2d",Cislo);
				fprintf(vystup,"%2d",Cislo);
				Cislo=0;

				for(j=0;j<I;j++)
					Cislo=(Cislo*2)+(int)d[p][j];

				printf(" (%d)\t",Cislo);
				fprintf(vystup," (%d)\t",Cislo);
			}
		}



	}while(Koniec());

	if(Krok!=0)
	{
		printf("\nCyklus %.0f Chyba:%13.10f\n",Krok,E);
		fprintf(vystup,"\n\nCyklus %.0f Chyba:%13.10f",Krok,E);

		for(p=0;p<PocetVektorov;p++)
		{
			for(j=0;j<J;j++)
				y[p][j]=AktFcia(v[j],x[p],I);

			for(k=0;k<K;k++)
				o[p][k]=AktFcia(w[k],y[p],J);


			if(!(p%5))
			{
				printf("\r");
				fprintf(vystup,"\n");
			}

			if(!(p%PocTrenParov)&&p!=0)
			{
				printf("----------------------------------------------------------------------------\n");
				fprintf(vystup,"----------------------------------------------------------------------------\n");
			}

			Cislo=0;

			for(j=0;j<I/2;j++)
				Cislo=(Cislo*2)+(int)x[p][j];

			printf("%dx",Cislo);
			fprintf(vystup,"%dx",Cislo);
			Cislo=0;

			for(j=i/2;j<I;j++)
				Cislo=(Cislo*2)+(int)x[p][j];

			printf("%d=",Cislo);
			fprintf(vystup,"%d=",Cislo);
			Cislo=0;

			for(j=0;j<I;j++)
				if(o[p][j]>0.9)
					Cislo=(Cislo*2)+1;
				else
					Cislo*=2;

			printf("%2d",Cislo);
			fprintf(vystup,"%2d",Cislo);
			Cislo=0;

			for(j=0;j<I;j++)
				Cislo=(Cislo*2)+(int)d[p][j];

			printf(" (%d)\t",Cislo);
			fprintf(vystup," (%d)\t",Cislo);
		}
	}

	printf("\nKONIEC TRENOVANIA\n");

	printf("\nZapisat vahy do suboru(a/n)\n");

	do{
		Subor=getch();
	}while(Subor!='a' && Subor!='n');

	if(Subor=='a')
	{
		if((VysVahy = fopen("v1320_x.txt","w")) == NULL)
		{
			printf("\nNemozem otvorit subor \"v1020_2.txt\" !");
			fclose(vystup);
			fclose(vahy);
			exit(1);
		}

		for(i=0;i<I;i++)  //K=I => mozeme pouzit ten isty cyklus na inic. vah
			for(j=0;j<J;j++)
				fprintf(VysVahy,"%f %f\n",v[j][i],w[i][j]);
	}
	fcloseall();
}

double AktFcia(double* Vaha,double* Vstup,int Kolko)
{
	double x=0;

	for(int i=0;i<Kolko;i++)
		x-=Vaha[i]*Vstup[i];

	return 1/(1+pow(M_E,x));

}
int Koniec(void)
{
	for(int p=0;p<PocTrenParov;p++)
		for(int k=0;k<K;k++)
			if((fabs(o[p][k]-d[p][k]))>.1)
				return 1;

	return 0;
}