// ZADANIE CISLO 2 :
//******************
// 1.cast programu: vykona sucin prvkov pola, ktore nacita zo zvoleneho
//                  vstupneho subora a vysledok zapise do vystupneho subora
// 2.cast programu: spocita, kolko pismen x je v retazci pismen, ktory tiez
//                  nacita zo vstupneho subora a pocet zapise do subora
// Copyright (c) 2000 by    Tibor Szabo    C26
//***************************************************************************

#include <stdio.h>
#include <alloc.h>
#include <conio.h>
#include <process.h>
#include <string.h>
#include <stdlib.h>

// ***** FUNKCIA *****
double nacitaj(double *p_one, int x)                 // funkcia na vypocet vysledku
{
  int i;
  double vysledok = 1;
  for(i=0; i < x; i++) {                             // cyklus for
	vysledok *= (p_one[i]);                          // vypocet sucinu
  }
  return (vysledok);                                 // vratenie vysledka
}


// ***** PODPROGRAM c.1 *****
void cisla()                            // podprogram pre sucin prvkov pola
{
  FILE *fr, *fw;                        // definicia suborov pre citanie a zapis
  char VSTUP_SUBOR[250], VYSTUP_SUBOR[250];
  int x, i = 0;                         // definicie premennych
  double *p_one, vysledok = 1;          // definicia pola a vysledku

  clrscr();                             // vycistenie obrazovky

  printf("Zadaj meno vstupneho subora a potvrd enterom.\n\r");
  scanf("%s", VSTUP_SUBOR);             // nacitanie vstupneho subora
	if ((fr = fopen(VSTUP_SUBOR, "r")) == NULL) {
	  printf("Vstupny subor sa nepodarilo otvorit.\n\r");
	  getch();                      // cakanie na klavesu
	  exit(1);                      // koniec programu
	}
  printf("Zadaj meno vystupneho subora a potvrd enterom.\n\r");
  scanf("%s", VYSTUP_SUBOR);          // nacitanie vystupneho subora
	if ((fw = fopen(VYSTUP_SUBOR, "w")) == NULL) {
	  printf("Vystupny subor sa nepodarilo otvorit.\n\r");
	  getch();                      // cakanie na klavesu
	  exit(1);                      // koniec programu
	}

  clrscr();                         // vycistenie obrazovky

  fscanf(fr, "%d\n", &x);           // nacitanie poctu prvkov pola
  if (x < 0) {                      // podmienka, aby pocet premennych nebol zaporne cislo.
	printf("Nemoze byt zaporny pocet cisel zo vstupneho subora.\n\r");
	printf("Program sa ukonci stlacenim klavesy.\n\r");
	getch();                        // cakanie na klavesu
	exit(1);                        // ukoncenie programu
  }
  if (x == 0) {                     // podmienka, ked je 0 cisel vo vstupnom subore
	printf("Vysledny sucin cisel pola je 0.\n\r");
	getch();
	exit(1);
  }

  p_one = (double *) malloc(x * sizeof(double));     // vymedzenie pamete
  if ((p_one) == NULL) {                             // podmienka pre pamet
	printf("Nie je volna pamet.\n\r");               // vypis na obrazovku
	getch();                                         // cakanie na klavesu
	exit(1);                                         // ukoncenie programu
  }
  for(i=0; i < x; i++) {                             // cyklus for
	fscanf(fr, "%lf\n", (p_one + i));                   // nacitanie cisel do pole
  }
  vysledok = nacitaj(p_one, x);                                 // vyvolanie funkcie nacitaj

  printf("Vysledok sucinu prvkov pola je %f\n\r", vysledok);       // vypis na obrazovku
  getch();                                                         // cakanie na klavesu
  fprintf(fw, "Vysledok sucinu prvkov pola je %f\n\r", vysledok);  // vypis do vystupneho subora
  free(p_one);                        // uvolnenie pamete
  fclose(fr);                         // zatvorenie vstupneho subora
  fclose(fw);                         // zatvorenie vystupneho subera
}


// ***** PODPROGRAM c.2 *****
void znak()                          // podprogram na spocitanie pismen x v retazci pismen
{
  FILE *fr, *fw;
  char VSTUP_SUBOR[250], VYSTUP_SUBOR[250];
  int y = 0, i = 0, pocet = 0;       // definicie premennych
  char *p_two;                       // definicia pola

  clrscr();                          // vycistenie obrazovky
  printf("Zadaj meno vstupneho subora a potvrd enterom.\n\r");
  scanf("%20s", VSTUP_SUBOR);        // nacitanie vstupneho subora
	if ((fr = fopen(VSTUP_SUBOR, "r")) == NULL) {
	  printf("Vstupny subor sa nepodarilo otvorit.\n\r");
	  getch();                       // cakanie na klavesu
	  exit(1);                       // ukoncenie programu
	}
  printf("Zadaj meno vystupneho subora a potvrd enterom.\n\r");
  scanf("%20s", VYSTUP_SUBOR);       // nacitanie vystupneho subora
	if ((fw = fopen(VYSTUP_SUBOR, "w")) == NULL) {
	  printf("Vystupny subor sa nepodarilo otvorit.\n\r");
	  getch();                      // cakanie na klavesu
	  exit(1);                      // ukoncenie programu
	}

  clrscr();                          // vycistenie obrazovky

  fscanf(fr, "%d\n", &y);            // nacitanie poctu pismen retazca
  if (y < 0) {                       // podmienka, aby pocet premennych nebol zaporne cislo.
	printf("Nemoze byt zaporny pocet pismen vo vstupnom subore.\n\r");
	printf("Program sa ukonci stlacenim klavesy.\n\r");
	getch();                        // cakanie na klavesu
	exit(1);                        // ukoncenie programu
	}
  if (y == 0) {                     // podmienka, ked je 0 pismen vo vstupnom subore
	printf("Vysledny sucin cisel pola je 0.\n\r");
	getch();                        // cakanie na klavesu
	exit(1);                        // ukoncenie programu
	}

  if ((p_two = (char *) malloc(y * sizeof(char))) == NULL) {      // pridelenie pamete
	printf("Nie je volna pamet.\n\r");
	getch();
	exit(1);
  }

  for(i=0; i < y; i++) {             // cyklus for pre
	p_two[i] = getc(fr);             // nacitanie pismen do pola
  }
  for(i=0; i < y; i++) {             // cyklus for pre porovnanie pismen
	if ((p_two[i] == 'x') || (p_two[i] == 'X')) {
	  pocet = pocet + 1;             // pocitanie pismen x v retazci
	}
  }

  printf("Pocet pismen x v retazci je %d", pocet);        // vypis na obrazovku
  getch();                                                // cakanie na klavesu
  fprintf(fw, "Pocet pismen x v retazci je %d", pocet);   // vypis do vystupneho subora
  free(p_two);                       // uvolnenie pamete
  fclose(fr);                        // zatvorenie vstupneho subora
  fclose(fw);                        // zatvorenie vystupneho subora
}


//  *****  HLAVNY PROGRAM  *****
main()
{
  clrscr();
  double xxx;
  int p;
  printf("Zadaj pomocne cislo nevyuzite v programe.\n\r");
  scanf("%lf", &xxx);                // pomocne cislo, lebo program nepracuje s cislami double

  clrscr();                          // vycistenie obrazovky
  printf("ZADANIE CISLO 2\n\r");     // vypis na obrazovku
  printf("\nVyber si z ponuky : \n\r");
  printf("\n1. Urobim sucin vsetkych prvkov pola.\n\r");
  printf("2. Spocitam pocet pismen x v retazci pismen. \n\r");
  printf("3. Koniec programu.\n\r");
  printf("\nTvoj vyber je : ");

  while (1) {
  switch(p = getch()) {              // cakanie na klavesu
	case '1' :{                      // ak je volba c.1
	  cisla();                       // vykona sa podprogram cisla
	  exit(1);}                      // koniec

	case '2' :{                     // ak je volba c.2
	  znak();                       // vykone sa podprogram znak
	  exit(1);}                     // koniec programu

	case '3' :{                     // ak je volba c.3
	  clrscr();                     // vycistenie obrazovky
	  printf("Program sa ukoncuje.\n\r");
	  exit(1);}                      // program sa ukonci

	default :{                       // ak je ina volba ako 1, 2 alebo 3
	  printf("Nezvolil si si z danych moznosti.\n\r");
	  printf("Stlacenim hociakej klavesy sa program ukonci.\n\r");
	  getch();                      // cakanie na klavesu
	  //exit(1);                      // program sa ukonci
	  break;}

	}
  }
  return 0;
}