#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define MAXCARS 50

// Macro na nacitanie riadku
#define GETLINE(s1, s2) {printf (s1); fflush(stdin); gets(s2);}
// Macro , ktory vypise jeden prvok
#define PRINT_ITEM(i, car) { \
		printf("Cislo prvku: %d\nTyp auta: %s\n", i, car[i].type); \
	   printf("Rok vyroby: %d\nCena auta: %f\n\n", car[i].year, car[i].cost); \
	}

typedef struct {
	char type[30];
	int year;
	float cost;
} CAR;

void Menu(void) {
	clrscr();
	printf("\n\nZOZNAM AUT\n"
		"~~~~~~~~~~~~~~~~~~~~~~~~~\n"
		"1. Zadanie noveho auta\n"
		"2. Vylucenie auta\n"
		"3. Vyhladanie auta\n"
		"4. Usporiadanie aut\n"
		"5. Vypis\n"
		"6. Vstup zo suboru\n"
		"7. Vystup do suboru\n"
		"8. Editacia\n"
		"9. Koniec\n"
		"________________________________________________________________________________");
}

void List(CAR *car, int no) {
	int i;
   int pages = no/4 + (no%4 ? 1 : 0);

   clrscr();
	for (i=1; i<=no; i++) {
      if ((i%4 == 1) && (i != 1)) {	   // ak zacina nova strana (ale nie prva)
			gotoxy(2, 22);
			cprintf("\n\n-- Page %d of %d --", i/4, pages);
	      getch(); clrscr();
		}
   	PRINT_ITEM (i, car);
   }
	gotoxy(2, 22);
	cprintf("\n\n-- Page %d of %d --", pages, pages);
	getch();
}

int Insert(CAR *car, int no) {
	no++;
	GETLINE ("Typ auta: ", car[no].type);
   printf("Rok vyroby: ");
   scanf("%d",&car[no].year);
   printf("Cena auta: ");
   scanf("%f",&car[no].cost);
   return no;
}

int Delete(CAR *car,int no) {
	int index[MAXCARS];
	int c, i;
	CAR a;

	for(int i=1; i<=no; i++) index[i]=0;
	printf("Podla:\na. typu\nb. roka\nc. ceny\n\n");
	do	c=getch(); while((c!='a')&&(c!='b')&&(c!='c'));
	switch(c) {
		case 'a':
         GETLINE ("Hladany typ: ", a.type);
			for(i=1; i<=no; i++) if (strcmp(car[i].type, a.type)==0) index[i]=1;
	      break;

		case 'b':
      	printf("Hladany rok: "); scanf("%d", &a.year);
		 	for(i=1; i<=no; i++) if (car[i].year==a.year) index[i]=1;
	      break;

		case 'c':
  			printf("Hladana cena: "); scanf("%f", &a.cost);
		 	for(i=1; i<=no; i++) if (car[i].cost == a.cost) index[i]=1;
	      break;

	}
   clrscr();
   printf("Vylucene prvky: \n\n");

	for(i=no; i>=1; i--) {
		if (index[i]==1) {
			PRINT_ITEM (i, car);
      	if (i==no) no--;    // je to posledny ?
      	else {
         	car[i] = car[no]; no--;
			}
   	}
	}

   getch();
	return(no);
}

void Search (CAR *car, int no) {
	char type[30];
	int c;
	int i,year;
	float cost;

	printf("Podla:\na. typu\nb. roka\nc. ceny\n\n");
	do c=getch(); while((c!='a')&&(c!='b')&&(c!='c'));
	switch(c) {
	case 'a':
      GETLINE ("Hladany typ: ", type);
      clrscr();
      printf("Najdene prvky: \n\n");
		for(i=1;i<=no;i++)
	      if (strcmp(car[i].type,type)==0) PRINT_ITEM (i, car);
      break;

	case 'b':
   	printf("Hladany rok: "); scanf("%d",&year);
      clrscr();
	   printf("Najdene prvky: \n\n");
		for(i=1; i<=no; i++)
      	if (car[i].year==year) PRINT_ITEM (i, car);
      break;

	case 'c':
   	printf("Hladana cena: "); scanf("%f",&cost);
	   clrscr();
	   printf("Najdene prvky: \n\n");
		for(i=1; i<=no; i++)
      	if (car[i].cost==cost) PRINT_ITEM (i, car);
      break;
 }
 getch();
}

void Sort(CAR *car,int no) {
	int c;
	int i, j;
	CAR temp;
   
	printf("Podla:\na. typu\nb. roka\nc. ceny\n\n");
	do c=getch(); while((c!='a')&&(c!='b')&&(c!='c'));
	switch(c) {
		case 'a':
      	for(i=1; i<no; i++) {
         	for(j=i+1; j<=no; j++)  {
	         	if (strcmp(car[i].type, car[j].type) > 0) {
               	temp=car[i]; car[i]=car[j]; car[j]=temp;
               }
				}
         }
         break;

		case 'b':
   		for(i=1; i<no; i++)  {
	         for(j=i+1; j<=no; j++) {
            	if(car[i].year > car[j].year) {
               	temp=car[i]; car[i]=car[j]; car[j]=temp;
               }
            }
         }
         break;

		case 'c':
      	for(i=1; i<no; i++) {
	         for(j=i+1; j<=no; j++) {
            	if(car[i].cost > car[j].cost) {
               	temp=car[i]; car[i]=car[j]; car[j]=temp;
               }
            }
         }
	}
}

int Input (CAR *car,int no) {
	FILE *file;
	char filename[11];

	printf("Meno suboru: "); scanf("%s",&filename);
	if ((file=fopen(filename,"rt")) == NULL) {
		printf("\n!!! Subor %s je nedostupny !!!\n", filename);
		exit(1);
	}
	while(!feof(file)) {
		no++;
		fgets (car[no].type, 30, file);
      int len = strlen(car[no].type);
      car[no].type[len-1] = '\0';		// nechceme posledny '\n'
		fscanf(file,"%d\n%f\n", &car[no].year, &car[no].cost);
   }
	fclose(file);
	return(no);
}

void Save (CAR *car,int no) {
	char filename[11];
	int c, i;
	FILE *file;

	printf("Text/Bin ? (T/B)\n");
	do c=tolower(getch()); while((c!='t')&&(c!='b'));
	printf("Meno suboru: ");
	scanf("%s",&filename);
	switch(c) {
		case 't':
      	if ((file=fopen(filename,"wt")) == NULL) {
         	printf("\n!!! Chyba !!!\n");
         	exit(1);
       	}
         for(i=1;i<=no;i++) {
				fputs (car[i].type, file);
            fprintf(file, "\n%d\n%f\n", car[i].year, car[i].cost);
         }
       	fclose(file);
       	break;
	  	case 'b':
      	if ((file=fopen(filename,"wb")) == NULL) {
         	printf("\n!!! Chyba !!!\n");
         	exit(1);
       	}
       	fwrite(car, sizeof(CAR), no+1, file);
       	break;

	}
	fclose(file);
}

void Edit (CAR *car, int no) {
	int i;
   char buffer[30];
   do {
		printf("\nCislo prvku (1 - %d): ", no);
      scanf("%d",&i);
   } while (i > no);		//TODO: > or >=  ???
	printf("---- Stare udaje:\n");
   PRINT_ITEM (i, car);
   printf("---- Nove udaje:\n");

   GETLINE("Typ auta: ", buffer);
	if (strlen(buffer) > 0) strcpy (car[i].type, buffer);
   GETLINE("Rok vyroby: ", buffer);
	if (strlen(buffer) > 0) sscanf (buffer, "%d",&car[i].year);
   GETLINE("Cena auta: ", buffer);
	if (strlen(buffer) > 0) sscanf (buffer, "%f",&car[i].cost);
}

void main(void) {
	int c;
	int no=0;  //TODO: why not zero ?
	CAR sCar[MAXCARS+1];

	Menu();
	do {
		c=getch();
		switch (c) {
   		case '1':
   			no = Insert (sCar, no);
   			Menu(); break;
		   case '2':
   			no = Delete (sCar, no);
   			Menu(); break;
		   case '3':
   			Search (sCar, no);
   			Menu(); break;
		   case '4':
   			Sort (sCar, no);
   			Menu(); break;
		   case '5':
   			List (sCar, no);
   			Menu(); break;
		   case '6':
   			no = Input (sCar, no);
   			Menu(); break;
		   case '7':
   			Save (sCar, no);
   			Menu(); break;
		   case '8':
   			Edit (sCar, no);
   			Menu(); break;
		}
	} while(c!='9');

}