entity Coder is
  port(I1,I2,I3,I4:in Bit;O1,O2,O3,O4,O5,O6,O7:out Bit);
end Coder;
architecture beh of Coder is
signal X4:Bit;
component Modulo
  port(X1,X2,X3,X4:in Bit;Y:out Bit);  
end component;
begin
  C1:Modulo    port map(X1=>I2,X2=>I4,X3=>I1,X4=>X4,Y=>O1);
  C2:Modulo    port map(X1=>I3,X2=>I4,X3=>I1,X4=>X4,Y=>O2);      
  C3:Modulo    port map(X1=>I3,X2=>I4,X3=>I2,X4=>X4,Y=>O4);      
  CX4:X4<='0' after 0ns;
  O3<=I1;  O5<=I2;  O6<=I3;  O7<=I4;
end beh;        
entity Correct is
  port(Ii1,Ii2,Ii3,Ii4,Ii5,Ii6,Ii7:in Bit;N1,N2,N3:out Bit);
end Correct;
architecture beh of Correct is
component Modulo
  port(X1,X2,X3,X4:in Bit;Y:out Bit);
end component;
begin
  C1:Modulo    port map(X1=>Ii4,X2=>Ii5,X3=>Ii6,X4=>Ii7,Y=>N1);
  C2:Modulo    port map(X1=>Ii2,X2=>Ii3,X3=>Ii6,X4=>Ii7,Y=>N2);      
  C3:Modulo    port map(X1=>Ii1,X2=>Ii3,X3=>Ii5,X4=>Ii7,Y=>N3);      
end beh;        
entity Decoder is
  port(Din1,Din2,Din3,Din4,Din5,Din6,Din7,Dn1,Dn2,Dn3:in Bit;Do1,Do2,Do3,Do4:out Bit);
end Decoder;
architecture beh of Decoder is
signal Tmp_not1,Tmp_not2,Tmp_not3,Tmp_and1,Tmp_and2,Tmp_and3,Tmp_and4:Bit;
component Not_Gate
  port(Nin:in Bit;Nout:out Bit);
end component;
component And4_Gate
  port(Ain1,Ain2,Ain3,Ain4:in Bit;Aout:out Bit);
end component;
component Xor_Gate
  port(Xin1,Xin2:in Bit; Xout:out Bit);
end component;   
begin
 ON1:Not_Gate
   port map(Nin=>Dn1,Nout=>Tmp_not1);
 ON2:Not_Gate
   port map(Nin=>Dn2,Nout=>Tmp_not2);
 ON3:Not_Gate
   port map(Nin=>Dn3,Nout=>Tmp_not3);
 OA1:And4_Gate
   port map(Ain1=>Dn1,Ain2=>Tmp_not2,Ain3=>Tmp_not3,Ain4=>Dn1,Aout=>Tmp_and1);
 OA2:And4_Gate
   port map(Ain1=>Tmp_not1,Ain2=>Dn2,Ain3=>Tmp_not3,Ain4=>Dn2,Aout=>Tmp_and2);
 OA3:And4_Gate
   port map(Ain1=>Tmp_not1,Ain2=>Dn2,Ain3=>Dn3,Ain4=>Dn2,Aout=>Tmp_and3);
 OA4:And4_Gate
   port map(Ain1=>Tmp_not1,Ain2=>Tmp_not2,Ain3=>Dn3,Ain4=>Dn3,Aout=>Tmp_and4);
 XA1:Xor_Gate
   port map(Xin1=>Tmp_and1,Xin2=>Din7,Xout=>Do4);
 XA2:Xor_Gate
   port map(Xin1=>Tmp_and2,Xin2=>Din5,Xout=>Do2);
 XA3:Xor_Gate
   port map(Xin1=>Tmp_and3,Xin2=>Din6,Xout=>Do3);
 XA4:Xor_Gate
   port map(Xin1=>Tmp_and4,Xin2=>Din3,Xout=>Do1);                        
end beh;        

