entity OR_Gate is 
 port (x,y:in Bit; out1: out Bit);
end OR_Gate;

architecture beh of OR_Gate is
  begin
    out1 <=  x or y;
  end beh;
  
 entity Half_adder is
  port (in1,in2: in Bit; Sum,Carry: out Bit);
 end Half_adder;
 
 architecture beh of Half_adder is
  begin
    Sum <= in1 xor in2;
    Carry <= in1 and in2;
  end beh;     
  
entity Full_adder is
 	port(A,B,Carry_in:in Bit ; AB,Carry_out:out Bit);
end Full_adder;

architecture beh of Full_adder is
 signal Temp_sum: Bit;
 signal Temp_carry1:Bit;
 signal Temp_carry2:Bit;
  
 component Half_adder
  port(in1,in2:in Bit ; Sum,Carry:out Bit);
 end component;
 
 component OR_Gate
  port(x,y:in Bit ; out1: out Bit);
 end component;
 
 begin
  U0: Half_adder
  	port map(in1=>A , in2=>B , Sum=>Temp_sum , Carry =>Temp_carry1);
  	
  U1:Half_adder
  	port map(in1=>Temp_sum , in2=>Carry_in , Sum=>AB , Carry=>Temp_carry2);
  	
  U2:OR_Gate
  	port map(x=>Temp_carry1 , y=>Temp_carry2 , out1=>Carry_out);
  	
  end beh;	
  			   