entity Not_Gate is
  port(Nin: in Bit; Nout: out Bit);
end Not_Gate;  
architecture beh of Not_Gate is
   begin
     Nout<=not Nin;
   end beh;     
---------------------------------------------------------------------------------------
entity And_Gate is
  port(Ain1,Ain2,Ain3: in Bit;Aout: out Bit);
end And_Gate;
architecture beh of And_Gate is
  begin
    Aout<=Ain1 and Ain2 and Ain3;
  end beh;
---------------------------------------------------------------------------------------
entity Or_Gate is
  port(Oin1,Oin2:in Bit;Oout:out Bit);
end Or_Gate;
architecture beh of Or_Gate is
  begin
    Oout<=Oin1 or Oin2;
  end beh;
---------------------------------------------------------------------------------------
entity Xor_Gate is
  port(Xin1,Xin2:in Bit;Xout:out Bit);  
end Xor_Gate;
architecture beh of Xor_Gate is
  begin
    Xout<=Xin1 xor Xin2;
  end beh;
---------------------------------------------------------------------------------------
entity Sum is
  port(Up: in Bit; Sin: in Bit_vector (3 downto 1); Carryout : out Bit; Sout: out Bit_vector(3 downto 1));
end Sum;
architecture beh of Sum is
component And_Gate
  port(Ain1,Ain2,Ain3: in Bit;Aout: out Bit);
end component;    
component Not_Gate
    port(Nin: in Bit; Nout: out Bit);
end component;
component Or_Gate
  port(Oin1,Oin2: in Bit;Oout : out Bit);
end component;
component Xor_Gate
  port(Xin1,Xin2: in Bit; Xout: out Bit);
end component;  
  signal Carry: Bit:='1';
  signal Temp_and: Bit_vector (1 to 6);
  signal  Temp_not: Bit_vector (4 downto 1);
  signal Temp_Carry: Bit_vector (2 downto 1);      
  begin
      O_not1: Not_Gate port map(Nin=>Up,Nout=>Temp_not(4));
      O_not2: Not_Gate port map(Nin=>Sin(3),Nout=>Temp_not(3));
      O_not3: Not_Gate port map(Nin=>Sin(2),Nout=>Temp_not(2));
      O_not4: Not_Gate port map(Nin=>Sin(1),Nout=>Temp_not(1));
      O_and1: And_Gate port map(Ain1=>Up,Ain2=>Carry,Ain3=>Sin(1),Aout=>Temp_and(1));
      O_and2: And_Gate port map(Ain1=>Temp_not(4),Ain2=>Carry,Ain3=>Temp_not(1),Aout=>Temp_and(2));
      O_or1: Or_Gate port map(Oin1=>Temp_and(1),Oin2=>Temp_and(2),Oout=>Temp_Carry(1));
      O_xor1: Xor_Gate port map(Xin1=>Carry,Xin2=>Sin(1),Xout=>Sout(1));
      O_and3: And_Gate port map(Ain1=>Up,Ain2=>Temp_Carry(1),Ain3=>Sin(2),Aout=>Temp_and(3));
      O_and4: And_Gate port map(Ain1=>Temp_not(4),Ain2=>Temp_Carry(1),Ain3=>Temp_not(2),Aout=>Temp_and(4));
      O_or2: Or_Gate port map(Oin1=>Temp_and(3),Oin2=>Temp_and(4),Oout=>Temp_Carry(2));
      O_xor2: Xor_Gate port map(Xin1=>Temp_Carry(1),Xin2=>Sin(2),Xout=>Sout(2));
      O_and5: And_Gate port map(Ain1=>Up,Ain2=>Temp_Carry(2),Ain3=>Sin(3),Aout=>Temp_and(5));
      O_and6: And_Gate port map(Ain1=>Temp_not(4),Ain2=>Temp_Carry(2),Ain3=>Temp_not(3),Aout=>Temp_and(6));
      O_or3: Or_Gate port map(Oin1=>Temp_and(5),Oin2=>Temp_and(6),Oout=>Carryout);
      O_xor3: Xor_Gate port map(Xin1=>Temp_Carry(2),Xin2=>Sin(3),Xout=>Sout(3));	                 
  end beh;