entity and_gate is
        port(X:in Bit ; Y:in Bit ; Z:out Bit);
end and_gate;
architecture behavioral of and_gate is
begin
        Z<=X and Y;
end behavioral;


entity xor_gate is
        port(X:in Bit;Y:in Bit;Z:out Bit);
end xor_gate;
architecture behavioral of xor_gate is
begin
        Z<=X xor Y;
end behavioral;


entity or_gate is
        port(X:in Bit;Y:in Bit;Z:out Bit);
end or_gate;
architecture behavioral of or_gate is
begin
        Z<=X or Y;
end behavioral;


entity half_adder is
        port(X:in Bit;Y:in Bit;Sum:out Bit;Carry:out Bit);
end half_adder;
architecture chod of half_adder is
component and_gate
        port(X:in Bit;Y:in bit;Z:out Bit);
end component;
component xor_gate
        port(X:in Bit;Y:in bit;Z:out Bit);
end component;
begin
        U0:xor_gate
                port map(X=>X,Y=>Y,Z=>Sum);
        U1:and_gate
                port map(X=>X,Y=>Y,Z=>Carry);
end chod;


entity full_adder is
        port(A:in Bit;B:in Bit;CarryIn:in Bit;AB,CarryOut:out Bit);
end full_adder;
architecture struct of full_adder is
signal  tempsum:bit;
signal  tempcarry1:bit;
signal  tempcarry2:bit;
component half_adder is
        port(X:in Bit;Y:in Bit;Sum:out Bit;Carry:out Bit);
end component;
component or_gate
        port(X:in Bit;Y:in bit;Z:out Bit);
end component;
begin
        Z0:half_adder
                port map(X=>A,Y=>B,Sum=>tempsum,Carry=>tempcarry1);
        Z1:half_adder
                port map(X=>tempsum,Y=>CarryIn,Sum=>AB,Carry=>tempcarry2);
        Z2:or_gate
                port map(X=>tempcarry1,Y=>tempcarry2,Z=>CarryOut);
end struct;