function [TT]=id_pt14(rad,metoda,t,y)
%function [TT]=id_pt14(rad,metoda,t,y)
%-------------------------------------
%metoda=0:      Strejc
%metoda=1:      Broida
%metoda=2:      zovseobecnenie
%
%related files: solveeqn.m, ps.m
%-------------------------------------
%copyright:     Katarina Zakova

%rad=2;

n=length(t);
t_final=max(t);
T=t_final/(n-1);
eps=.02;

for i=1:n-2,
  if (y(i+1)-y(i)<eps)&(y(i+2)-y(i+1)<eps)
      tA=i*T;
      nA=i;
  end
end

Pam=0;
for i=1:nA,
  Pam=Pam+T*(2-y(i+1)-y(i))/2;
end

for i=1:n,
  q1(i)=0.7-y(i);
  if q1(i)<0 q1(i)=1; end
  q2(i)=y(i)-0.7;
  if q2(i)<0 q2(i)=1; end
end
[qB1,nB1]=min(q1);yB1=y(nB1);
[qB2,nB2]=min(q2);yB2=y(nB2);
tB=(0.7-yB1)*(nB2-nB1)*T/(yB2-yB1)+nB1*T;

Pbm=0;
for i=1:nB1,
  Pbm=Pbm+T*(2-y(i+1)-y(i))/2;
end
Pbm=Pbm +(tB-nB1*T)*(2-0.7-yB1)/2;

%sust. 2.radu s dopr.onesk.
%disp('sust. 2.radu s dopr.onesk.');
%rad=2;

Td=0;Q=0;
      
   if metoda == 1
         r = 1;
       elseif metoda == 0
         r = 0;
       else
         r=solveeqn([rad,Td,Pam,tB,Pbm]);
   end
   
    
   switch rad
          case 1, TT=(Pam-Td); T1=TT;
          case 2, 
             q2=r-2; q4=r-4;  
             TT=2*q2*(Pam-Td)/q4; 
             T1=TT/2; T2=TT/(2-r);
          case 3, 
             q3=r-3; q23=2*r-3;  
             TT=3*q3*q23*(Pam-Td)/(27-18*r+2*r^2); 
             T1=TT/3; T2=TT/(3-r); T3=TT/(3-2*r);
          case 4, 
             q2=r-2; q4=r-4; q34=3*r-4;  
             TT=4*q2*q4*q34*(Pam-Td)/(-128+144*r-44*r^2+3*r^3); 
             T1=TT/4; T2=TT/(4-r); T3=TT/(4-2*r); T4=TT/(4-3*r);
          otherwise, disp('Unknown method.')
   end

   for i=1:n
      if r==0
         D=exp(-(i*T-Td)/T1);
         switch rad
          case 1, if i*T<Td yy(i)=0; else yy(i)=-D+1; end;
          case 2, if i*T<Td yy(i)=0; else yy(i)=-D*(1+(i*T-Td)/T1)+1; end;
          case 3, if i*T<Td yy(i)=0; else yy(i)=-D*(1+(i*T-Td)/T1+(i*T-Td)^2/(2*T1^2))+1; end;
          case 4, if i*T<Td yy(i)=0; else yy(i)=-D*(1+(i*T-Td)/T1+(i*T-Td)^2/(2*T1^2)+(i*T-Td)^3/(6*T1^3))+1; end;
          otherwise, disp('Unknown method.')
         end
      else
         switch rad
          case 1, if i*T<Td yy(i)=0; else yy(i)=1-exp(-(i*T-Td)/T1); end;
          case 2, if i*T<Td yy(i)=0; else yy(i)=T1/(T2-T1)*exp(-(i*T-Td)/T1)-T2/(T2-T1)*exp(-(i*T-Td)/T2)+1; end;
          case 3, if i*T<Td yy(i)=0; else yy(i)=T1*T1/(T2-T1)/(-T3+T1)*exp(-(i*T-Td)/T1)-T2*T2/(T2-T3)/(T2-T1)*exp(-(i*T-Td)/T2)-1/(-T3+T1)/(T2-T3)*T3*T3*exp(-(i*T-Td)/T3)+1; end; 
          case 4, if i*T<Td yy(i)=0; else yy(i)=T1*T1*T1/(-T4+T1)/(-T3+T1)/(T2-T1)*exp(-(i*T-Td)/T1)-T2*T2*T2/(-T4+T2)/(T2-T3)/(T2-T1)*exp(-(i*T-Td)/T2)-1/(T3-T4)/(-T3+T1)/(T2-T3)*T3*T3*T3*exp(-(i*T-Td)/T3)+1/(T3-T4)/(-T4+T1)/(-T4+T2)*T4*T4*T4*exp(-(i*T-Td)/T4)+1; end;
          otherwise, disp('Unknown method.')
         end
      end   
      Q=Q+(y(i)-yy(i))^2;
   end   

switch rad
          case 1, TT=[T1];
          case 2, TT=[T1, T2];
          case 3, TT=[T1, T2, T3];
          case 4, TT=[T1, T2, T3, T4];
          otherwise, disp('Unknown method.')
end

yy=yy';

