(defun zly (zoz)
	(cond	((null zoz) nil)
		((not (atom (first zoz))) t)
		(t (zly (rest zoz)))
	)
)

(defun isdef (zoz meno)
	(cond	((null zoz) nil)
		((equal meno (first (first zoz))) t)
		(t (isdef (rest zoz) meno))
	)
)

(defun ismember (x mn)
	(cond	((null mn) nil)
		((equal x (first mn)) t)
		(t (ismember x (rest mn)))
	)
)

(defun myintersect (mn1 mn2)
	(cond	((null mn1) nil)
		((ismember (first mn1) mn2)
			(cons (first mn1) (myintersect (rest mn1) mn2)))
		(t (myintersect (rest mn1) mn2))
	)
)

(defun myunion (mn1 mn2)
	(append mn1 mn2)
)

(defun myshow (mn)
	(cond	((null mn) nil)
		((ismember (first mn) (rest mn))
			(myshow (rest mn)))
		(t (cons (first mn) (myshow (rest mn))))
	)
)

(defun mycard (mn)
	(cond	((null mn) 0)
		(t (+ 1 (mycard (rest mn))))
	)
)

(defun obsah (zoz meno)
	(cond	((null zoz) nil)
		((equal (first (first zoz)) meno)
			(rest (first zoz)))
		(t (obsah (rest zoz) meno))
	)
)

(defun create (meno zoz)
	(cond	((isdef q meno) nil)
		(t (setq q (cons (cons meno zoz) q)))
	)
)

(defun mfilter (zoz p)
	(cond	((null zoz) nil)
		((eq (first zoz) p) (mfilter (rest zoz) p))
		(t (cons (first zoz) (mfilter (rest zoz) p)))
	)
)

(defun mdelete (zoz meno prvok)
	(cond	((null zoz) nil)
		((equal (first (first zoz)) meno)
			(cons
				(cons meno (mfilter (rest (first zoz)) prvok))
				(mdelete (rest zoz) meno prvok)
			)
		)
		(t (cons (first zoz) (mdelete (rest zoz) meno prvok)))
	)
)

(defun sdelete (meno prvok)
	(setq q (mdelete q meno prvok))
)

(defun intersect (meno1 meno2)
	(myintersect (obsah q meno1) (obsah q meno2))
)

(defun sunion (meno1 meno2)
	(myunion (obsah q meno1) (obsah q meno2))
)

(defun card (meno)
	(cond	((null (obsah q meno)) nil)
		(t (mycard (myshow (obsah q meno))))
	)
)

(defun show (meno)
	(myshow (obsah q meno))
)

(defun show-allr () ; pozor toto nie je este dorobene
	q
)

(defun show-rep (meno)
	(obsah q meno)
)

(defun sho ()
	(prog (name r)
		(princ "meno> ")
		(setq name (read))
		(setq r (show name))
		(cond	((null r) (princ "mnoz. neex."))
			(t (princ r))
		)		
	)
)

(defun shr ()
	(prog (name r)
		(princ "meno> ")
		(setq name (read))
		(setq r (show-rep name))
		(cond	((null r) (princ "mnoz. neex."))
			(t (princ r))
		)		
	)
)

(defun cre ()
	(prog (name h)
		(princ "meno> ")
		(setq name (read))
		(princ "hodnota> ")
		(setq h (read))
		(cond	((not (listp h)) (princ "hodnota musi byt zoznam"))
			((zly h) (princ "zoznam moze byt len zoznam atomov"))
			((null (create name h)) (princ "mnoz. uz ex."))
			(t (princ "mnoz. vytvorena"))
		)
	)
)

		
(defun del ()
	(prog (name h)
		(princ "meno> ")
		(setq name (read))
		(princ "hodnota> ")
		(setq h (read))
		(cond	((null (isdef q name)) (princ "taka mn. nie je def."))
			(t (sdelete name h))
		)
	)
)

(defun crd ()
	(prog (name h)
		(princ "meno> ")
		(setq name (read))
		(setq h (card name))
		(cond	((null h) (princ "taka mnoz. neex."))
			(t (princ h))
		)
	)
)

(defun inte ()
	(prog (name1 name2 name h)
		(princ "meno> ")
		(setq name (read))
		(princ "meno1> ")
		(setq name1 (read))
		(princ "meno2> ")
		(setq name2 (read))
		(cond	((null (isdef q name1)) (princ "taka mn.(mn1) neex."))
			((null (isdef q name2)) (princ "taka mn.(mn2) neex."))
			((not (null (isdef q name))) (princ "mn. meno uz ex."))
			(t (create name (intersect name1 name2)))
		)
	)
)

(defun uni ()
	(prog (name1 name2 name h)
		(princ "meno> ")
		(setq name (read))
		(princ "meno1> ")
		(setq name1 (read))
		(princ "meno2> ")
		(setq name2 (read))
		(cond	((null (isdef q name1)) (princ "taka mn.(mn1) neex."))
			((null (isdef q name2)) (princ "taka mn.(mn2) neex."))
			((not (null (isdef q name))) (princ "mn. meno uz ex."))
			(t (create name (sunion name1 name2)))
		)
	)
)

(defun sa (zozb)
	(cond	((null zozb) nil)
		(t (prog ()
			(princ (first (first zozb)))
			(princ " ... ")
			(princ (myshow (rest (first zozb))))
			(terpri)
			(sa (rest zozb))
		   )
		)
	)	
)


(defun show-all ()
	(sa q)
)

(defun main ()


(prog (what)
	(setq q nil)
ss	(terpri)
	(princ "1 ... show-all-rep") (terpri)
	(princ "2 ... show-rep") (terpri)
	(princ "3 ... create") (terpri)
	(princ "4 ... delete") (terpri)
	(princ "5 ... card") (terpri)
	(princ "6 ... intersect") (terpri)
	(princ "7 ... union") (terpri)
	(princ "8 ... show") (terpri)
	(princ "9 ... show-all") (terpri)
	(princ "0 ... quit") (terpri)
	
	(princ "kuk> ")

	(setq what (read))
	(cond	((eq what 1) (princ (show-allr)))
		((eq what 2) (shr))
		((eq what 3) (cre))
		((eq what 4) (del))
		((eq what 5) (crd))
		((eq what 6) (inte))
		((eq what 7) (uni))
		((eq what 8) (sho))
		((eq what 9) (show-all))
		((eq what 0) (go sz))
	)
	(go ss)
sz	(terpri)
)

)
