(setf mnoziny '())

;vyhodi opakujuce sa prvky
(defun vyhod (zoz)
	(cond ((null zoz) nil)
	      ((jevz (first zoz) (rest zoz)) (vyhod (rest zoz)))
	      (T (cons (first zoz) (vyhod (rest zoz))))))

;zisti ci je prvok v zozname
(defun jevz (prvok zoz)
	(cond ((not (numberp prvok)) T)
	      ((null zoz) nil)
	      ((eq prvok (first zoz)) T)
	      (T (jevz prvok (rest zoz)))))

;zisti ci je to zoznam
(defun jezoz (zoz)
	(cond ((atom zoz) (eq zoz NIL))
	      (T (jezoz (rest zoz)))))

;usporiada zoznam vzostupne
(defun uspor (zoz)
	(cond ((null zoz) nil)
	      (T (cons (najdimax zoz (first zoz)) (uspor (vyrad (najdimax zoz (first zoz)) zoz))))))

;vyradi prvok pom zo zoznamu
(defun vyrad (pom zoz)
	(cond ((null zoz) nil)
	      ((eq pom (first zoz)) (vyrad pom (rest zoz)))
	      (T (cons (first zoz) (vyrad pom (rest zoz))))))

;najde maximalny prvok v zozname
(defun najdimax (zoz pom)
	(cond ((null zoz) pom)
	      ((> (first zoz) pom) (najdimax (rest zoz) pom))
	      (T (najdimax (rest zoz) (first zoz)))))

;vytvory mnozinu zo zoznamu
(defun create (meno zoz)
	(cond ((or (not (atom meno)) (eq meno NIL)) 'chyba_v_mene_mnoziny)
	      ((not (jezoz zoz)) 'chyba_v_zadavani_zoznamu)
	      ((najdi meno mnoziny) 'mnozina_s_takym_menom_uz_existuje)
	      (T (setq mnoziny (cons (cons meno (uspor (vyhod zoz))) mnoziny)))))

;vypise predchodcu prvku
(defun pred (meno prvok)
	(cond ((not (atom meno)) 'chyba_v_mene_mnoziny)
	      ((not (atom prvok)) 'chyba_v_zadavani_prvku)
	      ((not(najdi meno mnoziny)) 'mnozina_s_takym_menom_neexistuje)
	      ((eq prvok nil) 'neexistuje_taky_prvok)
	      ((eq prvok (first (rest (najdi meno mnoziny)))) 'prvok_je_1_prvkom_mnoziny)
	      (T (predchodca (rest (najdi meno mnoziny)) prvok))))

;najde predchodcu prvku prvok
(defun predchodca (zoz prvok)
	(cond ((null zoz) 'prvok_sa_v_mnozine_nenachadza)
	      ((eq (first (rest zoz)) prvok) (first zoz))
	      (T (predchodca (rest zoz) prvok))))

;najde v zozname mnozin mnozinu s menom meno
(defun najdi (meno mnoz)
 	(cond ((null mnoz) nil)
	      ((eq meno (caar mnoz)) (first mnoz))
	      (T (najdi meno (rest mnoz)))))

;vypise nasledovnika prvku
(defun succ (meno prvok)
	(cond ((not (atom meno)) 'chyba_v_mene_mnoziny)
	      ((not (atom prvok)) 'chyba_v_zadavani_prvku)
	      ((not(najdi meno mnoziny)) 'mnozina_s_takym_menom_neexistuje)
	      (T (nasledovnik (rest (najdi meno mnoziny)) prvok))))

;najde nasledovnika prvku prvok
(defun nasledovnik (zoz prvok)
	(cond ((null zoz) 'prvok_sa_v_mnozine_nenachadza)
	      ((eq (first zoz) prvok) (cond ((second zoz) (second zoz))
					    (T 'prvok_je_poslednym_prvkom_mnoziny)))

	      (T (nasledovnik (rest zoz) prvok))))

;vypise vsetky prvky vacsie ako prvok
(defun allmax (meno prvok)
	(cond ((not (atom meno)) 'chyba_v_mene_mnoziny)
	      ((not (atom prvok)) 'chyba_v_zadavani_prvku)
	      ((not(najdi meno mnoziny)) 'mnozina_s_takym_menom_neexistuje)
	      (T (allvacsie (rest (najdi meno mnoziny)) prvok))))

;najde vsetky prvky vacsie ako prvok
(defun allvacsie (zoz prvok)
	(cond ((null zoz) 'prvok_sa_v_mnozine_nenachadza)
	      ((eq (first zoz) prvok) (cond ((second zoz) (rest zoz))
					    (T 'prvok_je_poslednym_prvkom_mnoziny)))

	      (T (allvacsie (rest zoz) prvok))))

;vypise vsetky prvky mensie ako prvok
(defun allmin (meno prvok)
	(cond ((not (atom meno)) 'chyba_v_mene_mnoziny)
	      ((not (atom prvok)) 'chyba_v_zadavani_prvku)
	      ((not(najdi meno mnoziny)) 'mnozina_s_takym_menom_neexistuje)
	      ((or (eq prvok nil) (not (jevz prvok (rest (najdi meno mnoziny))))) 'prvok_sa_v_mnozine_nenachadza)
	      ((eq prvok (first (rest (najdi meno mnoziny)))) 'prvok_je_1_prvkom_mnoziny)
	      (T (allmensie (rest (najdi meno mnoziny)) prvok))))

;najde vsetky prvky mensie ako prvok
(defun allmensie (zoz prvok)
	(cond ((null zoz) nil)
	      ((eq prvok (first zoz)) nil)
	      (T (cons (first zoz) (allmensie (rest zoz) prvok)))))


;vypise  kartezsky sucin dvoch mnozin
(defun kartez (meno1 meno2)
	(cond ((not (atom meno1)) 'chyba_v_mene_1_mnoziny)
	      ((not (atom meno2)) 'chyba_v_mene_2_mnoziny)
	      ((not(najdi meno1 mnoziny)) 'mnozina1_s_takym_menom_neexistuje)
	      ((not(najdi meno2 mnoziny)) 'mnozina2_s_takym_menom_neexistuje)
	      ((null (rest (najdi meno1 mnoziny))) '1_mnozina_je_prazdna)
	      ((null (rest (najdi meno2 mnoziny))) '2_mnozina_je_prazdna)
	      (T (stlpec (rest (najdi meno1 mnoziny)) (rest (najdi meno2 mnoziny))))))

;pomocna funkcia, ktora robi stlpce pre kartez sucin
(defun stlpec (m1 m2)
	(terpri)
	(cond ((null m1) nil)
      	      (T (riadok (first m1) m2)
		 (stlpec (rest  m1) m2))))

;pomocna funkcia, ktora vypise jeden riadok kar. sucinu 
(defun riadok (n1 n2)
	(cond ((null n2) nil)
              (T (prin1 (list n1 (first n2)))
		 (riadok n1 (rest n2)))))

;vypis mnoziny so zadanym menom
(defun show (meno)
	(cond ((not (atom meno)) 'chyba_v_mene_mnoziny)
	      ((not(najdi meno mnoziny)) 'mnozina_s_takym_menom_neexistuje)
	      (T (terpri)
		 (princ "-------------------")
		 (terpri)
      		 (princ "Meno : ")
		 (prin1 meno)
	         (terpri)
	         (princ "mnozina : ")
	         (princ "{")
	         (vypismnoz (rest (najdi meno mnoziny)))
	         (princ " }")
		 '-------------------)))

;vypis skutocnej reprezentacie mnoziny
(defun show_rep (meno)
	(cond ((not (atom meno)) 'chyba_v_mene_mnoziny)
	      ((not(najdi meno mnoziny)) 'mnozina_s_takym_menom_neexistuje)
	      (T (terpri)		
		 (pprint (najdi meno mnoziny)))))

;vlastna funkcia na vypis vsetkych mnozin
(defun shovsetky (mnoz)
	(cond ((null mnoz) '------------------)
	      (T (show (caar mnoz))
		 (shovsetky (rest mnoz)))))

;vypis vsetkych mnozin
(defun show_all ()
	(cond ((null mnoziny) 'nebola_vytvorena_ani_jedna_mnozina)
	      (T (shovsetky mnoziny))))

;vypis obsahu mnoziny
(defun vypismnoz (zoz)
	(cond ((null zoz) nil)
    	      (T (princ " ")
		 (prin1 (car zoz))
		 (vypismnoz (cdr zoz)))))

(create 'mn1 '(1 2 3 4 5))
(create 'mn4 '(3 6 77 8 5))
(create 'mn3 '(3 4 5))
(create 'mn2 '(() (32 () r) (e) e 11  r 3 nil 4 0))
(create 'mn5 '())
(create 'mn6 '(3))
(pprint mnoziny)

