// Priklad zo "Strucneho uvodu do C++ pre programatorov v jazyku C"
// (c) Peter Menhart 1996

#include <stdio.h>

  // namiesto makier je vhodne pouzivat inline funkcie:
inline void ERROR(char *txt) {printf("ERROR: %s\n", txt); }

class GEOM_UTVAR            // zakladna abstraktna trieda
{
  int stredX, stredY;       // default pristup je private
  int farba_ciary;
public:
  void NovyStred(int nX, int nY) { stredX = nX; stredY = nY; };
  void NovaFarba(int f) { farba_ciary = f; };
       // co ma nakreslit vseobecny objekt ???
  virtual void Nakresli() { ERROR("Ja sa neviem nakreslit..."); };
  GEOM_UTVAR(int sX, int sY, int fc = 1);  // default hodnota fc
};

GEOM_UTVAR::GEOM_UTVAR(int sX, int sY, int fc)  // konstruktor
{
  stredX = sX; stredY = sY; farba_ciary = fc;
}

class KRUZ_CLASS : public GEOM_UTVAR
				 // odvodena trieda KRUZ_CLASS bude
				 // mat ako public cast aj public
{                                // cast triedy GEOM_UTVAR
  int polomer;      // novy atribut, ktory nebol v zakladnej triede
public:
  virtual void Nakresli()     // metoda pre nakreslenie je specificka
    { printf("Kreslim kruznicu\n"); };
  KRUZ_CLASS(int sX, int sY, int pol, int fc = 1)
    : GEOM_UTVAR(sX, sY, fc)  // sposob volania konstruktora zakladnej
    { polomer = pol; };       //   zakladnej triedy
  ~KRUZ_CLASS() { printf("Kruznica zanikla\n"); };  // destruktor
};

class BOD_CLASS : public GEOM_UTVAR
{
public:
  // bod nepotrebuje ziaden novy atribut, iba nakreslit sa
  virtual void Nakresli()  // ina ako pre kruznicu
    { printf("Kreslim bod\n"); };
  BOD_CLASS(int sX, int sY, int fc = 1) : GEOM_UTVAR(sX, sY, fc)
    { };   // vsetko urobi konstruktor zakladnej triedy

};

class STVOREC_CLASS : public GEOM_UTVAR
{
  int dlzka_strany; // novy atribut, ktory nebol v zakladnej triede
public:
  virtual void Nakresli()  // ina ako pre kruznicu a bod
    { printf("Kreslim stvorec\n"); };
  STVOREC_CLASS(int sX, int sY, int strana = 4, int fc = 1)
    : GEOM_UTVAR(sX, sY, fc)  { dlzka_strany = strana; };
};

// pouzitie:
int main()
{
  KRUZ_CLASS kruz_objekt(2,5,12,5);   // farba ina ako default
  STVOREC_CLASS *stvorec = new STVOREC_CLASS(40,40);
                 // default farba aj dlzka strany
  BOD_CLASS bod1(3,7), bod2(5,9), bod3(7,11,3);

  kruz_objekt.NovyStred(2, 15);
  bod2.NovaFarba(5);
// pre jednoduchost pouzijeme namiesto zoznamu staticke pole
  GEOM_UTVAR *pole[6];  // pole smernikov na zakladnu triedu
  pole[0] = &kruz_objekt; pole[1] = &bod1; pole[2] = stvorec;
  pole[3] = &bod2; pole[4] = &bod3;  pole[5] = NULL;

  for (int i = 0; pole[i] != NULL; i++)
      pole[i]->Nakresli();

  return 0;
}

// Namiesto pola skuste pouzit implementaciu obojsmerne zretazeneho 
//  zoznamu z kniznice TINY (subory LINKS.*)
 