#include "toolset.h"

void main()
{
	enum { EV_STOP = 1, EV_ARRIVAL, EV_ENTER1,EV_ENTER2, EV_LEAVE1, EV_LEAVE2 };
	CEventSimulation SP("Simulacia 1.zadania");

	CLifoQueue Z1(&SP, "zasobnik1");
	CLifoQueue Z2(&SP, "zasobnik2");
	Z1.setSize(100);
	Z2.setSize(100);
	CFacility F1(&SP, "Obsluha F1");
	CFacility F2(&SP, "Obsluha F2");
	CMultiGen gen1(3),gen2(3),gen3(3);
	SP.interaction(TRUE);
	SP.stepping(FALSE);
	SP.tracing(FALSE);
	const TIMETYPE endTime  = 28800.0; // cas ukoncenia simulacie 8hodin v sek.
	CTrans *trNew;
	SP.print("*** Start simulation ***\n");
	trNew = new CTrans("Trn", SP.getSimTime());
	SP.schedule(0, EV_ARRIVAL, trNew); //naplanovanie prvej udalosti

	while (SP.getSimTime() < endTime)
		{
		EVENTTYPE ev; CTrans * tr;
		SP.cause(ev,tr);                 // vyber prvu udalost z kalendara
		switch(ev)
			{
			case EV_ARRIVAL:
				if(Z1.getLength()<100) Z1.insert(tr);

				if (F1.isEmpty())
				{
					tr = Z1.remove();
					SP.schedule(NOW, EV_ENTER1, tr);							//naplanovanie vstupu
				}                                 							//suc. zo Z1 do F1

				trNew = new CTrans("Trn", SP.getSimTime());
				SP.schedule(gen2.uniform(400,500),EV_ARRIVAL,trNew);							//naplanovanie prichodu
				break;                            							//dalsej suciastky
			case EV_ENTER1:
				F1.enter(tr);
				SP.schedule(gen1.uniform(360,440),EV_LEAVE1,tr);//naplanovanie odchodu
				break;																					//suciastky z prveho
			case EV_LEAVE1:                                   //pracoviska, doba
				tr = F1.leave(tr);                              //spracovania suc. je
																												//400s +/-40s
				if(Z2.getLength()<100) Z2.insert(tr);

				if (F2.isEmpty())
				{
					tr = Z2.remove();
					SP.schedule(NOW, EV_ENTER2, tr);							//naplanovanie vstupu
				}                                 							//suc. zo Z2 do F2

				if(Z1.getLength()>0)
				{
					tr = Z1.remove();
					SP.schedule(NOW,EV_ENTER1,tr);
				}

				break;
			case EV_ENTER2:
				F2.enter(tr);
				SP.schedule(gen3.uniform(280,320),EV_LEAVE2,tr);//naplanovanie odchodu
				break;               													 //suciastky z druheho
			case EV_LEAVE2:                                   //pracoviska, doba
				tr = F2.leave(tr);                              //spracovania suc. je
				delete(tr);                                     //300s +/-20s

				if(Z2.getLength()>0)
				{
					tr = Z2.remove();
					SP.schedule(NOW,EV_ENTER2,tr);
				}

				break;
			default: ErrorExit("Unknown type of event");
			}
		}
	SP.report();

}


