/* ZVP */

#include <stdio.h>
#define MAXELM 10

typedef struct tElm {
	int val;
	int next;
} TElm;

typedef struct tZvp {
	int head;
	TElm tab[MAXELM];
} TZvp;

TZvp zvpEmpty(void)
{
	TZvp lst;
	int i;
	for(i=0;i<MAXELM;i++) {
		lst.tab[i].next=i+1;
		lst.tab[i].val=i;
	}
	lst.head=0;
	lst.tab[MAXELM-1].next= -1;
	return lst;
}

TElm zvpNew(TZvp* lst)
{
	int i;
	i=lst->head;
	lst->head=lst->tab[i].next;
	return lst->tab[i];
}

TZvp zvpDispose(TZvp* lst, TElm elm)
{
	elm.next=lst->head;
	lst->tab[--(lst->head)]=elm;
	return *lst;
}

int zvpIsEmpty(TZvp lst)
{
	int i=0;
	int p=lst.head;
	while(lst.tab[p].next != -1) {
		p=lst.tab[p].next;
		i++;
	}
	return (i==MAXELM-1);
}

void zvpPrint(TZvp lst)
{
	int i;

	printf("head=%d\n",lst.head);
	for(i=0;i<MAXELM;i++)
		printf("%d: val=%d next=%d\n",i,lst.tab[i].val,lst.tab[i].next);

}

main()
{
	TZvp list;
	TElm elem;
	TElm el1;
	TElm el2;

	list= zvpEmpty();
	zvpPrint(list);
	if (zvpIsEmpty(list)) printf("Is Empty\n");
	else printf("Is Not Empty\n");
	
	printf("\nNEW:\n");
	elem=zvpNew(&list);
	zvpPrint(list);
	if (zvpIsEmpty(list)) printf("Is Empty\n");
	else printf("Is Not Empty\n");
	
	printf("\nNEW:\n");
	el1=zvpNew(&list);
	zvpPrint(list);
	if (zvpIsEmpty(list)) printf("Is Empty\n");
	else printf("Is Not Empty\n");

	printf("\nDISPOSE:\n");
	zvpDispose(&list, elem);
	zvpPrint(list);
	if (zvpIsEmpty(list)) printf("Is Empty\n");
	else printf("Is Not Empty\n");
	
	printf("\nDISPOSE:\n");
	zvpDispose(&list, el1);
	zvpPrint(list);
	if (zvpIsEmpty(list)) printf("Is Empty\n");
	else printf("Is Not Empty\n");	
}
