begin
write('ѥ');
end.
output);

{********** DEKODER MORZEOVKY - BINARNY STROM ********}
type
  strchar = array[0..254] of char;
  mrschar = array[0..2] of char;
  pmorsetree = ^tmorsetree;            {smernik typu element stromu}
  tmorsetree = record                  {element stromu}
    value: mrschar;                    {... hodnota v uzle}
    left: pmorsetree;                  {... smernik na lavy podstrom}
    right: pmorsetree;                 {... smernik na pravy podstrom}
  end;

const
  {zapis znakov pre MorsehoBinarnyStrom}
  chars : array[0..82] of mrschar =(
    'MBT', ' E ', ' I ', ' S ', ' H ', ' 5 ', #0, #0,
                                       ' 4 ', #0, #0,
                                ' V ', #0,
                                       ' 3 ', #0, #0,
                         ' U ', ' F ', #0, #0,
                                ' :U', #0,
                                       ' 2 ', #0, #0,
                  ' A ', ' R ', ' L ', #0, #0,
                                ' :A', #0, #0,
                         ' W ', ' P ', #0, #0,
                                ' J ', #0,
                                       ' 1 ', #0, #0,
           ' T ', ' N ', ' D ', ' B ', ' 6 ', #0, #0,
                                       #0,
                                ' X ', #0, #0,
                         ' K ', ' C ', #0, #0,
                                ' Y ', #0, #0,
                  ' M ', ' G ', ' Z ', ' 7 ', #0, #0,
                                       #0,
                                ' Q ', #0, #0,
                         ' O ', ' :O', ' 8 ', #0, #0,
                                       #0,
                                ' CH', ' 9 ', #0, #0,
                                       ' 0 ', #0, #0);

var
  i: integer;                          {index}
  inputstr: strchar;                   {vstupny retazec}
  outputstr: mrschar;                  {vystupny znak}
  morsetree: pmorsetree;               {smernik na strom morzeovky}

function createtree(var i: integer): pmorsetree;
{ Procedura vytvori strom morzeovej      }
{ abecedy. Strom je binarny a je tvoreny }
{ dynamickym alokovanim pamate.          }
var
  treeptr: pmorsetree;
begin
  if chars[i,0] <> #0 then begin
    new(treeptr);
    treeptr^.value:= chars[i];
    i:= i+1;
    treeptr^.left:= createtree(i);
    i:= i+1;
    treeptr^.right:= createtree(i);
    createtree:= treeptr;
  end else createtree:= nil;
end;

procedure searchchar(inp: strchar; var out: mrschar; var pos: integer);
{ Procedura najde zodpovedajucemu kodu v }
{ morzeovke jeho znak v latinke.         }
{ Pokial taky znak nie je vrati chybovy  }
{ kod - znak 32 (medzera).               }
var
  i: integer;
  treeptr: pmorsetree;
begin
  treeptr:= morsetree;                 {inicializacia vnutornych premennych}
  i:= pos;
  out[0]:= #32;
  while (inp[i] <> #32) and (inp[i] <> #0) do begin
    {pokial nie je koniec pismena alebo celeho textu tak rob...}
    if out[0] <> #0 then begin
    {ak je to spravny kod tak vykonaj...}
      if (inp[i] = '-') or (inp[i] = '_') then {...ak je vst '-' alebo '_' a...}
        if treeptr^.right <> nil then          {....."mam pod sebou strom"...}
          treeptr:= treeptr^.right             {.....tak chod na jeho adresu...}
        else out[0]:= #0;                      {.....inak chybovy znak}
      if inp[i] = '.' then                     {...ak je vst '.' a...}
        if treeptr^.left <> nil then           {....."mam po sebou strom"...}
          treeptr:= treeptr^.left              {.....tak chod na jeho adresu...}
        else out[0]:= #0;                      {.....inak chybovy znak}
    end;
    i:= i+1;
  end;
  pos:= i;
  if out[0] <> #0  then                      {ak je vsetko v poriadku...}
    out:= treeptr^.value;                    {... prepis do vystupu}
end;

{********** HLAVNY PROGRAM ***************************}
begin
  i:= 0;
  morsetree:= createtree(i);
  write('Zadaj text v morzeovke (max. 254 znakov): ');
  i:= 0;
  while not eoln do begin
    read(inputstr[i]);
    i:= i+1;
  end;
  inputstr[i]:= #0;
  write('Sprava: ');
  i:= 0;
  while inputstr[i] <> #0 do begin
    searchchar(inputstr, outputstr, i);
    if outputstr[0] = #0 then write(' ??? ')
    else write(outputstr);
    i:= i+1;
  end;
  writeln;
end.program binarnystrom(input,output);

{********** DEKODER MORZEOVKY - BINARNY STROM ********}
type
  strchar = array[0..254] of char;
  mrschar = array[0..2] of char;
  pmorsetree = ^tmorsetree;            {smernik typu element stromu}
  tmorsetree =