#include <stdio.h>
#include <conio.h>
#include <process.h>

const MAX_LEN=100;
const MAX=100;
const EMPTY=0;
const FULL=MAX-1;


struct stack_elem {
  char prior;
  char oper;
};

struct stack {
  char top;
  stack_elem elem[MAX];
};

stack s;
const stack_elem prior_table[] = { { 1,';' } ,
                                   { 2,'(' },
                                   { 2,')' },
                                   { 3,'+' },
                                   { 3,'-' },
                                   { 4,'*' },
                                   { 4,'/' },
                                   { 4,'%' },
                                   { 5,'^' }
                                 };

char getprior(char o)
{
  char i;

  for (i=0;i<(sizeof(prior_table)/sizeof(stack_elem));i++)
    if (prior_table[i].oper == o) return prior_table[i].prior;
  return -1;
}

void empty(stack *s)
{
  s->top = EMPTY;
}

char isempty(stack *s)
{
  return (s->top == EMPTY);
}

void push(stack *s,stack_elem elm)
{
  if (s->top == FULL) {
    printf("PUSH: Plny stack.\n");
    exit(1);
  }
  s->elem[s->top++] = elm;
}

void pop(stack *s)
{
  if ( isempty(s) ) {
	printf("POP: Prazdny stack.\n");
	exit(1);
  }
  s->top--;
}

stack_elem top(stack *s)
{
  if ( isempty(s) ) {
	printf("TOP: Prazdny stack.\n");
	exit(1);
  }
  return s->elem[(s->top-1)];
}

void addo(char *s,char o)
{
  *s = o;
  *(s+1) = 0;
}

char getnum(char *in,char *out)
{
  char r;

  r=0;
  while( (*in >= '0') && (*in <= '9') ) {
	addo(out++,*in);
	r++;
	in++;
  }
  addo(out,' ');
  return r+1;
}

void in2post(char *in,char *out)
{
  char *pi,*po,lastprior,prior,len;
  stack_elem e;

  lastprior = 0;
  po = out;
  for (pi=in;*pi!=0;) {
	switch (*pi) {
	  case '1':case '2':case '3':case '4':case '5':case'6':case'7':case'8':case'9':case'0':
		len = getnum(pi,po);
		po+=len;
		pi+=(len-1);
		break;
	  case '+':case '-':case '*':case '/':case '%':case ';':case '(':case ')':case '^':
		prior = getprior(*pi);
		if ( (prior >= lastprior) || (*pi == '(') ) {
		  e.prior = prior; e.oper = *pi;
		  push(&s,e);
		}
		else {
		  while ( !isempty(&s) ) {
			e = top(&s);
			if ( e.prior < prior ) break;
			pop(&s);
			if (e.oper == '(') continue;
			addo(po++,e.oper);
			addo(po++,' ');
		  }
		  if (*pi != ')' ) {
			e.prior = prior; e.oper = *pi;
			push(&s,e);
		  }
		}
		lastprior = prior;
		pi++;
		break;
	}
	pi++;
	pi--;
  }
  while ( !isempty(&s) ) {
	e = top(&s);
	pop(&s);
	addo(po++,e.oper);
	addo(po++,' ');
  }
}

int main()
{
  stack s;
  stack_elem e;
  char infix[MAX_LEN],postfix[MAX_LEN];

  clrscr();
  printf("Zadaj korektny vyraz v infixe :\n");
  scanf("%s",&infix);
  in2post(infix,postfix);
  printf("\nPostfix:\n%s",postfix);
  return 0;
}