/* Programovacie techniky
   meno:   Miroslav Oravec 
   kruzok: tlk4		
   nazov:  Tabulka s vonkajsim rozptylenim
   sk. rok:1998/99

Specifikacia:
Signatura:

druhy:	  tab,elm,key,bool
operacie: empty:	      		->tab
	  insert:	tab,key,elm 	->tab
	  read:  	tab,key		->elm
	  delete:	tab,key		->tab
	  isin: 	key,key		->bool
          search: 	key,tab		->bool

*/


#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#define MAX 5

typedef enum {FALSE=0,TRUE} BOOL; // typ bool nadobuda hodnoty TRUE a FALSE
typedef struct elm
               {
                char meno[8];
                int cislo;
               } ELM;             // elementarny prvok - obsahuje kluc(meno) a
                                  // nejake cislo
typedef struct tabul
              {
               ELM prvok;
               struct tabul *next;
              } TABUL;            // prvok tabul - obsahuje ELM a pointer
                                  // na dalsi prvok. Je zakladom pre tabulku
typedef TABUL* TABULKA;           // typ tabulka

int Hash(char*);                  // funkcia Hash urcuje index do tabulky
void Empty(TABULKA*);           // vytvori prazdnu tabulku
TABULKA Insert(TABULKA,char*,ELM);// vlozi prvok do tabulky
ELM Read(TABULKA,char*);          // cita prvok z tabulky
TABULKA Delete(TABULKA,char*);    // maze prvok z tabulky
BOOL IsIn(TABULKA,char*);         // zistuje, ci sa prvok nachadza v tabulke

TABULKA Vyber(void);

TABULKA tab;                      // tabulka
TABULKA otab;

void main()
{
 ELM prv;
 char znak=0;
 int i;

 if((tab=(TABULKA) malloc(MAX*sizeof(TABUL)))==NULL)
   {
    perror("Chyba ");
    exit(1);
   }

 if((otab=(TABULKA) malloc(MAX*sizeof(TABUL)))==NULL)
   {
    perror("Chyba ");
    exit(1);
   }

 for(i=0;i<MAX-1;i++)
   {
    (otab+i)->next=NULL;
    (otab+i)->prvok.meno[0]=NULL;
   }
 (otab+MAX-1)->next=NULL;
 (otab+MAX-1)->prvok.meno[0]=NULL;

 Empty(&tab);

 while(znak!='Q')
 {
  clrscr();

  printf("\nE - Empty\n");
  printf("I - Insert\n");
  printf("R - Read\n");
  printf("D - Delete \n");
  printf("S - IsIn\n");
  printf("Q - Quit\n");

 switch(znak)
   {
    case 'E': Empty(&tab);
              for(i=0;i<MAX-1;i++)
                {
                 (otab+i)->next=(otab+i+1);
                 (otab+i)->prvok.meno[0]=NULL;
                }
                 (otab+MAX-1)->next=NULL;
                 (otab+MAX-1)->prvok.meno[0]=NULL;
              break;
    case 'I': gotoxy(20,5);
              printf("Zadaj kluc : ");
              gets(prv.meno);
              gotoxy(20,6);
              printf("Zadaj ID : ");
              scanf("%d",&prv.cislo);
			  getchar();
              tab=Insert(tab,prv.meno,prv);
              break;
    case 'R': gotoxy(20,5);
              printf("Zadaj kluc : ");
              gets(prv.meno);
              if(!IsIn(tab,prv.meno))
                {
                 gotoxy(20,7);
                 printf("Prvok sa v tabulke nenachadza !!!");
                }
              else
                {
                 prv=Read(tab,prv.meno);
                 gotoxy(20,7);
                 printf("Meno : %s\tID : %d",prv.meno,prv.cislo);
                }
              break;
    case 'D': gotoxy(20,5);
              printf("Zadaj kluc : ");
              gets(prv.meno);
              if(!IsIn(tab,prv.meno))
                {
                 gotoxy(20,7);
                 printf("Prvok so v tabulke nenachadza !!!");
                }
              else
                Delete(tab,prv.meno);
              break;
    case 'S': gotoxy(20,5);
              printf("Zadaj kluc : ");
              gets(prv.meno);
              if(IsIn(tab,prv.meno))
                {
                 gotoxy(20,7);
                 printf("Kluc sa v tabulke nachadza.");
                }
              else
                {
                 gotoxy(20,7);
                 printf("Kluc sa v tabulke nenachadza.");
                }
              break;
    default : break;
   }

  printf("\n\nTab   | Kluc     | ID    | Next\n");
  printf("-------------------------------\n");
  for(i=0;i<MAX;i++)
    {
     printf("%d",i);
     if((tab+i)->prvok.meno[0]==NULL)
       {
        printf("\t-1");
        printf("\t   -1\t   -1\n");
       }
     else
       {
        printf("\t%s",(tab+i)->prvok.meno);
        printf("\t   %d",(tab+i)->prvok.cislo);
        printf("\t   0x%x\n",(tab+i)->next);
       }
    }
  printf("\n\nAddr  | Kluc     | ID\n");
  printf("-----------------------\n");
  for(i=0;i<MAX;i++)
    {
     if((otab+i)->prvok.meno[0]==NULL)
       printf("0x%x\t-1\t   -1\t\n",(otab+i));
     else
       printf("0x%x\t%s\t   %d\t\n",(otab+i),(otab+i)->prvok.meno,(otab+i)->prvok.cislo);
    }
  znak=toupper(getch());
 }
 free(tab);
 free(otab);
}

/////////////////////////////////////////////////////////////////////////////
//                           Funkcia IsIn                                  //
//    Vstup : typ TABULKA, a kluc typu char* , Vystup : typ BOOL           //
// Funkcia zistuje podla kluca string, ci sa prvok v tabulke tab nachadza  //
/////////////////////////////////////////////////////////////////////////////

BOOL IsIn(TABULKA tab,char* string)
{
 TABULKA pom;
 int index;

 index=Hash(string);
 pom=tab;
 if(strcmp((tab+index)->prvok.meno,string)==0)
   return TRUE;
 else
   {
    tab=tab+index;
    while(tab->next!=NULL)
      {
       tab=tab->next;
       if(strcmp(tab->prvok.meno,string)==0)
         {
          tab=pom;
          return TRUE;
         }
      }
   }
 tab=pom;
 return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
//                           Funkcia EMPTY                                 //
//    Vstup : typ TABULKA , Vystup : typ TABULKA                           //
// Funkcia vytvori prazdnu tabulku                                         //
/////////////////////////////////////////////////////////////////////////////

void Empty(TABULKA* tab)
{
 int i;

 for(i=0;i<MAX;i++)
   {
    (*tab+i)->prvok.meno[0]=NULL;
    (*tab+i)->next=NULL;
   }
}

/////////////////////////////////////////////////////////////////////////////
//                           Funkcia Hash                                  //
//    Vstup : typ char* (kluc) , Vystup : int                              //
// Funkcia vypocita index do tabulky                                       //
// index= suma hodnot znakov v ASCII tabulke a modulo z tejto sumy je index//
/////////////////////////////////////////////////////////////////////////////

int Hash(char* string)
{
 int i=0,sum=0;
 while(*(string+i)!=0)
    sum+=*(string+i++);
 sum=sum%MAX;
 return sum;
}

/////////////////////////////////////////////////////////////////////////////
//                           Funkcia Insert                                //
//    Vstup : typ TABULKA, kluc typu char*, typ ELM , Vystup : typ TABULKA //
// Funkcia vlozi prvok do tabulky                                          //
/////////////////////////////////////////////////////////////////////////////

TABULKA Insert(TABULKA tab,char* string,ELM prvok)
{
 TABULKA pom;
 int index;

 index=Hash(string);
 if((tab+index)->prvok.meno[0]==NULL)
   {
    strcpy((tab+index)->prvok.meno,string);
    (tab+index)->prvok.cislo=prvok.cislo;
    return tab;
   }
 pom=tab+index;
 while(pom->next!=NULL)
   pom=pom->next;
 pom->next=Vyber();
 if(pom->next!=NULL)
   {
    strcpy(pom->next->prvok.meno,string);
    pom->next->prvok.cislo=prvok.cislo;
    return tab;
   }
 else
   {
    gotoxy(20,7);
    printf("Nie je uz mozne zapisovat !!!");
    return tab;
   }
}

/////////////////////////////////////////////////////////////////////////////
//                           Funkcia Vyber                                 //
//    Vstup : nema ,  TABULKA                                  //
// Moja funkcieadp( pomprvok.ktora hlada a vracia volne miesto z otab                  //
/////////////////////////////////////////////////////////////////////////////

TABULKA Vyber(void)
{
 int i;

 for(i=0;i<MAX;i++)
   if((otab+i)->prvok.meno[0]==0)
     return (otab+i);
 return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//                           Funkcia Read                                  //
//    Vstup : typ TABULKA, a kluc typu char* , Vystup : typ ELM            //
// Funkcia cita prvok z tabulky                                            //
/////////////////////////////////////////////////////////////////////////////

ELM Read(TABULKA tab,char* string)
{
 ELM prvok={"\0",0};
 int index;

 index=Hash(string);
 if(strcmp((tab+index)->prvok.meno,string)==0)
   return (tab+index)->prvok;
 else
   {
    tab=tab+index;
    while(tab->next!=NULL)
      {
       tab=tab->next;
       if(strcmp(tab->prvok.meno,string)==0)
         return tab->prvok;
      }
   }
 return prvok;
}

/////////////////////////////////////////////////////////////////////////////
//                           Funkcia Delete                                //
//    Vstup : typ TABULKA, a kluc typu char* , Vystup : typ TABULKA        //
// Funkcia zrusi prvok v tabulke                                           //
/////////////////////////////////////////////////////////////////////////////

TABULKA Delete(TABULKA tab,char* string)
{
 TABULKA pom1;
 TABULKA pom2;
 int i,index;

 index=Hash(string);
 pom1=tab;

 for(i=0;i<index;i++)
   pom1++;
 pom2=pom1;
 if(strcmp(pom1->prvok.meno,string)==NULL)
   {
    if(pom1->next==NULL)
      {
       pom1->prvok.meno[0]=0;
       return tab;
      }
    else
      {
       strcpy(pom1->prvok.meno,pom1->next->prvok.meno);
       pom1->prvok.cislo=pom1->next->prvok.cislo;
       pom2=pom1->next;
       pom1->next=pom2->next;
       pom2->next=NULL;
       pom2->prvok.meno[0]=NULL;
       return tab;
      }
   }
 else
   {
    while(pom1->next!=NULL)
      {
       pom1=pom1->next;
       if(strcmp(pom1->prvok.meno,string)==0)
         {
          if(pom1->next==NULL)
            {
             pom2->next=0;
             pom1->prvok.meno[0]=0;
             return tab;
            }
          else
            {
             pom1->prvok.meno[0]=0;
             pom2->next=pom1->next;
             pom1->next=NULL;
             return tab;
            }
         }
      }
   }
 return tab;
}

