#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define N 10

typedef struct {
 char kluc[8];
 int udaj;
}POLOZKAT;

typedef struct listprvok {
 POLOZKAT polozka;
 listprvok *dalsi;
}LISTPRVOK;

typedef LISTPRVOK *LIST;
typedef LIST TABULKA[N];

POLOZKAT prvok;
TABULKA tab;
LISTPRVOK zozn,zozn1,zozn2;
LIST akt,akt1,akt2;

int hash(char x[8])
{
 int i=0,sum=0;

 while ((i<=strlen(x)) &&  (i<=7)) {
  sum+=x[i];
  i++;
 }//while
 return(sum % N);
}//hash

void empty(void)
{
 int i;

 for (i=0;i<=(N-1);i++)
  tab[i]=NULL;
 return;
}//empty

int isin(char kl[8])
{
 LISTPRVOK zozn;
 int c;

 c=0;
 akt=tab[hash(kl)];
 while (akt!=NULL) {
  zozn=*akt;
  if (strcmp(zozn.polozka.kluc,kl)==0) {
   c=1;
   return(c);
  }//if
  else
   akt=zozn.dalsi;
 }//while
 return(c);
}//isin

void insert(void)
{
 int trieda;
 LIST sthlava;

 printf("Zadaj hodnotu prvku, ktory chces vlozit:");
 scanf("%d",&prvok.udaj);
 printf("Zadaj kluc prvku s hodnotou %d:",prvok.udaj);
 scanf("%s",prvok.kluc);
 if (!isin(prvok.kluc)) {
  trieda=hash(prvok.kluc);
  sthlava=tab[trieda];
  tab[trieda]=(LIST)malloc(sizeof(LISTPRVOK));
  zozn.polozka=prvok;
  zozn.dalsi=sthlava;
  *tab[trieda]=zozn;
 }//if
 else
  printf("Prvok s klucom %s sa uz v tabulke nachadza.\n",prvok.kluc);
}//insert

void deletep(void)
{
 int trieda;
 char klu[8];

 printf("Zadaj kluc prvku,ktory chces z tabulky vylucit:");
 scanf("%s",klu);
 trieda=hash(klu);
 zozn=*tab[trieda];
 if (tab[trieda]!=NULL) {
  if ((strcmp(zozn.polozka.kluc,klu))==0) {
   tab[trieda]=zozn.dalsi;
   return;
  }//if
  else {
   akt=tab[trieda];
   while (zozn.dalsi!=NULL) {
	zozn1=*zozn.dalsi;
	if ((strcmp(zozn1.polozka.kluc,klu))==0) {
	 zozn.dalsi=zozn1.dalsi;
	 *akt=zozn;
	 return;
	}//if
	else {
	 akt=zozn.dalsi;
	 zozn=*akt;
	}//else
   }//while
  }//else
 }//if
  printf("Prvok s klucom %s sa v tabulke nenachadza.\n",klu);
}//deletep

void read(void)
{
 char klu[8];

 printf("Zadaj kluc prvku, ktoreho hodnotu chces citat:");
 scanf("%s",klu);
 akt=tab[hash(klu)];
 while (akt!=NULL) {
  zozn=*akt;
  if (strcmp(zozn.polozka.kluc,klu)==0) {
   printf("Pod klucom %s je ulozena hodnota %d",klu,zozn.polozka.udaj);
   return;
  }//if
  else
   akt=zozn.dalsi;
 }//while
 printf("Prvok s danym klucom sa v tabulke nenachadza.");
}//read

void isrel(void)
{
  char klu1[8],klu2[8];

  printf("Zadaj prvy kluc:");
  scanf("%s",klu1);
  printf("Zadaj druhy kluc:");
  scanf("%s",klu2);
  if ((!isin(klu1)) || (!isin(klu2))) {
    printf("Jeden s klucov sa nenachadza v tabulke");
    return;
  }//if
  if (hash(klu1)==hash(klu2))
   printf("Kluce %s a %s patria do rovnakej triedy.",klu1,klu2);
  else
   printf("Kluce %s a %s nepatria do rovnakej triedy.",klu1,klu2);
}//isrel

void ponuka(void)
{
 printf("\nPONUKA:\n");
 printf("1. Vlozenie prvku do tabulky\n");
 printf("2. Vymazanie prvku z tabulky\n");
 printf("3. Citanie prvku urceneho danym klucom\n");
 printf("4. Test, ci dva kluce patria do tej istej triedy\n");
 printf("5. Koniec\n");
 printf("VOLBA:");
}//ponuka

void vypis(void)
{
 int j;

 for (j=0;j<=(N-1);j++) {
  akt=tab[j];
  if (akt!=NULL) printf("trieda:%d\n",j);
  while (akt!=NULL) {
   zozn=*akt;
   printf("%d  %s\n",zozn.polozka.udaj,zozn.polozka.kluc);
   akt=zozn.dalsi;
  }//while
 }//for
}//vypis

void main(void)
{
 char b;

 empty();
 ponuka();
 while ((b=getchar())!='5') {
  switch (b) {
   case '1': {
	insert();
	vypis();
	ponuka();
	break;
   }//case1
   case '2': {
	deletep();
	vypis();
	ponuka();
	break;
   }//case2
   case '3': {
	read();
	ponuka();
	break;
   }//case3
   case '4': {
	isrel();
	ponuka();
	break;
   }//case4
   default: break;
  }//switch
 }//while
}//main