/*Martina Kovacikova  17.kruzok
  ZADANIE:
  Implementacia tabulky s vnutornym zretazenim.

SPECIFIKACIA:
 DRUHY:		tab
		elm
		key
		bool

 OPERACIE:	empty	:	      -> tab	;vytvorenie tabulky
		insert	: tab,key,elm -> tab	;vlozenie prvok
		read	:     tab,key -> elm	;vyber prvku
		delete	:     tab,key -> tab	;zrusenie prvku
		isin    :     key,tan -> bool   ;test,ci je prvok v tabulke
*/

#include <stdio.h>
#include <string.h>
#define N 4
#define PRAZDNY '\0'
#define ZRUSENY '*'

typedef char Alfa[8];
typedef struct{
   Alfa kluc;
   int udaj;
}PolozkaT;

typedef PolozkaT Tabulka[4];

Tabulka tabu;

void error(void)
{
   printf("\nCHYBA PRI INSERT!");
}

int hash(Alfa x)                       /*hashovacia funkcia*/
{
  int i,t;
	  for(i=0;x[i]!='\0';i++) t=t+x[i];
  t=t%N;
  return(t);

//  return(x[0]);
}

void empty(void)                          /*vytvorenie prazdnej tabulky*/
{
   int i;
   for (i=0;i<N;i++)
   {
      tabu[i].kluc[0]='\0';
      tabu[i].udaj=0;
   }
}

void vypis(void)                          /*vypis tabulky*/
{
   int i;
   printf("\nTABULKA:");
   for (i=0;i<N;i++)
   {
	printf("\n %8s %d ",tabu[i].kluc,tabu[i].udaj);
   }
}

int rehash(Alfa klu)                      /*funkcia, ktora najde miesto v tabulke odpovedajuce danemu klucu*/
{
   int i,init;
   init = hash(klu);
   i=0;
   while (i < N)
   {
      if (!strcmp(tabu[(init+i)%N].kluc,klu))
      {
	 break;
      }
      if (tabu[(init+i)%N].kluc[0]=='\0')
	 break;
      if (tabu[(init+i)%N].kluc[0]=='*')
	 break;
      i++;
   }
   return((init+i)%N);
}

int isin(Alfa kluc)                       /*zistenie, ci v tabulke existuje prvok s danym klucom*/
{
   int trieda;
   trieda = rehash(kluc);
   if ( !strcmp(tabu[trieda].kluc,kluc) ) return 1;
   else return 0;
}

void insert(PolozkaT prvok)               /*vlozenie polozky do tabulky*/
{
   int trieda;
   trieda = rehash(prvok.kluc);
   if( (tabu[trieda].kluc[0]=='\0')||(tabu[trieda].kluc[0]=='*') )
      tabu[trieda]=prvok;
   else error();
}

void delete(Alfa klu)                     /*vymazanie polozky z tabulky*/
{
   tabu[rehash(klu)].kluc[0]=ZRUSENY;
}

int readx(Alfa kluc)			  /*precitanie udaja prisluchajuceho k danemu klucu*/
{
   return(tabu[rehash(kluc)].udaj);
}

void pis(PolozkaT prvok)		  /*vypis jednej polozky z tabulky*/
{
   printf("\nKluc: %s Udaj: %d",prvok.kluc,prvok.udaj);
}

void main()
{
  PolozkaT prvok;
  Alfa kluc;
  int opakuj;
  char volba;

  empty();
  opakuj = 1;
  while(opakuj)
  {
     printf("\nMENU:");
     printf("\n    (I)NSERT");
     printf("\n    (R)EAD");
     printf("\n    (D)ELETE");
     printf("\n    ISI(N)");
     printf("\n    (K)ONIEC\n");
     scanf("%s",&volba);
     switch (volba)
     {
	case 'i':
	  printf("\nZadaj meno: ");
	  scanf("%s",&prvok.kluc);
	  printf("\nZadaj cislo: ");
	  scanf("%d",&prvok.udaj)(prvok);
	  vypis();
	  break;
	case 'r':
	  printf("\nZadaj meno: l_zoz)))==NULL){
	  scanf("%s",prvok.kluc);
	  if (!isin(prvok.kluc))
	     printf("Prvok s danym klucom neexistuje!");
	  else {
	     prvok.udaj=readx(prvok.kluc);
	     pis(prvok);
	  }
	  break;
	case 'd':
	  printf("\nZadaj meno: ");
	  scanf("%s",kluc);
	  if (!isin(kluc))
	     printf("Prvok s danym klucom neexistuje!");
	  else
	     delete(kluc);
	  vypis();
	  break;
	case  'n':
	  printf("\nZadaj meno: ");
	  scanf("%s",kluc);
	  if(isin(kluc)) printf("\n Prvok je v tabulke!");
	  else printf("\n Prvok nie je v tabulke");
	  break;
	case 'k':opakuj = 0;
	       break;
     }
  }
}