/*-----------------------------------------------------------------------------
  PROGRAMOVACIE TECHNIKY
  Miroslav VOLTEMAR
  Kruzok: 13
-----------------------------------------------------------------------------
Zadanie c.3: Implementacia tabulky s hash rozptylenim pomocou pola smernikov
	     na strukturu
-----------------------------------------------------------------------------
DRUHY:  Tab
	Elm
	Key
	Bool
-----------------------------------------------------------------------------
OPERACIE: EMPTY		       --> Tab   Vytvorenie prazdnej tabulky
	  INSERT : Tab,Key,Elm --> Tab   Vlozenie prvku do tabulky podla
					 hash-funkcie kluca
	  READ   : Tab,Key     --> Elm   Nacitanie prvku podla zadaneho kluca
	  DELETE : Tab,Key     --> Tab   Zmazanie prvku s klucom "Key"
	  ISEG   : Key,Key     --> Bool  Test ci dva kluce si su ekvivalentne
					 (ci su z rovnakej triedy)
	  ISIN   : Key,Tab     --> Bool  Test, ci sa prvok s klucom "Key"
					 nachadza v tabulke
-----------------------------------------------------------------------------
SIGNATURA:








-----------------------------------------------------------------------------
* Tabulka je reprezentovana pomocou struktury:
	{  kluc : char
	   udaj : int
	   smernik na dalsi prvok }
  Smernik na dalsi prvok sa vyuziva, ak padnu dva kluce
  do tej istej triedy, tak sa pomocou smernika zretazia.









-----------------------------------------------------------------------------
*/
#include<stdio.h>;
#include<stdlib.h>:
#include<string.h>:

typedef struct ITEM {
	  char alfa[10];
	  int hod;
	  struct ITEM *dalsi;
	  }item;

typedef item *kde;

 void empty(kde pole[]);
 void insert(kde pole[],char *s,int prvok);
 void delet(kde pole[],char *s);
 kde  read1(kde pole[],char *s);
 int isequal(char *s,char *c);
 int search(kde pole[],char *n);
 int hash(char *s);
 int citaj(char *s);
 void vypis(kde pole[]);

 void main()
 { kde pole[50],p;
   char s[10],s1[10];
   int c,i,x=1;
   empty(pole);
   printf("\n i - insert\n");
   printf(" d - delete\n");
   printf(" e - isequal\n");
   printf(" s - search\n");
   printf(" r - read\n");
   printf(" v - vypis\n");
   printf(" k - koniec  \n ?: ");

   do {
	   c = getchar();
	   switch(c) {
	 case 'i': {if(!citaj(s)) {printf("zadaj vysku: ");
				  scanf("%d",&i);getchar();
				  insert(pole,s,i);
					}
			 break; }
	case 'd' : {if(!citaj(s)) delet(pole,s);
			  break;}
	case 'r' : { if (!citaj(s)) { p=read1(pole,s);
			if(p==NULL) printf("taka neexistuje\n");
				else printf("MENO:%s VYSKA:%d\n",p->alfa,p->hod);
				 }
			   break;}
	case 'e' : { if(!citaj(s) && !citaj(s1)) {
				 if(isequal(s,s1))
				 printf("su si rovne\n"); else
						printf("su rozne");
					}
			 break;}
	case 's' : { if(!citaj(s)) {
			  if(search(pole,s)) printf("nachadza sa tam\n");
				 else printf("neni tam\n");
				 }
			 break;}
	case 'v' : {vypis(pole); getchar(); break;}

	case 'k' : {x=0;break;}
	default : {printf("stlacaj iba funkcne klavesnice\n");break;}
		 }
	if(x!=0) {
	   printf("\n i - insert\n");
	   printf(" d - delete\n");
	   printf(" e - isequal\n");
	   printf(" s - search\n");
	   printf(" r - read\n");
	   printf(" v - vypis\n");
	   printf(" k - koniec  \n ?: ");
		}
	 } while (x!=0);
   }



 void empty(kde pole[])   /*inicializacia tabluky*/
  { int i=0;
	for(;i<106;i++) pole[i]=NULL;
  }


 int hash(char *s){
	return(((s[0]-97)*3+(s[1]-90)/5)/10);
   }

 void insert(kde pole[],char *s,int hodnota){
   kde pom;
   int i;
   if((pom=(kde)malloc(sizeof(item)))==NULL)
			printf("vycerpana pamat\n");
		else {pom->hod=hodnota;
		  strcpy(pom->alfa,s);
		  i=hash(s);
		   pom->dalsi=pole[i];
		   pole[i]=pom;
			}
	}

 int isequal(char *s1,char *s2){
	return((hash(s1)==hash(s2)) ? 1:0);
	}

 kde read1(kde pole[],char *s){
   int i;
   kde pom;
   i=hash(s);pom=pole[i];
	while((pom!=NULL)&&(0!=strcmp(s,pom->alfa)))
		 pom=pom->dalsi;
	return(pom);
	}

 int search(kde pole[],char *s){
   int i;
   kde pom;
   i=hash(s);pom=pole[i];
	while((pom!=NULL)&&(0!=strcmp(s,pom->alfa)))
		 pom=pom->dalsi;
	return((pom==NULL) ? 0 : 1);
	}

 void delet(kde pole[],char *s){
   kde pom,pom1;
   int i;
   i=hash(s);pom=pole[i];
   if(pom==NULL) printf("taky tam nie je\n");
	   else {
	  if(strcmp(pom->alfa,s)==0){ pole[i]=pom->dalsi;
					  free(pom);}
	  else {
	  if(pom->dalsi!=NULL){
		while((0!=strcmp(pom->dalsi->alfa,s))&&(pom->dalsi->dalsi!=NULL))
			  pom=pom->dalsi;
		if(0!=strcmp(pom->dalsi->alfa,s)) printf("niet co deletovat\n");
			  else {
				  pom1=pom->dalsi;
				   pom->dalsi=pom->dalsi->dalsi;
				   free(pom1);
				   }
			 } else
			 printf("neni tam\n");
		  }
	  }
	}

 int citaj(char *s){
   int i=0;
   printf("zadaj meno: ");
   scanf("%9s",s);
   getchar();
   while((s[i]!='\0')&&(s[i]>96)&&(s[i]<123))
	   i++;
   if(s[i]!='\0') {printf("len male pismena\n");
			  return(1);}
		else  return(0);
	 }

 void vypis(kde pole[]){
   kde pom,pom1;
   int i;
   for (i=0;i<10;i++)
	{
	printf("%d ",i);
	pom=pole[i];
	if(pom==NULL) printf("\n",i);
	  else {
		while(pom->dalsi!=NULL)
			 {
			  printf(" MENO:%s V:%d  ",pom->alfa,pom->hod);
			  pom=pom->dalsi;
			 }
			printf(" MENO:%s V:%d  ",pom->alfa,pom->hod);
			printf("\n");
			}
	 }
 }


