/*
Meno    : Martin Chripko
Kruzok  : tlk - 2
Odbor   : Telekomunikacie
Rocnik  : 3
Zadanie : c.4

Signatura

	   Druhy : elm
			   list
			   bool

	   Operacie :
			 empty    :          -> list
			 first    : list     -> list
			 last     : list     -> list
			 next     : list     -> list
			 previous : list     -> list
			 read     : list     -> elm
			 P-insert : list,elm -> list
			 N-insert : list,elm -> list
			 P-delete : list     -> list
			 N-delete : list     -> list
			 isempty  : list     -> bool

*/
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

struct tUzol;
typedef tUzol *ptrUzol;
typedef int tElm;
typedef int bool;

struct tUzol{
	tElm	elm;
	ptrUzol	prev;
	ptrUzol next;
};

// funkcia Empty - Inicializovanie alebo vymazanie zoznamu

ptrUzol Empty()
{
	return NULL;
}

// funkcia First - Spristupnenie cez prvy prvok zoznamu

ptrUzol First( ptrUzol pUzol)
{
	if( pUzol != NULL )
	{
		if( pUzol->prev != NULL ) return(First(pUzol->prev));
		else return pUzol;
	}
	return pUzol;
}

// funkcia Last - Spristupnenie cez posledny prvok zoznamu

ptrUzol Last( ptrUzol pUzol)
{
	if( pUzol != NULL )
	{
		if( pUzol->next != NULL ) return(Last(pUzol->next));
		else return(pUzol);
	}
	return pUzol;
}

// funkcia Next - Spristupnenie cez nasledujuci prvok zoznamu

ptrUzol Next( ptrUzol pUzol)
{
	if( pUzol != NULL )
		return( pUzol->next );
	return pUzol;
}

// funkcia Previous - Spristupnenie cez nasledujuci prvok zoznamu

ptrUzol Previous( ptrUzol pUzol)
{
	if( pUzol != NULL )
		return( pUzol->prev );
	return pUzol;
}

// funkcia Read - Zistenie hodnoty prvku cez ktory je zoznam spristupneny

tElm Read( ptrUzol pUzol)
{
	if( pUzol != NULL )	return pUzol->elm;
	return -1;
}

// funkcia PInsert - Vlozenie noveho prvku pred prvok cez ktory je zoznam spristupneny

ptrUzol PInsert( ptrUzol pUzol, tElm elm)
{
	ptrUzol novy = (ptrUzol)malloc( sizeof( tUzol));
	novy->elm = elm; novy->prev = NULL; novy->next = NULL;
	if( pUzol != NULL )
	{
		novy->prev = pUzol->prev;
		pUzol->prev = novy;
		novy->next = pUzol;
		if( novy->prev != NULL )
			novy->prev->next = novy;
	}
	return novy;
}

// funkcia NInsert - Vlozenie noveho prvku za prvok cez ktory je zoznam spristupnen

ptrUzol NInsert( ptrUzol pUzol, tElm elm)
{
	ptrUzol novy = (ptrUzol)malloc( sizeof( tUzol));
	novy->elm = elm; novy->prev = NULL; novy->next = NULL;
	if( pUzol != NULL )
	{
		novy->next = pUzol->next;
		pUzol->next = novy;
		novy->prev = pUzol;
		if( novy->next != NULL )
			novy->next->prev = novy;
	}
	return novy;
}

// funkcia PDelete - Zmazanie prvku cez ktory je zoznam spristupneny
//					 a spristupnenie zoznamu cez predchadzajuci prvok

ptrUzol PDelete( ptrUzol pUzol)
{
	ptrUzol prev;
	if( pUzol != NULL )
	{
		prev = pUzol->prev;
		if( pUzol->prev != NULL )
			pUzol->prev->next = pUzol->next;
		if( pUzol->next != NULL )
			pUzol->next->prev = pUzol->prev;
		free( pUzol );
		return( prev);
	}
	return pUzol;
}

// funkcia NDelete - Zmazanie prvku cez ktory je zoznam spristupneny
//					 a spristupnenie zoznamu cez nasledujuci prvok


ptrUzol NDelete( ptrUzol pUzol)
{
	ptrUzol next;
	if( pUzol != NULL )
	{
		next = pUzol->next;
		if( pUzol->prev != NULL )
			pUzol->prev->next = pUzol->next;
		if( pUzol->next != NULL )
			pUzol->next->prev = pUzol->prev;
		free( pUzol );
		return( next);
	}
	return pUzol;
}

// funkcia isEmpty - Zistenie ci je zoznam prazdny (true/false)

bool isEmpty( ptrUzol pUzol)
{
	return( pUzol == NULL );
}

// funkcia printZoznam - Vypisovanie zoznamu na obrazovku

void printZoznam( ptrUzol pUzol)
{
	ptrUzol uzol = First( pUzol);
	while( uzol != NULL )
	{
		if( uzol == pUzol ) printf("<%d> ",uzol->elm);
		else printf("%d ",uzol->elm);
		uzol = Next( uzol );
	}
}

void cakaj(){printf("\nStlac daco");getch();}

// Hlavny program

void main()
{
	char menu;
	ptrUzol zoznam,pom;
	tElm elm;

	zoznam = Empty();
	do
	{
		clrscr();
		printZoznam( zoznam);
		printf("\n1.Empty 2.First 3.Last 4.Next 5.Previous 6.Read\n7.pInsert 8.ninSert 9.pDelete 0.ndeleTe isemptY Koniec\nTvoja volba:");
		menu = getch();
		switch( menu)
		{
			case '1':
			case 'e':
					zoznam = First(zoznam);while( zoznam != NULL ) zoznam = NDelete( zoznam );
					zoznam = Empty();
			break;
			case '2':
			case 'f':
					zoznam = First(zoznam);
			break;
			case '3':
			case 'l':
					zoznam = Last(zoznam);
			break;
			case '4':
			case 'n':
					pom = zoznam;
					zoznam = Next(zoznam);
					if( zoznam == NULL )
					{
						printf("\nSme na konci zoznamu !!! Vraciam sa");
						cakaj();
						zoznam = pom;
					}
			break;
			case '5':
			case 'p':
					pom = zoznam; zoznam = Previous(zoznam);
					if( zoznam == NULL )
					{
						printf("\nSme na zaciatku zoznamu !!! Vraciam sa");
						cakaj();
						zoznam = pom;
					}
			break;
			case '6':
			case 'r':
					printf("\nAktualny uzol obsahuje element:%d",Read(zoznam));
					cakaj();
			break;
			case '7':
			case 'i':
					printf("\nZadaj element:");
					scanf("%i",&elm);
					zoznam = PInsert( zoznam, elm);
			break;
			case '8':
			case 's':
					printf("\nZadaj element:");
					scanf("%i",&elm);
					zoznam = NInsert( zoznam, elm);
			break;
			case '9':
			case 'd':
					zoznam = PDelete(zoznam);
			break;
			case '0':
			case 't':
					zoznam = NDelete(zoznam);
			break;
			case 'y':
					if( isEmpty( zoznam) ) printf("\nZoznam je prazdny");
					else printf("\nZoznam nie je prazdny");
					cakaj();
			break;
		}
		while( kbhit() ) getch();
	}while( menu != 'k' );
	// vycistime pamat
	zoznam = First(zoznam);
	while( zoznam != NULL ) zoznam = NDelete( zoznam );
}

