{
**************ZASOBNIK FRONTOV****************
Zadanie cislo 2.
Jan Dolezaj
Kruzok 2 TKL
Odbor Telekomunikacie
Skolsky rok 1998/99

	
        Signatura:
                   queue - front
		   qel - prvok z fronty
                   qelm - element frontu
                   smerqelm - smernik na element frontu
                   stack - zasobnik
		   stackelm - element zasobnika
                   smerstckelm - smernik na element zasobnika
                   bool - boolovsky typ

      	operacie so zasobnikom:

	EMPTY :               -> stack    - zaciatocna inicializacia zasobnika
                                          a vymazanie zasobnika
        PUSH:  stackelm,stack -> stack    - vlozenie noveho prvku do zasobnika
        TOP:            stack -> stackelm - nastavi na vrchol zasobnika
        POP:            stack -> stack    - vymaze prvok	
        ISEMPTYSTCK:    stack -> bool     - zisti ci je prazdny

        operacie s frontom:

        EMPTYQ:               -> queue    - zaciatocna inicializacia a vymazanie
                                          frontu
	ISEMPTYQ:       queue -> bool     - test, ci front je prazdny
        INSERT:    qelm,queue -> queue    - vlozenie noveho prvku
        FIRST:          queue -> qelm     - nastavi sa na prvy prvok frontu
        REMOVE:         queue -> queue    - vymaze prvok z fronty

	reprezentacia:
                        qelm - typ char
                        smerqelm - smernik na element frontu
                        qel - element frontu - struktura s prvkami:
			   udaj - typ qelm
			   dalsi -  smernik typu smerqelm
                        queue - struktura frontu s prvkami
                           zac,kon - smerniky typu smerqel
                        stckelm - element zasobnika - struktura s prvkami:
                           i - typ integer
                           front - struktura typu queue
                        stack - smernik typu stckelm
                        stackelm - struktura zasobnika s prvkami:
                           udaj - typ smerstckelm
                           dalsi - smernik typu stack

}

program stack1 (input,output);

type
        qelm=char;
        smerqelm=^qel;
        qel=record              { element frontu }
               udaj:qelm;
               dalsi:smerqelm;
               end;
        queue=record            { front }
                zac,kon:smerqelm;
                end;

        smerstckelm=^stckelm;
        stckelm=record           { element zasobnika }
               i:integer;
               front:queue;
               end;
        stack=^stackelm;
        stackelm=record          { zasobnik }
                udaj:smerstckelm;
                dalsi:stack;
                end;
var
   menuit:integer;         { premenna pre menu }
   mystack:stack;
   myelm:smerstckelm;      { smernik na element stacku }
   koniec:boolean;

{------------ Cast pre frontu -----------------}

{**********
funkcia isemptyq zisti ci je prazdny front
vrati true ak je prazdny inak false
***********}
function isemptyq( front:queue):boolean;
begin
     isemptyq:= front.zac = nil;
end;

{***************
procedura vymazq vymaze prvky frontu a
uvolni smerniky
****************}
procedure vymazq(var front:queue);
var prev,frontelm:smerqelm;
begin
     if not isemptyq( front ) then
     begin
	frontelm:=front.zac;
	repeat
		prev:=frontelm;
		frontelm:=frontelm^.dalsi;
		dispose(prev);
	until frontelm=nil;
     end;
end;

{***********
procedura emptyq vymaze front
************}
procedure emptyq(var front:queue);
begin
     front.zac:=nil;
     front.kon:=nil;
end;

{**********
procedura insert vlozi novy prvok do fronty
a zmeni smernik na dalsi na nil
***********}
procedure insert(var front:queue;prvok:qelm);
var pom:smerqelm;
begin
      new(pom);
      pom^.udaj:=prvok;
      pom^.dalsi:=nil;
      if isemptyq(front) then    { inicializacia smernikou podla toho }
         front.zac:=pom          { ci je fronta prazdna }
      else
          front.kon^.dalsi:=pom;
      front.kon:=pom;
end;

{************
funkcia first nastavi qelm na prvy prvok vo fronte
*************}
function first(front:queue):qelm;
begin
      if isemptyq(front) then
         begin
              writeln;
              write('first:Queue is empty !!!');
         end
      else
         first:=front.zac^.udaj;
end;

{************
procedura remove vymaze prvy prvok vo fronte
*************}
procedure remove(var front:queue);
var pom:smerqelm;
begin
      if isemptyq(front) then
         begin
              writeln;
              write('remove:Queue is empty !!!');
         end
      else
         begin                             { ak nie je prazdny }
              pom:=front.zac;              { zmenin smerniky }
              front.zac:=front.zac^.dalsi; { nasledujuceho prvku }
              dispose(pom);
         end;
end;

{*************
procedura printfront vypise obsahy jednotlivych
prvkou frontu
**************}
procedure printfront(front:queue);
var frontelm:smerqelm;
begin
     if isemptyq(front) then
         write('Is empty ...')
     else
         begin
              frontelm:=front.zac;
              repeat
                    write(' ',frontelm^.udaj);
                    frontelm:=frontelm^.dalsi;
                    until frontelm=nil;
         end;
end;

{------------------- Cast pre zasobnik ------------------}

{*************
funckcia empty vyprazdni stack
**************}
function empty:stack;
begin
     empty:=nil;
end;

{*************
funkcia isemptystck zistuje ci je stack prazdni
**************}
function isemptystck(zasobnik:stack):boolean;
begin
     isemptystck:= zasobnik = nil;
end;

{**************
procedura vymazz vymaze prvky v zasobniku a
uvolni smerniky
***************}
procedure vymazz(var zas:stack);
var prev,pom:stack;
begin
     if not isemptystck(zas) then
     begin
          pom:=zas;
          repeat
		prev:=pom;
                pom:=pom^.dalsi;
		vymazq(prev^.udaj^.front);
		dispose(prev);
          until pom=nil;
     end;
end;


{*************
funkcia top vrati smernik na posledne zadany prvok
do zasobnika
**************}
function top(zasobnik:stack):smerstckelm;
begin
     if isemptystck(zasobnik) then
         begin
              writeln;writeln('top:Stack is empty !!!');
              top:=nil;
         end
     else top:= zasobnik^.udaj;
end;

{**************
procedura pop vyberie (vymaze)posledne zadany prvok
do zasobnika
***************}
procedure pop(var zasobnik:stack);
var pom:stack;
begin
     if isemptystck(zasobnik) then
        begin
             writeln;
             writeln('pop:Stack is emty !!!');
        end
     else
        begin
             pom:=zasobnik;              { zmenim smerniky }
             zasobnik:=zasobnik^.dalsi;
             dispose(pom^.udaj);
             dispose(pom);
        end;
end;

{***************
procedura push alokuje novy prvok
a inicializuje smerniky
****************}
procedure push(var zasobnik:stack;prvok:smerstckelm);
var pom:stack;
begin
     new(pom);
     if pom=nil then writeln('push:Not enought memory !!!')
     else
         begin
              new(pom^.udaj);                { inicializujem pom. smernik }
              pom^.udaj^.i:=prvok^.i;            { a postupne meni jednotlive }
              pom^.udaj^.front.zac:=prvok^.front.zac;  { smerniky }
              pom^.udaj^.front.kon:=prvok^.front.kon;
              pom^.dalsi:=zasobnik;
              zasobnik:=pom;
         end;
end;

{**************
procedura printstack vypisuje obsah zasobnika
***************}
procedure printstack(zasobnik:stack);
var pom:stack;
begin
     writeln;write('Stack:');
     if isemptystck(zasobnik) then write(' is empty ...')
     else
         begin
              pom:=zasobnik;
              repeat
                    writeln;
                    write(pom^.udaj^.i,':');
                    printfront(pom^.udaj^.front);
                    pom:=pom^.dalsi;
              until pom=nil;
         end;
end;

{---------------- Koniec casti pre zasobnik -------------------}

{**************
funkcia stckmenu vypise na obrazovku menu pre zasobnik
a vrati volbu uzivatela
***************}
function stckmenu:integer;
var c:integer;
begin
        writeln;writeln('Stack menu:');
        write('1.Empty  2.Push  3.Top  4.Pop  5.Queue menu  6.End - Your choice:');
        repeat
              readln(c);
        until ((c>0) and (c<7));
        stckmenu:=c;
end;

{**************
procedura clrscr vymaze jeden riadok
***************}
procedure clrscr;
var i:integer;
begin
     writeln(' ');
end;

{**************
funkcia quemenu vypise na obrazovku menu pre front
a vrati volbu uzivatela
***************}
function quemenu:integer;
var ii:integer;
begin
     writeln;
     writeln('Queue menu:');
     write('1:Empty  2:Insert  3:First  4:Remove  5:End - Your choice:');
     repeat
           readln(ii);
     until ((ii>0) and (ii<6));
     quemenu:=ii;
end;

{*************
procedura qmenu vykona podla volby uzivatela
zvolenu operaciu
**************}
procedure qmenu(var front:queue);
var myqelm:qelm;
    menupol:integer;
begin
     clrscr;
     write('Queue:');
     printfront(front);
     repeat
           menupol:=quemenu;
           clrscr;
           case menupol of
                1:begin
                    vymazq(front);
                    emptyq(front);         { empty }
                  end;
                2:begin                  { insert }
                       writeln;
                       write('Enter queue qlement for inserting(char):');
                       readln(myqelm);
                       clrscr;
                       insert(front,myqelm);
                  end;
                3:begin                   { first }
                       myqelm:=first(front);
                       writeln;
                       write('Element fetched:',myqelm);
                  end;
                4:remove(front);           { remove }
                5:koniec:=true;            { end }
           end;
           write('Queue:');
           printfront(front);
     until koniec;
     clrscr;
end;

{**************
HLAVNA CAST PROGRAMU
***************}
begin
     mystack:=empty;    { inicializacia a vyprazdnenie zasobnika }
     myelm:=nil;
     koniec:=false;
     clrscr;
     repeat
           menuit:=stckmenu;        { nacitanie volby }
           clrscr;
           case menuit of
                1:begin                  { empty }
                       vymazz(mystack);
                       vymazq(myelm^.front);
                       myelm:=nil;
                       mystack:=empty;
                  end;
                2:begin                  { push }
                       writeln;
                       new(myelm);
                       emptyq(myelm^.front);
                       write('Enter element:');
                       readln(myelm^.i);        { nacitam cislo prvku }
                       clrscr;
                       push(mystack,myelm);
                       myelm:=nil;
                  end;
                3:begin                    { top }
                       myelm:=top(mystack);
                       if myelm<>nil then begin
                             writeln;
                             writeln('Element fetched:',myelm^.i,':');
                             printfront(myelm^.front);
                       end;
                  end;
                4:pop(mystack);              { pop }
                5:begin                      { queue menu }
                       if myelm<>nil then
                         qmenu(myelm^.front)
                       else
                         begin
                           writeln('Cannot edit queue');
                           writeln('You have to "top" one from stack');
                         end;
                       koniec:=false;
                  end;
                6:koniec:=true;               { koniec }
           else
               writeln('Try another key....');
           end;
           printstack(mystack);   { vypis obsahu zasobnika }
     until(koniec);
     vymazz(mystack);
end.
