/*
Zadanie cislo 4.
Nazov: STROM
Jan Dolezaj
Kruzok 2 tlk
Odbor Telekomunikacie
Skolsky rok 1998/99

Signatura:
		tVrchol - vrchol stromu	
		tLabel	- label vrcholu	
		tStrom  - strom s vrcholmi
Operacie:
		Empty 			      -> Strom
		Emptyn		Label, Strom  -> Strom
		Koren		       Strom  -> Vrchol
		Predchodca 	Strom, Vrchol -> Vrchol
		LNasledovnik	Strom, Vrchol -> Vrchol
		PNasledovnik	Strom, Vrchol -> Vrchol			
		Hod		Strom, Vrchol -> Label
Reprezentacia:
		tLabel	- typ integer
		tVrchol - struktura s prvkami
				-  Label - typ integer
				-  LNasledovnik - smernik na LNasledovnik
				-  PNasledovnik - smernik na PNasledovnik
		ptrVrchol - smernik na vrchol
		tStrom - smernik na koren stromu
		

*/

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

struct	tVrchol;

typedef	int		tLabel;
typedef	tVrchol		*ptrVrchol;
typedef	ptrVrchol	tStrom;

struct	tVrchol         		//struktura vrcholu
{
	tLabel		Label;
	ptrVrchol	LNasledovnik;
	ptrVrchol	PNasledovnik;
};

/*************
funkcia Empty zinicializuje strom
**************/

tStrom	Empty( tLabel Label)
{
	tStrom	pom;
	pom = (tStrom)calloc( 1, sizeof(tVrchol) );
	if( pom == NULL ) cprintf("\n\rEmpty:Error allocating memory ... system may be unstabile !!!\n\r");
	else pom->Label = Label;
	return pom;
}

/**************
funkcia Empty1 vytvory novy koren pre zadany strom 
***************/

tStrom	Empty1( tLabel Label, tStrom Strom1)
{
	tStrom	pom;
	pom = (tStrom)calloc( 1, sizeof(tVrchol) );
	if( pom == NULL ) cprintf("\n\rEmpty:Error allocating memory ... system may be unstabile !!!\n\r");
	else
	{
		pom->Label = Label;
		pom->LNasledovnik = Strom1;
	}
	return pom;
}

/***************
funkcia Empty2 spoji zadane 2 stromy do jedneho so zadanym korenom
****************/

tStrom	Empty2( tLabel Label, tStrom Strom1, tStrom Strom2)
{
	tStrom	pom;
	pom = (tStrom)calloc( 1, sizeof(tVrchol) );
	if( pom == NULL ) cprintf("\n\rEmpty:Error allocating memory ... system may be unstabile !!!\n\r");
	else
	{
		pom->Label = Label;
		pom->LNasledovnik = Strom1;
		Strom1->PNasledovnik = Strom2;
	}
	return pom;
}

/***************
funkcia Empty3 spoji 3 stromy sa zadanym korenom
****************/

tStrom	Empty3( tLabel Label, tStrom Strom1, tStrom Strom2, tStrom Strom3)
{
	tStrom	pom;
	pom = (tStrom)calloc( 1, sizeof(tVrchol) );
	if( pom == NULL ) cprintf("\n\rEmpty:Error allocating memory ... system may be unstabile !!!\n\r");
	else
	{
		pom->Label = Label;
		pom->LNasledovnik = Strom1;
		Strom1->PNasledovnik = Strom2;
		Strom2->PNasledovnik = Strom3;
	}
	return pom;
}

/*************
funkcia Koren vrati label korena
**************/

ptrVrchol	Koren( tStrom Strom)
{
	return (ptrVrchol)Strom;
}

/*************
funkcia Predchodca vrati label predchodcu daneho vrcholu 
**************/

ptrVrchol	Predchodca( tStrom Strom, ptrVrchol Vrchol)
{
	ptrVrchol	pomv,pom;
	if( Strom == NULL ) return Strom;
	pom=Strom->LNasledovnik;
	while( pom != NULL )
	{
		if( pom == Vrchol ) return Strom;
		pom = pom->PNasledovnik;
	}
	pom = Strom->LNasledovnik;
	while( pom != NULL )
	{
		pomv = Predchodca( pom, Vrchol);
		if( pomv != NULL ) return pomv;
		pom = pom->PNasledovnik;
	}
	return NULL;
}

/************
funkcia LNasledovnik vrati label najlavejsieho nasledovnika
*************/

ptrVrchol	LNasledovnik( tStrom Strom, ptrVrchol Vrchol)
{ Strom=Strom;return Vrchol->LNasledovnik; }

/************
funkcia PNasledovnik vrati label praveho suseda
*************/


ptrVrchol	PNasledovnik( tStrom Strom, ptrVrchol Vrchol)
{ Strom=Strom;return Vrchol->PNasledovnik; }

/************
funkcia Hod vrati ohodnotenie vrcholu
************/

tLabel		Hod( ptrVrchol Vrchol)
{ return Vrchol->Label; }

/************
funkcia freeStrom vymaze vrchol a vsetkych nasledovnikov 
*************/

void	freeStrom( ptrVrchol Vrchol )
{
	ptrVrchol pom,pomfree;
	if( Vrchol == NULL ) return;
	pom = Vrchol->LNasledovnik;
	while( pom != NULL )
	{
		pomfree = pom;
		pom = pom->PNasledovnik;
		freeStrom( pomfree );
	}
	free( Vrchol );
}

/************
funkcia printStrom zobrazenie stromu na obrazovke
*************/

void	printStrom( tStrom Strom, ptrVrchol Vrchol)
{
	ptrVrchol pom1,pom;
	int count,i;
	if( Strom == NULL ) return;
//	cprintf("\n\r");
	if( Vrchol == Strom ) textattr( BLACK | (LIGHTGRAY<<4) );
	cprintf("%d",Strom->Label);
	textattr( LIGHTGRAY | (BLACK<<4) );
	cprintf("\n\r");
	pom = Strom->LNasledovnik;
	while( pom != NULL )
	{
		if( Vrchol == pom ) textattr( BLACK | (LIGHTGRAY<<4) );
		cprintf("%d,",pom->Label);
		textattr( LIGHTGRAY | (BLACK<<4) );
		pom = pom->PNasledovnik;
	}
	cprintf("\n\r");
	pom = Strom->LNasledovnik;count = 0;
	while( pom != NULL )
	{
		for(i=0;i<count;i++) cprintf("  ");
		count++;
		pom1 = pom->LNasledovnik;
		while( pom1 != NULL )
		{
			if( Vrchol == pom1 ) textattr( BLACK | (LIGHTGRAY<<4) );
			cprintf("%d,",pom1->Label);
			textattr( LIGHTGRAY | (BLACK<<4) );
			pom1 = pom1->PNasledovnik;
		}
		pom = pom->PNasledovnik;
		cprintf(" | ");
	}
	cprintf("\n\r");
	textattr( LIGHTGRAY | (BLACK<<4) );
}

/****************************************************************************
		HLAVNA CAST PROGRAMU                 
*****************************************************************************/

void main()
{
	tStrom	mojeStromy[5];
	ptrVrchol	pom,aktVrchol[5];
	int i,aktStrom=0,s1,s2,s3;
	tLabel Label;
	char menu;

	for(i=0;i<5;i++){ mojeStromy[i] = NULL;aktVrchol[i] = NULL; }
	clrscr();
/*
pristup do jednotlivych poloziek MENU
*/
	do
	{
		cprintf("\n\rEmpty eMpty1 emPty2 empTy3 Koren pRedchodca Lnasl pSused Hodnota Zmen strom(0-4)\n\rVloz-lnasl vloz-psUsed kOniec");
		menu = getch();
		switch( menu )
		{
			case 'e':
					freeStrom(mojeStromy[aktStrom]);
					cprintf(" Zadaj Label:");cscanf("%d",&Label);
					mojeStromy[aktStrom] = Empty( Label );
					aktVrchol[aktStrom] = mojeStromy[aktStrom];
					break;
			case 'm':
					freeStrom(mojeStromy[aktStrom]);
					cprintf(" Zadaj Label:");cscanf("%d",&Label);
					cprintf("\n\rZadaj cislo pripojeneho stromu1:");cscanf("%d",&s1);
					mojeStromy[aktStrom] = Empty1( Label, mojeStromy[s1]);
					mojeStromy[s1] = NULL;
					aktVrchol[aktStrom] = mojeStromy[aktStrom];
					break;
			case 'p':
					freeStrom(mojeStromy[aktStrom]);
					cprintf(" Zadaj Label:");cscanf("%d",&Label);
					cprintf("\n\rZadaj cislo pripojeneho stromu1:");cscanf("%d",&s1);
					cprintf("\n\rZadaj cislo pripojeneho stromu2:");cscanf("%d",&s2);
					mojeStromy[aktStrom] = Empty2( Label, mojeStromy[s1], mojeStromy[s2]);
					mojeStromy[s1] = mojeStromy[s2] = NULL;
					aktVrchol[aktStrom] = mojeStromy[aktStrom];
					break;
			case 't':
					freeStrom(mojeStromy[aktStrom]);
					cprintf(" Zadaj Label:");cscanf("%d",&Label);
					cprintf("\n\rZadaj cislo pripojeneho stromu1:");cscanf("%d",&s1);
					cprintf("\n\rZadaj cislo pripojeneho stromu2:");cscanf("%d",&s2);
					cprintf("\n\rZadaj cislo pripojeneho stromu3:");cscanf("%d",&s3);
					mojeStromy[aktStrom] = Empty3( Label, mojeStromy[s1], mojeStromy[s2], mojeStromy[s3]);
					mojeStromy[s1] = mojeStromy[s2] = mojeStromy[s3] = NULL;
					aktVrchol[aktStrom] = mojeStromy[aktStrom];
					break;
			case 'k':
					aktVrchol[aktStrom] = Koren(mojeStromy[aktStrom]);
					break;
			case 'r':
					aktVrchol[aktStrom] = Predchodca( mojeStromy[aktStrom], aktVrchol[aktStrom]);
					break;
			case 'l':
					aktVrchol[aktStrom] = LNasledovnik( mojeStromy[aktStrom], aktVrchol[aktStrom]);
					break;
			case 's':
					aktVrchol[aktStrom] = PNasledovnik( mojeStromy[aktStrom], aktVrchol[aktStrom]);
					break;
			case 'h':
					cprintf("\n\rHodnota aktualneho vrcholu je:%d",Hod(aktVrchol[aktStrom]) );
					getch();
					break;
			case 'z':
					cprintf("\n\rZadaj index stromu, ktory chces pouzivat:");cscanf("%d",&aktStrom);
					break;
			case 'v':
					if( aktVrchol[aktStrom] != NULL )
					{
						cprintf(" Zadaj Label:");cscanf("%d",&Label);
						pom = (ptrVrchol)calloc( 1, sizeof( tVrchol ) );
						pom->Label = Label;
						pom->LNasledovnik = aktVrchol[aktStrom]->LNasledovnik;
						aktVrchol[aktStrom]->LNasledovnik = pom;
					}
					break;
			case 'u':
					if( (aktVrchol[aktStrom] != NULL) && (aktVrchol[aktStrom] != mojeStromy[aktStrom]) )
					{
						cprintf(" Zadaj Label:");cscanf("%d",&Label);
						pom = (ptrVrchol)calloc( 1, sizeof( tVrchol ) );
						pom->Label = Label;
						pom->PNasledovnik = aktVrchol[aktStrom]->PNasledovnik;
						aktVrchol[aktStrom]->PNasledovnik = pom;
					}
					break;
		}
		while( kbhit() ) getch();
		clrscr();
		for( i=0; i<5; i++)
		{
			cprintf("Strom%d:",i);if( aktStrom == i ) cprintf(" <-");
			cprintf("\n\r");
			printStrom( mojeStromy[i], aktVrchol[i]);
		}
	}
	while( menu != 'o' );
	for(i=0;i<5;i++) freeStrom(mojeStromy[i]);
}
