/*
Zadanie cislo 3.
Hash tabulka s otvorenym rozptylom.

Signatura:
                tabulka - hash tabulka s otvorenym rozptylom
		tabELM  - prvok z hash tabulky 
                bool    - boolovsky typ
                kluc    - hashovaci kluc

Operacie:

	Empty                       ->tabulka 
	Isin	    kluc, tabulka   ->bool	
	Insert      tabELM,tabulka  ->tabulka
	Delete      kluc, tabELM    ->tabulka

Reprezentacia:
		       ttabulka    - pole smernikov na tabELM 
		       tabELM      - struktura s prvkami
		                      - kluc  - typu char
				      - data  - typ char
				      - dalsi - smernik na nasledujuci tabELM
                      
                       tkluc       - retazec o dlzke KLUc
		       tdata       - retazec o dlzke DATA
		       *tabELMptr  - smernik na strukturu tabELMptr
  	               adresa      - typ integer
		       *tabulkaptr - smernik na ttabulku
*/
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>

#define	KLUC	4			// dlzka kluca
#define	DATA	10			// dlzka dat
#define	POCET	15			// velkost zoznamu vektorov
#define true	1
#define false	0

struct tabELM;				// potrebna deklaracia

typedef int		bool;
typedef	char		tkluc[KLUC];
typedef	char		tdata[DATA];
typedef	tabELM		*tabELMptr;
typedef	int		adresa;
typedef	tabELMptr	ttabulka[POCET];
typedef	ttabulka	*tabulkaptr;

struct tabELM
{
	tkluc	kluc;
	tdata	data;
	tabELM*	dalsi;
};

char kluc[5],data[5];
//--------------------------------------------------------------
// hlavicky funkcii
//--------------------------------------------------------------
adresa	hash( tkluc kluc);
void	odstranzvysky( tabELMptr zoznam);
void	empty( tabulkaptr tabulka);
void	vycisti( tabulkaptr tabulka);
bool	isin( tkluc kluc, ttabulka tabulka );
bool	iseq( tkluc kluc1, tkluc kluc2 );
void	insert( tabELM prvok, tabulkaptr tabsmer);
tabELM	read( tkluc kluc, ttabulka tabulka );
void	erase( tkluc kluc, tabulkaptr tabsmer);
void	printprvok( tabELM prvok);
void	printtabulku( ttabulka tabulka);

void main()
{
	tabELM pomprvok;
	ttabulka tabulka;
	char menuit;

	sprintf(kluc,"%%%ds", KLUC );
	sprintf(data,"%%%ds", DATA );
	vycisti( &tabulka );
	clrscr();

	do{
		printtabulku( tabulka);
		printf("1.Empty 2.Isin 3.inSert 4.Read 5.Delete 6.koniec");
		menuit = getch();
		while( kbhit() ) getch();
		switch( menuit )
		{
			case '1':
			case 'e':
				empty( &tabulka );
				break;
			case '2':
			case 'i':
				printf("\nZadaj kluc:");
				scanf(kluc,pomprvok.kluc);
				printf("Hladany kluc sa ");
				if( !isin( pomprvok.kluc, tabulka ) ) printf("ne");
				printf("nasiel");
				break;
			case '3':
			case 's':
				printf("\nZadaj kluc:");
				scanf( kluc, pomprvok.kluc);
				printf("Zadaj data:");
				scanf( data, pomprvok.data);
				insert( pomprvok, &tabulka);
				break;
			case '4':
			case 'r':
				printf("\nZadaj kluc:");
				scanf(kluc,pomprvok.kluc);
				if( isin( pomprvok.kluc, tabulka ) )
				{
					pomprvok = read( pomprvok.kluc, tabulka);
					printf("Nasiel sa \"5.Element\":");
					printprvok( pomprvok );
				}
				else
				{
					printf("\"5.Element\" s takym klucom sa v tabulke nenachadza");
				}
				break;
			case '5':
			case 'd':
				printf("\nZadaj kluc:");
				scanf(kluc,pomprvok.kluc);
				erase( pomprvok.kluc, &tabulka);
				break;
			case '6':
				menuit = 'k';
				break;
			default:
				printf("\nSkus inu klavesu ...");
				break;
		}
		while( kbhit() ) getch();
	}while( menuit != 'k' );
}

//--------------------------------------------------------------
// funkcie - implementacie
//--------------------------------------------------------------

/*
funkcia hash - vola sa so zadanym klucik,
vrati umistnenie v hashovacej tabulke
*/

adresa	hash( tkluc kluc)
{
	int i=0;adresa sum=0;
	while( kluc[i] != '\0' ) sum += kluc[i++];
	return sum % POCET;
}

/*
 funkcia odstranzvysky - odstrani zoznam prvkov
*/
void	odstranzvysky( tabELMptr zoznam)
{	
	tabELMptr dalsi;
	do
	{
		dalsi = zoznam->dalsi;
		free( zoznam );
		zoznam = dalsi;
	}while( dalsi != NULL);
}

/*
funkcia empty - vymaze hash tabulku (nastavy smerniky na NULL)
na odstranenie zoznamu vola funkciu odstranzvysky
*/
void	empty( tabulkaptr tabsmer)
{	int i;
	for( i=0; i<POCET; i++)
	{
		if( (*tabsmer)[i] != NULL )
			odstranzvysky( (*tabsmer)[i] );
		(*tabsmer)[i] = NULL;
	}
}

/*
 funkcia vycisti - ako empty ale nekontroluje existenciu 
 zoznamov.tuto funkciu treba pouzit pri 1. inicializacii !!!
*/
void	vycisti( tabulkaptr tabsmer)
{	int i;	
			
	for( i=0; i<POCET; i++)
		(*tabsmer)[i] = NULL;
}

/*
funkcia isin - zistuje ci sa prvok dany klucom
nachadza v tabulke ( vrati TRUE alebo FALSE )
*/

bool	isin( tkluc kluc, ttabulka tabulka )
{	
	tabELMptr zoznam;
	zoznam = tabulka[ hash( kluc ) ];
	while( zoznam != NULL )
	{
		if( iseq( zoznam->kluc, kluc) ) return true;
		zoznam = zoznam->dalsi;
	}
	return false;
}

bool	iseq( tkluc kluc1, tkluc kluc2 )
{
	return( 0 == strncmp( kluc1, kluc2, KLUC ) );
}

/*
funkcia insert - vlozenie noveho prvku s danym klucom, pomocou
funkcie isin zistije ci uz aky klucik nahodou neexistuje
ak nie tak nic nezapise 
*/
void	insert( tabELM prvok, tabulkaptr tabsmer)
{
	adresa trieda;
	tabELMptr starahlava;
	if( isin( prvok.kluc, *tabsmer ) )	// mozme vlozit iba ak taky kluc neexistuje v tabulke
	{
		printf("\nTaky kluc uz v tabulke existuje ... nevkladam ...");
		return;
	}
	// a mozme vlozit
	trieda = hash( prvok.kluc);
	starahlava = (*tabsmer)[ trieda];
	if( NULL == ((*tabsmer)[ trieda] = (tabELMptr)calloc( 1, sizeof(tabELM) ) ) )
	{
		(*tabsmer)[ trieda] = starahlava;
		printf("\nNeda sa alokovat pamat pre novy prvok");
		return;
	}
	memcpy( (*tabsmer)[trieda], &prvok, sizeof(tabELM));	// skopirujeme si prvok do tabulky
	((*tabsmer)[ trieda])->dalsi = starahlava;
	return;
}

tabELM	read( tkluc kluc, ttabulka tabulka )
{
	tabELMptr zoznam;
	zoznam = tabulka[ hash( kluc ) ];
	while( zoznam != NULL )
	{
		if( iseq( zoznam->kluc, kluc) ) return *zoznam;
		zoznam = zoznam->dalsi;
	}
	return *zoznam;
}

/*
funkcia erase - vymaze podla zadaneho kluca dany prvok
skontroluje ci taky prvok vobec existuje, potom ho vymaze
a zmeni prislusne smerniky v zozname 
*/
void	erase( tkluc kluc, tabulkaptr tabsmer)
{
	adresa trieda;
	tabELMptr *staryptr,tofree;
	if( !isin( kluc, *tabsmer ) )	// mozme zmazat iba ak taky kluc existuje v tabulke
	{
		printf("\nTaky kluc v tabulke neexistuje ... nemazem ...");
		return;
	}
	trieda = hash( kluc);
	if( (*tabsmer)[trieda] != NULL )
	{
		staryptr = &((*tabsmer)[trieda]);
		do
		{
			if( 0 == strcmp((*staryptr)->kluc, kluc) )
			{
				printf("\nmazem ...");
				tofree = *staryptr;
				*staryptr = (*staryptr)->dalsi;
				free( tofree );
				return;
			}
			staryptr = &((*staryptr)->dalsi);
		}while( (*staryptr) != NULL );
	}
	printf("\nSem by sme sa nemali dostat !!!!!!");
}

/*
funckia printprvok - vypise na obrazovku jeden prvok
*/
void	printprvok( tabELM prvok)
{
	printf(" ");
	printf( kluc, prvok.kluc);
	printf(":");
	printf( data, prvok.data);
}

/*
funkcia printtabulku - zobrazi celu tabulku a pomocou funkcie
printprvok zobrazi prislusne prvky
*/
void	printtabulku( ttabulka tabulka)
{
	adresa i;
	tabELMptr prvokptr;
	printf("\nAdresa: KLUC:DATA KLUC:DATA ...\n");
	for( i=0; i<POCET; i++ )
	{
		printf("%2d:",i);
		prvokptr = tabulka[i];
		while( prvokptr != NULL )
		{
			printprvok( *prvokptr );
			prvokptr = prvokptr->dalsi;
		}
		printf("\n");
	}
}

