/*

known bugs:
		- verbose levels hihger than 1 have no free memory controlling
		- input argument have to be "syntax-like"



*/




#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int VERBOSE = 0;		//VERBOSE LEVEL (0 - nothing, 1 - somenting 2 - all)
int TABLE_ONLY = 0;		//PRINTS ONLY SYMBOLS WITH CODES

struct Tzoz {
	char symbol;
	char *cojetam;
	int pocet;
	struct Tzoz *horny;
	struct Tzoz *dolny;
	struct Tzoz *pred;
	struct Tpoc *kde;
} *prvy, *novy, *akt, *naj;

struct Tpoc {
	struct Tzoz *kde;
	struct Tpoc *nasl;
	char *kod;
} *root, *last, *public, *new;



void memerror(void);
void PRIDAJ (char co);
void NAPLN (char *co);
void USPORIADAJ(void);
void UROB_STROM(void);
void PRINTIT(void);
struct Tzoz *NAJDI_NAJMENSIE(struct Tzoz *except);
void *CODE(struct Tzoz *actual, char *kam);
void ASSIGN_CODE(void);
void ENCODE(char *vstup);


void HUFFMAN(char *vstup);
char *READFROMFILE(void);
void help(void);


int main (int argc, char *argv[]){
	char *inputstring="\0";
	int bolo=0;
	/*if (argc==1){
		fprintf(stderr,"Prilis malo argumentov\n");
		exit(3);
	}*/
	argv++;argc--;
	while(argc!=0){
		bolo=0;
		if (strcmp(*argv,"-h")==0){
			help();
			exit(0);
		}
		if (strcmp(*argv,"-v")==0){
			VERBOSE=1;
			bolo=1;
		}
		if (strcmp(*argv,"-vv")==0){
			VERBOSE=2;
			bolo=1;
		}
		if (strcmp(*argv,"-t")==0){
			TABLE_ONLY=1;
			bolo=1;
		}
		if (bolo==0){
			if((inputstring=((char *)malloc(strlen(*argv)+1)))==NULL) memerror();
			strcpy(inputstring,*argv);
			break;
		}
		argc--;argv++;
	}
	
	if (strlen(inputstring)!=0) HUFFMAN(inputstring);
	else HUFFMAN("propellerheads - decksandrumsandrockandroll: take california/echo and bounce/velvet pants/better?/oh yeah?/history repeating (featuring miss shirley bassey)/winning style/bang on!/a number of microphones/on her majesty's secret service/bigger?/cominagetcha/spybreak!\0");
	return(0);
}



/*
------------------- funkcie -------------------------------------------
-----------------------------------------------------------------------
*/

/*
------------toto su funkcie, ktore su pre externe vyuzitie aka _PUBLIC_
*/



void HUFFMAN(char *vstup){
	NAPLN(vstup);
	if (VERBOSE>1) printf("ZRETAZENIE PO VSTUPE------------\n");
	if (VERBOSE>1) PRINTIT();
	if (VERBOSE>0) printf("ZRETAZENIE PO USPORIADANI ------\n");
	if (VERBOSE>0) PRINTIT();
	USPORIADAJ();
	UROB_STROM();
	ASSIGN_CODE();
	if ((VERBOSE>0)||(TABLE_ONLY==1)) PRINTIT();
	if (TABLE_ONLY==0) ENCODE(vstup);
	return;
}


void ENCODE(char *vstup){
	while(strlen(vstup)!=0){
		public=root;
		while(1){
			if (*vstup==public->kde->symbol){
				printf("%s",public->kod);
				break;
			}
			public=public->nasl;
		}
		vstup++;
	}
	printf("\n");
	return;
}


/*
------------------help a full memory--------------------------
*/

void help(void){
	fprintf(stdout,"Huffman code encoder v1.13\n");
	fprintf(stdout,"Program designed for Programing Techniques");
	fprintf(stdout,"Parameters and syntax:\n");
	fprintf(stdout,"\nhuffman [options] [input string]\n");
	fprintf(stdout,"where options are:\n\t-v\tfor verbose output\n");
	fprintf(stdout,"\t-vv\tfor more verbose output\n");
	fprintf(stdout,"\t-t\tprints only table with codes for each symbol\n");
	fprintf(stdout,"\twithout any options prints only huffman code to stdout\n");
	fprintf(stdout,"\n[input string] is any string, which will be encoded");
	fprintf(stdout,"\n\nIf this is missing default string is:\n");
	fprintf(stdout,"propellerheads - decksandrumsandrockandroll: take california/echo and bounce/velvet pants/better?/oh yeah?/history repeating (featuring miss shirley bassey)/winning style/bang on!/a number of microphones/on her majesty's secret service/bigger?/cominagetcha/spybreak!\n");
	fprintf(stdout,"\n\n");

}

void memerror(void){
	fprintf(stderr,"Nedostatok pamate\n");
	exit(1);
}


/* 
-----------------Tu su funkcie na napln zoznamov (nie este usporadane)---
--------------------------------------------------------------------------- 
*/

void PRIDAJ (char co){
	public=root;
	if (VERBOSE>1) printf("\tPrehladavam, ci existuje ...\n\t\tV zozname je:");
	while(public!=NULL){
		if (VERBOSE>1) printf("%c,",public->kde->symbol);
		if (public->kde->symbol==co) break;
		public=public->nasl;
	}
	if (VERBOSE>1) printf("\n");
	if (VERBOSE>1) printf("\tKoniec prehladavania");
	if (public!=NULL){
		if (VERBOSE>1) printf("(znak sa nachadza uz) .. exit\n");
		public->kde->pocet++;
		return;
	}
	if (VERBOSE>1) printf("(znak sa este nenachadza) .. alokujem pamat ..");
	if((new=((struct Tpoc *)malloc(sizeof(struct Tpoc))))==NULL) memerror();
	if((novy=((struct Tzoz *)malloc(sizeof(struct Tzoz))))==NULL) memerror();
	if (VERBOSE>1) printf("ok\n\tNaplnam Struktury\n");
	new->nasl=NULL;
	new->kde=novy;
	novy->symbol=co;
	novy->cojetam=NULL;
	novy->kde=new;
	novy->horny=novy->dolny=novy->pred=NULL;
	if (root==NULL) root=new;
	if (last!=NULL) last->nasl=new;
	new->kde->pocet=1;
	new->kod=NULL;
	last=new;
	return;
}

void NAPLN (char *co){
	novy=prvy=akt=NULL;
	new=root=public=NULL;
	if (VERBOSE>0) printf("Vytvaram zoznam znakov ... \n");
	while(strlen(co)!=0){
		if (VERBOSE>0) printf("Pridavam: %c\n",*co);
		PRIDAJ(*co);
		co++;
	}
	return;
}

/* 
-----------------usporiadaj vstupny zoznam podla pocetnosti----------
---------------------------------------------------------------------
		(obycajny bubblesort)
*/

void USPORIADAJ(void){
	int priznak=1;
	struct Tpoc *pred,*succ;
	
	while(priznak==1){
		priznak=0;
		last=root;
		pred=succ=NULL;
		while(last->nasl!=NULL){
			public=last;
			if (public->kde->pocet>public->nasl->kde->pocet){
				priznak=1;
				if (pred==NULL){
					root=public->nasl;
					last=root;
					succ=public->nasl;
					public->nasl=succ->nasl;
					succ->nasl=public;
				}else{
					last=public->nasl;
					succ=public->nasl;
					pred->nasl=public->nasl;
					public->nasl=succ->nasl;
					succ->nasl=public;
				}
			}
			pred=last;
			last=last->nasl;
		}
	}
	return;
}

/*
----------------urob-strom-------------------------------
---------------------------------------------------------
*/

struct Tzoz *NAJDI_NAJMENSIE(struct Tzoz *except){
	int vymena=0;
	int pocet=-1;
	
	naj=NULL;
	last=root;
	while(last!=NULL){
		akt=last->kde;
		if (VERBOSE>1) printf("\tList: %c(%d,%d)\n",akt->symbol,akt->pocet,akt);
		while(akt->pred!=NULL) {
			akt=akt->pred;
			if (VERBOSE>1) printf("\t\tprechadzam na uzol: %s(%d,%d)\n",akt->cojetam,akt->pocet,akt);
		}
		if (((akt->pocet<=pocet)||(pocet==-1))&&(akt!=except)){
			/* ten s mensim pamatovym miestom je vyssie, cize ide prvy */
			if ((naj>akt)||(naj==NULL)){
				if (VERBOSE>1) printf("\t\t-->novy najmensi: %s(%d,%d)\n",akt->cojetam,akt->pocet,akt);
				naj=akt;
				pocet=naj->pocet;
				vymena=1;
			}
		}
		last=last->nasl;
	}
	if ((vymena==0)&&(except!=NULL)) return(NULL);
	return(naj);
}

void UROB_STROM(void){
	struct Tzoz *first, *second;
	
	while (1){
		if (VERBOSE>1) printf("HLADANIE------------------------------------------------\n");
		if (VERBOSE>1) printf("horny -----\n");
		first=NAJDI_NAJMENSIE(NULL);
		if (VERBOSE>1) printf("dolny -----\n");
		if ((second=NAJDI_NAJMENSIE(first))==NULL){
			if (VERBOSE>0) printf("Mame koren, zretazenie je hotove\n");
			prvy=first;
			break;
		}
		if (VERBOSE>0) printf("Najmensie prvky: %c(%d,%d), %c(%d,%d)\n",first->symbol,first->pocet,first,second->symbol,second->pocet,second);
		if((novy=((struct Tzoz *)malloc(sizeof(struct Tzoz))))==NULL) memerror();
		novy->symbol=0;
		novy->horny=first;
		novy->dolny=second;
		novy->pocet=first->pocet+second->pocet;
		novy->cojetam=((char *)malloc(1000));
		if (VERBOSE>0){
			strcpy(novy->cojetam,"");
			if (first->symbol==0) strcat(novy->cojetam,first->cojetam);
				else {
					*(novy->cojetam)=first->symbol;
					*(novy->cojetam+1)=0;
				}
			if (second->symbol==0) strcat(novy->cojetam,second->cojetam);
				else {
					*(novy->cojetam+1)=second->symbol;
					*(novy->cojetam+2)=0;
				}
		}
		novy->pred=NULL;
		first->pred=novy;
		second->pred=novy;
		if (VERBOSE>0) printf("NOVY UZOL: %s(%d,%d)\n", novy->cojetam, novy->pocet, novy);
	}
	
	return;
}


void *CODE(struct Tzoz *actual, char *kam){
	if(actual->horny!=NULL){
		strcat(kam,"0");
		CODE(actual->horny,kam);
	}
	
	if(actual->dolny!=NULL){
		strcat(kam,"1");
		CODE(actual->dolny,kam);
	}
	
	if ((actual->horny==NULL)&&(actual->dolny==NULL)){
		if (VERBOSE>1) printf("Symbol: `%c', Kod: %s\n",actual->symbol,kam); 
		actual->kde->kod=((char *)malloc(sizeof(kam)+2));
		strcpy(actual->kde->kod,kam);
		*(kam+strlen(kam)-1)=0;
		return;
	}
	*(kam+strlen(kam)-1)=0;
	return;
}

void ASSIGN_CODE(void){
	char *kam;
	if ((kam=((char *)malloc(1000)))==NULL) memerror();
	strcpy(kam,"");
	CODE(prvy,kam);
}


/*
-------------------iba taky maly vypis--------------------------
-----------------------------------------------------------------
*/


void PRINTIT(void){
	printf("\n");
	public=root;
	while(public!=NULL){
		printf("Hodnota: `%c', Pocetnost: %2d, ",public->kde->symbol,public->kde->pocet);
		if (public->kod !=NULL) printf("Kod: %s\n",public->kod);
					else printf("(kod este nie je dostupny)\n");
		public=public->nasl;
	}
	printf("\n");
}
