#include <stdio.h>
#include "oz.h"


int parse(char *c,oz* z)
{
	int cislo=0;

	switch ((int) c[0])
	{
		case 'q':
			return 0;
		case 'h':	
			printf("possible commands:\n");
			printf(" q - quit\n");
			printf(" z - print\n");
			printf(" r - active\n");
			printf(" o - pop            p - push\n");
			printf(" f - first          l - last\n");
			printf(" s - succ           u - pred\n");
			printf(" a - postdelete     b - predelete\n");
			printf(" c - deletefirst    d - deletelast\n");
			printf(" e - postinsert     m - preinsert\n");
			printf(" g - insertfirst    i - insertlast\n");
			printf(" j - copyfirst      k - copylast\n");
			break;
		case 'z':
			z->print();
			break;
		case 'r':
			(z->active()) ?
				printf("OZ je aktivny\n"):
				printf("OZ nie je aktivny\n");
			break;
		case 'p':
			scanf("%d",&cislo);
			if (z->actualize(cislo)<0) printf("Nemozno vlozit cislo do zasobnika\n");
			break;
		case 'o':
			cislo = z->copy();
			if (cislo<0) printf("Nemozno vytiahnut cislo zo zasobnika\n");
			else printf("Vytiahli sme cislo %d\n",cislo);
			break;
		case 'f':
			if (z->first()<0) printf("Zoznam nie je aktivny\n");
			break;
		case 'l':
			if (z->last()<0) printf("Zoznam nie je aktivny\n");
			break;
		case 's':
			if (z->succ()<0) printf("Zoznam nie je aktivny alebo sme na jeho konci\n");
			break;
		case 'u':
			if (z->pred()<0) printf("Zoznam nie je aktivny alebo sme na jeho zaciatku\n");
			break;
		case 'a':
			if (z->postdelete()<0) printf("Nemozno zmazat nasl. prvok\n");
			break;
		case 'b':
			if (z->predelete()<0) printf("Nemozno zmazat predch. prvok\n");
			break;
		case 'c':
			if (z->deletefirst()<0) printf("Nemozno zmazat prvy prvok\n");
			break;
		case 'd':
			if (z->deletelast()<0) printf("Nemozno zmazat posl. prvok\n");
			break;
		case 'e':
			scanf("%d",&cislo);
			if (z->postinsert(cislo)<0) printf("Nemozno pridat zasobnik za aktualny prvok\n");
			break;
		case 'm':
			scanf("%d",&cislo);
			if (z->preinsert(cislo)<0) printf("Nemozno pridat zasobnik pred aktualny prvok\n");
			break;
		case 'g':
			scanf("%d",&cislo);
			if (z->insertfirst(cislo)<0) printf("Nemozno pridat zasobnik na zac. zoz.\n");
			break;
		case 'i':
			scanf("%d",&cislo);
			if (z->insertlast(cislo)<0) printf("Nemozno pridat zasobnik na kon. zoz.\n");
			break;
		case 'j':
			cislo = z->copyfirst();
			if (cislo<0) printf("Nemozno vytiahnut cislo zo zasobnika\n");
			else printf("Vytiahli sme cislo %d\n",cislo);
			break;
		case 'k':
			cislo = z->copylast();
			if (cislo<0) printf("Nemozno vytiahnut cislo zo zasobnika\n");
			else printf("Vytiahli sme cislo %d\n",cislo);
			break;
		default:
			printf("type `help' for help\n");
	}
	return 1;
}

int main(int argc, char *argv[])
{
	oz z;

	char c[10]="h";
	argc++;

	printf("Obojsmerne zretazeny zoznam zasobnikov\n");

	while (parse(c,&z))
	{
		printf("%s> ",argv[0]);
		scanf("%9s",c);
	}
	return 0;
}
