#include "oz.h"

int oz::actualize(int h)
{
	if (active()) return eact->push(h);
	else return -2;  // ak zoz nie je aktivny
}

int oz::copy()
{
	if (active()) return eact->pop();
	else return -2;  // ak zoz nie je aktivny
}

int oz::first()
{
	if (!active()) return -2; // ak zoz nie je aktivny
	eact = efirst;
	return 0;
}

int oz::last()
{
	if (!active()) return -2; // ak zoz nie je aktivny
	eact = elast;
	return 0;
}

int oz::succ()
{
	if (!active()) return -2; // ak zoz nie je aktivny
	if (!eact->getnptr()) return -1; // ak nema nasledovnika
	eact = eact->getnptr();
	return 0;
}

int oz::pred()
{
	if (!active()) return -2; // ak zoz nie je aktivny
	if (!eact->getpptr()) return -1; // ak nema predchodcu
	eact = eact->getpptr();
	return 0;
}

int oz::predelete()
{
	elm* tmp;
	if (!active()) return -2; // ak zoz nie je aktivny
	if (!(tmp = eact->getpptr())) return -1;  // ak nema predchodcu
	if (tmp->getpptr())  // ak ma mazany prvok predchodcu
	{
		eact->setpptr(tmp->getpptr());
		(tmp->getpptr())->setnptr(eact);
	}
	else // mazany prvok bol prvy
	{
		eact->setpptr(NULL);
		efirst = eact;
	}
	delete tmp;
	return 0;
}

int oz::postdelete()
{
	elm* tmp;
	if (!active()) return -2; // ak zoz nie je aktivny
	if (!(tmp = eact->getnptr())) return -1; // ak nema nasledovnika (tmp)
	if (tmp->getnptr()) // ak ma mazany nasledovnik nasledovnika
	{
		eact->setnptr(tmp->getnptr());
		(tmp->getnptr())->setpptr(eact);
	}
	else // ak je mazany prvok posledny
	{
		eact->setnptr(NULL);
		elast = eact;
	}
	delete tmp;
	return 0;
}

int oz::deletefirst()
{
	elm* tmp;
	if (!active()) return -2; // ak zoz nie je aktivny
	if (!(tmp = efirst->getnptr())) // ak je efirst jediny
	{
		delete efirst;
		eact = NULL;
		return 0;
	}
	delete efirst;
	if (eact == efirst) eact = tmp;
	efirst = tmp;
	efirst->setpptr(NULL);
	return 0;
}

int oz::deletelast()
{
	elm* tmp;
	if (!active()) return -2; // ak je zoz neaktivny
	if (!(tmp = elast->getpptr())) // ak posl. prvok ne predchodcu
	{
		delete elast;
		eact = NULL;
		return 0;
	}
	delete elast;
	if (eact == elast) eact = tmp;
	elast = tmp;
	elast->setnptr(NULL);
	return 0;
}

int oz::postinsert(int stlen)
{
	int status;
	elm* tmp;
	if (!active()) return -2; // ak je zoz neaktivny
	tmp = new elm(stlen,status); // vytvorime novy prvok
	if (!tmp || status) return -1; // nie je dostatok pamate
	// tu uz je alokovana jednotka tmp
	tmp->setnptr(eact->getnptr());
	tmp->setpptr(eact);
	if (eact->getnptr()) (tmp->getnptr())->setpptr(tmp);	
	else elast = tmp;
	eact->setnptr(tmp);
	return 0;
}
		
int oz::preinsert(int stlen)
{
	int status;
	elm* tmp;
	if (!active()) return -2; // ak zoz nie je aktivny
	tmp = new elm(stlen,status);
	if (!tmp || status) return -1;
	// tu uz je alokovan jednotka tmp
	tmp->setnptr(eact);
	tmp->setpptr(eact->getpptr());
	if (eact->getpptr()) (tmp->getpptr())->setnptr(tmp);
	else efirst = tmp;
	eact->setpptr(tmp);
	return 0;
}

int oz::insertfirst(int stlen)
{
	int status;
	elm* tmp;
	tmp = new elm(stlen,status);
	if (!tmp || status) return -1;
	// tu uz je alokovana jednotka tmp
	if (active())
	{
		tmp->setnptr(efirst);
		efirst->setpptr(tmp);
		efirst = tmp;
	}
	else
	{
		efirst = tmp;
		elast = tmp;
		eact = tmp;
	}
	return 0;
}

int oz::insertlast(int stlen)
{
	int status;
	elm* tmp;	
	tmp = new elm(stlen,status);
	if (!tmp || status) return -1;
	// tu uz je alokovana jednotka tmp
	if (active())
	{
		tmp->setpptr(elast);
		elast->setnptr(tmp);
		elast = tmp;
	}
	else
	{
		elast = tmp;
		efirst = tmp;
		eact = tmp;
	}
	return 0;
}

int oz::copyfirst()
{
	if (active()) return efirst->pop();
	else return -2;
}

int oz::copylast()
{
	if (active()) return elast->pop();
	else return -2;
}

void oz::print()
{
	int i,j;
	elm* x;
	x = efirst;
	if (!active())
	{
		printf("Zoznam nie je aktivny\n");
		return;
	}
	putchar('\n');		
	for (i=0; i<8; ++i)
	{
		if (x == eact) break;
		else x = x->getnptr();
	}
	if (i == 7)
	{
		printf("Aktualny prvok by nam uz nevosiel na obrazovku\n");
		return;
	}
	for (j=0; j<(i*10)+10; ++j) putchar(' ');
	printf("*\n     ");
	x = efirst;
	putchar('+');
	for (j=0; j<7; ++j)
	{
		printf("---------+");
		if (!(x = x->getnptr())) break;	
	}
	putchar('\n');		
	x = efirst;
	printf("top: ");
	for (j=0; j<7; ++j)
	{
		if ((i=x->top())<0) printf("    ---   ");
		else printf("%8d  ",i);
		if (!(x = x->getnptr())) break;
	}
	putchar('\n');
}
