{ Meno    : Martin Chripko
  Kruzok  : Tlk - 2
  Zadanie : c.3
  Odbor   : Telekomunikacie

 SPECIFIKACIA:
 DRUHY:		tab
		elm
		key
		bool

 OPERACIE:	empty	:	      -> tab	;vytvorenie tabulky
		insert	: tab,key,elm -> tab	;vlozenie prvku
		read	:     tab,key -> elm	;vyber prvku
		delete	:     tab,key -> tab	;zrusenie prvku
		isin    :     key,tab -> bool   ;test,ci je prvok v tabulke
}




program hashtab(input,output);

uses crt;

const
	KLUC = 4;			{ dlzka kluca }
	DATA = 10;			{ dlzka dat }
	POCET = 15;			{ velkost zoznamu vektorov }

type
        tkluc = array[0..KLUC] of char;
        tdata = array[0..DATA] of char;
        tabELMptr = ^tabELM;
        tabELM = record
               kluc : tkluc;
               data : tdata;
               dalsi : tabELMptr;
               end;
        adresa = integer;
        ttabulka = array [0..POCET] of tabELMptr;

var pomprvok:tabELM;
    prvokptr:tabELMptr;
    tabulka:ttabulka;
    kluc1:tkluc;
    menuit:char;
    sem:text;
{--------------------------------------------------------------}

{ **** Hashovacia funkcia tabulky **** }

function hash( kluc:tkluc):adresa;
var i:integer;
    sum:adresa;
begin
	i:=0;sum:=0;
	while( ord(kluc[i]) <> 0 ) do
        begin
             sum := sum + ord(kluc[i]);
             i := i + 1;
        end;
	hash := sum mod POCET;
end;

{ Procedure odstran zvysky  - Odstranenie obsahu tabulky ( Riadku ) }

procedure odstranzvysky( zoznam:tabELMptr);
var dalsi:tabELMptr;
begin
	repeat
		dalsi := zoznam^.dalsi;
		dispose( zoznam );
		zoznam := dalsi;
	until( dalsi <> NIL);
end;

{ **** Procedure Empty **** }

procedure empty( var tab:ttabulka);
var i:integer;
begin
     for i:=0 to POCET do
     begin
          if( tab[i] <> NIL ) then odstranzvysky( tab[i] );
          tab[i] := NIL;
     end;
end;

{ **** Procedure Vycisti **** }

procedure vycisti( var tab:ttabulka);
var i:integer; begin for i:=0 to POCET do tab[i] := NIL; end;

function iseq( kluc1:tkluc; kluc2:tkluc):boolean;
var i:integer;
begin
     i := 0;
     iseq := true;
     while( (i < KLUC) and (ord(kluc1[i]) <> 0) and (ord(kluc2[i]) <> 0)) do
     begin
          if( kluc1[i] <> kluc2[i] ) then iseq := false;
          i := i + 1;
     end;
     if( (ord(kluc1[i]) <> 0) or (ord(kluc2[i]) <> 0) ) then iseq := false;
end;


function isin( kluc:tkluc; tabulka:ttabulka):boolean;
var zoznam:tabELMptr;
begin
     zoznam := tabulka[ hash(kluc) ];
     isin := false;
     while( zoznam <> NIL ) do
     begin
          if( iseq( zoznam^.kluc, kluc) ) then isin:=true;
          zoznam := zoznam^.dalsi;
     end;
end;

{ **** Procedure Insert **** }

procedure insert( prvok:tabELM; var tab:ttabulka);
var trieda:adresa;starahlava:tabELMptr;
begin
     if( isin( prvok.kluc, tab) ) then
          writeln('Taky kluc uz v tabulke existuje ... nevkladam ...')
     else
         begin
         trieda := hash( prvok.kluc);
         starahlava := tab[ trieda];
         new( tab[ trieda] );
         if( tab[ trieda] = NIL ) then
             begin
                  tab[ trieda] := starahlava;
		  writeln('Neda sa alokovat pamat pre novy prvok');
                  readkey;
             end
         else
             begin
                  tab[ trieda]^.kluc := prvok.kluc;
                  tab[ trieda]^.data := prvok.data;
                  tab[ trieda]^.dalsi := starahlava;
             end;
         end;
end;

function readp( kluc:tkluc; tab:ttabulka):tabELMptr;
var zoznam:tabELMptr;
begin
     zoznam := tab[ hash( kluc) ];
     readp := nil;
     while( zoznam <> NIL ) do
     begin
          if( iseq( kluc, zoznam^.kluc) ) then readp := zoznam;
          zoznam := zoznam^.dalsi;
     end;
end;

{ **** Procedure Erase **** }

procedure erase( klucik:tkluc; var tab:ttabulka);
var trieda:adresa;staryptr:tabELMptr;tofree:tabELMptr;
begin
     if( not isin( klucik, tab) ) then
          writeln('Taky kluc v tabulke neexistuje ... nemazem ...')
     else
         begin
              trieda := hash( klucik );
              if( iseq( tab[ trieda]^.kluc, klucik ) ) then
              begin
                   writeln('mazem ...');
                   tofree := tab[ trieda];
                   tab[ trieda] := tab[ trieda]^.dalsi;
                   dispose( tofree );
              end
              else
              begin
                   staryptr := tab[ trieda];
                   if( (staryptr <> NIL) and (staryptr^.dalsi <> NIL) ) then
                   begin
                   repeat
                         if( iseq( staryptr^.dalsi^.kluc, klucik ) ) then
                         begin
                              writeln('mazem ...');
                              tofree := staryptr^.dalsi;
                              staryptr^.dalsi := staryptr^.dalsi^.dalsi;
                              staryptr := staryptr^.dalsi^.dalsi;
                              dispose( tofree );
                         end
                         else
                             staryptr := staryptr^.dalsi;
                   until( staryptr^.dalsi = NIL );
                   end;
              end;
         end;
end;

procedure printkluc( klucik:tkluc);
var i:integer;
begin
     i:=0;
     while( (ord(klucik[i]) <> 0 ) and (i<KLUC)) do
     begin
          write(klucik[i]);i:=i+1;
     end;
end;

procedure printdata( dataa:tdata);
var i:integer;
begin
     i:=0;
     while( (ord(dataa[i]) <> 0 ) and (i<DATA)) do
     begin
          write(dataa[i]);i:=i+1;
     end;
end;

procedure printprvok( prvok:tabELM );
begin
     write(' ');
     printkluc( prvok.kluc);
     write(':');
     printdata(prvok.data);
end;

procedure printtabulku( tab:ttabulka );
var i:integer;prvokptr:tabELMptr;
begin
     writeln('Adresa: KLUC:DATA KLUC:DATA ...');
     for i:=0 to POCET do
     begin
          write(i); prvokptr := tab[i];
          while( prvokptr <> NIL ) do
          begin
               printprvok( prvokptr^ );
               prvokptr := prvokptr^.dalsi;
          end;
          writeln('');
     end;
end;

procedure citajkluc( var sem:tkluc );
var i:integer;
begin
     i := 0;
     while( i<KLUC ) do
     begin
          sem[i] := readkey;
          write( sem[i] );
          if( ord(sem[i]) = 13 ) then begin sem[i] := chr(0); i := KLUC;end
          else i := i + 1;
     end;
end;

procedure citajdata( var sem:tdata );
var i:integer;
begin
     i := 0;
     while( i<DATA ) do
     begin
          sem[i] := readkey;
          write( sem[i] );
          if( ord(sem[i]) = 13 ) then begin sem[i] := chr(0); i := DATA;end
          else i := i + 1;
     end;
end;

{===================================================================}

begin
     vycisti( tabulka );
     repeat
           writeln('');
           printtabulku( tabulka );
           writeln('1.Empty 2.Isin 3.inSert 4.Read 5.Delete 6.iseQ 7.Koniec');
           menuit := readkey;
           {write( menuit );}
           case menuit of
                '1','e':
		    empty( tabulka );
                '2','i':
                    begin
		         write('Zadaj kluc:');
                         citajkluc( pomprvok.kluc );
		         write('Hladany kluc sa ');
		         if( not isin( pomprvok.kluc, tabulka ) ) then write('ne');
                         write('nasiel');
		    end;
                '3','s':
                    begin
		         write('Zadaj kluc:');
                         citajkluc( pomprvok.kluc );
                         writeln('');
		         write('Zadaj data:');
                         citajdata( pomprvok.data );
                         insert( pomprvok, tabulka);
		    end;
                '4','r':
                    begin
		         write('Zadaj kluc:');
                         citajkluc( pomprvok.kluc );
                         if( isin( pomprvok.kluc, tabulka ) ) then
                         begin
                              prvokptr := readp( pomprvok.kluc, tabulka);
                              write('Nasiel sa prvok:');
                              printprvok( prvokptr^ );
                         end
                         else
                              write('Prvok s takym klucom sa nenasiel:');
                    end;
                '5','d':
                    begin
		         write('Zadaj kluc:');
                         citajkluc( pomprvok.kluc );
                         erase( pomprvok.kluc, tabulka );
                    end;
                '6','q':
                    begin
		         write('Zadaj kluc1:');
                         citajkluc( pomprvok.kluc );
                         writeln('');
		         write('Zadaj kluc2:');
                         citajkluc( kluc1 );
                         write('Kluce su ');
                         if( iseq( pomprvok.kluc, kluc1) ) then write('rovnake')
                         else write('nerovnake');
                    end;
                '7':
                    begin
                         menuit:='k';
                         empty(tabulka);
                    end;
           else
               writeln('Skus inu klavesu ...');
           end;
     until(menuit = 'k');
end.

