

/*
ZRETAZENA VOLNA PAMET ROVNAKYCH PRVKOV

Zadanie cislo : 1.
Meno          : Martin Chripko
Kruzok        : TLK-2
Odbor         : Telekomunikacie
Rocnik        : 4
Skolsky rok   : 1999/2000


	Signatura: 
		
	ZVP - zretaz. volna pamat
	polozka - prvok zo ZVP
	bool - boolovsky typ
	
	operacie
	
	EMPTY :               -> ZVP       - zaciatocne zretazenie volnej pamati Z
	ISEMPTY:          ZVP -> bool      - test, ci ZVP obsahuje volny prvok
	NEW:              ZVP -> bunka     - poskytnutie pameti
	DISPOSE:   bunka, ZVP -> ZVP       - uvolnenie obsadeneho prvku ZVP

	reprezentacia:	

	polozka - struktura s prvkami:
	hodnota - typu char
	nasl -  typu integer
	ZVP - pole s 23 prvkami typu bunka

*/
#include<stdio.h>

#include<conio.h>

struct bunka {
	char hodnota;
	int nasl;
	};

#define NODATA	' '
#define DATA	'#'
#define MAXZVP	23
#define ZVPEND	-1

typedef bunka* zvpt;

int prvyvolny;

/* Empty - Inicializuje zretazenu volnu pamet */

void empty( zvpt zvp)
{
 int i;
 for( i=0; i<MAXZVP; i++ )
   zvp[i].hodnota = NODATA;
 for( i=0; i<MAXZVP-1; i++ )
   zvp[i].nasl = i+1;
 zvp[i].nasl = ZVPEND;
 prvyvolny = 0;
}

/*New - obsadi jeden prvok v ZVP a vrati smernik na prvy volny */

int newone(zvpt zvp)
{
 if( prvyvolny == ZVPEND )
 {
  printf("\nUz sa neda obsadit !!! (plna pamat)");
  return prvyvolny;
 }
 int ret = prvyvolny;
 prvyvolny = zvp[prvyvolny].nasl;
 return ret;
}

/* Isempty - Zisti ci je ZVP volna ak ano vrati True ak nie tak False */

int isempty(zvpt zvp)
{
 int i = prvyvolny, pocet = 1;
 while( zvp[i].nasl != ZVPEND ){i=zvp[i].nasl; pocet++;}
 if( pocet < MAXZVP ) return 0;		// FALSE
 else return 1;				// TRUE
}

/* Dispose - Uvolni zadany prvok pokial je obsadeny  */

void dispose(zvpt zvp,int tento)
{
 if( prvyvolny != ZVPEND )
 {
  int i = prvyvolny;
  do
  {
   if( i == tento )
   {
	printf("\nElement %d sa neda uvolnit ==> nie je obsadeny !!!",tento);
	return;
   }
  }while( (i=zvp[i].nasl) != ZVPEND );
 }
 zvp[tento].nasl = prvyvolny;zvp[tento].hodnota = NODATA;
 prvyvolny = tento;
}


/* Hlavny program */

void main()
{
bunka zvp[MAXZVP];
int a;
int i,key;
empty(zvp);                     /* Inicializacia pamate ZVP */
clrscr();
while(1)
 {

	printf("\n");
	for( i=0; i<prvyvolny; i++ ) printf("   ");
	printf(" %c\n", prvyvolny == ZVPEND?' ':'V' );
	for( i=0; i<MAXZVP; i++ ) printf("%2d ",i);
	printf("\n");
	for( i=0; i<MAXZVP; i++ ) printf(" %c ",zvp[i].hodnota);
	printf("\n");
	for( i=0; i<MAXZVP; i++ ) printf("%2d ",zvp[i].nasl);
	printf("\nMenu:  ");
	printf("\n     1. New");
	printf("\n     2. Dispose");
	printf("\n     3. Empty");
	printf("\n     4. IsEmpty");
	printf("\n     5. End\n");
	printf("Vasa volba: ");
	key = getche();
	switch( key )
	{
		  case '1': i=newone(zvp);zvp[i].hodnota=DATA;
			break;

		  case '2': printf("\nKtory prvok chces uvolnit ? ");
			scanf("%d",&i);dispose(zvp,i);
			break;

		  case '3': empty(zvp);
			break;

		  case '4': printf("\nFunkcia IsEmpty vrati:%s",isempty(zvp) ? "True" : "False");
			break;

		  case '5':
				printf("\n\nKoniec !!!");
				return;

		  default :
				printf("\nNespravna volba . Stlacte cislo podla menu !!!");
				break;
	}
	printf("\n\nStlacte Enter !!!");
	getch();
	clrscr();

  }
}
