#include <strings.h>
#include <stdio.h>
#include "tab.h"


int hash(char *nkey)
{
	unsigned int i;
	int sum = 0;

	for ( i = 0 ; (i < L) && (i < strlen(nkey)) ; ++i )
		sum += nkey[i];

	return sum % N;
}

int del(tab *t, int i)
{
	polz1 *nova;

	nova = t[i];
	if (nova == NULL)
		return 0;
	t[i] = nova->next;
	delete nova;
	return 1;
}

void destr(tab *t)
{
	int i;

	for ( i = 0 ; i < N ; i++ )
		while (del(t, i));
}

void empty(tab *t)
{
	int i;
	for ( i = 0 ; i < N ; i++ )
		t[i] = NULL;
}

int search(char *nkey, tab *t)
{
	polz1 *nova;
	int adr;

	adr = hash(nkey);

	if ((nova = t[adr]) == NULL) return 0;

	while (nova->next && strcmp(nkey, nova->key))
		nova = nova->next;

	return !strcmp(nkey, nova->key);
}

int insert(tab *t, char *nkey, elm what)
{
	polz1 *nova;
	int adr;
	adr = hash(nkey);

	if (search(nkey, t)) return -1;

	nova = new polz1;
	
	strcpy(nova->key, nkey);
	nova->hodnota = what;
	nova->next = t[adr];

	t[adr] = nova;
	return 0;
} 

int deletet(tab *t, char *nkey)
{
	polz1 *nova;
	polz1 *predosl;

	int adr;
	adr = hash(nkey);

	if (!search(nkey, t)) return -1;

	predosl = t[adr];
	nova = t[adr];

	if (strcmp(nkey, nova->key) == 0)
	{
		t[adr] = nova->next;
		delete nova;
		return 0;
	}	
	
	nova = nova->next;

	do 
	{
		if (strcmp(nkey, nova->key) == 0) /* search zaruci aspon jeden vyskyt */
		{
			predosl->next = nova->next;
			delete nova;
			break;
		}

		predosl = nova;
		nova = nova->next;
	} while(1);
	return 0;
}

int iseq(char *nkey1, char *nkey2)
{
	return hash(nkey1) == hash(nkey2);
}	

elm readt(tab *t, char *nkey)
{
	polz1 *nova;
	int adr;
	adr = hash(nkey);

	if (!search(nkey, t)) return -1;
	
	nova = t[adr];

	while (strcmp(nkey, nova->key))
		nova = nova->next;

	return nova->hodnota;
}
 
