// Vyhladavaci strom, morzeovka ... (c) 1995 Radovan Semancik

#include <iostream.h>

class TBinTreeNode
{
protected:
	TBinTreeNode* left;
	TBinTreeNode* right;
public:
	TBinTreeNode(TBinTreeNode* lsuc,TBinTreeNode* rsuc) {left=lsuc; right=rsuc;};
	TBinTreeNode* getLeft() {return left;};
	TBinTreeNode* getRight() {return right;};
	void setLeft(TBinTreeNode* node) {left=node;};
	void setRight(TBinTreeNode* node) {right=node;};
	int isLeaf() {return ((left==NULL) && (right==NULL));};
	virtual void print(int lvl);
};

class TBinCharNode
{
protected:
	TBinCharNode* left;
	TBinCharNode* right;
	char val;
public:
	TBinCharNode(TBinCharNode* lsuc,TBinCharNode* rsuc, char v) {left=lsuc; right=rsuc; val=v;};
	TBinCharNode(char v) {left=right=NULL; val=v;};
	TBinCharNode* getLeft() {return left;};
	TBinCharNode* getRight() {return right;};
	void setLeft(TBinCharNode* node) {left=node;};
	void setRight(TBinCharNode* node) {right=node;};
	void setVal(char v) {val=v;};
	char getVal() {return val;};
	int Search(char *s, int lvl, char c);
	virtual void print(int lvl);
};

// **************

void TBinTreeNode::print(int lvl)
{
	int i;

	for(i=0;i<lvl;i++) cout << '\t';
	if (left!=NULL) {
		cout << "<left>\n";
		left->print(lvl+1);
	}
	for(i=0;i<lvl;i++) cout << '\t';
	if (right!=NULL) {
		cout << "<right>\n";
		right->print(lvl+1);
	}
}

void TBinCharNode::print(int lvl)
{
	int i;

	if (val!='\n') {
		for(i=0;i<lvl+1;i++) cout << "  ";
		cout << "<value: " << val << ">\n";
	}
	if (left!=NULL) {
		for(i=0;i<lvl+1;i++) cout << "  ";
		cout << "<left>\n";
		left->print(lvl+1);
	}
	if (right!=NULL) {
		for(i=0;i<lvl+1;i++) cout << "  ";
		cout << "<right>\n";
		right->print(lvl+1);
	}
}

int TBinCharNode::Search(char *s, int lvl, char c)
{
	int r;

	if (val==c) {
		s[lvl]='\0';
		return 1;
	}
	if (left!=NULL) {
		s[lvl]='.';
		r=left->Search(s,lvl+1,c);
		if (r) return r;
	}
	if (right!=NULL) {
		s[lvl]='-';
		r=right->Search(s,lvl+1,c);
		if (r) return r;
	}
	return 0;
}

main(int ac, char** ag)
{
	TBinCharNode Npoint('.'), N4('4'), N3('3'), Nques('?'), N2('2'), Nf('f'), Nl('l');
	TBinCharNode Np('p'), N1('1'), N6('6'), Neq('='), Nx('x'), Nc('c'), Ny('y');
	TBinCharNode N7('7'), Ncoma(','), Nq('q'), N8('8'), N9('9'), N0('0');

	TBinCharNode N5(&Npoint,NULL,'5'), Nh(&N5,&N4,'h'), X1(NULL,&N3,'\0'), Ns(&Nh,&X1,'s');
	TBinCharNode X2(&Nques,NULL,'\0'), X3(&X2,&N2,'\0'), Nu(&Nf,&X3,'u'), Ni(&Ns,&Nu,'i');
	TBinCharNode Nr(&Nl,NULL,'r'), Nj(NULL,&N1,'j'), Nw(&Np,&Nj,'w'), Na(&Nr,&Nw,'a'), Ne(&Ni,&Na,'e');

	TBinCharNode Nb(&N6,&Neq,'b'), Nd(&Nb,&Nx,'d'), Nk(&Nc,&Ny,'k'), Nn(&Nd,&Nk,'n');
	TBinCharNode X4(NULL,&Ncoma,'\0'), Nz(&N7,&X4,'z'), Ng(&Nz,&Nq,'g');
	TBinCharNode X5(&N8,NULL,'\0'), Nch(&N9,&N0,'@'), No(&X5,&Nch,'o'), Nm(&Ng,&No,'m');
	TBinCharNode Nt(&Nn,&Nm,'t'), Nroot(&Ne,&Nt,'$');

	char str[256];
	int i;
	char c;
	TBinCharNode* np;

	if (ac>1) {
		if (Nroot.Search(str,0,ag[1][0]))
			cout << str << '\n';
		else {
			cerr << "Znak nenajdeny\n";
			return -1;
		}
	} else {
		while(1) {
			cin >> str;
			if (str[0]==0 || str[0]==4) break;

			np=&Nroot;
			for(i=0;str[i]!=0;i++) {
				if(str[i]=='.') {
					if ((np=np->getLeft())==NULL) {
						cerr << "Chyba kodu!\n";
						return -1;
					}
				} else if(str[i]=='-') {
					if ((np=np->getRight())==NULL) {
						cerr << "Chyba kodu!\n";
						return -1;
					}
				} else {
					cerr << "Chyba kodu!\n";
					return -1;
				}
			}
			c=np->getVal();
			cout << c;
		}
		cout << '\n';
	}
}



