begin
write('ѥ');
end.

  Kruzok  : 3INF_8
  Rocnik  : 3.
  Zadanie c.4

Popis metod :
  Bubble sort - Algoritmus je zalozeny na principe postupneho porovnavania
  susednych dvojic prvkov a ich vzajomnej vymeny.

  Sortmin - Algoritmus najde pri kazdom prechode cyklu minimum z danej
  postupnosti a vymeni ho s prvym prvkom. Cyklus prechadza od zaciatku
  postupnosti po jej koniec. Zaciatok sa kazdym prechodom inkrementuje.

  Shell sort - Vylepseny Bubble sort s dynamickou velkostou kroku prechodu
  cyklom.
}
program triedenie;

const max=200;                       { konstanta - maximalny rozsah pola }
      rozsah=1000;                   { konstanta - max. velkost prvku }

type pole = array [1..max] of integer;

var a : pole;                       { a - vstupne pole }
    b : pole;                       { b - vystupne pole }
    n : integer;                    { n - pocet prvkov pola }
    pocetvymen : integer;           { pocet vymen prvkov danej metody }
    pocetporov : integer;           { pocet vykonanych porovnani }
    i : integer;                    { pomocna premenna pre cyklus }

procedure nacitanie(var d : pole);
{ ***************** procedura na nacitanie prvkov pola *************** }
begin
  for i:=1 to n do
   begin
    write('Zadaj hodnotu ',i,'. prvku : ');
    readln(d[i]);
   end;
end;

procedure vypis(var c : pole; meno : string; vymen : integer;
                    porov : integer);
{ ************* pomocna procedura na vypis pola ************************ }
begin
 writeln(meno,'  Pocet vymen : ',vymen,',  Pocet porovnani : ',porov);
 for i:=1 to n do
  write(c[i],', ');
 writeln;
 write('                                                   Stlac Enter');
 readln;
end;

procedure generuj(var c : pole); 
{generuje nahodne prvky pola o velkosti prvkov 0..rozsah }
begin
 randomize;
 for i:=1 to n do
  begin
   a[i]:=random(rozsah);
  end;
end;

procedure copypole(p : pole);
{ **************** pomocna procedura na kopirovanie do vysledneho pola ***}
begin
 for i:=1 to n do b[i]:=p[i];
end;

Procedure bubble(p : pole; count:integer; nahor:boolean;
                 var vymen : integer; var porov : integer);
 var i,i1,i2 : integer;
 begin
 vymen:=0;
 porov:=0;
   for i1:=1 to count-1 do begin
    for i2:=1 to count-i1 do
     if ((p[i2] > p[i2+1]) and nahor) or ((p[i2] < p[i2+1]) and not nahor)
      then                            { porovna 2 susedne prvky }
      begin
        i:=p[i2]; p[i2]:=p[i2+1]; p[i2+1]:=i;  { vymena }
        inc(vymen); porov:=porov+5;
      end;
    end;
 copypole(p);
 end;

procedure sortmin(p : pole; count:integer;
                  var vymen : integer; var porov : integer);
 var
   i,i1,i2 : integer;
   h : integer;
 begin
 vymen:=0;
 porov:=0;
   for i1:=1 to count-1 do
    begin
      i:=i1;
      for i2:=i1+1 to count do begin    { hlada minimum }
        if p[i2] < p[i] then i:=i2;
        inc(porov);
      end;
      h:=p[i]; p[i]:=p[i1]; p[i1]:=h;   { vymena prvkov }
      inc(vymen);
    end;
 copypole(p);
 end;

procedure shell(p : pole; count:integer; nahor:boolean;
                var vymen : integer; var porov : integer);
 label vrat;
 var
   i,j,m,h : integer;
 begin
   m:=count;
   vymen:=0;
   porov:=0;
   while m > 1 do
    begin
      inc(porov);
      m:=m div 2;                       { urci krok prechodu cyklu }
      for i:=1 to count-m do
       begin
         j:=i;
         vrat:                         { navestie }
        if ((p[j] > p[j+m]) and nahor) or ((p[j] < p[j+m]) and not nahor)
        then                           { porovnanie a vymena prvkov }
          begin
            h:=p[j]; p[j]:=p[j+m]; p[j+m]:=h;
            inc(vymen); porov:=porov+5;
            dec(j,m);
            if j > 0 then begin
             inc(porov);
             Goto vrat;
            end;
          end;
       end;
    end;
 copypole(p);
 end;

begin
 writeln;
 writeln('                        Triedenie      ');
 writeln;
 repeat
  writeln('1. Nahodne generovane pole');
  writeln('2. Zadavane pole');
  readln(i);
 until((i=1)or(i=2));
 write('Zadaj pocet prvkov pola (max.: ',max,') : ');
 readln(n);
 writeln;
 if i=1 then generuj(a)
 else nacitanie(a);
 writeln;
 vypis(a,'Povodne pole :',0,0);

 bubble(a,n,true,pocetvymen,pocetporov);
 vypis(b,'Bubble :',pocetvymen,pocetporov);

 sortmin(a,n,pocetvymen,pocetporov);
 vypis(b,'SortMin :',pocetvymen,pocetporov);

 shell(a,n,true,pocetvymen,pocetporov);
 vypis(b,'Shell :',pocetvymen,pocetporov);

 {pocetvymen:=0; pocetporov:=0;}
end.
{ Meno    : Marek Ratkovsky
  Kruzok  : 3INF_8
  Rocnik  : 3.
  Zadanie c.4

Popis metod :
  Bubble sort - Algoritmus je zalozeny na principe postupneho porovnavania
  susednych dvojic prvkov a ich vzajomnej vymeny.

  Sortmin - Algoritmus najde p