#include <stdlib.h>
#include <stdio.h>
#include "elm.h"
#include "sqelm.h"
#include "stack.h"
#include "mq.h"

extern void memo ();

static void cisti (mq* q1, mq* q2, stack* st) // uvolni alokovanu pamat
{
	q1->afree ();
	q2->afree ();
	st->afree ();
	return;
}
	
mq* conv2post (mq* in)
// skonvertuje infixovy zapis z frontu in do postfixoveho zapisu do frontu po
// pomocou zasobnika st
{
	static mq po;
	stack st;
	elm e, e1;

	while ((e = in->remove ()).op ())
	{
		if (e.op () == ' ')
		{
			if (po.insert (e) < 0)
			{
				cisti (in, &po, &st);
				memo ();
			}
			continue;
		}
		if (e.op () == '(')
		{
			if (st.insert (e) < 0)
			{
				cisti (in, &po, &st);
				memo ();
			}
			continue;
		}
		if (e.op () == ')')
		{
			while ((e1 = st.remove ()).op ()
					&& e1.op () != '(')
				if (po.insert (e1) < 0)
				{
					cisti (in, &po, &st);
					memo ();
				}
			if (!e1.op ())
			{
				cisti (in, &po, &st);
				return NULL;
			}
			continue;
		}

		// vlozime do frontu po vsetky operatory zo zasobnika st,
		// ktore maju prioritu >= ako aktualny (asociativita zlava)
		while ((st.top ()).op ()
			&& (st.top ()).prio () >= e.prio ())
				if (po.insert (st.remove ()) < 0)
				{
					cisti (in, &po, &st);
					memo ();
				}
		if (st.insert (e) < 0) // vlozime aktualny operator do st
			{
				cisti (in, &po, &st);
				memo ();
			}
	}

	// tu uz je front in prazdny, vyprazdnime zasobnik st

	while ((e1 = st.remove ()).op ())
	{
		if (e1.op () == '(')
		{
			cisti (in, &po, &st);
			return NULL;
		}

		if (po.insert (e1) < 0)
		{
			cisti (in, &po, &st);
			memo ();
		}
	}

	return &po;
}

