#include <stdio.h>
#include <stdlib.h>
#include "elm.h"
#include "sqelm.h"
#include "mq.h"
#include "stack.h"


extern void memo ();
extern void dvbyzero ();

static void cisti (mq* q1, stack* st) // uvolnime dynamicky alokovanu pamat
{
	q1->afree ();
	st->afree ();
	return;
}

static double applyunary (char op, double x)
{
	return (op == 'n') ? -x : x;
}

static double applybinary (char op, double x, double y)
{
	switch (op)
	{
		case '+':
			return x + y;
		case '-':
			return x - y;
		case '*':
			return x * y;
		case '/':
			return x / y;	
	}
	return 0;
}

elm spocitaj (mq* in)
// vypocita vysledok vyhodnotenim postfixoveho vyrazu vo fronte in
// pomocou zasobnika st
{
	stack st;
	double n;
	elm e;
	elm op1, op2;

	while ((e = in->remove ()).op ())
	{
		if (e.op () == ' ') // cislo
		{
			if (st.insert (e) < 0)
			{
				cisti (in, &st);
				memo ();
			}
			continue;
		}

		if (e.op () == 'n' || e.op () == 'p') // unarny operator
		{
			if (!(op1 = st.remove ()).op ())
			{
				cisti (in, &st);
				return op1;
			}
			n = applyunary (e.op (), op1.value ());
			op1.vloz (n);
			if (st.insert (op1) < 0)
			{
				cisti (in, &st);
				memo ();
			}
			continue;
		}

		// binarny operator

		if (!(op2 = st.remove ()).op ())
		{
			cisti (in, &st);
			return op2;
		}

		if (!(op1 = st.remove ()).op ())
		{
			cisti (in, &st);
			return op1;
		}

		if (e.op () == '/' && op2.value () == 0)
		{
			cisti (in, &st);
			dvbyzero ();
		}

		n = applybinary (e.op (), op1.value (), op2.value ());
		op1.vloz (n);

		if (st.insert (op1) < 0)	
		{
			cisti (in, &st);
			memo ();
		}
	}

	e = st.remove (); // vytiahne vypocitanu hodnotu zo zasobnika

	if (!st.isempty ())
	{
		e.clean ();
		st.afree ();
	}
	// ak v zasobniku este nieco ostalo, zneplatni vysledok

	return e;
}

