/* Definitions & Procedures */
#include "split.h"

static ulong crctable[256];

void make_crc_table(void)
{
    uint i, j;
    ulong r;
    for (i= 0; i < 256; i++) {
        r= i;
        for (j= 0; j < 8; j++)
            if (r & 1) r= (r >> 1) ^ CRCPOLY;
            else  r >>= 1;
        crctable[i]= r;
    }
}

ulong update_crc(ulong StartCRC, uchar *Addr, uint Size)
{
    uint i;
    for (i= 0; i < Size; i++)
        StartCRC= crctable[(uchar)StartCRC ^ Addr[i]] ^ (StartCRC >> 8);
    return(StartCRC);
}
