typedef unsigned char  uchar;               /*  8 bits */
typedef unsigned int   uint;                /* 16 bits */
typedef unsigned long  ulong;               /* 32 bits */

#define INITCRC      0xFFFFFFFFL            /* CRC32 init */
#define CRCPOLY      0xEDB88320L            /* CRC32 polynom */

#define BUFSIZE      0xF000                 /* Size of buffer */

#define CONTPREV     0x01                   /* Archive flags */
#define CONTNEXT     0x02

/* Exit codes */
enum {SUCCESS, ARCH_ERROR, CRC_ERROR, LEN_ERROR, READ_ERROR, WRITE_ERROR,
       OPEN_ERROR, MEMORY_ERROR, VOLUME_ERROR, USER_ERROR};

/* Function from SPLIT.C */
void errexit(int errcode, char *errstr);    /* Exits with error code */
void help(void);                            /* Prints usage help */

/* Function from PACK.C */
void pack(char *filename, ulong archsize);  /* Split a file */
void unpack(char *filename);                /* Link splited files */
void leadingzero(int num, char *s);         /* Int -> extension */

/* Function from CRC.C */
void make_crc_table(void);                  /* Initializes CRC table */
ulong update_crc(ulong StartCRC, uchar *Addr, uint Size);
                                            /* Calculates CRC */
