/* ## Marek DZURKO & Henrich FUKNA, kruzok 3, Pondelok 9:15, ZADANIE 01(M) ##
 *
 * Napiste program, ktoreho vstupom je program v C, vystupom je ten isty subor,
 * ale vsetky komentare su zakryptovane (pomocou XOR s opakovanim retazca
 * PASSWORD). Predpokladajte nevnarane komentare.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <dir.h>

#define BUF_SIZE    40960                                    /* Velkost bufra */

void help(void);
char *search_mem(char *from,char *what,int what_len,int mem_len);
void codecomm(char *filename,char *passwd);
void crypt(char *from,int len,char *key,int key_len,int *key_pos);

extern int errno;

void main(int argc,char **argv)
{
    int i;
    char *s,*filename=NULL,*passwd=NULL;

    printf("Codecomm - encrypt C-source commentars, (C) 1996 Marek DZURKO & Henrich FUKNA\n");
    while(--argc>0) {
        if (**++argv=='-')
            for(s= ++*argv;*s!=0;s++)
                switch (*s) {
                    case 'h':
                    case 'H': help();
                    default: fprintf(stderr,"Invalid switch: %c\n",*s);
                        help();
                }
        else if (filename==NULL) filename= *argv;
        else if (passwd==NULL) passwd= *argv;
        else { fprintf(stderr,"Too many arguments\n");
            help();
        }
    }
    if (!filename || !passwd) {
        fprintf(stderr,"Too few arguments\n");
        help();
    }
    codecomm(filename,passwd);
}

void codecomm(char *filename,char *passwd)
{
    char *buf, *pos1, *pos2, *tmp, errbuf[100], \
        drive[MAXDRIVE], dir[MAXDIR], file[MAXFILE], ext[MAXEXT];

    int n, last=0, handl, v, koef, key_len=strlen(passwd), flags;
    long file_pos=0;
    flags= fnsplit(filename, drive, dir, file, ext);

                                                     /* Kontrola typu pripony */
    if (flags && EXTENSION)
    if (strcmp(ext, ".c") && strcmp(ext, ".C") && strcmp(ext, ".h") &&
        strcmp(ext, ".H") && strcmp(ext, ".cpp") && strcmp(ext, ".CPP"))
        {
            fprintf(stderr,"File %s is'n C source\n",filename);
            exit(1);
        }
                                        /* Otvorenie suboru. Ak chyba -> exit */
    if ((handl=open(filename,O_RDWR|O_BINARY)) < 0)
    {
        sprintf(errbuf,"Codecomm: %s",filename);
        perror(errbuf);    exit(1);
    }
                            /* Alokovanie pamate pre buffer. Ak chyba -> exit */
    if ((buf=(char *) malloc(BUF_SIZE))==NULL)
    {
        perror("Codecomm"); exit(1);
    }
    v=koef=0;
                                     /* Citaj do buffer-a pokial mas co citat */
    while((n=read(handl,buf,BUF_SIZE))>1)
    {
        pos1=buf; koef=0;
        while (pos1<buf+n)          /* Opakuj pokial si nepresiel cely buffer */
        {
            if (v==0)                            /* Este nie si v komentari ? */
            {                                    /* Hladaj zaciatok komentara */
                tmp=pos1;
                do {
                    pos1=search_mem(tmp,"/",1,buf+n-pos1);
                    tmp=pos1+1;
                } while (*tmp!='*' && pos1!=NULL);

                if (pos1==NULL) {       /* Nie je zaciatok ? */
                    koef=1; break;
                }
                else {                                         /* Je zaciatok */
                    v=1; pos1+=2;                         /* v=1 - Som vnutri */
                                 /* Je zaciatok komentara na konci buffer-a ? */
                    if (pos1>=buf+n) break;
                }
            }
            if (v==1)                             /* Uz si vnutri komentara ? */
            {                                      /* Hladaj koniec komentara */
                tmp=pos1;
                do {
                    pos2=search_mem(tmp,"*",1,buf+n-tmp);
                    tmp=pos2+1;
                } while (*tmp!='/' && pos2!=NULL);

                if (pos2==NULL) {        /* Nie je koniec ? */
                    koef=1;
                                              /* Zakoduj az do konca buffer-a */
                    crypt(pos1,buf+n-pos1-1,passwd,key_len,&last);
                    break;
                }
                else {                                           /* Je koniec */
                    koef=0;
                                             /* Zakoduj az do konca komentara */
                    crypt(pos1,pos2-pos1,passwd,key_len,&last);
                    pos1=pos2+2;
                    v=0;
                }
            }
        }
        lseek(handl,file_pos,SEEK_SET);         /* Nastavenie predch. pozicie */
        write(handl,buf,n-koef);               /* Zapis buffer spat do suboru */
        file_pos=tell(handl);                                 /* Nova pozicia */
    }
    lseek(handl,file_pos,SEEK_SET);             /* Nastavenie predch. pozicie */
    write(handl,buf,n);                                 /* Uloz zvysok suboru */
    file_pos=tell(handl);                                     /* Nova pozicia */
    free(buf);                                               /* Uvolni buffer */
    close(handl);                                             /* Zatvor subor */
}

/* Funkcia cyklicky zakoduje cast pamati od From v dlzke Len klucom Key.
 * Zacne kodovat na pozicii kluca Key_pos. Po ukonceni kodovania vrati
 * novu poziciu (aby bolo kodovanie cyklicke)
 */
void crypt(char *from,int len,char *key,int key_len,int *key_pos)
{
    int i;
    for(i=0;i<len;i++) {
        *from++=((*from - 32) ^ key[(*key_pos+i) % key_len]) + 32;
    }
    *key_pos=(*key_pos+i) % key_len;                     /* Vrat novu poziciu */
}

/* Funkcia hlada retazec What v pamati, ktora zacina na From. Dlzka pamate
 * kde sa hlada je Mem_len, dlzka hladaneho retazca je What_len. Funkcia
 * vrati pointer na miesto v pamati kde sa nachadza dany retazec alebo NULL
 * ak sa tam nenachadza.
 */
char *search_mem(char *from,char *what,int what_len,int mem_len)
{
    char *s,*w;
    for(; mem_len>=what_len; from++, mem_len--)
    {
        for(s=from,w=what; *s==*w && *w!='\0'; s++, w++) ;
        if (*w=='\0') return(from);                        /* Retazec najdeny */
    }
    return(NULL);                                        /* Retazac nenajdeny */
}

/* Strucna napoveda
 */
void help(void)
{
    printf("Ussage : CODECOMM [-h|H] <filename> <passwd>\n");
    printf("        -h|H      - this help\n");
    printf("        filename  - C-source file\n");
    printf("        passwd    - password string\n\n");
    exit(1);
}
