$_ = 'abc123xyz';
s/\d+/$&*2/e;
print $_,"\n";                  # yields 'abc246xyz'
s/\d+/sprintf("%5d",$&)/e;
print $_,"\n";                  # yields 'abc  246xyz'
s/\w/$& x 2/eg;
print $_,"\n";                  # yields 'aabbcc  224466xxyyzz'

$_ = 'abc123xyz';
s/\d+/$&*2/;
print $_,"\n";                  # yields
s/\w/$& x 2/g;
print $_,"\n";                  # yields 'a x 2b x 2....'


# /e's can even nest;  this will expand
# simple embedded variables in $_
$a = "fsfsfs";
$b = "ghhshsh";
$_ = "($a) : ($b)";
s/(\$\w+)/$1/eeg;
print $_,"\n";

$_ = "($a) : ($b)";
s/(\$\w+)/$1/eg;
print $_,"\n";


$_ = "($a) : ($b)";
s/(\$\w+)/$1/g;
print $_,"\n";

$_ = "$a : $b";
s/(\$\w+)/$1/;
print $_,"\n";

__END__
        # Delete C comments.
        $program =~ s {
            /\*        (?# Match the opening delimiter.)
            .*?        (?# Match a minimal number of characters.)
            \*/        (?# Match the closing delimiter.)
        } []gsx;

        s/^\s*(.*?)\s*$/$1/;        # trim white space
OUTPUTS
abc  246xyz
aabbcc  224466xxyyzz
abc123*2xyz
a x 2b x 2c x 21 x 22 x 23 x 2*2 x 2x x 2y x 2z x 2
(fsfsfs) : (ghhshsh)
(fsfsfs) : (ghhshsh)
(fsfsfs) : (ghhshsh)
fsfsfs : ghhshsh