# this demonstrates how to pass an array name to sub
sub double
{
    local(*foo) = @_;
    foreach $bar (@foo)
    {
        $bar *= 2;
    }
}

@a = (1 .. 5);
print "Before: @a\n";
&double(*a);
print "After: @a\n";

# the same can be done like follows
sub double2
{
    foreach $bar (@_)
    {
        $bar *= 2;
    }
}

@a = (1 .. 5);
print "Before: @a\n";
&double2(@a);
print "After: @a\n";
 
# but this MUST be done using *name, as two arrays in function
#  arguments would be concatenated together
sub arrayadd
{
   local(*a, *b) = @_;
   local($max) = $#a > $#b ? $#a : $#b;
   for (local($i) = 0; $i <= $max; $i++)     
   {
       $sum[$i] = $a[$i] + $b[$i];
   }
   return @sum;
}

@a = (1..5);
@b = (10..18);
@c = &arrayadd(*a, *b);

print "Suma = @c\n";