/* []----------------------------------------------------[] */
/* | STDERR2F.C                                           | */
/* |                                                      | */
/* | Presmeruje standardny chybovy vystup do suboru ktory | */
/* | ulozi do prave aktualneho adresara.                  | */
/* []----------------------------------------------------[] */
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <dos.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>

typedef unsigned char BYTE;                                   /*  8 bits */
typedef unsigned int WORD;                                    /* 16 bits */

extern WORD _stklen = 0x80;             /* nastavenie velkosti zasobnika */
extern WORD _heaplen = 0x480;                    /* nastavenie near heap */

char Copyright[] = {"STDERR-to-FILE by Henrich FUKNA & Marek DZURKO"};

union REGS Reg;                    /* struktura pre univerzalne registre */
struct SREGS SReg;                  /* struktura pre segmentove registre */

WORD TSRTask;               /* identifikacne cislo rezidentu pre INT 2Fh */

BYTE ResOff= 0,                                    /* priznak deaktivace */
     Scan= 0,                                       /* prave citany znak */
     ShiftMask= 0,                                   /* maska prepinacov */
     KbShift,
     KbVal;

char Key[5]= "^@F",                   /* prednastavena aktivacna klavesa */
     FName[80]= "STDERR2F.SAV";             /* prednastavene namo suboru */

int TSRFile;                                      /* ukazatel na subor */

void interrupt (*OldKeyboard)(void);           /* povodny vektor INT 09h */
void interrupt (*OldDOSFn)(void);              /* povodny vektor INT 21h */
void interrupt (*OldCritErr)(void);            /* povodny vektor INT 24h */
void interrupt (*OldMultiplex)(void);          /* povodny vektor INT 2Fh */

/*extern void interrupt NewKeyboard(void);          /* novy vektor INT 09h */
/*extern void interrupt NewCritErr(void);           /* novy vektor INT 24h */
void interrupt NewMultiplex();                    /* novy vektor INT 2Fh */

/* -------------------------------------------------------- */
/* Funkcia STbeep generuje zvukovy signal o frekvencii High */
/* a dlzke trvania Length.                                  */
/* -------------------------------------------------------- */
void STBeep(WORD Length, WORD High)
{
    sound(High);
    delay(Length);
    nosound();
}

/* -------------------------------------------------------- */
/* Funkcia IdentStr porovna dva retazce na "far" adresach.  */
/* -------------------------------------------------------- */
WORD IdentStr(char far *Master, char far *Copy)
{
  while (*Master) if (*Master++ != *Copy++) return 0;
  return 1;
}

/* -------------------------------------------------------- */
/* Na funkciu je presmerovany vektor INT 09h - klavesnica   */
/* (IRQ 1). Zaistuje kontolu stacenia kombinacie nastavenia */
/* hot key a nastavenie priznaku aktivity TRS.              */
/* -------------------------------------------------------- */
void interrupt NewKeyboard(void)
{
    if (inportb(0x60) == Scan) {
        KbShift= peek(0x0040, 0x0017) & 0x0F;
        if ((KbShift == (ShiftMask & 0xFE)) ||
           (KbShift == (ShiftMask & 0xFD))) {
            if (ResOff != 0) {
                ResOff= 0;
                STBeep(125, 750);
            } else {
                ResOff= 1;
                STBeep(125, 1750);
            }
            KbVal= inportb(0x61);
            outportb(0x61, KbVal | 0x80);
            outportb(0x61, KbVal);
            outportb(0x20, 0x20);
        } else {
            OldKeyboard();
        }
    } else {
        OldKeyboard();
    }
}

/* -------------------------------------------------------- */
/* Na funkciu je presmerovany vektor INT 24h - kriticka     */
/* chyba po dobu prace TSR programu. Simuluje navrat do     */
/* DOSu s chybou (ako by uzivatel odpovedal "Fail").        */
/* -------------------------------------------------------- */
#pragma argsused         /* vypnutie kontroly pouzitia vsetkych parametrov */
void interrupt NewCritErr(WORD bp, WORD di, WORD si, WORD ds,
                          WORD es, WORD dx, WORD cx, WORD bx,
                          WORD ax, WORD ip, WORD cs, WORD flgs)
{
    STBeep(500, 500);
    ax= (ax & 0xFF00) + 0x03;
}

/* -------------------------------------------------------- */
/* Funkcia NewDOSFn obsadi vektor INT21h (DOS Function) kde */
/* testuje zapis do suboru na handle STDERR.                */
/* -------------------------------------------------------- */
#pragma argsused         /* vypnutie kontroly pouzitia vsetkych parametrov */
void interrupt NewDOSFn(WORD bp, WORD di, WORD si, WORD ds,
                        WORD es, WORD dx, WORD cx, WORD bx,
                        WORD ax, WORD ip, WORD cs, WORD flgs)
{
    if ((ResOff == 0) &&                                  /* som aktivny */
       ((ax & 0xFF00) == 0x4000) &&            /* a je zapis na STDERR ? */
       ((bx & 0xFFFF) == 0x0002)) {
        OldCritErr= getvect(0x24);         /* nastavenie kritickej chyby */
        setvect(0x24, NewCritErr);
        TSRFile= open(FName, O_RDWR | O_APPEND | O_CREAT | O_BINARY, S_IREAD | S_IWRITE);
        if (TSRFile != -1) {              /* ak sa podari otvorit subor */
            lseek(TSRFile, filelength(TSRFile), SEEK_SET);
            _dos_write(TSRFile, MK_FP(ds, dx), cx, &ax);
            close(TSRFile);   /* tak zapisem informacie a zatvorim subor */
        }
        setvect(0x24, OldCritErr);             /* povodna kriticka chyba */
    } else asm {                               /* volanie starej obsluhy */
        pop bp
        pop di
        pop si
        pop ds
        pop es
        pop dx
        pop cx
        pop bx
        pop ax
        jmp dword ptr CS:OldDOSFn
    }
}

/* -------------------------------------------------------- */
/* Funkcia Terminate robi ddeinstalaciu TSR programu        */
/* (pokial je to mozne).                                    */
/* -------------------------------------------------------- */
WORD Terminate(void)
{
    if ((getvect(0x09) == NewKeyboard) &&      /* pokial nikto neobsadil */
        (getvect(0x21) == NewDOSFn) &&          /* mnou pouzite vektory, */
        (getvect(0x2F) == NewMultiplex)) {      /* mozem sa odinstalovat */
        ResOff= 1;                        /* nastav priznak deinstalacie */
        setvect(0x09, OldKeyboard);       /* vrat vsetky pouzite vektory */
        setvect(0x21, OldDOSFn);                   /* do povodneho stavu */
        setvect(0x2F, OldMultiplex);
        STBeep(125, 1750);
        Reg.h.ah= 0x49;
        SReg.es= _psp;          /* uvolni vlastny pamatovy blok z pamati */
        intdosx(&Reg, &Reg, &SReg);
        return 0;                              /* odinstalovanie uspesne */
    }
    return 1;                                    /* nemozno odinstalovat */
}

/* -------------------------------------------------------- */
/* Funkcia NewMultiplex obsadi vektor INT 2Fh (komikacia s  */
/* procesmi) a prebera komunikaciu procesu s cislom TSRTask */
/* -------------------------------------------------------- */
#pragma argsused         /* vypnutie kontroly pouzitia vsetkych parametrov */
void interrupt NewMultiplex(WORD bp, WORD di, WORD si, WORD ds,
                            WORD es, WORD dx, WORD cx, WORD bx,
                            WORD ax, WORD ip, WORD cs, WORD flgs)
{
    if ((ax & 0xFF00) == TSRTask) {             /* komunikacia so mnou ? */
        switch (ax & 0x00FF) {              /* vymaskuj cislo podfunkcie */
            case 0x00: ax= ax | 0x00FF;/* SubFn 00 - kontola pritomnosti */
                       es= FP_SEG(Copyright);
                       bx= FP_OFF(Copyright);
                       break;
            case 0x01: ax= ResOff;            /* SubFn 01 - daj stav TSR */
                       cx= Scan;
                       dx= ShiftMask;
                       es= FP_SEG(FName);
                       bx= FP_OFF(FName);
                       break;
            case 0x02: Scan= cx;             /* SubFn 02 - zmena hot key */
                       ShiftMask= dx;
                       break;
            case 0x04: _fstrcpy(FName, MK_FP(es, bx));
                       break;                 /* SubFn 04 - zmena suboru */
            case 0x08: if ((ax= Terminate()) != 0)
                           flgs= flgs | 0x0001;/* SubFn 08- deinstalacia */
        }
    } else asm {                               /* volanie starej obsluhy */
        pop bp
        pop di
        pop si
        pop ds
        pop es
        pop dx
        pop cx
        pop bx
        pop ax
        jmp dword ptr CS:OldMultiplex
    }
}

/* -------------------------------------------------------- */
/* Funkcia Install robi vsetky akcie nevyhnutne pre spravnu */
/* cinnost TSR programu po jeho umiestneni do pamati.       */
/* -------------------------------------------------------- */
void Install(void)
{
    delay(1);
    OldKeyboard= getvect(0x09);                    /* uloz stare vektory */
    OldDOSFn= getvect(0x21);
    OldMultiplex= getvect(0x2F);
    setvect(0x09, (void interrupt (*)(void)) NewKeyboard);/*a nastav nove*/
    setvect(0x21, (void interrupt (*)(void)) NewDOSFn);
    setvect(0x2F, (void interrupt (*)(void)) NewMultiplex);
    fputs(" ...was loaded.\n", stdout);
    STBeep(125, 750);
    Reg.h.ah=0x49;
    SReg.es= peek(_psp, 0x2C);             /* uvolni Enviroment z pamati */
    intdosx(&Reg, &Reg, &SReg);
    keep(0, _SS + (_SP >> 4) + 1 - _psp);             /* zostan v pamati */
}

/* -------------------------------------------------------- */
/* Fukncia vypise pomoc.                                    */
/* -------------------------------------------------------- */
void Help(void)
{
    fputs("help page\n\n", stdout);
    fputs(" Usage: STDERR2F [options]\n\n", stdout);
    fputs("   Options:\n", stdout);
    fputs("      -h  -?  display this help\n", stdout);
    fputs("      -x, -u  remove program from memory\n", stdout);
    fputs("      -fxxxx  filename\t\t\t\tDefault: STDERR2F.SAV\n", stdout);
    fputs("      -kxxxx  set hotkey\n", stdout);
    fputs("                 ^   Ctrl\n", stdout);
    fputs("                 @   Alt\n", stdout);
    fputs("                 !   Shift\n", stdout);
    fputs("                 A-Z Key\t\t\tDefault: ^@F\n\n", stdout);
    fputs("  low tone = active; high tone = deactive\n", stdout);
}

/* -------------------------------------------------------- */
/* Hlavny program. Otestuje agrumety, zisti ci uz je kopia  */
/* TSR v pamati a vrati spravu.                             */
/* -------------------------------------------------------- */
int main(int argc, char *argv[])
{
    BYTE TaskNum= 0xFF,
         KeyCh= 0,
         KeyL= 0,
         FileCh= 0,
         ch,
         KCode[26] = {0x1E, 0x30, 0x2E, 0x20, 0x12, 0x21, 0x22, 0x23, 0x17,
                      0x24, 0x25, 0x26, 0x32, 0x31, 0x18, 0x19, 0x10, 0x13,
                      0x1F, 0x14, 0x16, 0x2F, 0x11, 0x2D, 0x15, 0x2C},
         SCode[35][2] = {"Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P",
          "", "", "", "", "A", "S", "D", "F", "G", "H", "J", "K", "L", "",
          "", "", "", "", "Z", "X", "C", "V", "B", "N", "M"};
    WORD i, UnInst= 0;

    fputs("STDERR TO FILE (c) 1996 Henrich FUKNA & Marek DZURKO\n", stdout);
    fputs(" ...", stdout);
    while (--argc > 0) {                    /* test vstupnych argumentov */
        if (**++argv == '-')
            switch (*++*argv) {
                case '?':
                case 'h':
                case 'H': Help();
                          return 5;
                case 'x':
                case 'X':
                case 'u':
                case 'U': UnInst= 1;
                          break;
                case 'k':
                case 'K': if (strcmp(++*argv, "")) {
                              strcpy(Key, *argv);
                              KeyCh= 1;
                          } else {
                              fputs("invalid hot key\n", stdout);
                              Help();
                              return 6;
                          }
                          break;
                case 'f':
                case 'F': if (strcmp(++*argv, "")) {
                              strcpy(FName, *argv);
                              FileCh= 1;
                          } else {
                              fputs("invalid file name\n", stdout);
                              Help();
                              return 6;
                          }
                          break;
                default:  fputs("invalid switch\n", stdout);
                          Help();
                          return 6;
            }
        else {
        fputs("invalid argument\n", stdout);
            Help();
            return 6;
        }
    }
    for (i= 0; i < strlen(Key); i++) {
        Key[i]= toupper(Key[i]);
        switch (Key[i]) {
            case '^': ShiftMask= ShiftMask | 0x04;
                      break;
            case '@': ShiftMask= ShiftMask | 0x08;
                      break;
            case '!': ShiftMask= ShiftMask | 0x03;
                      break;
            default: if (Key[i] >= 'A' && Key[i] <= 'Z' && KeyL == 0) {
                         Scan= KCode[Key[i] - 'A'];
                         KeyL= 1;
                      } else {
                         fputs("Allowed keys:\n", stdout);
                         for (ch= 'A'; ch <= 'Z'; ch++) printf("%c ", ch);
                         fputs("\n", stdout);
                         return 6;
                     }
        }
    }
    if (KeyL == 0) {
        fputs("invalid hot key\n", stdout);
        Help();
        return 6;
    }
    while (TaskNum > 0x7F) {         /* hladaj prve volne cislo v pamati */
    Reg.h.ah= TaskNum;                 /* alebo svoju kopiu v pamati */
    Reg.h.al= 0x00;
    int86x(0x2F, &Reg, &Reg, &SReg);
    if (Reg.h.al == 0xFF)
        if (IdentStr(MK_FP(_DS, Copyright), MK_FP(SReg.es, Reg.x.bx))) {
            if (UnInst == 1) {
                Reg.h.ah= TaskNum;
                Reg.h.al= 0x08;
                int86(0x2F, &Reg, &Reg);
                if (Reg.x.flags & 0x0001) {      /* nemozno odinstalovat */
                    fputs("can not be unloaded\n", stdout);
                    return 3;
                } else {                            /* TSR odinstaloavny */
                    fputs("was unloaded\n", stdout);
                    return 2;
                }
            } else {                               /* TSR uz instalovany */
                fputs("already loaded\n", stdout);
                if (KeyCh == 1) {                       /* zmena hot key */
                    Reg.h.ah= TaskNum;
                    Reg.h.al= 0x02;
                    Reg.x.cx= Scan;
                    Reg.x.dx= ShiftMask;
                    int86x(0x2F, &Reg, &Reg, &SReg);
                    fputs(" ...hot key changed\n", stdout);
                }
                if (FileCh == 1) {                       /* zmena suboru */
                    Reg.h.ah= TaskNum;
                    Reg.h.al= 0x04;
                    SReg.es= FP_SEG(FName);
                    Reg.x.bx= FP_OFF(FName);
                    int86x(0x2F, &Reg, &Reg, &SReg);
                    fputs(" ...file name changed\n", stdout);
                }
                fputs(" ...TSR status\n", stdout);    /* vypis stavu TSR */
                Reg.h.ah= TaskNum;
                Reg.h.al= 0x01;
                int86x(0x2F, &Reg, &Reg, &SReg);
                fputs("Resident is:  ", stdout);
                if (Reg.x.ax == 0) fputs("ON\n", stdout);
                    else fputs("OFF\n", stdout);
                fputs("Hot key is:   ", stdout);
                if (Reg.x.dx & 4) fputs("Ctrl+", stdout);
                if (Reg.x.dx & 8) fputs("Alt+", stdout);
                if ((Reg.x.dx & 1) || (Reg.x.dx & 2))
                    fputs("Shift+", stdout);
                printf("%s\n", SCode[Reg.x.cx - 16]);
                fputs("Save file is: ", stdout);
                _fstrcpy(FName, MK_FP(SReg.es, Reg.x.bx));
                printf("%s\n", FName);
                return 4;
            }
        }
        if (Reg.h.al == 0x00) {
            TSRTask= TaskNum << 8;
            if (UnInst == 0) {
                fputs(" initialitation\n", stdout);
                fputs("Resident is:  ", stdout);
                if (ResOff == 0) fputs("ON\n", stdout);
                else fputs("OFF\n", stdout);
                fputs("Hot key is:   ", stdout);
                if (ShiftMask & 4) fputs("Ctrl+", stdout);
                if (ShiftMask & 8) fputs("Alt+", stdout);
                if ((ShiftMask & 1) || (ShiftMask & 2))
                    fputs("Shift+", stdout);
                printf("%s\n", SCode[Scan - 16]);
                fputs("Save file is: ", stdout);
                 printf("%s\n", FName);
                Install();                          /* TSR nainstalovany */
            } else {
              fputs("was not loaded", stdout);
              return 7;
            }
            return 0;
        }
        TaskNum--;
    }
    fputs("can not be loaded\n", stdout);          /* nemozno instalovat */
    return 1;
}
