// GRAFIKA2Doc.cpp : implementation of the CGRAFIKA2Doc class
//

#include "stdafx.h"
#include "GRAFIKA2.h"

#include "GRAFIKA2Doc.h"
#include <cmath>     
#include <iostream.h>              

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2Doc

IMPLEMENT_DYNCREATE(CGRAFIKA2Doc, CDocument)

BEGIN_MESSAGE_MAP(CGRAFIKA2Doc, CDocument)
	//{{AFX_MSG_MAP(CGRAFIKA2Doc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2Doc construction/destruction

CGRAFIKA2Doc::CGRAFIKA2Doc()
{	
	BodRotacie = new CBod(200,200,200);
	Scena= new CScena();

}

CGRAFIKA2Doc::~CGRAFIKA2Doc()
{
	delete BodRotacie;
	delete Scena;
}

BOOL CGRAFIKA2Doc::OnNewDocument() //deletne staru scenu a vytvori novu
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	delete Scena;
	Scena= new CScena();
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2Doc serialization

void CGRAFIKA2Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2Doc diagnostics

#ifdef _DEBUG
void CGRAFIKA2Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGRAFIKA2Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG



//////////////////////////////////////////////////////////////////////
// CBod Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


CBod::CBod()
{

}

CBod::~CBod()
{

}

//////////////////////////////////////////////////////////////////////
// CStena Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStena::CStena()
{
	Pero = new CPen(PS_SOLID,2,RGB(0,0,0));	//Nove cierne pero s hrubkov 2
}

CStena::~CStena()
{
	delete Pero;
	Body.RemoveAll();
}

void CStena::Vykresli(CDC *dc,UINT Menu) //fcia na vykreslenie jednej steny
{	
	int i;
	unsigned char Farba;
	CBod *ZdrojSvetla,*StredPlochy;
	ZdrojSvetla = new CBod(300,300,1000);	
	StredPlochy = new CBod(0,0,0);
	CPen* pOldPen = dc->SelectObject(Pero);
	CVektor *Vektor1,*Vektor2,*Normala,*VektorSvetla;

	switch(Menu)
	{
		case 1:	//vykreslenie steny pre bodovy model
			for(i=0;i<Body.GetSize();i++)
			{
				dc->SetPixel((int)Body[i]->x,(int)Body[i]->y,RGB(0,0,0));
				dc->SetPixel((int)Body[i]->x+1,(int)Body[i]->y,RGB(0,0,0));
				dc->SetPixel((int)Body[i]->x-1,(int)Body[i]->y,RGB(0,0,0));
				dc->SetPixel((int)Body[i]->x,(int)Body[i]->y+1,RGB(0,0,0));
				dc->SetPixel((int)Body[i]->x,(int)Body[i]->y-1,RGB(0,0,0));
			}
			break;
		case 2:// vykreslenie steny pre drotovy model
			dc->MoveTo((int)Body[0]->x,(int)Body[0]->y);

			for(i=1;i<Body.GetSize();i++)
				dc->LineTo((int)Body[i]->x,(int)Body[i]->y);
	
			dc->LineTo((int)Body[0]->x,(int)Body[0]->y);
			break;
		case 3:// vykreslenie steny pre stenovy model
			Vektor1 = new CVektor(Body[1],Body[0]);
			Vektor2 = new CVektor(Body[2],Body[1]);
			Normala = new CVektor(Vektor1,Vektor2);

			if(Normala->z<0)	//vypocita sa normala steny a ak je zetova suradnica zaporna, tak sa vykresli
			{
				dc->MoveTo((int)Body[0]->x,(int)Body[0]->y);

				for(i=1;i<Body.GetSize();i++)
					dc->LineTo((int)Body[i]->x,(int)Body[i]->y);
	
				dc->LineTo((int)Body[0]->x,(int)Body[0]->y);
			}

			delete Vektor1;
			delete Vektor2;
			delete Normala;
			break;
		case 4:// vykreslenie steny pre tienovany model
			Vektor1 = new CVektor(Body[1],Body[0]);
			Vektor2 = new CVektor(Body[2],Body[1]);
			Normala = new CVektor(Vektor1,Vektor2);
			
			if(Normala->z<0) // to iste co pre stenovy s tym, ze sa pocita aj sklon steny
			{				//	a podla toho sa urci jej farba (pocita sa uhol medzi normalov steny
							//	a vektorom svetla, ktory vznikne s bodov:ZdrojSvetla a Stred prisl. steny
				struct tagPOINT *Strana;
				Strana=new tagPOINT[Body.GetSize()];
				for(int i=0;i<Body.GetSize();i++)
				{
					Strana[i].x=(long)Body[i]->x;
					Strana[i].y=(long)Body[i]->y;
					StredPlochy->x+=Body[i]->x;
					StredPlochy->y+=Body[i]->y;
					StredPlochy->z+=Body[i]->z;
				}
				
				StredPlochy->x/=i;
				StredPlochy->y/=i;
				StredPlochy->z/=i;
			
				VektorSvetla = new CVektor(ZdrojSvetla,StredPlochy);
				Farba=(unsigned char)(VektorSvetla->UholMdVektormi(Normala)*1.6+111);
				CBrush* Vypln = new CBrush(RGB(Farba,Farba,Farba));
				CBrush* OldVypln=dc->SelectObject(Vypln);
				dc->Polygon(Strana,Body.GetSize());
				dc->SelectObject(OldVypln);
				delete Vypln;		
				delete VektorSvetla;
				delete Strana;
			}

			delete Vektor1;
			delete Vektor2;
			delete Normala;
			break;
	}

	delete ZdrojSvetla;
	delete StredPlochy;
	dc->SelectObject(pOldPen);

	
}

//////////////////////////////////////////////////////////////////////
// CMnohosten Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMnohosten::CMnohosten(FILE* Subor) //nahratie mnohostena
{
	int Pocet=3,index,x,y,z;
	char KoniecBodov=0;
	CBod *Bod;
	
	while (Pocet == 3)
	{
		Bod=new CBod;
		Pocet=fscanf(Subor,"%d %d %d\n",&x,&y,&z); 
						// natiahne jeden riadok so suboru = jeden bod
		Bod->x=(double)x;
		Bod->y=(double)y;
		Bod->z=(double)z;

		if (Pocet == 3)
			Body.Add(Bod); //prida bod so suboru do pola bodov
		else
			delete Bod;
	}

	fscanf(Subor,"%c",&KoniecBodov);
	
	CStena *Stena;
	while (index != 'e' && Pocet != -1)	// kym nie 'e', ako end, alebo 
										// kym uz v subore nic nie je
	{
		Stena=new CStena();
		Pocet=1;
		
		while(Pocet==1)
		{
			Pocet=fscanf(Subor,"%d",&index);

			if (Pocet==1)
				Stena->Body.Add(Body[index]); 
						// prida bod do mnoziny bodov mnohostenna
		}
		
		fscanf(Subor,"%c",&index);
		
		if(index == 's')	//ak 's' prida stranu do pola ploch monoplocha
			Plocha.Add(Stena);
	}
	
}

CMnohosten::~CMnohosten()
{
	for(int i=0;i<Plocha.GetSize();i++)
		delete Plocha[i];

	Body.RemoveAll();
	Plocha.RemoveAll();
}

void CMnohosten::Vykresli(CDC * dc,UINT Menu)	//fcia vykresli mnohosten
{	
	for(int i=0;i<Plocha.GetSize();i++)
		Plocha[i]->Vykresli(dc,Menu);	
}

//////////////////////////////////////////////////////////////////////
// CScena Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CScena::CScena()
{

}

CScena::~CScena()
{
	for(int i=0;i<Mnohoploch.GetSize();i++)
		delete Mnohoploch[i];

	Mnohoploch.RemoveAll();
}

void CScena::Vykresli(CDC *dc,UINT Menu) //vykreslenie sceny
{
	for(int i=0;i<Mnohoploch.GetSize();i++)
		Mnohoploch[i]->Vykresli(dc,Menu);

}

void CScena::Rotacia(UINT Menu,CBod* BodRotacie,int direct)
{
	//Zrotuje scenu po mnohostenoch

	for(int i=0;i<Mnohoploch.GetSize();i++)
		Mnohoploch[i]->Rotacia(Menu,BodRotacie,direct);
}

BOOL CGRAFIKA2Doc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	//zmaze sa stara a vytvori sa nova scenu
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	delete Scena;
	Scena= new CScena();
	FILE *VstupnySubor;
	VstupnySubor=fopen(lpszPathName,"rt");
	Scena->Nahraj(VstupnySubor);
	return TRUE;
}

void CGRAFIKA2Doc::Rotuj(UINT Smery,int direct)
{
	Scena->Rotacia(Smery,BodRotacie,direct);
}

void CScena::Nahraj(FILE *Subor)	//nahra sa scena po mnohoplochoch
{
	CMnohosten* MnPl;
	while(!feof(Subor))
	{
		MnPl=new CMnohosten(Subor);
		
		if(!feof(Subor))
			Mnohoploch.Add(MnPl);
	}
}

void CMnohosten::Rotacia(UINT Menu,CBod *BodRotacie,int direct)
{
	//fcia na rotaciu mnohoplochu podla smeru(Menu) a orientacie(direct)
	int i;
	CBod PomocnyBod(0,0,0);
	double Uhol,pi = 3.1415926535;

	if (direct)
		Uhol=-(double)1/180*pi;
	else
		Uhol=(double)1/180*pi;


	Menu-=4;
	
	if(Menu<=3)		//rotuj podla osi Z
		for(i=0;i<Body.GetSize();i++)
		{
			PomocnyBod.x= Body[i]->x-BodRotacie->x;
			PomocnyBod.y= Body[i]->y-BodRotacie->y;
			Body[i]->x=cos(Uhol)*PomocnyBod.x-sin(Uhol)*PomocnyBod.y+BodRotacie->x;
			Body[i]->y=cos(Uhol)*PomocnyBod.y+sin(Uhol)*PomocnyBod.x+BodRotacie->y;
		}
	else Menu+=4;
	
	Menu-=2;

	if(Menu<=1)		//rotuj podla osi Y
		for(i=0;i<Body.GetSize();i++)
		{
			PomocnyBod.x= Body[i]->x-BodRotacie->x;
			PomocnyBod.z= Body[i]->z-BodRotacie->z;
			Body[i]->x=cos(Uhol)*PomocnyBod.x+sin(Uhol)*PomocnyBod.z+BodRotacie->x;
			Body[i]->z=cos(Uhol)*PomocnyBod.z-sin(Uhol)*PomocnyBod.x+BodRotacie->z;
		}
	else Menu+=2;
	
	Menu-=1;
	
	if(Menu==0)		//rotuj podla osi X
		for(i=0;i<Body.GetSize();i++)
		{  
			PomocnyBod.y= Body[i]->y-BodRotacie->y;
			PomocnyBod.z= Body[i]->z-BodRotacie->z;	
			Body[i]->y=cos(Uhol)*PomocnyBod.y-sin(Uhol)*PomocnyBod.z+BodRotacie->y;//+.5;
			Body[i]->z=cos(Uhol)*PomocnyBod.z+sin(Uhol)*PomocnyBod.y+BodRotacie->z;//+.5;
		}
}



//////////////////////////////////////////////////////////////////////
// CVektor Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CVektor::CVektor(CBod *a, CBod *b) //z dvoch bodov spravi vektor
{
	x=b->x - a->x;
	y=b->y - a->y;
	z=b->z - a->z;
}

CVektor::~CVektor()
{

}

CVektor::CVektor(CVektor *u, CVektor *v) //vytvori vektor kolmy na vektory u a v 
{
	x= u->y * v->z - u->z * v->y;
	y= u->z * v->x - u->x * v->z;
	z= u->x * v->y - u->y * v->x;
}

double CVektor::UholMdVektormi(CVektor *v)	//vrati uhol medzi vektormi v intervale 0-90 stupnov
{
	double a,pi = 3.1415926535;

	a=90-180*(acos(SkalarnySucin(v)/(VelkostVektora()*VelkostVektora(v))))/pi;
	
	if(a>=0)
		return a;
	else
		return -a;
}

double CVektor::VelkostVektora() //vrati velkost vektora
{
	return sqrt(x * x + y * y + z * z);
}

double CVektor::VelkostVektora(CVektor *v)  //vrati velkost vektora
{
	return sqrt(v->x * v->x + v->y * v->y + v->z * v->z);
}

double CVektor::SkalarnySucin(CVektor *v) //vrati skalarny sucin vektorov
{
	return (x*v->x+y*v->y+z*v->z);
}
