// GRAFIKA2Doc.cpp : implementation of the CGRAFIKA2Doc class
//

#include "stdafx.h"
#include "GRAFIKA2.h"

#include "GRAFIKA2Doc.h"
#include <cmath>     
#include <iostream.h>              

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2Doc

IMPLEMENT_DYNCREATE(CGRAFIKA2Doc, CDocument)

BEGIN_MESSAGE_MAP(CGRAFIKA2Doc, CDocument)
	//{{AFX_MSG_MAP(CGRAFIKA2Doc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2Doc construction/destruction
int ZBuffer[1024][768];


CGRAFIKA2Doc::CGRAFIKA2Doc()
{	
	BodRotacie = new CBod(200,200,0);
	Scena= new CScena();
}

CGRAFIKA2Doc::~CGRAFIKA2Doc()
{
	delete BodRotacie;
	delete Scena;
}

BOOL CGRAFIKA2Doc::OnNewDocument() //deletne staru scenu a vytvori novu
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	delete Scena;
	Scena= new CScena();
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2Doc serialization

void CGRAFIKA2Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2Doc diagnostics

#ifdef _DEBUG
void CGRAFIKA2Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGRAFIKA2Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG



//////////////////////////////////////////////////////////////////////
// CBod Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


CBod::CBod()
{
	Normala=new CVektor(0,0,0);
}

CBod::CBod(double x1,double y1,double z1)
{
	x=x1;
	y=y1;
	z=z1;
	Normala=new CVektor(0,0,0);
}


CBod::~CBod()
{
	delete Normala;
}

//////////////////////////////////////////////////////////////////////
// CStena Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CStena::CStena()
{
}

CStena::~CStena()
{
	Body.RemoveAll();
}

void CStena::Vykresli(CDC *dc,UINT Menu) //fcia na vykreslenie jednej steny
{	
	int i;
	unsigned char Farba;
	CBrush* Vypln;
	CVektor V,U,Z;

	switch(Menu)
	{
		case 1:	//vykreslenie steny pre bodovy model
			for(i=0;i<Body.GetSize();i++)
			{
				dc->SetPixelV((int)Body[i]->x,(int)Body[i]->y,RGB(0,0,0));
				dc->SetPixelV((int)Body[i]->x+1,(int)Body[i]->y,RGB(0,0,0));
				dc->SetPixelV((int)Body[i]->x-1,(int)Body[i]->y,RGB(0,0,0));
				dc->SetPixelV((int)Body[i]->x,(int)Body[i]->y+1,RGB(0,0,0));
				dc->SetPixelV((int)Body[i]->x,(int)Body[i]->y-1,RGB(0,0,0));
			}
			break;
		case 2:// vykreslenie steny pre drotovy model
			dc->MoveTo((int)Body[0]->x,(int)Body[0]->y);

			for(i=1;i<Body.GetSize();i++)
				dc->LineTo((int)Body[i]->x,(int)Body[i]->y);

			dc->LineTo((int)Body[0]->x,(int)Body[0]->y);
			break;
		case 3:// vykreslenie steny pre stenovy model
			{
			double Z=0;
			
			for(i=0;i<Body.GetSize();i++)
				Z+=Body[i]->Normala->z;
							
			if(Z<0)	//vypocita sa normala steny a ak je zetova suradnica zaporna, tak sa vykresli
			{
				dc->MoveTo((int)Body[0]->x,(int)Body[0]->y);

				for(i=1;i<Body.GetSize();i++)
					dc->LineTo((int)Body[i]->x,(int)Body[i]->y);

				dc->LineTo((int)Body[0]->x,(int)Body[0]->y);
			}
			
			}			
			break;
		case 4:// vykreslenie steny pre tienovany model
			{
			double Z=0;
			int Pocet=0;
			struct tagPOINT *Strana;
							// to iste co pre stenovy s tym, ze sa pocita aj sklon steny
							//	a podla toho sa urci jej farba (pocita sa uhol medzi normalov steny
							//	a vektorom svetla, ktory vznikne s bodov:ZdrojSvetla a Stred prisl. steny
			Strana=new tagPOINT[Body.GetSize()];

			for(i=0;i<Body.GetSize();i++)
			{
				Strana[i].x=(long)Body[i]->x;
				Strana[i].y=(long)Body[i]->y;
				Z+=Body[i]->Normala->z;
				Pocet++;
			}
			Z/=(double)Pocet;
			Farba=(unsigned char)this->Farba(Z);
			Vypln = new CBrush(RGB(0,0,Farba));
			CBrush* OldVypln=dc->SelectObject(Vypln);
			dc->Polygon(Strana,Body.GetSize());
			dc->SelectObject(OldVypln);
			delete Vypln;		
			delete Strana;
			}
			break;
		case 5:
			{
			CArray<CBodHrany*,CBodHrany*> PoleBodov;
						
			for(i=1;i<Body.GetSize();i++)
				if((UINT)(Body[i-1]->y)!=(UINT)(Body[i]->y))
					BresLine(&PoleBodov,(int)Body[i-1]->x,(int)Body[i-1]->y,(int)Body[i-1]->z,(int)Body[i]->x,(int)Body[i]->y,(int)Body[i]->z,
						Body[i-1]->Normala->FarbaHT(),
						Body[i]->Normala->FarbaHT());
			
			if((UINT)(Body[i-1]->y)!=(UINT)(Body[0]->y))
				BresLine(&PoleBodov,(int)Body[i-1]->x,(int)Body[i-1]->y,(int)Body[i-1]->z,(int)Body[0]->x,(int)Body[0]->y,(int)Body[0]->z,
					Body[i-1]->Normala->FarbaHT(),
					Body[0]->Normala->FarbaHT());
			
			i=PoleBodov.GetSize();

			qsort(PoleBodov.GetData(), i,sizeof(CBodHrany *),::compare2);
	
			for(i=1;i<PoleBodov.GetSize();i++)
				if((UINT)(PoleBodov[i]->y)==(UINT)(PoleBodov[i-1]->y))
						BresLine(dc,(int)PoleBodov[i-1]->x,(int)PoleBodov[i]->x,(int)PoleBodov[i]->y,(int)PoleBodov[i-1]->z,(int)PoleBodov[i]->z,
							PoleBodov[i-1]->farba,PoleBodov[i]->farba);
							
			for(i=0;i<PoleBodov.GetSize();i++)
				delete PoleBodov[i];

			PoleBodov.RemoveAll();
			}
			break;
	}
}

//////////////////////////////////////////////////////////////////////
// CMnohosten Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMnohosten::CMnohosten(FILE* Subor) //nahratie mnohostena
{
	int PocetRB,Jemnost=10,Pocet=3,i,j,k,x,y,z,a,b;
	char TypPlochy,KoniecBodov=0;
	char index=0;
	CBod *Bod,*Bod1;
	double B[4],BT[4];
	double u,v;
	CStena *Stena;

  fscanf(Subor,"%c",&TypPlochy);
  if(TypPlochy!='e')
  {

	if((TypPlochy!='u')&&(TypPlochy!='s')&&(TypPlochy!='v'))
	{
		Typ=1;
		while (Pocet == 3)
		{
			Bod=new CBod;
			Pocet=fscanf(Subor,"%d %d %d\n",&x,&y,&z); 
						// natiahne jeden riadok so suboru = jeden bod
			Bod->x=(double)x;
			Bod->y=(double)y;
			Bod->z=(double)z;

			if (Pocet == 3)
				Body.Add(Bod); //prida bod so suboru do pola bodov
			else
				delete Bod;
		}

		fscanf(Subor,"%c",&KoniecBodov);
	
		while (index != 'e' && Pocet != -1)	// kym nie 'e', ako end, alebo 
										// kym uz v subore nic nie je
		{
			Stena=new CStena();
			Pocet=1;
		
			while(Pocet==1)
			{
				Pocet=fscanf(Subor,"%d",&index);

				if (Pocet==1)
					Stena->Body.Add(Body[index]); 
							// prida bod do mnoziny bodov mnohostenna
			}
		
			fscanf(Subor,"%c",&index);
		
			if(index == 's')	//ak 's' prida stranu do pola ploch monoplocha
				Plocha.Add(Stena);
		}
	
		fscanf(Subor,"%c",&index);
	}
	else
	{	
		Typ=2;
		while (Pocet == 3)
		{
			Bod=new CBod;
			Pocet=fscanf(Subor,"%d %d %d\n",&x,&y,&z); 
			 			// natiahne tri suradnice bodu so suboru = jeden bod
			Bod->x=(double)x;
			Bod->y=(double)y;
			Bod->z=(double)z;

			if (Pocet == 3)
				RiadiaciBod.Add(Bod); //prida bod so suboru do pola Riadiacich bodov
			else
				delete Bod;
		}

		Bod1=new CBod;
	
		for(u=0,a=0;u<=1;u+=(double)Jemnost/100.0,a++)
		{
			switch(TypPlochy)
			{
			case 'u':
				B[0]=pow(1-u,3);
				B[1]=3*u*(1-u)*(1-u);
				B[2]=3*u*u*(1-u);
				B[3]=pow(u,3);
				PocetRB=4;
				break;
			case 's':
				B[0]=2*pow(1-u,3)/6.0;
				B[1]=2*(3*pow(u,3)-6*u*u+u)/6.0;
				B[2]=2*(-3*pow(u,3)+3*u*u+3*u+1)/6.0;
				B[3]=2*pow(u,3)/6.0;
				PocetRB=4;
				break;
			case 'v':
				B[0]=pow(1-u,2);
				B[1]=2*u*(1-u);
				B[2]=pow(u,2);
				PocetRB=3;
				break;
			}
		
	
			for(v=0,b=0;v<=1;v+=(double)Jemnost/100.0,b++)
			{
				Bod=new CBod(0,0,0);
			
				switch(TypPlochy)
				{
				case 'u':
					BT[0]=pow(1-v,3);
					BT[1]=3*v*(1-v)*(1-v);
					BT[2]=3*v*v*(1-v);
					BT[3]=pow(v,3);
					break;
				case 's':
					BT[0]=2*pow(1-v,3)/6.0;
					BT[1]=2*(3*pow(v,3)-6*v*v+v)/6.0;
					BT[2]=2*(-3*pow(v,3)+3*v*v+3*v+1)/6.0;
					BT[3]=2*pow(v,3)/6.0;
					break;
				case 'v':
					BT[0]=pow(1-v,2);
					BT[1]=2*v*(1-v);
					BT[2]=pow(v,2);
					PocetRB=3;
					break;
				}
   
				for(i=0;i<PocetRB;i++)
				{
					Bod1->x=0;
					Bod1->y=0;
					Bod1->z=0;
			
					for(j=0;j<PocetRB;j++)
					{
						Bod1->x+=(RiadiaciBod[j+i*4]->x*BT[j]);
						Bod1->y+=(RiadiaciBod[j+i*4]->y*BT[j]);
						Bod1->z+=(RiadiaciBod[j+i*4]->z*BT[j]);
					}
			
					Bod->x+=(B[i]*Bod1->x);
					Bod->y+=(B[i]*Bod1->y);
					Bod->z+=(B[i]*Bod1->z);
				}
				
				Body.Add(Bod); //prida bod so suboru do pola bodov
			}

			if(a>0)
			{
				for(k=0;k<b-1;k++)
				{
					Stena=new CStena();
					Stena->Body.Add(Body[b*(a-1)+(k+1)]);
					Stena->Body.Add(Body[b*a+k]);
					Stena->Body.Add(Body[b*a+(k+1)]);
					Plocha.Add(Stena);
					Stena=new CStena();
					Stena->Body.Add(Body[b*a+k]);
					Stena->Body.Add(Body[b*(a-1)+(k+1)]);
					Stena->Body.Add(Body[b*(a-1)+k]);
					Plocha.Add(Stena);
				}
			}
		}
	
		delete Bod1;
	}
  }
}

CMnohosten::~CMnohosten()
{
	for(int i=0;i<Plocha.GetSize();i++)
		delete Plocha[i];

	Body.RemoveAll();
	RiadiaciBod.RemoveAll();
	Plocha.RemoveAll();
}

void CMnohosten::Vykresli(CDC * dc,UINT Menu)	//fcia vykresli mnohosten
{	
	int i,j;

	for(i=0;i<Plocha.GetSize();i++)		
	{
		for(j=0,Plocha[i]->Stred=0;j<Plocha[i]->Body.GetSize();j++)
			Plocha[i]->Stred+=(int)Plocha[i]->Body[j]->z;
	
			Plocha[i]->Stred/=j;
	}
	if(Menu==4)
	{
		i=Plocha.GetSize();
		qsort(Plocha.GetData(), i,sizeof(CStena *),::compare);
	}

	if(Typ==2)
		for(i=0;i<Plocha.GetSize();i++)
			Plocha[i]->Vykresli(dc,Menu);
	else
		for(i=0;i<Plocha.GetSize();i++)
			Plocha[i]->Vykresli2(dc,Menu);
}

//////////////////////////////////////////////////////////////////////
// CScena Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CScena::CScena()
{

}

CScena::~CScena()
{
	for(int i=0;i<Mnohoploch.GetSize();i++)
		delete Mnohoploch[i];

	Mnohoploch.RemoveAll();
}

void CScena::Vykresli(CDC *dc,UINT Menu) //vykreslenie sceny
{
	for(int ii=0;ii<800;ii++)
		for(int jj=0;jj<600;jj++)
			::ZBuffer[ii][jj]=10000;
	
		for(int i=0;i<Mnohoploch.GetSize();i++)
		Mnohoploch[i]->Vykresli(dc,Menu);

}

void CScena::Rotacia(UINT Menu,CBod* BodRotacie,int direct)
{
	//Zrotuje scenu po mnohostenoch

	for(int i=0;i<Mnohoploch.GetSize();i++)
		Mnohoploch[i]->Rotacia(Menu,BodRotacie,direct);
}

BOOL CGRAFIKA2Doc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	//zmaze sa stara a vytvori sa nova scenu
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	delete Scena;
	Scena= new CScena();
	FILE *VstupnySubor;
	VstupnySubor=fopen(lpszPathName,"rt");
	Scena->Nahraj(VstupnySubor);
	//fclose(VstupnySubor);
	return TRUE;
}

void CGRAFIKA2Doc::Rotuj(UINT Smery,int direct)
{
	Scena->Rotacia(Smery,BodRotacie,direct);
}

void CScena::Nahraj(FILE *Subor)	//nahra sa scena po mnohoplochoch
{
	CMnohosten* MnPl;

	while(!feof(Subor))
	{
		MnPl=new CMnohosten(Subor);
		
		if(!feof(Subor))
			Mnohoploch.Add(MnPl);
	}

	for(int i=0;i<Mnohoploch.GetSize();i++)
		Mnohoploch[i]->Inicializuj();
}

void CMnohosten::Rotacia(UINT Menu,CBod *BodRotacie,int direct)
{
	//fcia na rotaciu mnohoplochu podla smeru(Menu) a orientacie(direct)
	int i;
	CBod PomocnyBod(0,0,0);
	double Uhol,pi = 3.1415926535897932384626433832795;

	switch(direct)
	{
	case 0:Uhol=-(double)1/180*pi;
		break;
	case 1:Uhol=(double)1/180*pi;
		break;
	case 2:Uhol=-(double)10/180*pi;
		break;
	case 3:Uhol=(double)10/180*pi;
		break;
	}
	Menu-=4;
	
	if(Menu<=3)		//rotuj podla osi Z
		for(i=0;i<Body.GetSize();i++)
		{
			PomocnyBod.x= Body[i]->x-BodRotacie->x;
			PomocnyBod.y= Body[i]->y-BodRotacie->y;
			Body[i]->x=cos(Uhol)*PomocnyBod.x-sin(Uhol)*PomocnyBod.y+BodRotacie->x;
			Body[i]->y=cos(Uhol)*PomocnyBod.y+sin(Uhol)*PomocnyBod.x+BodRotacie->y;
			PomocnyBod.x= Body[i]->Normala->x;
			PomocnyBod.y= Body[i]->Normala->y;
			Body[i]->Normala->x=cos(Uhol)*PomocnyBod.x-sin(Uhol)*PomocnyBod.y;
			Body[i]->Normala->y=cos(Uhol)*PomocnyBod.y+sin(Uhol)*PomocnyBod.x;

		}
	else Menu+=4;
	
	Menu-=2;

	if(Menu<=1)		//rotuj podla osi Y
		for(i=0;i<Body.GetSize();i++)
		{
			PomocnyBod.x= Body[i]->x-BodRotacie->x;
			PomocnyBod.z= Body[i]->z-BodRotacie->z;
			Body[i]->x=cos(Uhol)*PomocnyBod.x+sin(Uhol)*PomocnyBod.z+BodRotacie->x;
			Body[i]->z=cos(Uhol)*PomocnyBod.z-sin(Uhol)*PomocnyBod.x+BodRotacie->z;
			PomocnyBod.x= Body[i]->Normala->x;
			PomocnyBod.z= Body[i]->Normala->z;
			Body[i]->Normala->x=cos(Uhol)*PomocnyBod.x+sin(Uhol)*PomocnyBod.z;
			Body[i]->Normala->z=cos(Uhol)*PomocnyBod.z-sin(Uhol)*PomocnyBod.x;
		
		}
	else Menu+=2;
	
	Menu-=1;
	
	if(Menu==0)		//rotuj podla osi X
		for(i=0;i<Body.GetSize();i++)
		{  
			PomocnyBod.y= Body[i]->y-BodRotacie->y;
			PomocnyBod.z= Body[i]->z-BodRotacie->z;	
			Body[i]->y=cos(Uhol)*PomocnyBod.y-sin(Uhol)*PomocnyBod.z+BodRotacie->y;//+.5;
			Body[i]->z=cos(Uhol)*PomocnyBod.z+sin(Uhol)*PomocnyBod.y+BodRotacie->z;//+.5;
			PomocnyBod.y= Body[i]->Normala->y;
			PomocnyBod.z= Body[i]->Normala->z;	
			Body[i]->Normala->y=cos(Uhol)*PomocnyBod.y-sin(Uhol)*PomocnyBod.z;//+.5;
			Body[i]->Normala->z=cos(Uhol)*PomocnyBod.z+sin(Uhol)*PomocnyBod.y;//+.5;
		}
}



//////////////////////////////////////////////////////////////////////
// CVektor Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CVektor::CVektor(CBod *a, CBod *b) //z dvoch bodov spravi vektor
{
	x=b->x - a->x;
	y=b->y - a->y;
	z=b->z - a->z;
}

CVektor::~CVektor()
{

}

CVektor::CVektor(CVektor *u, CVektor *v) //vytvori vektor kolmy na vektory u a v 
{
	x= u->y * v->z - u->z * v->y;
	y= u->z * v->x - u->x * v->z;
	z= u->x * v->y - u->y * v->x;
}

double CVektor::UholMdVektormi(CVektor *v)	//vrati uhol medzi vektormi v intervale 0-90 stupnov
{
	double a,pi = 3.1415926535;

	a=180*(acos(SkalarnySucin(v)/(VelkostVektora()*VelkostVektora(v))))/pi-90;
	
	if(a>=0 && a<255)
		return a;
	else
		return 0;// ///////////!!!!!!!!!!!!!!!!!!!!!1
}

double CVektor::VelkostVektora() //vrati velkost vektora
{
	return sqrt(x * x + y * y + z * z);
}

double CVektor::VelkostVektora(CVektor *v)  //vrati velkost vektora
{
	return sqrt(v->x * v->x + v->y * v->y + v->z * v->z);
}

double CVektor::SkalarnySucin(CVektor *v) //vrati skalarny sucin vektorov
{
	return (x*v->x+y*v->y+z*v->z);
}

void CStena::BresLine(CDC *dc,int x1,int x2,int y,int z1,int z2,int color1,int color2)
{
	int x,xend;
	double cincr,dz;
	double color,z;

	cincr=(double)(color2-color1)/(double)(x2-x1);
	dz=(double)(z2-z1)/(double)(x2-x1);

	if(x1>x2)
	{
		x=x2;
		z=z2;
		color=color2;
		xend=x1;
	}
	else
	{
		x=x1;
		z=z1;
		color=color1;
		xend=x2;
	}

	if(ZBuffer[x][y]>z)
	{
		dc->SetPixel(x,y,RGB(0,0,color));
		ZBuffer[x][y]=(int)z;
	}

	while(x<xend)
	{
		x++;
 		color+=cincr;
		z+=dz;
		
		if(ZBuffer[x][y]>z)
		{
			dc->SetPixel(x,y,RGB(0,0,color));
			ZBuffer[x][y]=(int)z;
		}
	}
}

void CStena::BresLine(CArray<CBodHrany*,CBodHrany*> *PoleBodov,int x1,int y1,int z1,int x2,int y2,int z2,int color1,int color2)
{
  int dx,dy,d,incr1,incr2,x,y,xend,pom;
  double cincr,dz,z;
  double color;

  dx=abs(x2-x1);
  dy=abs(y2-y1);
  pom=1;
  

  CBodHrany *Bod;
  if(dx>=dy)
  {
	incr1=2*dy;
	incr2=2*(dy-dx);
	d=2*dy-dx;
	cincr=(color2-color1)/(double)(x2-x1);
	dz=(double)(z2-z1)/(double)(x2-x1);

	if(x1>x2)
	{
	  x=x2;
	  y=y2;
	  z=z2;
	  color=color2;
	  xend=x1;

	  if(y1<y2)
		pom=-1;
	}
	else
	{
	  x=x1;
	  y=y1;
	  z=z1;
	  color=color1;
	  xend=x2;

	  if(y2<y1)
		pom=-1;
	}
	 
	Bod=new CBodHrany((double)x,(double)y,z,(int)color);
	PoleBodov->Add(Bod);

	while(x<xend)
	{
	  x++;
	  color+=cincr;
	  z+=dz;

	  if(d<0)
	  {
		d+=incr1;
	  }
	  else
	  {
		d+=incr2;
		y+=pom;
	  	Bod=new CBodHrany((double)x,(double)y,z,(int)color);
		PoleBodov->Add(Bod);
	  }
	}
  }

  else
  {
	d=2*dx-dy;
	incr1=2*dx;
	incr2=2*(dx-dy);
    cincr=(double)(color2-color1)/(double)(y2-y1);
	dz=(double)(z2-z1)/(double)(y2-y1);


	if (y1>y2)
	{
	  x=x2;
	  y=y2;
	  z=z2;
	  color=color2;
	  xend=y1;

	  if(x2>x1) pom=-1;
	}
	else
	{
	  x=x1;
	  y=y1;
	  z=z1;
	  color=color1;
	  xend=y2;

	  if(x1>x2) pom=-1;
	}

    Bod=new CBodHrany((double)x,(double)y,z,(int)color);
    PoleBodov->Add(Bod);

	while (y<xend)
	{
	  y++;
	  color+=cincr;
	  z+=dz;

	  if(d<0)
		d+=incr1;
	  else
	  {
		d+=incr2;
		x+=pom;
	  }

	  Bod=new CBodHrany((double)x,(double)y,z,(int)color);
	  PoleBodov->Add(Bod);
	}
  }
}
//////////////////////////////////////////////////////////////////////
// CBodHrany Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBodHrany::CBodHrany()
{

}

CBodHrany::~CBodHrany()
{

}

void CStena::VypNormaly()
{
	CVektor *Vektor1,*Vektor2,*Normala;
	Vektor1 = new CVektor(Body[0],Body[2]);
	Vektor2 = new CVektor(Body[1],Body[0]);
	Normala = new CVektor(Vektor1,Vektor2);


	for(int i=0;i<Body.GetSize();i++)
	{
		Body[i]->Normala->x+=Normala->x;
		Body[i]->Normala->y+=Normala->y;
		Body[i]->Normala->z+=Normala->z;
	}

	delete Vektor1;
	delete Vektor2;
	delete Normala;
}

void CStena::ZnulujNormaly()
{
	for(int i=0;i<Body.GetSize();i++)
	{
		Body[i]->Normala->x=0;
		Body[i]->Normala->y=0;
		Body[i]->Normala->z=0;
	}


}

int CVektor::FarbaHT()
{
	double a,pi = 3.1415926535897932384626433832795;
	a=180*acos(z)/pi-90;
	a*=1,5;
	a+=150;

	return (int)a;
}

int CStena::Farba(double Z)
{
	double a,pi = 3.1415926535897932384626433832795;
	a=180*acos(Z)/pi-90;
	a*=1,5;
	a+=150;

	return (int)a;
}

int compare(const void * p1, const void * p2)
{
	if( (*(CStena **)p1)->Stred > (*(CStena **)p2)->Stred )
		return -1;
	if( (*(CStena **)p1)->Stred < (*(CStena **)p2)->Stred )
		return 1;

	return 0;
}
int compare2(const void * p1, const void * p2)
{
	if( (*(CBodHrany **)p1)->y > (*(CBodHrany **)p2)->y )
		return -1;
	if( (*(CBodHrany **)p1)->y < (*(CBodHrany **)p2)->y )
		return 1;

	return 0;
}

void CMnohosten::Inicializuj()
{
	int i;
	double VelkostNormaly;

	for(i=0;i<Plocha.GetSize();i++)
		Plocha[i]->ZnulujNormaly();

	for(i=0;i<Plocha.GetSize();i++)
		Plocha[i]->VypNormaly();

	for(i=0;i<Body.GetSize();i++)
	{
		VelkostNormaly=Body[i]->Normala->VelkostVektora();
		Body[i]->Normala->x/=VelkostNormaly;
		Body[i]->Normala->y/=VelkostNormaly;
		Body[i]->Normala->z/=VelkostNormaly;
	}
}

void CStena::BresLine(CDC * dc, int x1, int x2, int y,int z1,int z2,unsigned char color)
{
	int x,xend;
	double z;
	double dz;

	dz=(double)(z2-z1)/(double)(x2-x1);


	if(x1>x2)
	{
		x=x2;
		z=z2;
		xend=x1;
	}
	else
	{
		x=x1;
		z=z1;
		xend=x2;
	}

	if(ZBuffer[x][y]>z)
	{
		dc->SetPixel(x,y,RGB(0,0,color));
		ZBuffer[x][y]=(int)z;
	}

	while(x<xend)
	{
		x++;
		z+=dz;

		if(ZBuffer[x][y]>z)
		{
			dc->SetPixel(x,y,RGB(0,0,color));
			ZBuffer[x][y]=(int)z;
		}
	}
}

void CStena::BresLine(CArray<CBodHrany*,CBodHrany*> *PoleBodov,int x1,int y1,int z1,int x2,int y2,int z2)
{
  int dx,dy,d,incr1,incr2,x,y,xend,pom;
  double z,dz;

  dx=abs(x2-x1);
  dy=abs(y2-y1);
  pom=1;
  CBodHrany *Bod;

  if(dx>=dy)
  {
	incr1=2*dy;
	incr2=2*(dy-dx);
	d=2*dy-dx;
	dz=(double)(z2-z1)/(double)(x2-x1);

	if(x1>x2)
	{
	  x=x2;
	  y=y2;
	  z=z2;
	  xend=x1;

	  if(y1<y2)
		pom=-1;
	}
	else
	{
	  x=x1;
	  y=y1;
	  z=z1;
	  xend=x2;

	  if(y2<y1)
		pom=-1;
	}
	 
	Bod=new CBodHrany((double)x,(double)y,z,0);
	PoleBodov->Add(Bod);

	while(x<xend)
	{
	  x++;
	  z+=dz;

	  if(d<0)
	  {
		d+=incr1;
	  }
	  else
	  {
		d+=incr2;
		y+=pom;
	  	Bod=new CBodHrany((double)x,(double)y,z,0);
		PoleBodov->Add(Bod);
	  }
	}
  }

  else
  {
	d=2*dx-dy;
	incr1=2*dx;
	incr2=2*(dx-dy);
	dz=(double)(z2-z1)/(double)(y2-y1);

	if (y1>y2)
	{
	  x=x2;
	  y=y2;
	  z=z2;
	  xend=y1;

	  if(x2>x1) pom=-1;
	}
	else
	{
	  x=x1;
	  y=y1;
	  z=z1;
	  xend=y2;

	  if(x1>x2) pom=-1;
	}

    Bod=new CBodHrany((double)x,(double)y,z,0);
    PoleBodov->Add(Bod);

	while (y<xend)
	{
	  y++;
	  z+=dz;

	  if(d<0)
		d+=incr1;
	  else
	  {
		d+=incr2;
		x+=pom;
	  }

	  Bod=new CBodHrany((double)x,(double)y,z,0);
	  PoleBodov->Add(Bod);
	}
  }
}

void CStena::Vykresli2(CDC * dc, UINT Menu)
{
	int i;
	unsigned char Farba;
	CBrush* Vypln;
	CVektor V,U,Z;
	switch(Menu)
	{
		case 1:	//vykreslenie steny pre bodovy model
			for(i=0;i<Body.GetSize();i++)
			{
				dc->SetPixelV((int)Body[i]->x,(int)Body[i]->y,RGB(0,0,0));
				dc->SetPixelV((int)Body[i]->x+1,(int)Body[i]->y,RGB(0,0,0));
				dc->SetPixelV((int)Body[i]->x-1,(int)Body[i]->y,RGB(0,0,0));
				dc->SetPixelV((int)Body[i]->x,(int)Body[i]->y+1,RGB(0,0,0));
				dc->SetPixelV((int)Body[i]->x,(int)Body[i]->y-1,RGB(0,0,0));
			}
			break;
		case 2:// vykreslenie steny pre drotovy model
			dc->MoveTo((int)Body[0]->x,(int)Body[0]->y);

			for(i=1;i<Body.GetSize();i++)
				dc->LineTo((int)Body[i]->x,(int)Body[i]->y);

			dc->LineTo((int)Body[0]->x,(int)Body[0]->y);
			break;
		case 3:// vykreslenie steny pre stenovy model
			{
			double Z=0;
			
			for(i=0;i<Body.GetSize();i++)
				Z+=Body[i]->Normala->z;
							
			if(Z<0)	//vypocita sa normala steny a ak je zetova suradnica zaporna, tak sa vykresli
			{
				dc->MoveTo((int)Body[0]->x,(int)Body[0]->y);

				for(i=1;i<Body.GetSize();i++)
					dc->LineTo((int)Body[i]->x,(int)Body[i]->y);

				dc->LineTo((int)Body[0]->x,(int)Body[0]->y);
			}
			
			}			
			break;
		case 4:// vykreslenie steny pre tienovany model
			{
			double Z=0;
			int Pocet=0;
			struct tagPOINT *Strana;
							// to iste co pre stenovy s tym, ze sa pocita aj sklon steny
							//	a podla toho sa urci jej farba (pocita sa uhol medzi normalov steny
							//	a vektorom svetla, ktory vznikne s bodov:ZdrojSvetla a Stred prisl. steny
			Strana=new tagPOINT[Body.GetSize()];

			for(i=0;i<Body.GetSize();i++)
			{
				Strana[i].x=(long)Body[i]->x;
				Strana[i].y=(long)Body[i]->y;
				Z+=Body[i]->Normala->z;
				Pocet++;
			}
			Z/=(double)Pocet;
			Farba=(unsigned char)this->Farba(Z);
			Vypln = new CBrush(RGB(0,0,Farba));
			CBrush* OldVypln=dc->SelectObject(Vypln);
			dc->Polygon(Strana,Body.GetSize());
			dc->SelectObject(OldVypln);
			delete Vypln;		
			delete Strana;
			}
			break;
		case 5:
			{
			double Z=0;
			int Pocet=0;
			CArray<CBodHrany*,CBodHrany*> PoleBodov;
						
			for(i=1;i<Body.GetSize();i++)
				if((UINT)(Body[i-1]->y)!=(UINT)(Body[i]->y))
					BresLine(&PoleBodov,(int)Body[i-1]->x,(int)Body[i-1]->y,(int)Body[i-1]->z,(int)Body[i]->x,(int)Body[i]->y,(int)Body[i]->z);
			
			if((UINT)(Body[i-1]->y)!=(UINT)(Body[0]->y))
				BresLine(&PoleBodov,(int)Body[i-1]->x,(int)Body[i-1]->y,(int)Body[i-1]->z,(int)Body[0]->x,(int)Body[0]->y,(int)Body[0]->z);
			
			i=PoleBodov.GetSize();

			qsort(PoleBodov.GetData(), i,sizeof(CBodHrany *),::compare2);
				
			for(i=0;i<Body.GetSize();i++)
			{
				Z+=Body[i]->Normala->z;
				Pocet++;
			}

			Z/=(double)Pocet;
			Farba=(unsigned char)this->Farba(Z);
			for(i=1;i<PoleBodov.GetSize();i++)
				if((UINT)(PoleBodov[i]->y)==(UINT)(PoleBodov[i-1]->y))
						BresLine(dc,(int)PoleBodov[i-1]->x,(int)PoleBodov[i]->x,(int)PoleBodov[i]->y,(int)PoleBodov[i-1]->z,(int)PoleBodov[i]->z,
							Farba);
							
			for(i=0;i<PoleBodov.GetSize();i++)
				delete PoleBodov[i];

			PoleBodov.RemoveAll();
			}
			break;
	}
}

