// GRAFIKA2Doc.h : interface of the CGRAFIKA2Doc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRAFIKA2DOC_H__843247CD_5C5C_11D2_9245_00608C63A44F__INCLUDED_)
#define AFX_GRAFIKA2DOC_H__843247CD_5C5C_11D2_9245_00608C63A44F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

int compare(const void *, const void *);
int compare2(const void * , const void *);


class CBod;

class CVektor 
{
public:	
	int FarbaHT();
	double SkalarnySucin(CVektor *); 
	double VelkostVektora(CVektor*);
	double VelkostVektora();
	double UholMdVektormi(CVektor*);
	CVektor():x(0),y(0),z(0){};
	CVektor(double x1,double y1, double z1):x(x1),y(y1),z(z1){};
	CVektor(CBod *,CBod *);
	CVektor(CVektor*,CVektor*);
	virtual ~CVektor();
	double x;
	double y;
	double z;
};

class CBod	//trieda Bod
{
public:
	CBod();
	CBod(double x1,double y1,double z1);
	virtual ~CBod();
	double x;
	double y;
	double z;
	CVektor *Normala;
};

class CGRAFIKA2Doc;
class CStena;
class CMnohosten;
class CScena;

class CGRAFIKA2Doc : public CDocument
{
protected: // create from serialization only
	CGRAFIKA2Doc();
	DECLARE_DYNCREATE(CGRAFIKA2Doc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGRAFIKA2Doc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	void Rotuj(UINT,int);
	CBod * BodRotacie;
	CScena *Scena;
	virtual ~CGRAFIKA2Doc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGRAFIKA2Doc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
class CBodHrany  
{
public:	
	double x;
	double y;
	double z; //pre Z-buffer
	int farba;
	CBodHrany();
	CBodHrany(double x1,double y1,double z1,int farba1):x(x1),y(y1),z(z1),farba(farba1){};
	virtual ~CBodHrany();

};

class CStena  
{
public:
	void Vykresli2(CDC *dc,UINT Menu);
	void BresLine(CArray<CBodHrany*,CBodHrany*>*,int,int,int,int,int,int);
	void BresLine(CDC *,int,int,int,int,int,unsigned char);
	int Stred;
	void ZnulujNormaly();
	void VypNormaly();
	void BresLine(CDC *,int,int,int,int,int,int,int);
	void BresLine(CArray<CBodHrany*,CBodHrany*>*,int,int,int,int,int,int,int,int);
	CArray<CBod*,CBod*> Body;
	void Vykresli(CDC *dc,UINT Menu);
	CArray<int,int> IndexNaBod;	//Pole indexov do pola bodov

	CStena();
	virtual ~CStena();
private:
	int Farba(double);
};

class CMnohosten  
{
public:
	int Typ;
	void Inicializuj();
	void Rotacia(UINT,CBod*,int);
	CArray<CBod*,CBod*> Body;
	CArray<CBod*,CBod*> RiadiaciBod;
	void Vykresli(CDC * dc,UINT Menu);
	CArray<CStena*,CStena*> Plocha;
	CMnohosten(FILE*);
	virtual ~CMnohosten();
};

class CScena  
{
public:
	void Nahraj(FILE *);
	void Rotacia(UINT,CBod*,int);
	CArray<CMnohosten*,CMnohosten*> Mnohoploch;
	void Vykresli(CDC *dc,UINT Menu);
	CScena();
	virtual ~CScena();
};




//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRAFIKA2DOC_H__843247CD_5C5C_11D2_9245_00608C63A44F__INCLUDED_)
