// GRAFIKA2View.cpp : implementation of the CGRAFIKA2View class
//

#include "stdafx.h"
#include "GRAFIKA2.h"

#include "GRAFIKA2Doc.h"
#include "GRAFIKA2View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2View

IMPLEMENT_DYNCREATE(CGRAFIKA2View, CView)

BEGIN_MESSAGE_MAP(CGRAFIKA2View, CView)
	//{{AFX_MSG_MAP(CGRAFIKA2View)
	ON_COMMAND(ID_ZOBRAZENIE_BODOVE, OnZobrazenieBodove)
	ON_COMMAND(ID_ZOBRAZENIE_DROTOVE, OnZobrazenieDrotove)
	ON_COMMAND(ID_ZOBRAZENIE_STENOVE, OnZobrazenieStenove)
	ON_UPDATE_COMMAND_UI(ID_ZOBRAZENIE_BODOVE, OnUpdateZobrazenieBodove)
	ON_UPDATE_COMMAND_UI(ID_ZOBRAZENIE_DROTOVE, OnUpdateZobrazenieDrotove)
	ON_UPDATE_COMMAND_UI(ID_ZOBRAZENIE_STENOVE, OnUpdateZobrazenieStenove)
	ON_COMMAND(ID_ROTUJOKOLOZ, OnRotujokoloz)
	ON_UPDATE_COMMAND_UI(ID_ROTUJOKOLOZ, OnUpdateRotujokoloz)
	ON_COMMAND(ID_ROTUJOKOLOY, OnRotujokoloy)
	ON_UPDATE_COMMAND_UI(ID_ROTUJOKOLOY, OnUpdateRotujokoloy)
	ON_COMMAND(ID_ROTUJOKOLOX, OnRotujokolox)
	ON_UPDATE_COMMAND_UI(ID_ROTUJOKOLOX, OnUpdateRotujokolox)
	ON_COMMAND(ID_BUTTON32783, OnButton32783)
	ON_COMMAND(ID_BUTTON32787, OnButton32787)
	ON_COMMAND(ID_BUTTON32789, OnButton32789)
	ON_COMMAND(ID_BUTTON32793, OnButton32793)
	ON_COMMAND(ID_BUTTON32794, OnButton32794)
	ON_COMMAND(ID_ZOBRAZENIE_HT, OnZobrazenieHt)
	ON_COMMAND(ID_ZOBRAZENIE_DT, OnZobrazenieDt)
	ON_UPDATE_COMMAND_UI(ID_ZOBRAZENIE_DT, OnUpdateZobrazenieDt)
	ON_UPDATE_COMMAND_UI(ID_ZOBRAZENIE_HT, OnUpdateZobrazenieHt)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2View construction/destruction

CGRAFIKA2View::CGRAFIKA2View()
{
	Menu1 = 1;			//na zaciatku bodovy model a rotacia podla osi X
	RotujX=TRUE;	
	RotujY=FALSE;
	RotujZ=FALSE;
	mybitmap=NULL;
	mydc=new CDC;
	mydc->CreateCompatibleDC(NULL);

}

CGRAFIKA2View::~CGRAFIKA2View()
{
}

BOOL CGRAFIKA2View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	BOOL ret = CView::PreCreateWindow(cs);

	cs.lpszClass = AfxRegisterWndClass(CS_DBLCLKS|CS_HREDRAW|CS_VREDRAW,
		                               AfxGetApp()->LoadStandardCursor(IDC_ARROW));
	
	return ret;
	//return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2View drawing

void CGRAFIKA2View::OnDraw(CDC* pDC)
{
	CPen* Pero;
//		Sleep(1000);
	
	if(Menu1==4)
		Pero= new CPen(PS_NULL,0,RGB(0,0,0));
	else
		Pero= new CPen(PS_SOLID,1,RGB(0,0,0));

	CGRAFIKA2Doc* pDoc = GetDocument();
	
	ASSERT_VALID(pDoc);
    
	if(ZmenaOkna)
	{
		if(mybitmap)
		{
			mydc->SelectObject(oldbitmap);
			delete mybitmap;
		}
		mybitmap=new CBitmap;
		mybitmap->CreateCompatibleBitmap(pDC,velkostX,velkostY);
		oldbitmap=mydc->SelectObject(mybitmap);
		mydc->BitBlt(0,0,velkostX,velkostY,pDC,0,0,WHITENESS);   
		ZmenaOkna=FALSE;
	}

	CPen* pOldPen = mydc->SelectObject(Pero);
    mydc->BitBlt(0,0,velkostX,velkostY,mydc,0,0,WHITENESS);
	pDoc->Scena->Vykresli(mydc,Menu1);
	pDC->BitBlt(0,0,velkostX,velkostY,mydc,0,0,SRCCOPY);
	mydc->SelectObject(pOldPen);
	delete Pero;
}

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2View diagnostics

#ifdef _DEBUG
void CGRAFIKA2View::AssertValid() const
{
	CView::AssertValid();
}

void CGRAFIKA2View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGRAFIKA2Doc* CGRAFIKA2View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGRAFIKA2Doc)));
	return (CGRAFIKA2Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGRAFIKA2View message handlers

void CGRAFIKA2View::OnZobrazenieBodove() 
{
	Menu1=1;
	Invalidate();
	UpdateWindow();
}

void CGRAFIKA2View::OnZobrazenieDrotove() 
{
	Menu1=2;
	Invalidate();
	UpdateWindow();

}

void CGRAFIKA2View::OnZobrazenieStenove() 
{
	Menu1=3;
	Invalidate();
	UpdateWindow();
}


void CGRAFIKA2View::OnZobrazenieDt() 
{
	Menu1=4;
	Invalidate();
	UpdateWindow();
}

void CGRAFIKA2View::OnZobrazenieHt() 
{
	Menu1=5;
	Invalidate();
	UpdateWindow();
}
void CGRAFIKA2View::OnUpdateZobrazenieBodove(CCmdUI* pCmdUI) 
{
	if(Menu1==1)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CGRAFIKA2View::OnUpdateZobrazenieDrotove(CCmdUI* pCmdUI) 
{
	if(Menu1==2)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CGRAFIKA2View::OnUpdateZobrazenieStenove(CCmdUI* pCmdUI) 
{
	if(Menu1==3)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CGRAFIKA2View::OnUpdateZobrazenieDt(CCmdUI* pCmdUI) 
{
	if(Menu1==4)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
	
}

void CGRAFIKA2View::OnUpdateZobrazenieHt(CCmdUI* pCmdUI) 
{
	if(Menu1==5)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
	
}

void CGRAFIKA2View::OnRotujokolox() 
{
	if(RotujX)
		RotujX=FALSE;
	else
		RotujX=TRUE;
}

void CGRAFIKA2View::OnUpdateRotujokolox(CCmdUI* pCmdUI) 
{
	if(RotujX)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);	
}

void CGRAFIKA2View::OnRotujokoloy() 
{
	if(RotujY)
		RotujY=FALSE;
	else
		RotujY=TRUE;	
}

void CGRAFIKA2View::OnUpdateRotujokoloy(CCmdUI* pCmdUI) 
{
	if(RotujY)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CGRAFIKA2View::OnRotujokoloz() 
{
	if(RotujZ)
		RotujZ=FALSE;
	else
		RotujZ=TRUE;
}

void CGRAFIKA2View::OnUpdateRotujokoloz(CCmdUI* pCmdUI) 
{
	if(RotujZ)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CGRAFIKA2View::OnButton32783() //rotuj do lava 30 krat
{
	
	CGRAFIKA2Doc* pDoc = GetDocument();

	UINT Smery=0;
	if(RotujX)
		Smery+=1;
	if(RotujY)
		Smery+=2;
	if(RotujZ)
		Smery+=4;

	pDoc->Rotuj(Smery,3);
	Invalidate();
	UpdateWindow();
}
/////////////////////////////////////////////////////////////////////////////
// CBodOtocDlg dialog

CBodOtocDlg::CBodOtocDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBodOtocDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBodOtocDlg)
	m_BodOtocZ = 200;
	m_BodOtocX = 200;
	m_BodOtocY = 200;
	//}}AFX_DATA_INIT
}


void CBodOtocDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBodOtocDlg)
	DDX_Text(pDX, IDC_EDIT3, m_BodOtocZ);
	DDX_Text(pDX, IDC_EDIT1, m_BodOtocX);
	DDX_Text(pDX, IDC_EDIT2, m_BodOtocY);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBodOtocDlg, CDialog)
	//{{AFX_MSG_MAP(CBodOtocDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBodOtocDlg message handlers

int CBodOtocDlg::DoModal(CBod *SBod) //dialog pre stred rotacie
{
	int Result;

	m_BodOtocX=(int)SBod->x;
	m_BodOtocY=(int)SBod->y;
	m_BodOtocZ=(int)SBod->z;
	
	Result=CDialog::DoModal();

	if(Result == 1)	
	{
		SBod->x=m_BodOtocX;
		SBod->y=m_BodOtocY;
		SBod->z=m_BodOtocZ;
	}

	return Result;
}

void CGRAFIKA2View::OnButton32787() 
{
	// TODO: Add your command handler code here
	CBodOtocDlg dialog;
	CGRAFIKA2Doc* pDoc = GetDocument();
	dialog.DoModal(pDoc->BodRotacie);
}



void CGRAFIKA2View::OnButton32789() //rotacia do prava 30 krat
{
		CGRAFIKA2Doc* pDoc = GetDocument();

	UINT Smery=0;
	if(RotujX)
		Smery+=1;
	if(RotujY)
		Smery+=2;
	if(RotujZ)
		Smery+=4;

	pDoc->Rotuj(Smery,2);
	Invalidate();
	UpdateWindow();
}

void CGRAFIKA2View::OnButton32793() //rotacia do lava 1 krat
{
	CGRAFIKA2Doc* pDoc = GetDocument();

	UINT Smery=0;
	
	if(RotujX)
		Smery+=1;
	if(RotujY)
		Smery+=2;
	if(RotujZ)
		Smery+=4;

	pDoc->Rotuj(Smery,1);
	Invalidate();
	UpdateWindow();
}

void CGRAFIKA2View::OnButton32794() //rotacia do prava 1 krat
{
	CGRAFIKA2Doc* pDoc = GetDocument();

	UINT Smery=0;

	if(RotujX)
		Smery+=1;
	if(RotujY)
		Smery+=2;
	if(RotujZ)
		Smery+=4;
	
	pDoc->Rotuj(Smery,0);
	Invalidate();
	UpdateWindow();
}

void CGRAFIKA2View::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	ZmenaOkna=TRUE;
	velkostX=cx;
	velkostY=cy;	
}
/*void CGRAFIKA2View::OnInitialUpdate()
{
	velkostX=::GetSystemMetrics(SM_CXSCREEN);
	velkostY=::GetSystemMetrics(SM_CYSCREEN);

	ZmenaOkna=TRUE;
}
*/
