//-------------------------------------------------------------------
// PROGRAM: gen2bill.cpp
//
// By: Joseph A Fisher
//
// Date: August, 1992
// Subject: Main program to generate 2^31-2 random numbers.
//
// To generate 2^31 - 2 random numbers took 6.5 hrs on a 50 mhz IBM PC.
//
// RandNumGen.ZIP version 1.00, Copyright (C) 1992, Joseph A Fisher
// RandNumGen.ZIP comes with ABSOLUTELY NO WARRANTY and is copyrighted under
// the terms of the GNU General Public License.
//-------------------------------------------------------------------

#pragma hdrstop

//---------------------------- Includes ---------------------------//
#include <stdio.h>
#include <iostream.h>
#include "random.hpp"
#include <dos.h>

const long LONG_MAX =2147483647;
const long LONG_TEST=2147483645;

int main( int argc, char* argv[ ] )
    {
    //-- open the random.dat output data file for writing --//
    FILE *pOutput1 = fopen( "random1.dat", "wt" );
    if ( pOutput1 == NULL )
        {
        cout << "Error opening random1.dat output data file";
        return 0;
        }

    cout << "\n\nPlease wait while random numbers are generated!\n";
    cout << "This takes 6.5 hrs on a 486-50\n";

    //-- create every possible type of random number object --//
    RandUniform RNG1( (UINT) 1, (long) 1, "RandUniform" );

    //-- print the headers --//
    struct dostime_t t;
    _dos_gettime(&t);

    fprintf( pOutput1, "The current time is: %2d:%02d:%02d\n",
             t.hour, t.minute, t.second );

    fprintf( pOutput1, "%-25s\n", RNG1.GetHeader() );
    fprintf( pOutput1, "%-12ld\n", RNG1.GetSeed() );    // starting seed

    //-- print 19 numbers from the stream of length 2^31 - 2 --//
    //-- this will circle around to the beginning seed --//
#if 0
    for ( long j = 0; j < 19; j++ )
    {
        //-- generate random numbers --//
        for( long i = 0; i < 113025455; i++ )
            RNG1.GetUnif01();

        fprintf( pOutput1, "%-12ld\n", RNG1.GetSeed() );
    };
#endif

    RNG1.GetUnif01();
    fprintf( pOutput1, "%-12ld\n", RNG1.GetSeed() );

    _dos_gettime(&t);
    fprintf( pOutput1, "The current time is: %2d:%02d:%02d\n",
             t.hour, t.minute, t.second );

    //-- close the output file --//
    fclose( pOutput1 );

    cout << "See random1.dat for output of random numbers.\n\n";

    return 1;
    }

