//-------------------------------------------------------------------
// PROGRAM: generate.cpp
//
// By: Joseph A Fisher
//
// Date: April 1992
// Subject: Main program to generate random numbers to an output file.
//
// RandNumGen.ZIP version 1.00, Copyright (C) 1992, Joseph A Fisher
// RandNumGen.ZIP comes with ABSOLUTELY NO WARRANTY and is copyrighted under
// the terms of the GNU General Public License.
//-------------------------------------------------------------------

#pragma hdrstop

//---------------------------- Includes ---------------------------//
#include <stdio.h>
#include <iostream.h>
#include "random.hpp"


int main( int argc, char* argv[ ] )
   {
   //-- open the random.dat output data file for writing --//
   FILE *pOutput1 = fopen( "random1.dat", "wt" );
   FILE *pOutput2 = fopen( "random2.dat", "wt" );
   if ( pOutput1 == NULL || pOutput2 == NULL )
      {
      cout << "Error opening random1.dat or ramdom2.dat output data file";
      return 0;
      }

   cout << "\n\nPlease wait while random numbers are generated!\n\n";

   //-- create every possible type of random number object --//
   RandUniform         RNG1  ( 0.0, 1.0 );
   RandExponential     RNG2  ( 5.5 );
   RandTriangular      RNG3  ( 1.0, 5.0, 10.0 );
   RandWeibull         RNG4  ( 3.0, 6.0 );
   RandPoisson         RNG5  ( 6.0 );
   RandErlang          RNG6  ( 5, 5.0 );
   RandBernoulli       RNG7  ( 0.65 );
   RandNormal          RNG8  ( 5.0, 1.0, 0 );
   RandLogNormal       RNG9  ( 10.0, 3.5, 0 );
   RandBeta            RNG10 ( 2.1, 4.1, 0, 1 );
   Rand_F              RNG11 ( 4, 40, 1, 0 );
   RandDiscreteUniform RNG12 ( (long) 5, 10, 0 );
   RandBinomial        RNG13 ( 20, 0.99 );
   Rand_T              RNG14 ( 10, 0 );
   RandChiSquare       RNG15 ( 4, 0 );
   RandGamma           RNG16 ( 0.85, 0.4 );
   RandGeometric       RNG17 ( 0.25 );
   RandNegBinomial     RNG18 ( 5, 0.5 );


   //-- print the headers --//
   fprintf( pOutput1, "%-25s" "%-25s" "%-25s" "%-25s" "%-25s" "%-25s"
                      "%-25s" "%-25s" "%-25s\n", RNG1.GetHeader(),
                      RNG2.GetHeader(), RNG3.GetHeader(), RNG4.GetHeader(),
                      RNG5.GetHeader(), RNG6.GetHeader(), RNG7.GetHeader(),
                      RNG8.GetHeader(), RNG9.GetHeader() );

   //-- print the headers --//
   fprintf( pOutput2, "%-25s" "%-25s" "%-25s" "%-25s" "%-25s" "%-25s"
                      "%-25s" "%-25s" "%-25s\n", RNG10.GetHeader(),
                      RNG11.GetHeader(), RNG12.GetHeader(), RNG13.GetHeader(),
                      RNG14.GetHeader(), RNG15.GetHeader(), RNG16.GetHeader(),
                      RNG17.GetHeader(), RNG18.GetHeader() );


   //-- generate random numbers --//
   for( UINT i = 0; i < 1000; i++ )
      {
      //-- print out the random numbers --//
      fprintf( pOutput1, "%-25.10f" "%-25.10f" "%-25.10f" "%-25.10f"
                  "%-25.10f" "%-25.10f" "%-25.10f" "%-25.10f" "%-25.10f\n",
               RNG1.RandValue(), RNG2.RandValue(), RNG3.RandValue(),
               RNG4.RandValue(), RNG5.RandValue(), RNG6.RandValue(),
               RNG7.RandValue(), RNG8.RandValue(), RNG9.RandValue() );


      //-- print out the random numbers --//
      fprintf( pOutput2, "%-25.10f" "%-25.10f" "%-25.10f" "%-25.10f"
                  "%-25.10f" "%-25.10f" "%-25.10f" "%-25.10f" "%-25.10f\n",
               RNG10.RandValue(), RNG11.RandValue(), RNG12.RandValue(),
               RNG13.RandValue(), RNG14.RandValue(), RNG15.RandValue(),
               RNG16.RandValue(), RNG17.RandValue(), RNG18.RandValue() );
      }

   //-- close the output file --//
   fclose( pOutput1 );
   fclose( pOutput2 );

   cout << "See random1.dat and random2.dat for output of random numbers.\n\n";

   return 1;
   }
