#include <graphics.h>
#include <conio.h>
#include <stdio.h>
#include <dos.h>
#include <malloc.h>
#include <string.h>
#include <math.h>

class Mys
{
 public:
 int x,y;		//suradnice mysi
 int xx,yy;		//pamatanie si predchadzajucich suradnic mysi
 int buttons;		//stav tlacitok na mysi
 int vis;
 void init() { struct REGPACK reg;reg.r_ax=0;intr(0x33, &reg);vis=1;}
 void on()   { struct REGPACK reg;reg.r_ax=1;intr(0x33, &reg);} //zap./vyp. mysi
 void off()  { struct REGPACK reg;reg.r_ax=2;intr(0x33, &reg);}
 void get();	//zistenie stavu mysi
};
class Button:public Mys
{
 public:
 static int * pf;
 int  x1;		//rozmery buttonu
 int  y1;
 int  x2;
 int  y2;
 char *name;		//text v buttone
 int  farba;		//farba buttonu
 char stav;		//ci je zapnuty, alebo vypnuty

 Button(int xt1,int yt1,int xt2,int yt2, char *tname="", int tfarba=16)
	{
	 x1 = xt1;
	 y1 = yt1;
	 x2 = xt2;
	 y2 = yt2;
	 name = tname;
	 farba = tfarba;
	 stav = 0;
	 Mys::on();
	}
 void off();		//procedury na zapinanie a vypinanie jednotlivych
 void on();		//typov buttonov
 void on_c();
 void off_c();
 void on_t();
 void off_t();
 void on_s();
 void off_s();
 void on_k();
 void off_k();
 void on_l();
 void off_l();
 void on_p();
 void off_p();
};


class Polozka :public Mys   //polozka Roll menu
{
   public:
   int tx;		    //pozicia polozky
   int ty;
   char *meno;              //meno polozky
   Polozka (int x,int y,char *m):tx(x),ty(y),meno(m) {   }
   void vypisn();	    //vypis polozky, ako aktivnej
   void vypisa();	    //vypis polozky, ako neaktivnej
};

class Roll:public Mys       //okienko rolovacieho menu
{
   public:		    //suradnice okienka
   int rx1;
   int ry1;
   int rx2;
   int ry2;
   int pocet;		    //pocet poloziek v Roll menu
   char **polozky;
   void far *image;	    //pointer, kam sa odlozi BMP spod okienka
   Polozka *pol[10];	    //pole pointerov na polozky Roll menu
   Roll(int x1,int y1,int x2,int p,char **po=NULL):rx1(x1),rx2(x2),ry1(y1),ry2(y1+p*12+2),pocet(p),polozky(po),image(NULL) { }
   ~Roll();
   void draw();		    //nakreslenie okienka
   int aktiv();		    //vyberie aktivnu polozku z okienka a vrati jej
			    //poradie
};

class Menu:public Mys
{
  public:
  char **mena;
  char *mpo[2][7];              //pointery na mena poloziek v roll
  int popol[3];                 //pocet poloziek v jedn. roll
  int obj;			//aktualny button objektu
  int pf;			//aktualny button farby
  Button *to[3+5+2+7+1];	//pole pointerov na buttony
  Roll *rol;			//pointer na Roll menu

  Menu(char **);
  int vyber();			//vyber z rolovacich menu
  int vyber2();			//vyber z tlacitkovych menu
};

class Bod:public Mys		//abstraktna trieda, z ktorej dedia triedy
{				//Kruh, Stvorec, Ciara, Trojuholnik, Polygon
  public:
  int x1,y1,x2,y2,color,vypl;
  Bod() {};
  Bod(int a,int b,int c,int d,int e):x1(a),y1(b),x2(c),y2(d),color(e) {}
  /* Vsetky tieto poznamky platia aj pre triedy Kruh, Stvorec, Ciara, Troj*/
  virtual void kresli(int=0)=0;//vykreslenie objektu
  virtual void zvzm()=0;       //zmena velkosti objektu
  virtual void posun()=0;      //posun objektu
  virtual void zmaz()=0;       //zmazanie objektu z obrazovky
  virtual int  ident()=0;       //identifikacia, co je to za objekt
  virtual void getsur(int &,int &,int &,int &,int &,int &,int &)=0;
		//objekt vrati vsetky svoje suradnice
  virtual void stred(int &, int &)=0;
  virtual void vypln(int, int, int);
  virtual void otoc()=0;
  virtual int orez(int,int,int,int,int)=0;
  virtual void uloz(FILE *)=0;

};

class Kruh:public Bod
{
  public:
  int r;

  Kruh(int);
  Kruh(FILE *);
  Kruh(int a,int b,int c,int d):Bod(a,b,0,0,d),r(c) {kresli();}
  ~Kruh();
  void getsur (int &a,int &b,int &c,int &d,int &,int &,int &) {a=x1;b=y1,c=r,d=color;}
  void kresli(int=0);
  void zvzm();
  void posun();
  void zmaz(){ delete this;}
  int ident() {return 'k';}
  void stred(int &sx,int &sy) {sx=x1;sy=y1;}
  void otoc();
  int orez(int,int,int,int,int);
  void uloz(FILE *);
};

class Stvorec:public Bod
{
  public:
  int x3,x4,y3,y4;

  Stvorec(int);
  Stvorec(FILE *);
  Stvorec(int a,int b,int c,int d,int e):Bod(a,b,c,d,e) {kresli();}
  ~Stvorec();
  void getsur(int &a,int &b,int &c,int &d,int &e,int &,int &) {a=x1;b=y1;c=x2;d=y2;e=color;}
  void kresli(int=0);
  void zvzm();
  void posun();
  void zmaz(){ delete this;}

  int ident() {return 's';}
  void stred(int &sx, int &sy) {sx=(x1+x2+x3+x4)/4;sy=(y1+y2+y3+y4)/4;}
  void otoc();
  int orez(int,int,int,int,int);
  void uloz(FILE *);

};

class Troj:public Bod
{
  public:
  int x3,y3;

  Troj(int);
  Troj(FILE *);
//  Troj(int a,int b,int c,int d,int e,int f,int g):Bod(a,b,c,d,g),x3(e),y3(f) {kresli();}
  ~Troj();
  void getsur(int &a,int &b,int &c,int &d,int &e,int &f,int &g) {a=x1;b=y1;c=x2;d=y2;e=x3;f=y3;g=color;}
  void kresli(int=0);
  void zvzm();
  void posun();
  void zmaz(){ delete this;}
  int ident() {return 't';}
  void stred(int &sx, int &sy) {sx=(x1+x2+x3)/3;sy=(y1+y2+y3)/3;}
  void otoc();
  int orez(int,int,int,int,int);
  void uloz(FILE *);

};

class Ciara:public Bod
{
  public:
  int cox1,cox2,coy1,coy2;
  Ciara(int);
  Ciara(int,int, int);
  Ciara(int a,int b,int c,int d,int e):Bod(a,b,c,d,e) {}
  Ciara(FILE *);
  ~Ciara();
  void getsur(int &a,int &b,int &c,int &d,int &e,int &,int &) {a=x1;b=y1;c=x2;d=y2;e=color;}
  void kresli(int=0);
  void zvzm();
  void posun();
  void zmaz(){ delete this;}
  int ident() {return 'c';}
  void stred(int &, int &){};
  void vypln(int,int,int) {};
  void otoc();
  int vo(int,int);
  int orez(int,int,int,int,int);
  void orezus(int,int,int,int,int);
  void uloz(FILE *);


};




#include "zozn.cpp"

class Obraz:public Mys
{
 DList zozn;
 public:
 int ore,ox1,ox2,oy1,oy2;

 Obraz() :ore(0) {}
 void novy(int,int);    //nakreslenie noveho objektu
 void zrus();		//zmazanie aktualneho objektu
 void dalsi();		//prepnutie na nasledujuci objekt
 void predch();		//prepnutie na predchadzajuci objekt
 void redraw();		//prekreslenie obrazovky
 void posuv()
   {
    if(zozn.kurzor)
      {
       setviewport (0,20,609,479,1);
       if (ore) zozn.akt()->orez(ox1,oy1,ox2,oy2,zozn.akt()->color);
       zozn.akt()->kresli(1);
       zozn.akt()->posun();
       setviewport (0,0,639,479,1);
       redraw();
      }
   }
		//posun aktualneho objektu
 void velkost()
   {
    if(zozn.kurzor)
      {
       setviewport (0,20,609,479,1);
       if (ore) zozn.akt()->orez(ox1,oy1,ox2,oy2,zozn.akt()->color);
       zozn.akt()->kresli(1);
       zozn.akt()->zvzm();
       setviewport (0,0,639,479,1);
       redraw();
      }
   }
		//zmena velkosti aktualneho objektu
 void farba(int);
		//zmaena farby aktualneho objektu na farbu a
 void load(char *,int);	//nahratie sceny zo suboru
 void save(char *);	//ulozenie sceny do suboru
 void zavri();		//zmazanie sceny
 void otoc();		//otocenie objektu
 void vypln();		//vyplnenie objektu
 void orez();		//orezanie objektu(sceny)

};

class Polygon:public Bod
{
  public:
  DList ciary;
  Polygon(int);
  Polygon(FILE *);
  ~Polygon();
  void getsur(int &a,int &b,int &c,int &d,int &e,int &,int &) {a=x1;b=y1;c=x1;d=y1;e=color;}
  void kresli(int=0);
  void zvzm();
  void posun();
  void zmaz(){ delete this;}
  int ident() {return 'p';}
  void vypln (int, int ,int);
  void stred(int &, int &);
  void otoc();
  int orez(int,int,int,int,int);
  void uloz(FILE *);

};


class Window:public Mys	//okno na vypis sprav
{
  public:
  int wx1;		//suradnice okna
  int wy1;
  int wx2;
  int wy2;
  Button *buton;	//pointer na button v okne
  void far *imag;	//ukazovatel na BMP spod okna

  Window(int,int,int,int,char *,char *);
  ~Window();
  void zrus();		//cakanie na stlacenie buttonu
  virtual char *getname() {return NULL;}
};

class Winlo:public Window //okno na zadavanie mien suborov
{
  public:
  Winlo();
  char *getname();        //vykreslenie okna a zadanie mena
};



void lineb(int x1,int y1,int x2,int y2,int color)
{
  int dx,dy,d,incr1,incr2,x,y,xend,yend,kx,ky;
  dx=abs(x2-x1); dy=abs(y2-y1);
  if (dx>=dy) {
	d=2*dy-dx;
	incr1=2*dy;
	incr2=2*(dy-dx);
	if (x1>x2) {
		x=x2; y=y2; xend=x1;
		ky=1;
		if (y2>y1) ky=-1;
	}
	else {
		x=x1; y=y1; xend=x2;
		ky=1;
		if (y1>y2) ky=-1;
	}
	putpixel(x,y,color);
	while (x<xend) {
		x++;
		if (d<0) d+=incr1;
		else {
			y+=ky;
			d+=incr2;
		}
		putpixel(x,y,color);
	}
  }
  else {
	d=2*dx-dy;
	incr1=2*dx;
	incr2=2*(dx-dy);
	if (y1>y2) {
		y=y2; x=x2; yend=y1;
		kx=1;
		if (x2>x1) kx=-1;
	}
	else {
		y=y1; x=x1; yend=y2;
		kx=1;
		if (x1>x2) kx=-1;
	}
	putpixel(x,y,color);
	while (y<yend) {
		y++;
		if (d<0) d+=incr1;
		else {
			x+=kx;
			d+=incr2;
		}
		putpixel(x,y,color);
	}
  }
}
void kruznica(int xk, int yk, int r,int color)
{
 int p1,x,y;
 setviewport(xk,yk,xk+1,yk+1,0);
 x=0;
 y=r;
 p1=3-2*r;

 putpixel(x,y,color);
 putpixel(y,x,color);
 putpixel(-y,x,color);
 putpixel(-x,y,color);
 putpixel(-x,-y,color);
 putpixel(-y,-x,color);
 putpixel(y,-x,color);
 putpixel(x,-y,color);

 while (x<y)
   {

   if (p1<0)
     p1+=4*x+6;
   else
     {
     y--;
     p1+=4*(x-y)+10;
     }
   x++;
   putpixel(x,y,color);
   putpixel(y,x,color);
   putpixel(-y,x,color);
   putpixel(-x,y,color);
   putpixel(-x,-y,color);
   putpixel(-y,-x,color);
   putpixel(y,-x,color);
   putpixel(x,-y,color);

   }
 setviewport(0,0,getmaxx(),getmaxy(),0);
}

