#include "bres.cpp"
enum  	Vypinac {swoff,swon};
enum	Aktivny {akt,neakt};

class Mys
{
  public:
    int x;
    int y;
    int buttons;

  Mys()
  {
  }

  void Init(void)
  {
	struct REGPACK reg;
	reg.r_ax = 0;
	intr(0x33, &reg);
  }

  void on(void)
  {
	struct REGPACK reg;
	reg.r_ax = 1;
	intr(0x33, &reg);
  }

  void off(void)
  {
	struct REGPACK reg;
	reg.r_ax = 2;
	intr(0x33, &reg);
  }

  void get(void)
  {
	struct REGPACK reg;
	reg.r_ax = 3;
	intr(0x33, &reg);
	x = reg.r_cx;
	y = reg.r_dx;
	buttons = reg.r_bx;
  }

  void put(unsigned int x,unsigned int y)
  {
	struct REGPACK reg;
	Mys::off();
	reg.r_ax = 4;
	reg.r_cx=x;
	reg.r_dx=y;
	intr(0x33, &reg);
	Mys::on();
  }

  void Init_Okno(void)
  {
	struct REGPACK reg;
	reg.r_ax = 7;
	reg.r_cx=0;
	reg.r_dx=560;
	intr(0x33, &reg);
	reg.r_ax = 8;
	reg.r_cx=20;
	reg.r_dx=480;
	intr(0x33, &reg);
  }

  void Normal(void)
  {
	struct REGPACK reg;
	reg.r_ax = 7;
	reg.r_cx=0;
	reg.r_dx=640;
	intr(0x33, &reg);
	reg.r_ax = 8;
	reg.r_cx=0;
	reg.r_dx=480;
	intr(0x33, &reg);
  }

};

class	Tlacidlo:public Mys
{
  public:
	unsigned int 	x1;
	unsigned int  	y1;
	unsigned int 	x2;
	unsigned int 	y2;
	char			*name;
	int				farba;
	Vypinac			stav;
	Aktivny   		aktiv;

  Tlacidlo(unsigned int xt1, unsigned int yt1, unsigned int xt2, unsigned int yt2, char *tname="", int tfarba=16)
  {
	x1 = xt1;
	y1 = yt1;
	x2 = xt2;
	y2 = yt2;
	name  = tname;
	farba = tfarba;
	stav  = swoff;
	aktiv = akt;
  }

  void offakt()
  {
	unsigned int xtn,ytn;
	Mys::off();
	setfillstyle(9,7);
	bar(x1+2,y1+2,x2-2,y2-2);
	setcolor(15);
	rectangle(x1+1,y1+1,x2-1,y2-1);
	setcolor(8);
	line(x1+1,y2-1,x2-1,y2-1);
	line(x2-1,y2-1,x2-1,y1+2);
	xtn = ((x2+x1)/2) - (strlen(name)/2)*8;
	ytn = ((y2+y1)/2) - 4;
	setcolor(0);
	outtextxy(xtn,ytn,name);
	setcolor(7);
	outtextxy(xtn-1,ytn-1,name);
	stav = swoff;
	aktiv = neakt;
	Mys::on();
  }

  void off(int typ=1)
  {
	Mys::off();
	unsigned int xtn,ytn;
	setfillstyle(1,7);
	bar(x1+2,y1+2,x2-2,y2-2);
	setcolor(15);
	rectangle(x1+1,y1+1,x2-1,y2-1);
	setcolor(8);
	line(x1+1,y2-1,x2-1,y2-1);
	line(x2-1,y2-1,x2-1,y1+2);
	xtn = ((x2+x1)/2) - (strlen(name)/2)*8;
	ytn = ((y2+y1)/2) - 4;
	setcolor(0);
	outtextxy(xtn,ytn,name);
	setcolor(15);
	outtextxy(xtn-1,ytn-1,name);
    stav = swoff;
    aktiv = akt;
    Mys::on();
    Mys::buttons=typ;

    while(Mys::buttons!=0)
      Mys::get();
  }

  void on(int typ=1)
  {
	Mys::off();
	unsigned int xtn,ytn;
	setfillstyle(1,7);
	bar(x1+2,y1+2,x2-2,y2-2);
	setcolor(8);
	rectangle(x1+1,y1+1,x2-1,y2-1);
	setcolor(15);
	line(x1+1,y2-1,x2-1,y2-1);
	line(x2-1,y2-1,x2-1,y1+2);
	xtn = ((x2+x1)/2) - (strlen(name)/2)*8;
	ytn = ((y2+y1)/2) - 4;
	setcolor(4);
	outtextxy(xtn+1,ytn+1,name);
	setcolor(15);
	outtextxy(xtn,ytn,name);
	stav = swon;
	aktiv = akt;
	Mys::on();
	Mys::buttons=typ;

	while(Mys::buttons!=0)
      Mys::get();
  }

  void off_c()
  {
	Mys::off();
	unsigned int xtn,ytn;
	setfillstyle(1,7);
	bar(x1+1,y1+1,x2-1,y2-1);
	setfillstyle(1,farba);
	bar(x1+6,y1+6,x2-6,y2-6);
	setcolor(15);
	rectangle(x1,y1,x2,y2);
	rectangle(x1+5,y1+5,x2-5,y2-5);
	setcolor(8);
	line(x1,y2,x2,y2);
	line(x2,y2,x2,y1+1);
	line(x1+5,y1+5,x1+5,y2-6);
	line(x1+5,y1+5,x2-5,y1+5);
	stav = swoff;
	Mys::on();
  }

  void on_c()
  {
	Mys::off();
	unsigned int xtn,ytn;
	setfillstyle(1,7);
	bar(x1+1,y1+1,x2-1,y2-1);
	setfillstyle(1,farba);
	bar(x1+6,y1+6,x2-6,y2-6);
	setcolor(8);
	rectangle(x1,y1,x2,y2);
	rectangle(x1+5,y1+5,x2-5,y2-5);
	setcolor(15);
	line(x1,y2,x2,y2);
	line(x2,y2,x2,y1+1);
	line(x1+5,y1+5,x1+5,y2-6);
	line(x1+5,y1+5,x2-5,y1+5);
	stav = swon;
	Mys::on();
  }

};

class   Objekty:public Mys
{
  public:
    Vypinac vyplnene;
	Aktivny aktiv;
	int typ,xo1,xo2,xo3,yo1,yo2,yo3,farba;
    double smernicaA,smernicaB,smernicaC,qveA,qveB,qveC;

  Objekty(int otyp,int ofarba=1,int xoo1=20,int yoo1=20,int xoo2=20,int yoo2=20,int xoo3=20,int yoo3=20)
  {
	typ=otyp;
	farba=ofarba;
	aktiv=akt;
    vyplnene=swoff;
	xo1=xoo1;
	xo2=xoo2;
    xo3=xoo3;
	yo1=yoo1;
	yo2=yoo2;
    yo3=yoo3;
    smernicaA=0;
    smernicaB=0;
    smernicaC=0;
    qveA=0;
    qveB=0;
    qveC=0;
	inic(farba);
  }

  void inic(int a_f)
  {
	setcolor(a_f);
	Mys::get();
    vyplnene=swoff;
	xo1=xo2=xo3=Mys::x;
	yo1=yo2=xo3=Mys::y;
	setcolor(a_f+8);
  }

  void nakresli(int utvar,int a_f)
  {
	typ=utvar;
	Mys::get();
    vykresli(BLACK);

    if(utvar==2)
    {
      xo3=Mys::x;
	  yo3=Mys::y;
    }
    else
    {
	  xo2=Mys::x;
	  yo2=Mys::y;
    }

	vykresli(a_f+8);
  }

  void deaktivuj(void)
  {
	aktiv=akt;
    vykresli(farba);

    if(vyplnene==swon)
      vypln_objekt(farba);
  }

  void aktivuj(void)
  {
	aktiv=neakt;
    vykresli(farba+8);

    if(vyplnene==swon)
     vypln_objekt(farba+8);
  }

  void vykresli(unsigned int farba)
  {
	setviewport(10,20,560,479,1);
	setcolor(farba);
	Mys::off();

	switch(typ)
	{
	  case 0: Bres_line(xo1-10,yo1-20,xo2-10,yo2-20,farba);break;
	  case 1: kruh(xo1,yo1,abs(xo2+yo2-xo1-yo1),farba);break;
	  case 2: Bres_line(xo2-10,yo2-20,xo1-10,yo1-20,farba);
              Bres_line(xo3-10,yo3-20,xo2-10,yo2-20,farba);
              Bres_line(xo3-10,yo3-20,xo1-10,yo1-20,farba);break;
      default:double bodx[10];
              double body[10],R=abs(xo2+yo2-xo1-yo1);
              float uhol;
              int i;

              for(i=0;i<=typ;i++)
              {
                uhol=i*M_PI/180*(360/(typ+1))+smernicaA;
                bodx[i]=R*cos(uhol)+xo1;
                body[i]=R*sin(uhol)+yo1;
              }

              for(i=0;i<typ;i++)
              {
                Bres_line(int(bodx[i])-10,int(body[i])-20,int(bodx[i+1])-10,int(body[i+1])-20,farba);
              }

              Bres_line(int(bodx[0])-10,int(body[0])-20,int(bodx[typ])-10,int(body[typ])-20,farba);break;
	}

	Mys::on();
	setviewport(0,0,639,479,1);
  }

  void posun(int i)
  {
	vykresli(BLACK);

	switch(i)
	{
		case 0:if(yo1+yo2+yo3>1){yo1--;yo2--;yo3--;}break;
		case 1:if((yo1+yo2+yo3)/3<479){yo1++;yo2++;yo3++;}break;
		case 2:if(xo1+xo2+xo3>1){xo1--;xo2--;xo3--;}break;
		case 3:if((xo1+xo2+xo3)/3<639){xo1++;xo2++;xo3++;}break;
	}

	vykresli(farba+8);
  }

  void zmen_velkost(int i)
  {
    vykresli(BLACK);

	switch(typ)
	{
		case 0:zmen_velkost_ciara(i);;break;
        case 1:if((((xo1+xo2)/2)<639)&&(((yo1+yo2)/2)<479)&&(abs(xo2+yo2-xo1-yo1)>=4)||!(i))
                 if(i){xo2--;yo2--;}
                 else {xo2++;yo2++;}
               break;
        case 2:zmen_velkost_trojuholnik(i);break;

		default:if((((xo1+xo2)/2)<639)&&(((yo1+yo2)/2)<479)&&(abs(xo2+yo2-xo1-yo1)>=4)||!(i))
                  if(i){xo2--;yo2--;}
                  else {xo2++;yo2++;}
                break;
	}

    vykresli(farba+8);
  }

  void smer(void)
  {
	switch(typ)
	{
        case 0:smer_ciara();break;
        case 1:break;
		case 2:smer_trojuholnik();break;
	}
  }

  void kve(void)
  {
	switch(typ)
	{
        case 0:kve_ciara();break;
        case 1:break;
		case 2:kve_trojuholnik();break;
	}
  }

  void smer_ciara(void)
  {
    if((xo2-xo1)==0)
      smernicaA=1000.0;
    else
    {
      double pom1=(int)(xo2-xo1);
      double pom2=(int)(yo2-yo1);
      smernicaA=pom2/pom1;
    }
  }

  void kve_ciara(void)
  {
    if((xo2-xo1)==0)
      qveA=-1000.0;
    else
      qveA=double(yo1-smernicaA*xo1);
  }

  void smer_trojuholnik(void)
  {
    int xoS=(xo1+xo2+xo3)/3;
    int yoS=(yo1+yo2+yo3)/3;

    if((xo1-xoS)==0)
      smernicaA=1000.0;
    else
    {
      double pom1=(int)(xo1-xoS);
      double pom2=(int)(yo1-yoS);
      smernicaA=pom2/pom1;
    }

    if((xo2-xoS)==0)
      smernicaB=1000.0;
    else
    {
      double pom1=(int)(xo2-xoS);
      double pom2=(int)(yo2-yoS);
      smernicaB=pom2/pom1;
    }

    if((xo3-xoS)==0)
      smernicaC=1000.0;
    else
    {
      double pom1=(int)(xo3-xoS);
      double pom2=(int)(yo3-yoS);
      smernicaC=pom2/pom1;
    }
  }

  void kve_trojuholnik(void)
  {
    int xoS=(xo1+xo2+xo3)/3;
    int yoS=(yo1+yo2+yo3)/3;

    if((xo1-xoS)==0)
      qveA=-1000.0;
    else
      qveA=double(yo1-smernicaA*xo1);

    if((xo2-xoS)==0)
      qveB=-1000.0;
    else
      qveB=double(yo2-smernicaB*xo2);

    if((xo3-xoS)==0)
      qveC=-1000.0;
    else
      qveC=double(yo3-smernicaC*xo3);

  }

  void zmen_velkost_trojuholnik(int i)
  {
    int xoS=(xo1+xo2+xo3)/3;
    int yoS=(yo1+yo2+yo3)/3;

    if((abs(xo1-xoS)>8||abs(yo1-yoS)>8)&&(abs(xo2-xoS)>8||abs(yo2-yoS)>8)&&(abs(xo3-xoS)>8||abs(yo3-yoS)>8)||!(i))
    {
      vykresli(BLACK);

      if(smernicaA==1000)
        if((yoS>=yo1) && !(i) || (yoS<=yo1) && (i))
          yo1--;
        else
          yo1++;
      else
        if(abs(smernicaA)>=1)
          if((yoS>=yo1) && !(i) || (yoS<=yo1) && (i))
          {
            yo1--;
            xo1=(yo1-qveA)/smernicaA;
          }
          else
          {
            yo1++;
            xo1=(yo1-qveA)/smernicaA;
          }
        else
          if((xoS>=xo1) && !(i) || (xoS<=xo1) && (i))
          {
            xo1--;
            yo1=smernicaA*xo1+qveA;
          }
          else
          {
            xo1++;
            yo1=smernicaA*xo1+qveA;
          }

      if(smernicaB==1000)
        if((yoS>=yo2) && !(i) || (yoS<=yo2) && (i))
          yo2--;
        else
          yo2++;
      else
        if(abs(smernicaB)>=1)
          if((yoS>=yo2) && !(i) || (yoS<=yo2) && (i))
          {
            yo2--;
            xo2=(yo2-qveB)/smernicaB;
          }
          else
          {
            yo2++;
            xo2=(yo2-qveB)/smernicaB;
          }
        else
          if((xoS>=xo2) && !(i) || (xoS<=xo2) && (i))
          {
            xo2--;
            yo2=smernicaB*xo2+qveB;
          }
          else
          {
            xo2++;
            yo2=smernicaB*xo2+qveB;
          }

      if(smernicaC==1000)
        if((yoS>=yo3) && !(i) || (yoS<=yo3) && (i))
          yo3--;
        else
          yo3++;
      else
        if(abs(smernicaC)>=1)
          if((yoS>=yo3) && !(i) || (yoS<=yo3) && (i))
          {
            yo3--;
            xo3=(yo3-qveC)/smernicaC;
          }
          else
          {
            yo3++;
            xo3=(yo3-qveC)/smernicaC;
          }
        else
          if((xoS>=xo3) && !(i) || (xoS<=xo3) && (i))
          {
            xo3--;
            yo3=smernicaC*xo3+qveC;
          }
          else
          {
            xo3++;
            yo3=smernicaC*xo3+qveC;
          }

      vykresli(farba+8);
    }
  }

  void zmen_velkost_ciara(int i)
  {
    vykresli(BLACK);

    if(smernicaA==1000)
      if((yo2>=yo1) && !(i) || (yo2<=yo1) && (i))
      {
        yo1--;
        yo2++;
      }
      else
      {
        yo1++;
        yo2--;
      }
    else
      if(abs(smernicaA)>=1)
        if((yo2>=yo1) && !(i) || (yo2<=yo1) && (i))
        {
          yo1--;
          yo2++;
          xo1=(yo1-qveA)/smernicaA;
          xo2=(yo2-qveA)/smernicaA;
        }
        else
        {
          yo2--;
          yo1++;
          xo1=(yo1-qveA)/smernicaA;
          xo2=(yo2-qveA)/smernicaA;
        }
      else
        if((xo2>=xo1) && !(i) || (xo2<=xo1) && (i))
        {
          xo1--;
          xo2++;
          yo1=smernicaA*xo1+qveA;
          yo2=smernicaA*xo2+qveA;
        }
        else
        {
          xo2--;
          xo1++;
          yo1=smernicaA*xo1+qveA;
          yo2=smernicaA*xo2+qveA;
        }

    vykresli(farba+8);
  }

  void vypln_objekt(int f)
  {
    Mys::off();
    if(f==BLACK) vyplnene=swoff;
    else vyplnene=swon;
    setcolor(f);
    rectangle(10,20,560,479);

	switch(typ)
	{
	  case 0:break;
	  case 1:vypln(xo1,yo1,f);break;
	  case 2:vypln((xo1+xo2+xo3)/3,(yo1+yo2+yo3)/3,f);break;
	  default:vypln(xo1,yo1,f);break;
	}

    setcolor(0);
    rectangle(10,20,560,479);
    Mys::on();

  }

  void vypln(int x, int y,int f)
  {
    int i,tmp;

    Mys::off();

    if (getpixel(x,y)!=f)
    {
      if(y>=0 && y<561)
      {
        i=x;

        while (getpixel(i,y)!=f && i<561)
          putpixel(i++,y,f);

        tmp=i;
        i=x-1;

        while (getpixel(i,y)!=f && i>=0)
          putpixel(i--,y,f);

        vypln((i+tmp)/2,y+1,f);
        vypln((i+tmp)/2,y-1,f);

      }
    }

    Mys::on();

  }

  void posun_mouse(void)
  {
	int a,xzo1,xzo2,xzo3,yzo1,yzo2,yzo3,xzS,yzS;

    Mys::get();

    if(typ==1)
    {

      xzS=xo1+Mys::x-(xo1+xo2)/2;
      yzS=yo1+Mys::y-(yo1+yo2)/2;

      if((xzS>10)&&(xzS+abs(xo2+yo2-xo1-yo1)<639)&&(yzS>20)&&(yzS+abs(xo2+yo2-xo1-yo1)<479))
      {
        vykresli(BLACK);
	    a=(xo1+xo2)/2;
	    xo1=xo1+Mys::x-a;
	    xo2=xo2+Mys::x-a;
	    xo3=xo3+Mys::x-a;
	    a=(yo1+yo2)/2;
	    yo1=yo1+Mys::y-a;
	    yo2=yo2+Mys::y-a;
	    yo3=yo3+Mys::y-a;
        vykresli(farba+8);
      }
      else
        Mys::put((xo1+xo2)/2,(yo1+yo2)/2);
    }
    else
    {
      vykresli(BLACK);
	  a=(xo1+xo2)/2;
	  xo1=xo1+Mys::x-a;
	  xo2=xo2+Mys::x-a;
	  xo3=xo3+Mys::x-a;
	  a=(yo1+yo2)/2;
	  yo1=yo1+Mys::y-a;
	  yo2=yo2+Mys::y-a;
	  yo3=yo3+Mys::y-a;
      vykresli(farba+8);
    }



  }

  void rotuj(void)
  {
	switch(typ)
	{
	  case 0:rotuj_ciara();break;
	  case 1:rotuj_kruh();break;
	  case 2:rotuj_trojuholnik();break;
	  default:rotuj_mnohouholnik();break;
	}

    smer();
    kve();
  }

  void rotuj_kruh()
  {
    int rx,ry,xo,R=abs(xo1+yo1-xo2-yo2);
    double dx,dy,uhol=0;
    Mys::get();
    while(Mys::buttons!=2) Mys::get();
    Mys::off();
    rx=Mys::x;
    ry=Mys::y;
    Bres_line (rx-5,ry,rx+5,ry,7);
    Bres_line (rx,ry-5,rx,ry+5,7);
    Mys::on();
    while(Mys::buttons!=0) Mys::get();
    while(Mys::buttons!=2) Mys::get();
    xo=Mys::x;
    Mys::off();

    while(Mys::buttons==2)
    {
      Mys::get();

      if (Mys::x!=xo)
      {
	     vykresli(BLACK);
	     dx= xo1-rx;
         dy= yo1-ry;
         uhol=(float)(Mys::x-xo)/90;
         xo1=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	     yo1=cos(uhol)*dy+sin(uhol)*dx+ry+.5;
         yo2=xo2=abs(R-xo1-yo1)/2;
	     xo=Mys::x;
	     vykresli(farba+8);
      }
    }

    Mys::on();
    Bres_line (rx-5,ry,rx+5,ry,0);
    Bres_line (rx,ry-5,rx,ry+5,0);
    vykresli(farba+8);
    setviewport(0,0,639,479,1);
  }

  void rotuj_mnohouholnik()
  {
    int rx,ry,xo,R=abs(xo1+yo1-xo2-yo2);
    double dx,dy,uhol=0;
    Mys::get();
    while(Mys::buttons!=2) Mys::get();
    Mys::off();
    rx=Mys::x;
    ry=Mys::y;
    Bres_line (rx-5,ry,rx+5,ry,7);
    Bres_line (rx,ry-5,rx,ry+5,7);
    Mys::on();
    while(Mys::buttons!=0) Mys::get();
    while(Mys::buttons!=2) Mys::get();
    xo=Mys::x;
    Mys::off();

    while(Mys::buttons==2)
    {
      Mys::get();

      if (Mys::x!=xo)
      {
	     vykresli(BLACK);
         uhol=(float)(Mys::x-xo)/90;

	     dx= xo1-rx;
         dy= yo1-ry;
         xo1=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	     yo1=cos(uhol)*dy+sin(uhol)*dx+ry+.5;
         yo2=xo2=abs(R-xo1-yo1)/2;
         smernicaA=smernicaA+uhol;
	     xo=Mys::x;
	     vykresli(farba+8);
      }
    }

    Mys::on();
    Bres_line (rx-5,ry,rx+5,ry,0);
    Bres_line (rx,ry-5,rx,ry+5,0);
    vykresli(farba+8);
    setviewport(0,0,639,479,1);
  }

  rotuj_trojuholnik()
  {
    int rx,ry,xo;
    double dx,dy,uhol=0;
    Mys::get();
    while(Mys::buttons!=2) Mys::get();
    Mys::off();
    rx=Mys::x;
    ry=Mys::y;
    Bres_line (rx-5,ry,rx+5,ry,7);
    Bres_line (rx,ry-5,rx,ry+5,7);
    Mys::on();
    while(Mys::buttons!=0) Mys::get();
    while(Mys::buttons!=2) Mys::get();
    xo=Mys::x;
    Mys::off();

    while(Mys::buttons==2)
    {
      Mys::get();

      if (Mys::x!=xo)
      {
	     vykresli(BLACK);
         uhol=(float)(Mys::x-xo)/90;

	     dx= xo1-rx;
         dy= yo1-ry;
         xo1=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	     yo1=cos(uhol)*dy+sin(uhol)*dx+ry+.5;

         dx= xo2-rx;
	     dy= yo2-ry;
	     xo2=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	     yo2=cos(uhol)*dy+sin(uhol)*dx+ry+.5;

	     dx= xo3-rx;
	     dy= yo3-ry;
	     xo3=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	     yo3=cos(uhol)*dy+sin(uhol)*dx+ry+.5;

	     xo=Mys::x;
	     vykresli(farba+8);
      }
    }

    Mys::on();
    setcolor(0);
    Bres_line (rx-5,ry,rx+5,ry,0);
    Bres_line (rx,ry-5,rx,ry+5,0);
    vykresli(farba+8);
    setviewport(0,0,639,479,1);
  }

  rotuj_ciara()
  {
    int rx,ry,xo;
    double dx,dy,uhol=0;
    Mys::get();
    while(Mys::buttons!=2) Mys::get();
    Mys::off();
    rx=Mys::x;
    ry=Mys::y;
    setcolor(7);
    Bres_line (rx-5,ry,rx+5,ry,7);
    Bres_line (rx,ry-5,rx,ry+5,7);
    Mys::on();
    while(Mys::buttons!=0) Mys::get();
    while(Mys::buttons!=2) Mys::get();
    xo=Mys::x;
    Mys::off();

    while(Mys::buttons==2)
    {
      Mys::get();

      if(Mys::x!=xo)
      {
	    vykresli(BLACK);
        uhol=(float)(Mys::x-xo)/90;

	    dx= xo1-rx;
        dy= yo1-ry;
        xo1=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	    yo1=cos(uhol)*dy+sin(uhol)*dx+ry+.5;

        dx= xo2-rx;
	    dy= yo2-ry;
	    xo2=cos(uhol)*dx-sin(uhol)*dy+rx+.5;
	    yo2=cos(uhol)*dy+sin(uhol)*dx+ry+.5;

	    xo=Mys::x;
	    vykresli(farba+8);
      }
    }

    Mys::on();
    setcolor(0);
    Bres_line (rx-5,ry,rx+5,ry,0);
    Bres_line (rx,ry-5,rx,ry+5,0);
    vykresli(farba+8);
    setviewport(0,0,639,479,1);
  }




};

class 	RolMenu:public Mys
{
  public:
    unsigned int xr1,xr2,yr1,yr2;
    int po_r,rfarba;
    char **rname;
    int *aktivna_polozka;
    void far *obraz;

  RolMenu(unsigned int xrr1, unsigned int yrr1, unsigned int xrr2, unsigned int yrr2, int po_rr, char **rnamer,int *aktivna_polozka1=0)
  {
	xr1 = xrr1;
	xr2 = xrr2;
	yr1 = yrr1;
	yr2 = yrr2;
	po_r =po_rr;
	rname = rnamer;
	aktivna_polozka=aktivna_polozka1;
  }

  ~RolMenu()
  {
	Mys::off();
	putimage(xr1,yr1,obraz,COPY_PUT);
	farfree(obraz);
	*aktivna_polozka=10;
	xr1=xr2=yr1=yr2=0;
	Mys::on();
  }

  void VykrRolMenu()
  {
	Mys::off();
	obraz=farmalloc(imagesize(xr1,yr1,xr2,yr2));

	if (obraz==NULL)
    {
      closegraph();
      printf ("Not enough memory\n");
    }

	getimage(xr1,yr1,xr2,yr2,obraz);
	setfillstyle(1,7);
	bar(xr1+2,yr1+2,xr2-2,yr2-2);
	setcolor(15);
	rectangle(xr1+1,yr1+1,xr2-1,yr2-1);
	setcolor(8);
	line(xr1+1,yr2-1,xr2-1,yr2-1);
	line(xr2-1,yr2-1,xr2-1,yr1+2);

	for(int j=0;j<po_r;j++)
	{
	  setcolor(0);
	  outtextxy(xr1+10,yr1+j*15+5,rname[j]);
	  setcolor(15);
	  outtextxy(xr1+9,yr1+j*15+4,rname[j]);
	}

	Mys::on();

  }

  void Zaktivuj(int *aktualna_polozka,int *ci2)
  {
	Mys::off();
	setcolor(15);

	if(*aktualna_polozka<po_r)
      outtextxy(xr1+9,yr1+*aktualna_polozka*15+4,rname[*aktualna_polozka]);

	setcolor(3);
	outtextxy(xr1+9,yr1+*ci2*15+4,rname[*ci2]);
	*aktualna_polozka=*ci2;
	setcolor(15);
	Mys::on();
  }
};

class Sprava:public Mys
{
  public:
    unsigned int sx1,sx2,sy1,sy2;
    char *sspr,*stext;
    void far *obr;
    Tlacidlo *tlac;

  ~Sprava()
  {
	Mys::off();
	putimage(sx1,sy1,obr,COPY_PUT);
	farfree(obr);
	sx1=sx2=sy1=sy2=0;
	Mys::on();
  }

  Sprava(int ssx1,int ssy1,int ssx2,int ssy2,char *ssspr,char *sstext)
  {
	sx1=ssx1;
	sy1=ssy1;
	sx2=ssx2;
	sy2=ssy2;
	sspr=ssspr;
	stext=sstext;
	inic();
	potvr();
  }

  void inic()
  {
	Mys::off();
	int xtn,ytn;
	obr=farmalloc(imagesize(sx1,sy1,sx2,sy2));

	if (obr==NULL)
    {
      closegraph();
      printf ("Not enough memory\n");
    }

	getimage(sx1,sy1,sx2,sy2,obr);
	setfillstyle(1,7);
	bar(sx1+2,sy1+2,sx2-2,sy2-2);
	setcolor(15);
	rectangle(sx1+1,sy1+1,sx2-1,sy2-1);
	setcolor(8);
	rectangle(sx1+6,sy1+6,sx2-6,sy2-6);
	line(sx1+1,sy2-1,sx2-1,sy2-1);
	line(sx2-1,sy2-1,sx2-1,sy1+2);
	setcolor(15);
	line(sx1+6,sy2-6,sx2-6,sy2-6);
	line(sx2-6,sy2-6,sx2-6,sy1+7);
	tlac=new Tlacidlo((sx1+sx2)/2-20,sy2-25,(sx1+sx2)/2+20,sy2-7,"OK");
	tlac->off(1);
	xtn=((sx2+sx1)/2)-(strlen(stext)/2)*8;
	ytn=((sy2+sy1)/2)-12;
	outtextxy(xtn,ytn,stext);
	xtn=((sx2+sx1)/2)-(strlen(sspr)/2)*8;;
	setcolor(RED);
	outtextxy(xtn,sy1+8,sspr);
	Mys::on();
  }

  void potvr(void)
  {
	while (1)
	{
	  Mys::get();

	  if(Mys::buttons==1)
		if ((Mys::x>tlac->x1) && (Mys::x<tlac->x2) && (Mys::y>tlac->y1) && (Mys::y<tlac->y2))
		{
		  Mys::off();
		  tlac->on();
		  delete tlac;
		  delete this;
		  Mys::on();
		  break;
		}
	}
  }

  Sprava(int ssx1,int ssy1,int ssx2,int ssy2,char *ssspr,char *sstext,int b)
  {
	sx1=ssx1;
	sy1=ssy1;
	sx2=ssx2;
	sy2=ssy2;
	sspr=ssspr;
	stext=sstext;
	inic();
	inic2();
  }

  void inic2(void)
  {
	Mys::off();
	setfillstyle(1,7);
	bar(sx1+17,sy2-51,sx2-17,sy2-35);
	setcolor(15);
	rectangle(sx1+16,sy2-50,sx2-16,sy2-36);
	setcolor(8);
	line(sx1+16,sy2-50,sx2-16,sy2-50);
	line(sx1+16,sy2-50,sx1+16,sy2-36);
	outtextxy(sx1+18,sy2-60,"Meno:");
	Mys::on();
  }

  char * zadaj()
  {
    char ret[50];
    char a;
    int i=0;
    ret[0]='_';

    for(int j=1;j<50;j++) ret[j]='\0';
      do
	  {
	    setfillstyle(1,7);
	    bar(sx1+19,sy2-46,sx2-17,sy2-38);
	    setcolor(BLACK);
	    outtextxy(sx1+19,sy2-46,ret);
	    while(!kbhit())
	    {
	      Mys::get();
	      if (Mys::buttons==1)
		    if ((Mys::x>tlac->x1) && (Mys::x<tlac->x2) && (Mys::y>tlac->y1) && (Mys::y<tlac->y2))
		    {
		      Mys::off();
		      tlac->on();
		      while (Mys::buttons!=0) Mys::get();
		      Mys::on();
		      ret[i]='\0';
		      delete this;
		      return (strdup(ret));
		    }
	    }

	    a=getch();

	    if (a!=10 && a!=13 && a!=0 && a!='\b')
        {
          ret[i]=a;
          ret[++i]='_';
        }

	    if (a==0) getch();

	    if (a=='\b' && i>0)
	    {
	      ret[i]='\0';
	      ret[--i]='_';
	    }

      }while (a!=13 && a!=10);

      ret[i]='\0';
      delete this;
      return (strdup(ret));
  }
};
