//-------------------------------------------------------------------
//  PROGRAM: randbern.cpp
//-------------------------------------------------------------------

#pragma hdrstop

//--------------------------- Includes ----------------------------//

#if !defined ( _RANDBERN_HPP )
#include "randbern.hpp"
#endif


extern "C"
{
#include <math.h>
#include <string.h>
#include <stdio.h>
}



//-- constructors --//

RandBernoulli::RandBernoulli( double _probability, char *_name )
   : Rand( 1, _name ),
     probability( fabs( _probability ) )
   {
   SetDistName( "Bern" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%g", probability );
   SetParameterA_Name( temp );
   }


RandBernoulli::RandBernoulli( double _probability, UINT _stream,
      long _seed, char *_name )
   : Rand( _stream, _seed, _name ),
     probability( fabs( _probability ) )
   {
   SetDistName( "Bern" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%g", probability );
   SetParameterA_Name( temp );
   }


double RandBernoulli::RandValue( void )
   {
   AddOneObservation();

   return( ( GetUnif01() <= probability ) ? 1 : 0 );
   }

