//-------------------------------------------------------------------
//  PROGRAM: randchi.cpp
//-------------------------------------------------------------------

#pragma hdrstop

//--------------------------- Includes ----------------------------//

#if !defined ( _RANDCHI_HPP )
#include "randchi.hpp"
#endif

#if !defined ( _RANDGAMA_HPP )
#include "randgama.hpp"
#endif

extern "C"
{
#include <string.h>
#include <stdio.h>
}


//-- constructors --//

RandChiSquare::RandChiSquare( UINT _degreesOfFreedom, long _seed, char *_name )
   : Rand( 1, _seed, _name ),
     pRNG( NULL ),
     degreesOfFreedom( _degreesOfFreedom )
   {
   SetDistName( "ChiSquare" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%u", degreesOfFreedom );
   SetParameterA_Name( temp );

   //-- run the constructor for the gamma distribution --//
   pRNG = new RandGamma( (double) degreesOfFreedom / 2.0, 2.0, _seed );
   }

RandChiSquare::RandChiSquare( UINT _degreesOfFreedom, UINT _stream,
      long _seed, char *_name )
   : Rand( 1, _seed, _name ),
     pRNG( NULL ),
     degreesOfFreedom( _degreesOfFreedom )
   {
   SetDistName( "ChiSquare" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%u", degreesOfFreedom );
   SetParameterA_Name( temp );

   //-- run the constructor for the gamma distribution --//
   pRNG = new RandGamma( (double) degreesOfFreedom / 2.0, 2.0, _stream, _seed );
   }

RandChiSquare::~RandChiSquare( void )
   {
   if ( pRNG )
      delete pRNG;
   }

double RandChiSquare::RandValue( void )
   {
   AddOneObservation();

   return( pRNG->RandValue() );      // get a gamma variate
   }


