//-------------------------------------------------------------------
//  PROGRAM: randduni.cpp
//-------------------------------------------------------------------

#pragma hdrstop

//--------------------------- Includes ----------------------------//

#if !defined ( _RANDDUNI_HPP )
#include "randduni.hpp"
#endif


extern "C"
{
#include <math.h>
#include <string.h>
#include <stdio.h>
}




//-- constructors --//

RandDiscreteUniform::RandDiscreteUniform( char *_name )
   : Rand( 1, _name ),
     lowerBound( 0 ),
     upperBound( 1 ),
     largestInt( 2 )
   {
   SetDistName( "DiscUniform" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%u", 0 );
   SetParameterA_Name( temp );
   sprintf( temp, "%u", 1 );
   SetParameterB_Name( temp );
   }


RandDiscreteUniform::RandDiscreteUniform( UINT _stream, long _seed, char *_name )
   : Rand( _stream, _seed, _name ),
     lowerBound( 0 ),
     upperBound( 1 ),
     largestInt( 2 )
   {
   SetDistName( "DiscUniform" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%u", 0 );
   SetParameterA_Name( temp );
   sprintf( temp, "%u", 1 );
   SetParameterB_Name( temp );
   }

RandDiscreteUniform::RandDiscreteUniform( long _lowerBound, long _upperBound,
      long _seed, char *_name )
   : Rand( 1, _seed, _name ),
     lowerBound( _lowerBound ),
     upperBound( _upperBound ),
     largestInt( upperBound - lowerBound + 1 )
   {
   SetDistName( "DiscUniform" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%Lu", lowerBound );
   SetParameterA_Name( temp );
   sprintf( temp, "%Lu", upperBound );
   SetParameterB_Name( temp );
   }

RandDiscreteUniform::RandDiscreteUniform( long _lowerBound, long _upperBound, \
      UINT _stream, long _seed, char *_name )
   : Rand( _stream, _seed, _name ),
     lowerBound( _lowerBound ),
     upperBound( _upperBound ),
     largestInt( upperBound - lowerBound + 1 )
   {
   SetDistName( "DiscUniform" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%Lu", lowerBound );
   SetParameterA_Name( temp );
   sprintf( temp, "%Lu", upperBound );
   SetParameterB_Name( temp );
   }



double RandDiscreteUniform::RandValue( void )
   {
   AddOneObservation();

   long largestInteger = (long) floor( (double) largestInt * GetUnif01() );

   return ( (double) ( lowerBound + largestInteger ) );
   }


