//-------------------------------------------------------------------
//  PROGRAM: randerla.cpp
//-------------------------------------------------------------------

#pragma hdrstop

//--------------------------- Includes ----------------------------//

#if !defined ( _RANDERLA_HPP )
#include "randerla.hpp"
#endif


extern "C"
{
#include <math.h>
#include <string.h>
#include <stdio.h>
}



//-- constructors --//

RandErlang::RandErlang( UINT _shape, double _scale, char *_name )
   : Rand( 1, _name ),
     shape( _shape ),
     scale( fabs( _scale ) ),
     a( - ( scale / (double) _shape ) )

   {
   SetDistName( "Erlang" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%u", shape );
   SetParameterA_Name( temp );
   sprintf( temp, "%g", scale );
   SetParameterB_Name( temp );
   }

RandErlang::RandErlang( UINT _shape, double _scale,
      UINT _stream, long _seed, char *_name )
   : Rand( _stream, _seed, _name ),
     shape( _shape ),
     scale( fabs( _scale ) ),
     a( - ( scale / (double) _shape ) )

   {
   SetDistName( "Erlang" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%u", shape );
   SetParameterA_Name( temp );
   sprintf( temp, "%g", scale );
   SetParameterB_Name( temp );
   }

double RandErlang::RandValue( void )
   {
   AddOneObservation();

   double multFactor = GetUnif01();

   for( UINT i = 1; i < shape; i++ )
      {
      //-- get more U(0,1) numbers --//
      multFactor = multFactor * GetUnif01();
      }

   return( - 1/scale * log( multFactor ) );
   }
