//-------------------------------------------------------------------
//  PROGRAM: randexp.cpp
//-------------------------------------------------------------------

#pragma hdrstop

//--------------------------- Includes ----------------------------//

#if !defined ( _RANDEXP_HPP )
#include "randexp.hpp"
#endif


extern "C"
{
#include <math.h>
#include <string.h>
#include <stdio.h>
}



//-- constructors --//

RandExponential::RandExponential( double _mean, char *_name )
   : Rand( 1, _name ),
     mean( fabs( _mean ) )
   {
   SetDistName( "Expon" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%g", mean );
   SetParameterA_Name( temp );
   }

RandExponential::RandExponential( double _mean, long _seed, char *_name )
   : Rand( 1, _seed, _name ),
     mean( fabs( _mean ) )
   {
   SetDistName( "Expon" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%g", mean );
   SetParameterA_Name( temp );
   }

RandExponential::RandExponential( double _mean, UINT _stream,
   long _seed, char *_name )
   : Rand( _stream, _seed, _name ),
     mean( fabs( _mean ) )
   {
   SetDistName( "Expon" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%g", mean );
   SetParameterA_Name( temp );
   }


//-- return an exponential random number --//
double RandExponential::RandValue( void )
   {
   AddOneObservation();

   return ( -mean * log( GetUnif01() ) );
   }

