//-------------------------------------------------------------------
//  PROGRAM: randgeo.cpp
//-------------------------------------------------------------------

#pragma hdrstop

//--------------------------- Includes ----------------------------//

#if !defined ( _RANDGEO_HPP )
#include "randgeo.hpp"
#endif

#if !defined ( _RANDBERN_HPP )
#include "randbern.hpp"
#endif


extern "C"
{
#include <math.h>
#include <string.h>
#include <stdio.h>
}



//-- constructors --//

RandGeometric::RandGeometric( double _probability, char *_name )
   : Rand( 1, _name ),
     probability( fabs( _probability ) )
   {
   SetDistName( "Geometric" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%g", probability );
   SetParameterA_Name( temp );

   pRNG = new RandBernoulli( probability );
   }


RandGeometric::RandGeometric( double _probability, UINT _stream,
      long _seed, char *_name )
   : Rand( _stream, _seed, _name ),
     probability( fabs( _probability ) )
   {
   SetDistName( "Geometric" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%g", probability );
   SetParameterA_Name( temp );

   pRNG = new RandBernoulli( probability, _stream, _seed );
   }

//-- destructor --//
RandGeometric::~RandGeometric( void )
   {
   if ( pRNG )
      delete pRNG;
   }


//-- returns a geometric variate --//
double RandGeometric::RandValue( void )
   {
   AddOneObservation();

   //-- number of failures before the 1st success --//
   long numTrials = -1; 
   UINT bernoulliResult = 0;

   while( bernoulliResult == 0 )
      {
      bernoulliResult = (UINT) pRNG->RandValue();

      numTrials++;
      }

   return (double) numTrials;
   }

