//-------------------------------------------------------------------
//  PROGRAM: randpois.cpp
//-------------------------------------------------------------------

#pragma hdrstop

//--------------------------- Includes ----------------------------//

#if !defined ( _RANDPOIS_HPP )
#include "randpois.hpp"
#endif

extern "C"
{
#include <math.h>
#include <string.h>
#include <stdio.h>
}


//-- constructors --//

RandPoisson::RandPoisson( double _mean, char *_name ) 
   : Rand( 1, _name ),
     mean( fabs( _mean ) ),
     a( exp( - mean ) )

   {
   SetDistName( "Poisson" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%g", mean );
   SetParameterA_Name( temp );
   }

RandPoisson::RandPoisson( double _mean, UINT _stream, long _seed, char *_name ) 
   : Rand( _stream, _seed, _name ),
     mean( fabs( _mean ) ),
     a( exp( - mean ) )

   {
   SetDistName( "Poisson" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%g", mean );
   SetParameterA_Name( temp );
   }


double RandPoisson::RandValue( void )
   {
   AddOneObservation();

   double b = 1;
   long count = 0;

   //-- count observations once --//
   b = b * GetUnif01();

   if ( b < a )
      return ( (double) count );

   do
      {
      count++;
      b = b * GetUnif01();
      } while( b >= a );

   return ( (double) count );
   }

