//-------------------------------------------------------------------
//  PROGRAM: randtri.cpp
//-------------------------------------------------------------------

#pragma hdrstop

//--------------------------- Includes ----------------------------//

#if !defined ( _RANDTRI_HPP )
#include "randtri.hpp"
#endif

extern "C"
{
#include <math.h>
#include <string.h>
#include <stdio.h>
}


//-- constructors --//

RandTriangular::RandTriangular( double _tMin, double _tMode, 
      double _tMax, char *_name ) 
   : Rand( 1, _name ),     // stream = 1
     tMin( _tMin ), 
     tMode( _tMode ), 
     tMax( _tMax ),
     S( tMode - tMin ),
     T( tMax - tMin )
   { 
   SetDistName( "Triang" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%g", tMin );
   SetParameterA_Name( temp );
   sprintf( temp, "%g", tMode );
   SetParameterB_Name( temp );
   sprintf( temp, "%g", tMax );
   SetParameterC_Name( temp );
   }


RandTriangular::RandTriangular( double _tMin, double _tMode, double _tMax,
      UINT _stream, long _seed, char *_name )
   : Rand( _stream, _seed, _name ),
     tMin( _tMin ), 
     tMode( _tMode ), 
     tMax( _tMax ),
     S( tMode - tMin ),
     T( tMax - tMin )
   { 
   SetDistName( "Triang" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%g", tMin );
   SetParameterA_Name( temp );
   sprintf( temp, "%g", tMode );
   SetParameterB_Name( temp );
   sprintf( temp, "%g", tMax );
   SetParameterC_Name( temp );
   }


double RandTriangular::RandValue( void )
   {
   AddOneObservation();

   // composition method at the moment, from Perry and Hoover.

   //-- generate a uniform 0-1 random variable
   double U01A = GetUnif01();          // uses stream 1
   double U01B = GetUnif01();          // independent ???
   double X = 0;

   if ( U01A <= S/T )
      X = S * sqrt( U01B ) + tMin;
   else
      X = T - ( T - S ) * sqrt( U01B ) + tMin;

   return( X );
   }


