//-------------------------------------------------------------------
//  PROGRAM: rand_f.cpp
//-------------------------------------------------------------------

#pragma hdrstop

//--------------------------- Includes ----------------------------//

#if !defined ( _RAND_F_HPP )
#include "rand_f.hpp"
#endif

#if !defined ( _RANDCHI_HPP )
#include "randchi.hpp"
#endif

extern "C"
{
#include <string.h>
#include <stdio.h>
}


//-- constructor --//
Rand_F::Rand_F( UINT _k1, UINT _k2, UINT _stream, long _seed, char *_name )
   : Rand( 1, _seed, _name ),
     pRNG1( NULL ),
     pRNG2( NULL ),
     k1( _k1 ),
     k2( _k2 )
   {
   SetDistName( "F-dist" );

   //-- set the coefficients --//
   char temp[ 40 ];
   sprintf( temp, "%u", k1 );
   SetParameterA_Name( temp );
   sprintf( temp, "%u", k2 );
   SetParameterB_Name( temp );

   //-- run the constructors for the chi-square distribution --//
   pRNG1 = new RandChiSquare( k1, _stream, _seed );
   pRNG2 = new RandChiSquare( k2, _stream + 1, _seed );
   }


//-- destructor --//
Rand_F::~Rand_F( void )
   {
   if ( pRNG1 )
      delete pRNG1;

   if ( pRNG2 )
      delete pRNG2;
   }


double Rand_F::RandValue( void )
   {
   AddOneObservation();

   double Numerator   = pRNG1->RandValue() / (double) k1;
   double Denominator = pRNG2->RandValue() / (double) k2;

   return( Numerator / Denominator );
   }



