(setq mat1 '((0 0 0 0 0 0 0 0 0)
	     (0 1 1 1 1 1 1 1 0)
	     (0 1 0 1 0 1 1 0 0)
	     (0 1 1 0 0 0 1 1 0)
	     (0 1 0 0 1 1 1 1 0)
	     (0 1 0 1 1 0 1 1 0)
	     (0 0 0 0 0 0 0 0 0)))

(setq mat2 '((0 0 0 0 0 0 0 0)
	     (0 1 0 0 0 0 1 0)
	     (0 1 1 1 1 1 1 0)
	     (0 1 1 0 0 1 1 0)
	     (0 0 1 1 1 1 0 0)
 	     (0 0 0 1 1 0 0 0)
	     (0 0 1 1 1 1 0 0)
	     (0 1 1 0 0 1 1 0)
	     (0 1 0 0 0 0 1 0)
	     (0 1 0 0 0 0 1 0)
	     (0 0 0 0 0 0 0 0)))

(setq mat3 '((0 0 0 0 0 0 0)
	     (0 0 0 1 0 0 0)	
	     (0 0 1 1 1 0 0)
	     (0 1 1 1 1 1 0)
	     (0 0 0 0 0 0 0)))

(setq mat4 '((0 0 0 0 0 0)
	     (0 0 1 1 0 0)
	     (0 1 1 1 1 0)
	     (0 1 1 1 1 0)
	     (0 0 1 1 0 0)
	     (0 0 0 0 0 0)))

(setq mat5 '((0 0 0 0 0 0)
	     (0 1 1 1 1 0)
	     (0 1 1 1 1 0)
	     (0 1 1 1 1 0)
	     (0 1 1 1 1 0)
	     (0 0 0 0 0 0)))

(defun a()
	(load 'p)
	(setq konst 2))




;**************************** P R V A   C A S T *****************************

;*************** fcia ktora vypocita obsah objektu v matici *****************
(defun obsah (zoz)
	(cond ((null zoz) 0)
	      ((and (atom (first zoz)) (eq (first zoz) 1)) (+ 1 (obsah (rest zoz))))
	      ((atom (first zoz)) (obsah (rest zoz)))
	      (T (+ (obsah (first zoz)) (obsah (rest zoz))))))


;********************* hlavna fcia na vypocet obvodu ************************
(defun obvod (zoz)
	(- (obv zoz) (Euler zoz)))


;********************* pomocna fcia na vypocet obvodu **********************
(defun obv (zoz)
	(cond ((not (second zoz)) 0)
	      (T (+ (obvriadku (first zoz) (second zoz)) (obv (rest zoz))))))


;*************** fcia ktora zistuje obvod v dvoch riadkoch ******************
(defun obvriadku (zoz1 zoz2)
	(cond ((not (second zoz1)) 0)
	      ((and (eq (first zoz1) (second zoz1)) (eq (first zoz1) (first zoz2))) (+ (obvriadku (rest zoz1) (rest zoz2))))
	      ((or (and (not (eq (first zoz1) (second zoz1))) (eq (first zoz1) (first zoz2))) (and (eq (first zoz1) (second zoz1)) (not (eq (first zoz1) (first zoz2))))) (+ 1 (obvriadku (rest zoz1) (rest zoz2))))
	      (T (+ 2 (obvriadku (rest zoz1) (rest zoz2))))))


;********* fcia na vypocet obvod pri sikmych hranach pomocou Eulera **********
(defun Euler (zoz)
	(cond ((not(second zoz)) 0)
	      ((eq (dvariadky (first zoz) (second zoz)) 0) (+ (dvariadky (first zoz) (second zoz)) (Euler (rest zoz))))
	      (T (+ (dvariadky (first zoz) (second zoz)) (Euler (cddr zoz))))))

;*************  pomocna fcia ku Euler. Zistuje 3 1 vo stvorci 2x2 ************
(defun dvariadky (zoz1 zoz2)
	(cond ((not (second zoz1)) 0)
	      ((eq (+ (first zoz1) (second zoz1) (first zoz2) (second zoz2)) 3) (+ 1 (dvariadky (cddr zoz1) (cddr zoz2))))
	      (T (dvariadky (rest zoz1) (rest zoz2)))))


;****************** H L A V N A    F U N K C I A   I ***********************
(defun zisti1 (zoz)
	(setq k1 (/ (* (obvod zoz) (obvod zoz)) (obsah zoz)))
	(terpri)
	(princ "Dany objekt je ")
	(cond ((< k1 14) (princ "kruh"))
	      ((< k1 17) (princ "stvorec"))
	      (T (princ "trojuholnik")))
	'--------------------------)





;********************* D R U H A    C A S T ************************

;************ hlavna fcia na vypocet sumy vah v jednom riadku ***************
(defun xvahy (zoz)
	(cond ((null zoz) 0)
	      (T (+ (xvah (first zoz) 1) (xvahy (rest zoz))))))


;*************** pomocna fcia k fcii xvahy pre jeden riadok *****************
(defun xvah (zoz pom)
	(cond ((null zoz) 0)
	      (T (+ (* pom (first zoz)) (xvah (rest zoz) (+ 1 pom))))))


;********** hlavna fcia pre vypocet sumy vah jednotlivych stpcekov ***********
(defun  yvahy (zoz pom)
	(cond ((null zoz) 0)
	      (T (+ (* pom (yvah (first zoz))) (yvahy (rest zoz) (+ 1 pom))))))

;*************** pomocna fcia k fcii yvahy pre jeden riadok *****************
(defun yvah (zoz)
	(cond ((null zoz) 0)
	      (T (+ (first zoz) (yvah (rest zoz))))))


;******************* fcia na vygenerovanie riadku z nul *********************
(defun genriad (zoz)
	(cond ((null zoz) nil)
	(T (cons  0 (genriad (rest zoz))))))


;***** fcia ktora vracia zoznam vzdialenosti vonkajsich bodov od taziska *****
(defun vzdialenosti (zoz)
	(vzdialen zoz (genriad zoz) 1))


;**************** pomocna fcia ku fcii vzdialenost *********************
(defun vzdialen (zoz pom ysilon)
	(cond ((null (rest zoz)) (vzdial pom (first zoz) (genriad (first zoz)) 0 1 ysilon))
	      (T (append (vzdial pom (first zoz) (second zoz) 0 1 ysilon) (vzdialen (rest zoz) (first zoz) (+ ysilon 1))))))


;******* pomocna fcia ktora vracia vzdialenosti vonkajsich  bodov ********
;********************** od taziska v jednom riadku ***********************
(defun vzdial (zoz1 zoz2 zoz3 pred iks ysilon)
	(cond ((null zoz2) nil)
	      ((and (eq (first zoz2) 1) 
	            (or (eq 0 (first zoz1)) (eq 0 (first zoz3)) (eq 0 pred)))
			  (cons (+ (* (- xtaz iks) (- xtaz iks)) (* (- ytaz ysilon) (- ytaz ysilon))) 
			        (vzdial (rest zoz1) (rest zoz2) (rest zoz3) (first zoz2) (+ iks 1) ysilon)))

	      (T (vzdial (rest zoz1) (rest zoz2) (rest zoz3) (first zoz2) (+ iks 1) ysilon))))


;*************** fcia najde bod najviac vzdialeny od taziska *****************
(defun najdimax (zoz pom)
	(cond ((null zoz) pom)
	      ((> (first zoz) pom) (najdimax (rest zoz) (first zoz)))
	      (T (najdimax (rest zoz) pom))))


;************** fcia najde bod nejmenej vzdialeny od taziska *****************
(defun najdimin (zoz pom)
	(cond ((null zoz) pom)
	      ((< (first zoz) pom) (najdimin (rest zoz) (first zoz)))
	      (T (najdimin (rest zoz) pom))))


;******************** H L A V N A    F U N K C I A    II *********************
(defun zisti2 (zoz)
	(setq xtaz (/ (xvahy zoz) (obsah zoz)))
	(setq ytaz (/ (yvahy zoz 1) (obsah zoz)))
	(setq k2 (vzdialenosti zoz))
	(setq k2 (/ (najdimax k2 (first k2)) (najdimin k2 (first k2))))
	(terpri)
	(princ "Dany objekt je ")
	(cond ((< k2 1.4) (princ "kruh"))
	      ((< k2 6) (princ "stvorec"))
	      (T (princ "trojuholnik")))
	'--------------------------)




;******************** T R E T I A   C A S T ************************

;****************** HLAVNA FCIA NA VYPOCET PLOCHY ******************
(defun plocha (zoz)
	(setq konst 2)
	(setq pmatica (precisluj (dajdvojku zoz)))
	(terpri)
	(princ "Plocha obrazca je:")
	(prin1 (spocitaj (susedne pmatica)))
	'--------------------)
	

;****************** fcia ktora da na zaciatok matice 2-ku ******************
(defun dajdvojku (zoz)
	(cons (cons 2 (rest (first zoz))) (rest zoz)))


;******** vlastna funkcia na vypis matice s nazvom mat  *********
(defun vyp (mat)
	(cond ((null mat) 'END)
	      (T (terpri)
		 (vypismat (first mat))
		 (vyp (rest mat)))))


;******************** vypis matice **********************
(defun vypis (mat)
	(cond ((null mat) 'matica_je_prazdna)
	      (T (vyp mat))))


;****************** vypis jedneho riadku matice **********************
(defun vypismat (zoz)
	(cond ((null zoz) nil)
    	      (T (princ " ")
		 (prin1 (car zoz))
		 (vypismat (cdr zoz)))))


;******************** fcia na precislovanie stlpcekov ***********************
(defun stlpcek (zoz1 zoz2)
	(cond ((null zoz1) nil)
	      ((eq 1 (first zoz1)) (cons (first zoz2) (stlpcek (rest zoz1) (rest zoz2))))
	      ((eq 1 (first zoz2)) (cons 1 (stlpcek (rest zoz1) (rest zoz2))))
	      (T (cons (first zoz1) (stlpcek (rest zoz1) (rest zoz2))))))
  

;*********************** fcia na precislovanie riadku ************************
(defun riad (zoz)
	(cond ((null zoz) nil)
	      ((and (eq 0 (second zoz)) (eq 1 (first zoz))) (setq konst (+ konst 1))
										(cons (first zoz) (riad (cons konst (cddr zoz)))))
	      ((eq 0 (second zoz)) (cons (first zoz) (riad (cons (first zoz) (cddr zoz))))) 
	      (T (cons (first zoz) (riad (rest zoz))))))


;***************** vlastna funkcia na precislovanie ******************
(defun precisluj (zoz)
	(cond ((null (second zoz)) (cons (riad (first zoz)) nil))
	      (T (cons (setq riadocek (riad (first zoz))) (precisluj (cons (stlpcek riadocek (second zoz)) (cddr zoz)))))))


;************* fcia na najdenie suseda k danemu prvku v riadku**************
(defun susedvriadku (zoz pom)
	(cond ((null zoz) nil)
	      ((and (eq pom (first zoz)) (not (or (eq pom (second zoz)) (eq 1 (second zoz))))) (second zoz))
	      ((and (eq pom (second zoz)) (not (or (eq pom (first zoz)) (eq 1 (first zoz))))) (first zoz))
	      (T (susedvriadku (rest zoz) pom))))  


;************** fcia ktora v celej matici zameni pom za cislo 2***************
(defun zamen (zoz pom)
	(cond ((null zoz) nil)
	      ((and (atom (first zoz)) (eq (first zoz) pom)) (cons 2 (zamen (rest zoz) pom)))
	      ((atom (first zoz)) (cons (first zoz) (zamen (rest zoz) pom)))
	      (T (cons (zamen (first zoz) pom) (zamen (rest zoz) pom)))))


;************ fcia ktora zistuje ci este nieco susedi z dvojkou *************
;********************** a ak ano tak aplikuje zamen *************************
(defun susedne (zoz)
	(cond ((null zoz) pmatica)
	      ((susedvriadku (first zoz) 2) (susedne (setq pmatica (zamen pmatica (susedvriadku (first zoz) 2)))))
	      (T (susedne (rest zoz)))))


;************** fcia ktora spocita prvky v matici rozne od 2-ky**************
(defun spocitaj(zoz)
	(cond ((null zoz) 0)
	      ((and (atom (first zoz)) (not (eq (first zoz) 2))) (+ 1 (spocitaj (rest zoz))))
	      ((atom (first zoz)) (spocitaj (rest zoz)))
	      (T (+ (spocitaj (first zoz)) (spocitaj (rest zoz))))))


;**************************** POMOCNE BLBOSTI *****************************
(defun skus (zoz)
	(setq pmatica (precisluj zoz)))
(defun sk()
	(vypis pmatica))
(defun s()
	(vypis (susedne pmatica)))
