;*************************************************************************
;**********************       Marek Ratkovsky      ***********************
;*************************************************************************
;**********************	     Produkcny  System     ***********************
;*************************************************************************

;********************** zadefinovanie premennych *************************
(setq prem '(?X ?Y ?Z))

;******************* zadefinovanie mnoziny faktov ************************
(setq F '(	(Marek je otec Vlado)
		(Vlado je otec Zuzana)
		(Vlado je otec Stano)
		(Surodenci Vlado Milan)
		(Zena Zuzana)
		(Muz Marek)
		(Milan je otec Ferko)
		(Muz Stano)
		(Muz Ferko)))

;****************** zadefinovanie mnoziny pravidiel ********************
(setq P '(	( ((?X je otec ?Y) (?X je otec ?Z)) 
			( (pridaj (Surodenci ?Y ?Z))))
		( ((Surodenci ?X ?Y))
			( (pridaj (Surodenci ?Y ?X))))
		( ((?X je otec ?Y) (Muz ?Y))
			( (pridaj (?Y je syn ?X))))
		( ((Surodenci ?X ?Y) (Muz ?Y))
			( (pridaj (?Y je brat ?X))))
		( ((Surodenci ?X ?Y) (Zena ?X))
			( (pridaj (?X je sestra ?Y))))
		( ((?Z je otec ?X) (?X je otec ?Y))
			( (pridaj (?Z je starky ?Y))
			  (pridaj (?Y je vnuca ?Z))))))

;****** vrati zoznam akcii ktore pridaju nieco nove do faktov *******
(defun odfiltruj (zoz)
	(cond	((null zoz) nil)
		((filtruj (first zoz)) (odfiltruj (rest zoz)) )
		(T (cons (first zoz) (odfiltruj (rest zoz)) ))))

;********** zisti ci dane pravidlo nieco nove prida do faktov ***********
(defun filtruj (zoz)
	(cond	((null zoz) T)
		((eq (first (first zoz)) 'pridaj)
			(cond	((najdi1 (second (first zoz)) F) 
					(filtruj (rest zoz)))
				(T nil)))
		((eq (first (first zoz)) 'zrus)
			(cond	((najdi1 (second (first zoz)) F) nil)
				(T (filtruj (rest zoz)))))
		(T T)))

;*********** vygeneruje zoznam akcii pre vsetky pravidla ****************
(defun aplikuj (fakty pravidla)
	(vynuluj prem)
	(cond	((null pravidla) nil)
		(T (append (vrat_zoz_akcii fakty (first pravidla)) 
			(aplikuj fakty (rest pravidla)) ))))

; *********** first pravidlo su podmienky second su dosledky ************
; ***********     vrati zoznam akcii pre dane pravidlo      *************
(defun vrat_zoz_akcii (fakty pravidlo)
	(vytvor (uprav (generuj fakty (first pravidlo) (get_prem prem))) 
		(second pravidlo)))

;*** vrati zoznam akcii pre zoznam zoznamov naviazanych premennych ******
;****************           pre dane pravidlo         *******************
(defun vytvor (zoz akcie)
	(cond	((null zoz) nil)
		(T (nastav prem (first zoz))
		   (cons (vyhodnot akcie) (vytvor (rest zoz) akcie)))))

;***** vrati zoznam akcii pre jeden zoznam naviazanych premennych *****
(defun vyhodnot (dosledok)
	(cond	((null dosledok) nil)
		((najdi3 dosledok prem) (eval dosledok))
		((atom dosledok) dosledok)
		(T (cons (vyhodnot (first dosledok)) (vyhodnot (rest dosledok))))))

;**************vyhodi zo zoznamu zoznamov premennych ********************
;**zoznamy v ktorych hodnoty premennych su naviazane na rovnaku hodnotu **
(defun uprav (zoz)
	(cond	((null zoz) nil)
		((najdi (first zoz)) (cons (first zoz) (uprav (rest zoz))))
		(T (uprav (rest zoz)))))


;* vygeneruje zoznam zoznamov naviazanych premennych pre jedno pravidlo *
(defun generuj (fakty pravidlo zoz)
	(cond	((null pravidlo) (cons zoz nil))
		((generuj1 fakty (first pravidlo) zoz)
		  (append
  (generuj fakty (rest pravidlo) (get_prem prem))
  (generuj (generuj1 fakty (first pravidlo) (nastav prem zoz))
	pravidlo (nastav prem zoz))))
		(T nil)))

;*********** vrati zvysok zoznamu faktov ktore este nepresiel *************
(defun generuj1 (fakty pravidlo zoz)
	(nastav prem zoz)
	(cond	((null fakty) nil)
		((naviaz (first fakty) pravidlo) (rest fakty))
		(T (generuj1 (rest fakty) pravidlo zoz))))

;***************  vrati T ak sa v zozname neopakuju prvky   ***************
(defun najdi (zoz)
	(cond	((null zoz) T)
		((najdi1 (first zoz) (rest zoz)) nil)
	        (T (najdi (rest zoz)))))

;****************  zisti ci sa pom nachadza v zozname zoz  ****************
(defun najdi1 (pom zoz)
	(cond	((null zoz) nil)
		((null pom) nil)
		((equal (first zoz) pom) T)
		(T (najdi1 pom (rest zoz)))))

;************* naviaze premenne ****************
(defun naviaz (prem1 prem2)
	(cond	((and (null prem1) (null prem2)) T)
		((eq (first prem1) (first prem2)) (naviaz (rest prem1) (rest prem2)))
		((najdi3 (first prem2) prem) 
			(cond	((null (eval (first prem2))) 
			  		(set (first prem2) (first prem1))
			  		(naviaz (rest prem1) (rest prem2)))
				((eq (eval (first prem2)) (first prem1))
			  		(naviaz (rest prem1) (rest prem2)))
				(T nil)))
		(T nil)))

;****  zisti ci je pom premenna zadefinovana v zozname premennych  *****
(defun najdi3 (pom zoz)
	(cond	((null zoz) nil)
		((eq (first zoz) pom) T)
		(T (najdi3 pom (rest zoz)))))

;*****************   Vynuluje premenne zo zoznamu zoz   ****************
(defun vynuluj (zoz)
	(cond	((null zoz) nil)
	(T (set (first zoz) nil) (vynuluj (rest zoz)))))

;*********  vrati zoznam hodnot premennych, ako su naviazane  **********
(defun get_prem(zoz)
	(cond	((null zoz) nil)
		(T (cons (eval (first zoz)) (get_prem (rest zoz))))))

;**********************  vypise zoznam faktov  *************************
(defun vypis (zoz)
	(cond 	((null zoz) nil)
		(T (princ (first zoz)) (terpri) (vypis (rest zoz)))))

;************ naviaze premenne zo zoz na premenne zo zoz1 **************
(defun nastav(zoz1 zoz)
	(cond   ((null zoz) nil)
		(T (set (first zoz1) (first zoz))
		   (cons (first zoz) (nastav (rest zoz1) (rest zoz))))))

;********** pridanie a zrusenie novych faktov medzi fakty *************
(defun pridaj_do_faktov (pravidlo)
	(cond	((null pravidlo) nil)
		(T (cond ((eq (first (first pravidlo)) 'pridaj) 
				(setq F (cons (second (first pravidlo)) F)))
			 ((eq (first (first pravidlo)) 'zrus)
				(zrus (second (first pravidlo)))))
		   (pridaj_do_faktov (rest pravidlo)))))

;*************** odstranenie faktu s mnoziny faktov *******************
(defun zrus (fakt) 
	(setq F (odstran fakt F)) )

;*********************** vlastne odstranenie **************************
(defun odstran (pom zoz)
	(cond	((null zoz) nil)
		((equal pom zoz) (odstran (rest zoz)))
		(T (cons (first zoz) (odstran (rest zoz))))))

;******************  H L A V N A   F U N K C I A  *********************
(defun ps ()
	(setq prikazy (odfiltruj (aplikuj F P)))
	(cond	((null prikazy) (terpri) (vypis F) nil)
		(T (pridaj_do_faktov (first prikazy)) (ps))))

;************************* Pomocna funkcia ****************************
(defun l ()
	(load 'ui3))
