;*************************************************************************
;**********************      Marek Ratkovsky      ************************
;*************************************************************************
;**********************   	  LOGIKA          ************************
;*************************************************************************
;**********************  premenovanie premennych   ***********************
;******************        zadefinovanie mnozin       ********************
(setq prem ())
(setq kvant '(EX VS))
(setq lave '({ [))
(setq prave '(} ]))
;*****************       zadefinovanie vyrazov       *********************

(setq v1 '(EX X VS Y { NEG P [ X ] OR { EX Y [ Q [ X Z ] AND NEG R [ f [ Y ] ] ] AND VS Z [ NEG Q [ X  Z ] OR P [ X ] ] } } ))

(setq v2 '(VS X EX Y { [ f [ X ] OR g [ Y ] ] OR EX X { [ f [ X ] AND Q [ X  Y ] ] AND EX X [ f [ X ] ] } } ))

(setq v3 '(VS X EX Y { VS X { f [ X ] { EX Y f [ Y ] }  Q [ X Y ] }))

(setq v4 '(VS X { EX Y { f [ X  Y ] } AND { g [ X Y ] } OR VS Y { g [ X Y ] } }))
;**********************      vyhodnocuje vyraz      **********************
(defun premenuj (vyraz)
	(cond 	((null vyraz) nil)
		((je_premena (first vyraz)) (cons (naviaz (first vyraz) prem) (premenuj (rest vyraz))))
		((je_kvant (first vyraz)) (dopln (second vyraz) prem) 
					(cons (first vyraz) (cons (naviaz (second vyraz) prem) (premenuj (cddr vyraz)))))
		(T (uprav (first vyraz)) (cons (first vyraz) (premenuj (rest vyraz))))))

;******************  upravuje jednotlive prvky vyrazu  *******************
(defun uprav (prvok1)
	(cond	((null prvok1) nil)
		((je_lava prvok1)  (inkrementuj prem) prvok1)
		((je_prava prvok1) (dekrementuj prem) 
				   prvok1)
		((atom prvok1))
		(T nil)))

;*******************   naviaze premennu ktoru treba   ********************
(defun naviaz (prvok mnozina)
	(cond	((null mnozina) nil)
		((je prvok (first mnozina)) (caar mnozina))
		(T (naviaz prvok (rest mnozina)))))

;****** inkrementuje vsetky premenne ktore su na zaciatku zoznamov ********
(defun inkrementuj (mnozina)
	(cond	((null mnozina)  T)
		((caar mnozina) (set (caar mnozina) (+ (eval (caar mnozina)) 1))
		   		(inkrementuj (rest mnozina)))
		(T (inkrementuj (rest mnozina)))))

;****** dekrementuje vsetky premenne ktore su na zaciatku zoznamov ********
(defun dekrementuj (mnozina)
	(cond	((null mnozina)  nil)
		((caar mnozina) (set (caar mnozina) (- (eval (caar mnozina)) 1))
		   		(dekrementuj (rest mnozina)))
		(T (dekrementuj (rest mnozina)))))

;***********************  vyradi nily z mnoziny   **************************
(defun vyrad_nilove (mnozina)
	(cond	((null mnozina) ())
		((first mnozina) (cons (first mnozina) (vyrad_nilove (rest mnozina))))	
		(T (vyrad_nilove (rest mnozina)))))
;********************* vyradi prvy prvok zo zoznamu ***********************
(defun vyrad_posledny(mnozina)
	(cond	((second mnozina) nil)
		(T (cons (first mnozina) (vyrad_prvy (rest mnozina))))))
		 
;**************** vyradi vsetky nulove prvky zo zoznamu *******************
(defun vyrad_nulove(mnozina)
	(cond	((null mnozina) nil)
		((eq (eval (caar mnozina)) 0) (cons (rest (first mnozina)) (vyrad_nulove (rest mnozina))))
		(T (cons (first mnozina) (vyrad_nulove (rest mnozina))))))

;**************** doplni premmenu podla toho ci uz je *********************
;****************  alebo nie je v mnozine premennych  *********************
(defun dopln (premena mnozina)
	(setq prem (dopln1 premena mnozina)))

;*********************** pomocna fcia k dopln *****************************
(defun dopln1 (premena mnozina)
	(cond	((null mnozina) (set premena 0)
				(cons (append (cons premena nil) nil) nil))
		((je premena (first mnozina))
			(setq prvy (first navprem))
			(set prvy 0)
			(setq navprem (rest navprem)) 			
			(cons (cons prvy (first mnozina)) (rest mnozina)))
		(T (append (cons (first mnozina) nil) (dopln1 premena (rest mnozina))))))

;*********************  prida do prem dalsiu premenu  *********************
(defun pridaj (prvok)
	(setq prem (cons prvok prem)))

;**************           zisti ci pom je v zoz          ***************
(defun je (pom zoz)
	(cond	((null zoz) nil)
		((eq (first zoz) pom) T)
		(T (je pom (rest zoz)))))

;**********************   zisti ci je kvantif   ************************
(defun je_kvant(prvok)
	(je prvok kvant))

;****  zisti ci je pom premenna zadefinovana v zozname premennych  *****
(defun je_premena (prvok)
	(je_prem1 prvok prem))

;******* pomocna fcia na zistenie ci je dana premena definovana *********
;*******************   hlada v zozname zoznamov   ***********************
(defun je_prem1 (prvok mnozina)
	(cond 	((null mnozina) nil)
		(T (or (je prvok (first mnozina)) (je_prem1 prvok (rest mnozina))))))

;*******************   zisti ci je lava zatvorka   *********************
(defun je_lava(prvok)
	(je prvok lave))

;*******************   zisti ci je prava zatvorka   ********************
(defun je_prava(prvok)
	(je prvok prave))

;**********************      vypise vyraz      *************************
(defun vypis (zoz)
	(cond 	((null zoz) nil)
		(T 	(princ (first zoz)) 
			(princ " ") 
			(vypis (rest zoz)))))

;************************* Pomocna funkcia ****************************
(defun l ()
	(load 'ui4))

;**********************HLAVNA FCIA*************************
(defun p (vyraz)
	(setq navprem '(X1 X2 X3 X4 X5 X6 X7 X8 X9))
	(setq prem ())
	(terpri)
	(vypis vyraz)
	(terpri)
	(terpri)
	(vypis (premenuj vyraz)))
