#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

typedef struct{ char meno[20];		//definicia struktury -meno zvierata,
 		char pav[3];		//pavilon,vaha,vek
		int vaha;
		int vek;
	      } ZVIERA;

int menu(void);					//vypis a praca s menu
// vsetky funkcie maju ako vstup pointer na databazu, subor a/alebo pocet poloziek
int citajTXT(ZVIERA *,FILE *);			//nacitanie udajov z txt suboru
void vypisALL(ZVIERA *,int *);			//vypis udajov na obrazovku
void pisSUB(ZVIERA *,FILE *,FILE *,int *);	//zapisanie dat do bin/txt sub.
void pridaj(ZVIERA *,int *);			//pridanie zaznamu
void vymaz(ZVIERA *,int *);			//vymazanie zaznamu
void usporiadaj(ZVIERA *,int *);		//usporiadanie databazy
void hladaj(ZVIERA *,int *);			//vyhladanie prvku v databaze

//***********HLAVNA FUNKCIA**************
void main(void)		
{ FILE *ft,*fb;					//txt a binarny subor
  ZVIERA zvierata[100],*zwery=&zvierata[0];	//pointer na databazu
  int *poc=0;					//pocet prvkov

  *poc=citajTXT(zwery,ft);			//nacitanie dat a poc. prvkov
  do { switch (menu()) {			//zistenie hodnoty funkcie menu
		case 0: clrscr(); exit(0); break;	//koniec programu
		case 1: *poc=citajTXT(zwery,ft);	//nacitanie z txt. sub
		case 2: pisSUB(zwery,ft,fb,poc); break;	//zapis suborov
		case 3: vypisALL(zwery,poc); break;	//vypis na obrazovku
		case 4: pridaj(zwery,poc); break;	//pridanie zaznamu
		case 5: vymaz(zwery,poc); break;	//vymazanie zaznamu
		case 6: usporiadaj(zwery,poc); break;	//usporiadanie databazy
		case 7: hladaj(zwery,poc); break;	//vyhaldanie prvku
		}
	 }
  while (1==1);			//nekonecny cyklus
}

//---------------------------------------------------------------------
int menu(void)			//vypis menu a nacitanie volby
{ char volba;			//funkcia vracia zvolenu volbu
  clrscr();
  printf("1/Nacitanie suboru\n");
  printf("2/Zapisanie suboru\n");
  printf("3/Vypis suboru\n");
  printf("4/Pridanie zaznamu\n");
  printf("5/Vymazanie zaznamu\n");
  printf("6/Usporiadanie\n");
  printf("7/Vyhladavanie\n");
  printf("0/Koniec\n");
  do
   volba=getch();
  while (!((volba>='0') && (volba<='7')));
  switch (volba) {
   case	'0': return(0); break;
   case	'1': return(1); break;
   case '2': return(2); break;
   case '3': return(3); break;
   case '4': return(4); break;
   case '5': return(5); break;
   case '6': return(6); break;
   case '7': return(7); break;
  }
}

//---------------------------------------------------------------------
int citajTXT(ZVIERA *zw,FILE *f)		//naciatnie dat z txt suboru
{ int i=0;					//funkcia vrati pocet poloziek
  clrscr();
  if ((f=fopen("zvierata.txt","rt"))==NULL)		//otovrenie suboru
		{
		  printf("Nemozem otvorit vstupny subor!\a");
		  exit(1);
		}
  else { printf("Citam udaje.");
	 while (!feof(f))			//nacitavanie dat
	 { fscanf(f,"%s",(zw+i)->meno);
	   fscanf(f,"%s",(zw+i)->pav);
	   fscanf(f,"%d",&((zw+i)->vaha));
	   fscanf(f,"%d",&((zw+i)->vek));
	   i++;
	   printf(".");
	 }
       }
  fclose(f);				//uzatvorenie suboru
  printf(".Hotovo");
  return(i-1);				//vrati pocet poloziek
}

//-------------------------------------------------------------------
void vypisALL(ZVIERA *zw,int *poc)		//vypis databzay na obrazovku
{ int i;
  clrscr();
  printf("Meno zvierata      Pavilon    Vaha    Vek\n");
  printf("-----------------------------------------\n");
  for (i=0;i<*poc;i++)			//vypis poloziek
   { printf("%s",(zw+i)->meno);
     gotoxy(22,wherey());
     printf("%s",(zw+i)->pav);
     gotoxy(32,wherey());
     printf("%d",(zw+i)->vaha);
     gotoxy(39,wherey());
     printf("%d\n",(zw+i)->vek);
   }
  printf("-----------------------------------------\n");
  printf("Pocet zaznamov: %d\n",*poc);		//vypis poctu poloziek
  getch();
}

//-------------------------------------------------------------------
void pisSUB(ZVIERA *zw,FILE *ft,FILE *fb,int *poc)	//zapis databazy do txt a bin
{ int i;
  gotoxy(1,13);
  printf("Zapisujem udaje.");
  if (*poc!=0){
	ft=fopen("zvierata.txt","wt");		//otvorenie suborov pre zapis
	fb=fopen("zvierata.bin","wb");
	for(i=0;i<*poc;i++)			
	  {     printf(".");			//zapis poloziek do txt suboru
		fprintf(ft,"%s ",(zw+i)->meno);
		fprintf(ft,"  %s ",(zw+i)->pav);
		fprintf(ft,"  %d ",(zw+i)->vaha);
		fprintf(ft,"  %d\n",(zw+i)->vek);
	  }
	fwrite(zw,sizeof(ZVIERA),*poc,fb);	//zapis do binarneho suboru
  }
 fclose(ft);				//zatvorenie suborov
 fclose(fb);
 printf(".Hotovo.");
 getch();
}

//------------------------------------------------------------------
void pridaj(ZVIERA *zw,int *poc)		//pridanie zaznamu do databzy
{ clrscr();
  printf("Zadaj meno zvierata: ");		//nacitanie novych udajov
  scanf("%s",(zw+*poc+1)->meno);	
  printf("Zadaj pavilon: ");
  scanf("%s",(zw+*poc+1)->pav);
  printf("Hmotnost: ");
  scanf("%d",&(zw+*poc+1)->vaha);
  printf("Vek: ");
  scanf("%d",&(zw+*poc+1)->vek);
  (*poc)++;				//zvysenie poctu
}

//------------------------------------------------------------------
void vymaz(ZVIERA *zw,int *poc)			//vymazanie zaznamu
{ int i=0;
  char meno_[20];
  clrscr();
  printf("Meno zvierata: ");			//ktore zviear vymazat...
  scanf("%s",meno_);
  while ( (i<*poc) && (strcmp( (zw+i)->meno,meno_ ) !=0) ) i++;  //najdenie
  if (i==*poc)					//daneho prvku
    printf("\nDany zaznam neexistuje\a");
  else
   { (*poc)--;					//posunutie databzy-vymazanie
     while (i<=*poc)
      { *(zw+i)=*(zw+i+1);
	i++;
      }
     printf("\nZaznam bol vymazany.");
   }
  getch();
}

//-----------------------------------------------------------------------
void usporiadaj(ZVIERA *zw,int *poc)		//usporiadanie databazy
{ int i,j;
  char c;
  ZVIERA tmp;
  clrscr();
  printf("1/Usporiadanie podla mena\n");		//volba kluca
  printf("2/Usporiadanie podla pavilonov\n");
  do
   c=getch();
  while (!((c=='1') || (c=='2')));
  printf("\n\nUsporaduvam.");
  switch (c) {
     case '1': for (i=0;i<*poc;i++)			//podla mena
		 for (j=i+1;j<*poc;j++)
		   if (strcmp( (zw+i)->meno, (zw+j)->meno )>0)
			{ printf(".");
			  tmp=*(zw+j);
			  *(zw+j)=*(zw+i);
			  *(zw+i)=tmp;
			}
	       break;
     case '2': for (i=0;i<*poc;i++)			//podla pavilonu
		 for (j=i+1;j<*poc;j++)
		   if (strcmp( (zw+i)->pav, (zw+j)->pav )>0)
			{ printf(".");
			  tmp=*(zw+j);
			  *(zw+j)=*(zw+i);
			  *(zw+i)=tmp;
			}
	     }
  printf(".Hotovo.");
  getch();
//popis algoritmu: vonkajsi cyklus porovnava i-ty prvkov s j-tym (i<j), pricom
// ak j-ty je mensi ako i-ty, tieto prvky vymeni. dalej porovnava ostatne prvky 
// j-tym (teraz uz po vymene i-tym...). Tymto sa do i-teho prvku dostane 
//najnizsi prvok zo zostavajucich
}

//-----------------------------------------------------------------------
void hladaj(ZVIERA *zw,int *poc)		//vyhladavanie v databaze
{ int i;
  char c;
  char meno_[20];
  char pav_[3];
  int vek_;
  clrscr();
  printf("1/Hladanie podla mena\n");			//volba kluca
  printf("2/Hladanie podla pavilonu\n");
  printf("3/Hladanie podla veku\n");
  do
   c=getch();
  while (!((c>='1') && (c<='3')));
  switch (c) {
	case '1': printf("\n\nHladane zviera: ");	//podla mena
		  scanf("%s",&meno_);
		  printf("Boli najdene nasledujuce zaznamy:\n");
		  for (i=0;i<*poc;i++)
		    if (strcmp(meno_,(zw+i)->meno)==0)
		     { printf("%s",(zw+i)->meno);
		       gotoxy(22,wherey());
		       printf("%s    %d    %d\n",
			      (zw+i)->pav,(zw+i)->vaha,(zw+i)->vek);
		     }
		  break;
	case '2': printf("\n\nHladany pavilon: ");	//podla pavilonu
		  scanf("%s",&pav_);
		  printf("Boli najdene nasledujuce zaznamy:\n");
		  for (i=0;i<*poc;i++)
		    if (strcmp(pav_,(zw+i)->pav)==0)
		      { printf("%s",(zw+i)->meno);
			gotoxy(22,wherey());
			printf("%s    %d    %d\n",
			       (zw+i)->pav,(zw+i)->vaha,(zw+i)->vek);
		      }
		  break;
	case '3': printf("\n\nHladany vek: ");		//podla veku
		  scanf("%d",&vek_);
		  printf("Boli najdene nasledujuce zaznamy:\n");
		  for (i=0;i<*poc;i++)
		    if (strcmp(pav_,(zw+i)->pav)==0)
		      { printf("%s",(zw+i)->meno);
			gotoxy(22,wherey());
			printf("%s    %d    %d\n",
			       (zw+i)->pav,(zw+i)->vaha,(zw+i)->vek);
		      }
		  break;
   }
  printf("-----------------------------------------");
  getch();
//popis algoritmu: cyklus porovnava kazdy prvok databazy s hladanym klucom
//a v pripade zhody dany zaznam vypise
}