 /**************************************************************************************/
/*        LEFT RIGHT Chaos Sequenece Representation of symbolic time series -Bible    */
/*------------------------------------------------------------------------------------*/
/*   sequence in file task.trs  -->                                                   */
/*   points constituting csr in task.left.csr and task.right.csr                      */
/*   number of symbols in the alphabet must be pow(2,N), info file: task.cst          */
/**************************************************************************************/

#define MAX_DIM         10      /* maximalna dimenzia */
#define MAX_SYM         100     /* maximalny pocet symbolov v abecede */
#define MAX_LEN_WINDOW  100     /* maximalna dlzka okna */
#define MAX_TEXT_LENGTH 3000000 /* maximalna dlzka textu na prelozenie do fraktalnej reprezentacie */ 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>







void main(int argc, char *argv[]);
FILE *otvor_subor(char *nazov_sub, char *mod);
int  code_of_the_symbol(char symbol);
int  read_k_symbols_from_file(FILE *fp, char *string, int k);



char  task[80],
      left_window[MAX_LEN_WINDOW],
      right_window[MAX_LEN_WINDOW];
float A[MAX_SYM][MAX_DIM][MAX_DIM],
      T[MAX_SYM][MAX_DIM];
char  SYM_CODE[MAX_SYM],
      ssymbol[5];
float X_pov[MAX_DIM],
      X[MAX_DIM];
int   num_sym_alph;




void main(int argc, char *argv[])
{
  FILE *fp_seq,*fp_left_csr,*fp_right_csr,*fp_csi;
  int symboli,length_seq,LEN_WINDOW,i,sym,dim,r,c,d,s;
  char p_task[100],first_symbols[MAX_LEN_WINDOW],symbol,next_symbol,aux_sym;
  int pomd,num_sym_seq,symbol_kod,next_symbol_int;
  float pom,
        points;


  if(argc == 1)
   { printf("\n\n\nName of the task: ");
     scanf("%s",task);
   }
   else
    { if (argc != 2)
       { printf("\nUsage: csr_bibl_lr [file_name (without .trs)]\n");
         exit(-1);
       }
      strcpy(task,argv[1]);
    }



  strcpy(p_task,task);
  strcat(p_task,".cst");
  fp_csi=otvor_subor(p_task,"r");

  fscanf(fp_csi,"\nLENGTH OF INPUT WINDOW: %d",&LEN_WINDOW);
  fscanf(fp_csi,"\nNUMBER OF SYMBOLS IN THE ALPHABET: %d",&num_sym_alph);
  fscanf(fp_csi,"\nDIMENSION: %d",&dim);
  for( sym=1; sym<=num_sym_alph; sym++)
   { fscanf(fp_csi,"\nSYMBOL %c - COEFFICIENTS OF THE AFFINE MAPPING:",&symbol);
     SYM_CODE[sym-1]=symbol;
     for( r=1; r<=dim; r++)
      { fscanf(fp_csi,"\n");
        for( c=1; c<=dim; c++)
          fscanf(fp_csi,"A%d,%d=%f ",&pomd,&pomd,&(A[sym-1][r-1][c-1]));
        fscanf(fp_csi,"T%d=%f",&pomd,&(T[sym-1][r-1]));
      }
   }
  fclose(fp_csi);

/*
  for( sym=1; sym<=num_sym_alph; sym++)
   { printf("\nSYMBOL: %c", SYM_CODE[sym-1]);
     for( r=1; r<=dim; r++)
      { printf("\n");
        for( c=1; c<=dim; c++)
        printf("A%d,%d=%1.2f ",r,c,A[sym-1][r-1][c-1]);
        printf("T%d=%1.2f",r,T[sym-1][r-1]);
      }
   }
  printf("\n");
*/

  strcpy(p_task,task);
  strcat(p_task,".trs");
  fp_seq=otvor_subor(p_task,"r");
  strcpy(p_task,task);
  strcat(p_task,".left.csr");
  fp_left_csr=otvor_subor(p_task,"w");
  strcpy(p_task,task);
  strcat(p_task,".right.csr");
  fp_right_csr=otvor_subor(p_task,"w");

  aux_sym=read_k_symbols_from_file(fp_seq,left_window,LEN_WINDOW);
  aux_sym=read_k_symbols_from_file(fp_seq,right_window,LEN_WINDOW-1);
  for(sym=LEN_WINDOW-1; sym>=1; sym--)
   right_window[sym]=right_window[sym-1];
  right_window[0]=left_window[LEN_WINDOW-1];
  left_window[LEN_WINDOW]='\0';
  right_window[LEN_WINDOW]='\0'; 
  points=0;
  do
   { points++;
     /* left window */
     /* printf("left: %s  ", left_window); */
     for( s=1; s<=dim; s++) X_pov[s-1]=0.5;
     for(sym=1; sym<=LEN_WINDOW; sym++)
      { symbol=left_window[sym-1];
        symbol_kod=code_of_the_symbol(symbol);
        if (symbol_kod != -1)
         { for( s=1; s<=dim; s++)
            { pom=0;
              for( c=1; c<=dim; c++)
               pom=pom+A[symbol_kod][s-1][c-1]*X_pov[c-1];
              X[s-1]=pom + T[symbol_kod][s-1];
              if(sym == LEN_WINDOW)
	       fprintf(fp_left_csr,"%f ",X[s-1]);
            }
           for( s=1; s<=dim; s++) X_pov[s-1]=X[s-1];
           if(sym == LEN_WINDOW)
	    fprintf(fp_left_csr,"\n");
         }
      }
      
     /* right window */ 
     /* printf("right: %s\n", right_window); */
     for( s=1; s<=dim; s++) X_pov[s-1]=0.5;
     for(sym=LEN_WINDOW; sym>=1; sym--)
      { symbol=right_window[sym-1];
        symbol_kod=code_of_the_symbol(symbol);
        if (symbol_kod != -1)
         { for(s=1; s<=dim; s++)
            { pom=0;
              for(c=1; c<=dim; c++)
               pom=pom+A[symbol_kod][s-1][c-1]*X_pov[c-1];
              X[s-1]=pom + T[symbol_kod][s-1];
              if(sym == 1)
	       fprintf(fp_right_csr,"%f ",X[s-1]);
            }
           for( s=1; s<=dim; s++) X_pov[s-1]=X[s-1];
           if(sym == 1)
	    fprintf(fp_right_csr,"\n");
         }
      }
      
     next_symbol_int=read_k_symbols_from_file(fp_seq,&next_symbol,1);
     for(sym=1; sym<=LEN_WINDOW-1; sym++)
      right_window[sym-1]=right_window[sym];
     right_window[LEN_WINDOW-1]=next_symbol; 
     for(sym=1; sym<=LEN_WINDOW-1; sym++)
      left_window[sym-1]=left_window[sym];
     left_window[LEN_WINDOW-1]=right_window[0];

   } while(next_symbol_int != EOF && points<MAX_TEXT_LENGTH);

  fclose(fp_seq);
  fclose(fp_left_csr);
  fclose(fp_right_csr); 
}







FILE *otvor_subor(char *nazov_sub, char *mod)
{ FILE *fp;

  fp=fopen(nazov_sub, mod);
  if (fp == NULL)
   { printf("\ncan't find file %s !",nazov_sub);
     exit(0); }
  return(fp);
}





int code_of_the_symbol(char symbol)  /* returns -1 if does not find the symbol */
{ int i,code,found;
  char symbolc;

  found=0;
  code=0;
  for(i=1; i<=num_sym_alph; i++)
   { if (SYM_CODE[i-1]==symbol)
      { code=i-1;
        found=1;
      }
   }
  if (found==0) code=-1;
  return(code);
}





int read_k_symbols_from_file(FILE *fp, char *string, int k)
/* read k symbols from *fp into string */
{ int  i,symbol_int;
  char aux_string[2];

  for(i=1; i<=k; i++)
   { do
      { symbol_int=fgetc(fp);
        sprintf(aux_string,"%c",symbol_int);
      }
      while( !((aux_string[0]>='A' && aux_string[0]<='z') ||
               (aux_string[0] == '+') ||
               (symbol_int == EOF)) );
     *(string+i-1)=aux_string[0];
   }
  *(string+k)='\0';
  return(symbol_int);
}



