#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#define PocetRelaxacii 20
#define PocetVzorov 3
#define PocetNeuronov 40

FILE *vystup;
int S[PocetVzorov][PocetNeuronov]=
			 {{1,-1,-1,1,-1,-1,1,-1,-1,1,-1,-1,1,-1,-1,1,-1,-1,1,-1,-1,1,-1,-1,1,-1,-1,1,-1,-1,1,-1,-1,1,-1,-1,1,-1,-1,1},
				{1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1,1,-1},
				{-1,1,-1,1,-1,-1,-1,1,-1,1,-1,-1,-1,1,-1,1,-1,-1,-1,1,-1,1,-1,-1,-1,1,-1,1,-1,-1,-1,1,-1,1,-1,-1,-1,1,-1,1}
			 };       									 //Tri vzory ktore sa ma siet naucit

float J[PocetNeuronov][PocetNeuronov]; //Matica synaptickych spojeni

main(void){
	void ZobrazMaticu(int*);
	void Relaxuj(int*);
	int i,j,r,k;
	int N[PocetNeuronov]; 					 //Pomocna matica
	char Vzor,TypPoskodenia,PoskodenieSM;
	clrscr();

	if ((vystup = fopen("hns.txt","a")) == NULL)
	{
		printf("\nNemozem otvorit subor \"hns.txt\" !");
		exit(1);
	}

	do{

		for (i=0;i<PocetNeuronov;i++)  //Vynulujeme maticu synaptickych spojeni
			for(j=0;j<PocetNeuronov;j++)
				J[i][j] = 0;

		for(i=0;i<PocetNeuronov;i++)	 //Vytvorime maticu synaptickych spojeni
			for(j=0;j<PocetNeuronov;j++)
			{
				if(i != j)
					for (k=0;k<PocetVzorov;k++)
						J[i][j] += S[k][i]*S[k][j];

				J[i][j] /= PocetNeuronov;
			}


		clrscr();
		printf("\n1...Vzor cislo 1");
		printf("\n2...Vzor cislo 2");
		printf("\n3...Vzor cislo 3");
		printf("\nVyber vzor na relaxaciu.");

		do{
			Vzor=getch();
		}while(Vzor<'1' || Vzor>'3');

		printf("\n1...Povodny vzor bez poskodenia");
		printf("\n2...5 Poskodeni vzoru");
		printf("\n3...10 Poskodeni vzoru");
		printf("\n4...15 Poskodeni vzoru");
		printf("\n5...20 Poskodeni vzoru");
		printf("\nZadaj typ poskodenia vzoru cislo %c.",Vzor);

		do{
			TypPoskodenia=getch();
		}while(TypPoskodenia<'1' || TypPoskodenia>'5');

		printf("\n1...  0%% poskodenie Synaptickej matice");
		printf("\n2... 20%% poskodenie Synaptickej matice");
		printf("\n3... 40%% poskodenie Synaptickej matice");
		printf("\n4... 60%% poskodenie Synaptickej matice");
		printf("\n5... 80%% poskodenie Synaptickej matice");
		printf("\n6...100%% poskodenie Synaptickej matice");
		printf("\nZadaj percento poskodenia synaptickej matice.");

		do{
			PoskodenieSM=getch();
		}while(PoskodenieSM<'1' || PoskodenieSM>'6');

		fprintf(vystup,"\nSynapticka matica ma %d %% poskodenie.",(PoskodenieSM-'1')*20);
		fprintf(vystup,"\nVzor cislo %c, ",Vzor);

		randomize();

		for(i=0;i<(PoskodenieSM-'1')*312;i++)
		{
			j=rand()%PocetNeuronov;
			k=rand()%PocetNeuronov;

			if(J[j][k]!=0)
				J[j][k]=0;
			else
				i--;
		}

		if(TypPoskodenia == '1')
		{
			fprintf(vystup,"bez poskodenia.");
			Relaxuj(S[Vzor-'1']);
		}
		else
		{
			fprintf(vystup,"so %d poskodeniami.",(TypPoskodenia-'1')*5);
			for (k=0;k<PocetNeuronov;k++)
				N[k] = S[Vzor-'1'][k];

			randomize();

			for (k=0;k<(TypPoskodenia-'1')*5;k++)
			{
				i=rand()%PocetNeuronov;

				if(N[i]==1)
					N[i]=-1;
				else
					N[i]=1;
			}

			Relaxuj(N);
		}

		printf("\n\nDalsi priklad??(a/n)");
	}while(getch()!='n');

	fclose(vystup);
}

void ZobrazMaticu(int* Matica)     //Vypise obsah Matice
{
	for (int i=0;i<PocetNeuronov;i++)
	{
		if(!(i%8))
		{
			fprintf(vystup,"\n");
			printf("\n");
		}

		fprintf(vystup,"%d",(Matica[i]+1)/2);
		printf("%d",(Matica[i]+1)/2);
	}
}

void Relaxuj(int* Matica)				   //Matica zrelaxuje v PocetRelaxacii Relaxacii
{
	int i,j,k,l,MN[PocetNeuronov];
	float Prekryv,Energia,x;

	for (i=0;i<PocetNeuronov;i++)
		MN[i] = Matica[i];

	for (k=0;k<PocetRelaxacii;k++)
	{
		printf("\n\nRelaxacia cislo %d",k+1);
		fprintf(vystup,"\n\nRelaxacia cislo %d",k+1);
		ZobrazMaticu(MN);

		for(i=0;i<PocetVzorov;i++) 	   //Vypocet prekryvov pre kazdy vzor
		{
			Prekryv=0;

			for (j=0;j<PocetNeuronov;j++)
				Prekryv+=MN[j]*S[i][j];    //Vlastny vypocet prekryvu pre i-ty vzor

			Prekryv/=40;
			printf("\nPrekryv so vzorom %d je %f.",i+1,Prekryv);
			fprintf(vystup,"\nPrekryv so vzorom %d je %f.",i+1,Prekryv);
		}

		Energia=0;

		for(i=0;i<PocetNeuronov;i++)   //Vypocet energie siete
			for(j=0;j<PocetNeuronov;j++)
				Energia-=J[i][j]*MN[i]*MN[j];

		Energia/=2;
		printf("\nEnergia siete je %f.",Energia);
		fprintf(vystup,"\nEnergia siete je %f.",Energia);

		for(l=0;l<PocetNeuronov;l++)
		{
			x=0;

			i=rand()%PocetNeuronov;  //Nahodne sa vyberie neuron

			for (j=0;j<PocetNeuronov;j++)//Relaxacia
				x+=J[i][j]*MN[j];

			if (x < 0)                   //Deterministicke pravidlo
				MN[i]=-1;
			else
				MN[i]= 1;
		}

		if(getch()=='k')
			break;
	}
}
