//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Grids.hpp>
#define velkost 11
//---------------------------------------------------------------------------
class Matrix22
{
public:
  double cell[2][2];
  Matrix22() {
    for (int i = 0; i < 2; i++)
      for (int j = 0; j < 2; j++)
        cell[i][j] = 0;
  };
  void setrow(int row, double c1, double c2) {
    row--;
    cell[row][0] = c1;
    cell[row][1] = c2;
  };
  Matrix22 operator + (Matrix22 A) {
    Matrix22 result;
    for (int i = 0; i < 2; i++)
      for (int j = 0; j < 2; j++)
        result.cell[i][j] = A.cell[i][j] + this->cell[i][j];
    return result;
  };
  Matrix22 operator - (Matrix22 A) {
    Matrix22 result;
    for (int i = 0; i < 2; i++)
      for (int j = 0; j < 2; j++)
        result.cell[i][j] = this->cell[i][j] - A.cell[i][j];
    return result;
  };
  Matrix22 operator * (Matrix22 A) {
    Matrix22 result;
    for (int i = 0; i < 2; i++)
      for (int j = 0; j < 2; j++)
        for (int k = 0; k < 2; k++)
         result.cell[i][j] = result.cell[i][j] + (this->cell[i][k] * A.cell[k][j]);
    return result;
  };
};



class Matrix44
{
public:
  double cell[4][4];
  Matrix44() {
    for (int i = 0; i < 4; i++)
      for (int j = 0; j < 4; j++)
        cell[i][j] = 0;
  };
  void setrow(int row, double c1, double c2, double c3, double c4) {
    row--;
    cell[row][0] = c1;
    cell[row][1] = c2;
    cell[row][2] = c3;
    cell[row][3] = c4;
  };
  Matrix44 operator + (Matrix44 A) {
    Matrix44 result;
    for (int i = 0; i < 4; i++)
      for (int j = 0; j < 4; j++)
        result.cell[i][j] = A.cell[i][j] + this->cell[i][j];
    return result;
  };
  Matrix44 operator - (Matrix44 A) {
    Matrix44 result;
    for (int i = 0; i < 4; i++)
      for (int j = 0; j < 4; j++)
        result.cell[i][j] = this->cell[i][j] - A.cell[i][j];
    return result;
  };
  Matrix44 operator * (Matrix44 A) {
    Matrix44 result;
    for (int i = 0; i < 4; i++)
      for (int j = 0; j < 4; j++)
        for (int k = 0; k < 4; k++)
         result.cell[i][j] = result.cell[i][j] + (this->cell[i][k] * A.cell[k][j]);
    return result;
  };
};

class Matrix55
{
public:
  double cell[5][5];
  Matrix55() {
    for (int i = 0; i < 5; i++)
      for (int j = 0; j < 5; j++)
        cell[i][j] = 0;
  };
  void setrow(int row, double c1, double c2, double c3, double c4,double c5) {
    row--;
    cell[row][0] = c1;
    cell[row][1] = c2;
    cell[row][2] = c3;
    cell[row][3] = c4;
    cell[row][4] = c5;
  };
  Matrix55 operator + (Matrix55 A) {
    Matrix55 result;
    for (int i = 0; i < 5; i++)
      for (int j = 0; j < 5; j++)
        result.cell[i][j] = A.cell[i][j] + this->cell[i][j];
    return result;
  };
  Matrix55 operator - (Matrix55 A) {
    Matrix55 result;
    for (int i = 0; i < 5; i++)
      for (int j = 0; j < 5; j++)
        result.cell[i][j] = this->cell[i][j] - A.cell[i][j];
    return result;
  };
  Matrix55 operator * (Matrix55 A) {
    Matrix55 result;
    for (int i = 0; i < 5; i++)
      for (int j = 0; j < 5; j++)
        for (int k = 0; k < 5; k++)
         result.cell[i][j] = result.cell[i][j] + (this->cell[i][k] * A.cell[k][j]);
    return result;
  };
};


class Vector4
{
public:
  double coor[4];
  Vector4() {
    for (int i = 0; i < 3; i++)
      coor[i] = 0;
    coor[3] = 1;
  };
  int x() {
    return coor[0];
  };
  int y() {
    return coor[1];
  };
  int z() {
    return coor[2];
  };
  void setvector(double x, double y, double z) {
    coor[0] = x;
    coor[1] = y;
    coor[2] = z;
    coor[3] = 1;
  };
  Vector4 operator + (Vector4 A) {
    Vector4 result;
    for (int i = 0; i < 3; i++)
      result.coor[i] = this->coor[i] + A.coor[i];
    result.coor[3] = 1;
    return result;
  };
  Vector4 operator - (Vector4 A) {
    Vector4 result;
    for (int i = 0; i < 3; i++)
      result.coor[i] = this->coor[i] - A.coor[i];
    result.coor[3] = 1;
    return result;
  };
  double operator * (Vector4 A) {
    double result;
    result = 0;
    for (int i = 0; i < 3; i++)
      result = result + this->coor[i] * A.coor[i];
    return result;
  };
  Vector4 operator ^ (Vector4 A) {
    Vector4 result;
    result.coor[0] = this->coor[1] * A.coor[2] - A.coor[1] * this->coor[2];
    result.coor[1] = this->coor[0] * A.coor[2] - A.coor[0] * this->coor[2];
    result.coor[2] = this->coor[0] * A.coor[1] - A.coor[0] * this->coor[1];
    result.coor[3] = 1;
    return result;
  };
  Vector4 operator * (Matrix44 A) {
    Vector4 result;
    for (int i = 0; i < 4; i++)
      for (int j = 0; j < 4; j++)
        result.coor[i] = result.coor[i] + (this->coor[j] * A.cell[j][i]);
    result.coor[3] = 1;
    return result;
  };
  Vector4 operator * (double k) {
    Vector4 result;
    for (int i = 0; i < 4; i++)
      result.coor[i] = this->coor[i] * k;
    return result;
  };
};

class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TPanel *Panel2;
    TPanel *Panel1;
    TPaintBox *PaintBox;
    TPaintBox *PaintBox2;
    TPanel *Panel3;
        TButton *Button3;
        TButton *Button4;
        TGroupBox *Rotation;
        TButton *xplus;
        TButton *xminus;
        TButton *yplus;
        TButton *yminus;
        TButton *zplus;
        TButton *zminus;
        TGroupBox *GroupBox2;
        TButton *xmplus;
        TButton *xmminus;
        TButton *ymminus;
        TButton *ymplus;
        TButton *zmminus;
        TButton *zmplus;
        TProgressBar *progressbar1;
    TButton *Correspond1;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall PaintBoxPaint(TObject *Sender);


        void __fastcall PaintBoxMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall PaintBox2MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        
        void __fastcall zminusClick(TObject *Sender);
        void __fastcall zplusClick(TObject *Sender);
        void __fastcall xplusClick(TObject *Sender);
        void __fastcall xminusClick(TObject *Sender);
        void __fastcall yplusClick(TObject *Sender);
        void __fastcall yminusClick(TObject *Sender);
        
        void __fastcall zmplusClick(TObject *Sender);
        void __fastcall zmminusClick(TObject *Sender);
        void __fastcall xmplusClick(TObject *Sender);
        void __fastcall xmminusClick(TObject *Sender);
        void __fastcall ymplusClick(TObject *Sender);
        void __fastcall ymminusClick(TObject *Sender);
    
    void __fastcall Correspond1Click(TObject *Sender);
    
private:	// User declarations
    class Vector4 P1, P2, P3, P4, V;
    class Vector4 CL, CR;
    int f, bx;
    void line(Vector4 A, Vector4 B);
    void delay() {
      for (int j = 0; j < 1000; j++)
        for (int k = 0; k < 1000; k++) {}
    }


public:		// User declarations
    __fastcall TForm1(TComponent* Owner);
    __fastcall ~TForm1();
    void hideobject();
    void showobject();
};

//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------

#endif
