function [q] = spojity(u,m1,m2,pol1,pol2,Umin,Umax,S1,beta1,beta2,beta3)

%m1 = 0.7;
%m2 = 0.7;
%Umin = 0;
%Umax = 10.2e-6;

% vstup u(1) ---> h1
% vstup u(2) ---> h2
% vstup u(3) ---> derivacia h2  dh2
% vstup u(4) ---> zelana hodnota w

% volba pracovneho bodu linearizacie
h1w = u(4)*(1+((beta3/beta2)*(beta3/beta2)));
h1prac = m1*h1w+(1-m1)*u(1);
h2prac = m2*u(4)+(1-m2)*u(2); 

% transformacia suradneho systemu
y = u(2)-u(4);
d = u(3);

% transformacia obmedzeni akcnej veliciny
f = beta1*beta2/2+beta2*beta2/2-beta2*beta3/2*sqrt(h2prac/(h1prac-h2prac))+beta2*beta3/2*sqrt((h1prac-h2prac)/h2prac)-beta3*beta3/2;
Ks = beta2/(2*S1*sqrt(h1prac-h2prac));
U = [Ks*Umin - f; Ks*Umax - f];

% zistenie jecka prevolbu U1 alebo U2, akcny zasah
if y > 0 
   Uj=U(2);
   else
   Uj=U(1);
end

% volba linearneho alebo nelinearneho algoritmu
if (y<0 & d>Uj/pol1) | (y>0 & d<Uj/pol1)
  ur = (1-pol2*(y-0.5*(d*d/Uj+Uj/(pol1^2)))/d)*Uj;
  else
  ur = -pol1*pol2*y + (pol1+pol2)*d;
end

% spetna transformacia akcneho zasahu
q = (ur + f)/Ks;

%obmedzenie
if q > Umax
   q = Umax;
elseif q < Umin
      q = Umin;
end

   
