% subor st1.m




clear all;

K=2;
j=0;

[t,x,y]=rk45('s00',15);

i1=min(find(y0>=0.39));
i2=min(find(y0>=0.63));
i3=min(find(y0>=0.86));

T1n(1)=2*t0(i1);
T1n(2)=t0(i2);
T1n(3)=t0(i3)/2;

% -----------------------
% -----------------------
% Diskretny S - regulator
% -----------------------
% -----------------------

for vzor=0:1;
for i=1:3,
% -----------------------

T1=T1n(i);
Td=T1;

Tvzor=(1-vzor)*(T1/2)+vzor*(2*T1);

%  ----------------------
%  Aproximacia PT1 clenom
%  ----------------------
D=exp(-Tvzor/T1);
C=(1/K);

[t1,x1,y1]=rk45('s01',250);
figure;
plot(t,y);
j=j+1;
maxim(j)=100*max(abs(y-1));
grid on;
title('Prech. char. URO - aprox. PT1 clenom');
xlabel('t [sec]');ylabel('y');
if vzor==0
 txt=sprintf('%s%f%s%f%s%f','T1=',T1,', Tvz=T1/2=',Tvzor,', C=1/K=',C);
else
 txt=sprintf('%s%f%s%f%s%f','T1=',T1,', Tvz=2*T1=',Tvzor,', C=1/K=',C);
end;
if i==1 | i==2
 text(50,0.75+vzor*(1.01-0.75),txt);
else
 text(50,0.75+vzor*(1.004-0.75),txt);
end;
set(gcf,'Position',[238 288 668 420]);


%  ----------------------
%  Aproximacia PTd clenom
%  ----------------------
k=fix(Td/T1);
C=(1/K);

[t1,x1,y1]=rk45('s03',250);
figure;
plot(t,y);
j=j+1;
maxim(j)=100*max(abs(y-1));
grid on;
title('Prech. char. URO - aprox. PTd clenom');
xlabel('t [sec]');ylabel('y');
if vzor==0
 txt=sprintf('%s%f%s%f%s%f','Td=',Td,', Tvz=Td/2=',Tvzor,', C=1/K=',C);
else
 txt=sprintf('%s%f%s%f%s%f','Td=',Td,', Tvz=2*Td=',Tvzor,', C=1/K=',C);
end;

 text(50,0.75+vzor*(1.01-0.75),txt);

set(gcf,'Position',[238 288 668 420]);

% -----------------------
% -----------------------

end;
end;

% ----------------------
% ----------------------
% Spojity PI - regulator
% ----------------------
% ----------------------


for i=1:3,
% -----------------------
T1=T1n(i);
Td=T1;

%  ----------------------
%  Aproximacia PT1 clenom
%  ----------------------
Ta=T1/2;
Tp=T1/2;

C=1/(4*K*Tp);

[t1,x1,y1]=rk45('s02',250);
figure;
plot(t,y);
j=j+1;
maxim(j)=100*max((y-1));
grid on;
title('Prech. char. URO - aprox. PT1 clenom');
xlabel('t [sec]');ylabel('y');
 txt=sprintf('%s%f%s%f','T1=',T1,', C=1/4KTp=',C);
text(100,0.1,txt);
set(gcf,'Position',[238 288 668 420]);

%  ----------------------
%  Aproximacia PTd clenom
%  ----------------------
Ta=T1/2;
Tp=T1/2;

C=1/(exp(1)*K*Tp);

[t1,x1,y1]=rk45('s04',250);
figure;
plot(t,y);
j=j+1;
maxim(j)=100*max((y-1));
grid on;
title('Prech. char. URO - aprox. PTd clenom');
xlabel('t [sec]');ylabel('y');
 txt=sprintf('%s%f%s%f','Td=',Td,', C=1/eKTp=',C);
text(100,0.1,txt);
set(gcf,'Position',[238 288 668 420]);
% -----------------------

end;
pause;
close all;


