clear;
disp('Kvadraticky model by Peter Herich');
b0=0;b1=0;b2=0;b3=0;b4=0;b5=0;b6=0;b7=0;b8=0;b9=0;a0=0;
Q=0;
Qv=0;
T=5;
N=15;
n=3;
t0975=2.042;
mi=0.7303;
ni=30;
ni2=5;
randn('seed',1);

% Boxov kvadraticky plan:

u0=[1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
u1=[1 -1 1 -1 1 -1 1 -1 1.2154 -1.2154 0 0 0 0 0];
u2=[1 1 -1 -1 1 1 -1 -1 0 0 1.2154 -1.2154 0 0 0];
u3=[1 1 1 1 -1 -1 -1 -1 0 0 0 0 1.2154 -1.2154 0];
u1m=u1.^2-mi;
u2m=u2.^2-mi;
u3m=u3.^2-mi;
u12=u1.*u2;
u13=u1.*u3;
u23=u2.*u3;

p=[4.6455 1.3545 4.6455 1.3545 4.6455 1.3545 4.6455 1.3545 5 1 3 3 3 3 3]';
q=[3.6455 3.6455 .3545 .3545 3.6455 3.6455 .3545 .3545 2 2 4 0 2 2 2]';
r=[9.5569 9.5569 9.5569 9.5569 5.4431 5.4431 5.4431 5.4431 7.5 7.5 7.5 7.5 10 5 7.5]';
m=[p q r];   
for k=1:15;v=m(k,:);
   for i=1:3;y(k,i)=(2*(350-328))/v(1)*sqrt(v(2))*exp(-v(3)/T)+randn;end
   y(k,4)=(y(k,1)+y(k,2)+y(k,3))/3;
   Q=Q+(y(k,1)-y(k,4))^2+(y(k,2)-y(k,4))^2+(y(k,3)-y(k,4))^2;
end

p0=1/N;
p1=1/(mi*N);
p2=2/(mi^2*((1-mi)^2*N^2));
p3=1/(mi^2*N);
p0pos=p0+n*mi^2*p2;
p=[p0 p1 p2 p3 p0pos];

for i=1:15
  b1=b1+u1(i)*y(i,4);
end
b1=p1*b1;
for i=1:15
  b2=b2+u2(i)*y(i,4);
end
b2=p1*b2;
for i=1:15
  b3=b3+u3(i)*y(i,4);
end
b3=p1*b3;
for i=1:15
  b4=b4+u1m(i)*y(i,4);
end
b4=p2*b4;
for i=1:15
  b5=b5+u2m(i)*y(i,4);
end
b5=p2*b5;
for i=1:15
  b6=b6+u3m(i)*y(i,4);
end
b6=p2*b6;
for i=1:15
  b7=b7+u12(i)*y(i,4);
end
b7=p3*b7;
for i=1:15
  b8=b8+u13(i)*y(i,4);
end
b8=p3*b8;
for i=1:15
  b9=b9+u23(i)*y(i,4);
end
b9=p3*b9;

b=[b1 b2 b3 b4 b5 b6 b7 b8 b9];

for i=1:15
   a0=a0+y(i,4);
end
a0=p0*a0;
b0=a0-mi*(b4+b5+b6);

for k=1:15;
   yv(k)=b0+b1*u1(k)+b2*u2(k)+b3*u3(k)+b4*u1(k)^2+b5*u2(k)^2+b6*u3(k)^2+b7*u12(k)+b8*u13(k)+b9*u23(k);
end

Sy2=Q/ni;
SBlin=sqrt(Sy2*p1);
DELTAlin=SBlin*t0975;
SBkvd=sqrt(Sy2*p2);
DELTAkvd=SBkvd*t0975;
SBzms=sqrt(Sy2*p3);
DELTAzms=SBzms*t0975;
SBabs=sqrt(Sy2*p0pos);
DELTAabs=SBabs*t0975;

SB=[SBlin SBkvd SBzms SBabs];
DELTA=[DELTAlin DELTAkvd DELTAzms DELTAabs];

for k=1:15;
   Qv=Qv+3*(y(k,4)-yv(k))^2;
end   

Syv2=Qv/ni2;
pomer=Syv2/Sy2;

disp('y = ');disp(y);
disp('Q = ');disp(Q);
disp('p =');disp(p');
disp('b(1-9) =');disp(b');
disp('a0 =');disp(a0);
disp('b0 =');disp(b0);
disp('yv = ');disp(yv');
disp('SB = ');disp(SB');
disp('delta = ');disp(DELTA');
disp('Qv = ');disp(Qv);
disp('Sy2 = ');disp(Sy2);
disp('Syv2 = ');disp(Syv2);
disp('pomer =');disp(pomer);

