/*   typedef struct{                                                                     */
/*	      char polozka; -ulozena hodnota zasobnika                                       */
/*	       int miesto;  -ukazuje na vrch zasobnika (ak je -1 tak je vrch)                */
/*	       } stackelm;                                                                   */
/*   zasobnik[N+1] -pole sturctur (typu stackelm) reprezetjuce zasobnik                  */
/*   operacie: empty                     ->zasobnik									     */
/*             push    zasobnik,stackelm -> zasobnik                                     */
/*             pop     zasobnik -> stackelm,zasobnik                                     */
/*             isempty zasobnik -> bool                                                  */
/*                                                                                       */
/*	      									                                             */

#include<stdio.h>
#include<stdlib.h>
#include<conio.h>

/*---------------------------- definovanie konstant ---------------------------------*/
#define N 8
#define TRUE 1
#define FALSE 0

/*---------------------------- globalne premene ---------------------------------*/

typedef struct{
		   char polozka;
		   int miesto;
} stackelm;

stackelm zasobnik[N+1];
/*---------------------------- deklaracia funkcii ---------------------------------*/
void empty(void);
void push(char c);
int pop(void);
isempty(void);
void vypis(void);
void menu(void);

/*---------------------------- hlavny program ---------------------------------*/
int main(void){
int v;
clrscr();
menu();
empty();
vypis();

while(v != '5'){
  gotoxy(3,10);
  printf("Zadaj volbu: ");
  v=getch();
  switch ((char) v){
	case '1': empty();
		  break;
	case '2': gotoxy(4,11);
		  if(zasobnik[N].miesto==-1) {
		  printf("Zasobnik je plny");
		  getch();
		  } else {
		  printf("Chces vlozit: ");
		  push( (char)getche());
		  }
		  break;



	case '3': if (isempty()==TRUE){
		  printf("Zasobnik je prazdny!");
		  getch();
		  } else{
		  printf("Vybrata polozka: %c ",pop());
		  getch();
		  }
		  break;

	case '4': if (isempty()==TRUE){
				  printf("Zasobnik je prazdny!");
				  getch();
				  }
		  else{
			   printf("Zasobnik nie je prazdny!");
			   getch();
		 }
		 break;
	}

  clrscr();
  menu();
  vypis();

}
  return(0);
}
/*---------------------------- funkcia Empty ---------------------------------*/
void empty(void)
{
int i;
 for(i=0;i<N;i++){                          /* vytvorenie zasobnika */
	 if (i==0) zasobnik[i].miesto = -1;
	else zasobnik[i].miesto = 0;
 }
}
/*---------------------------- funkcia Push ---------------------------------*/
void push(char c){
int i,pom;
if(zasobnik[0].miesto == -1) {  /* pre pripad ze zasobnik je prazdny */
	 zasobnik[0].miesto=0;      /* zmena ukazovatela na vrch zasobnika */
	 zasobnik[1].miesto=-1;
	 zasobnik[1].polozka=c;     /* vkladanie polozky do zasobnika      */
} else for(i=N-1;i>0;i--) if (zasobnik[i].miesto == -1){         /* ak je tam aspon jedna polozka */
				zasobnik[i+1].polozka=c;             /* vkladanie polozky do zasobnika */
				zasobnik[i].miesto=0;                /* zmena ukazovatela na vrch zasobnika */
				zasobnik[i+1].miesto=-1;
			}
}
/*---------------------------- funkcia Pop ---------------------------------*/
int pop( void){
 int i,pom;
 for(i=0;i<=N;i++) if (zasobnik[i].miesto == -1) pom=i-1;
 zasobnik[pom+1].miesto=0;   /* zmena ukazovatela na vrch zasobnika */
 zasobnik[pom].miesto=-1;
 return (zasobnik[pom+1].polozka); /* vracia vybratu polozku */
}
/*---------------------------- funkcia Isempty ---------------------------------*/
isempty(){
if (zasobnik[0].miesto==-1) return(TRUE);
       else return(FALSE);
}
/*---------------------------- funkcia Menu ---------------------------------*/
void menu (void)
{
  gotoxy(1,4);
  printf("       1... Empty   2... Push   3... Pop   4... Isempty   5... Quit");
  gotoxy(6,7);
  printf("ͻ\n");
  printf("     ");
  printf("   Zasobnik                                             \n");
  printf("     ");
  printf("ͼ\n");
 }
/*---------------------------- funkcia Vypis ---------------------------------*/
void vypis(void)
{
 int i = 0;
 if(zasobnik[0].miesto!=-1) do {
	  i++;
	  gotoxy(20+6*i,8);
	  printf("%c",zasobnik[i].polozka);
   } while(zasobnik[i].miesto!=-1);
   while(++i<N) {
	  gotoxy(20+6*i,8);
	  printf(" ");
   }
}

